# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class AcknowledgeRequestBody(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'alarm_ids': 'list[str]',
        'force_clear': 'bool',
        'notes': 'list[AlarmNote]'
    }

    attribute_map = {
        'alarm_ids': 'alarmIds',
        'force_clear': 'forceClear',
        'notes': 'notes'
    }

    def __init__(self, alarm_ids=None, force_clear=False, notes=None, local_vars_configuration=None):  # noqa: E501
        """AcknowledgeRequestBody - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._alarm_ids = None
        self._force_clear = None
        self._notes = None
        self.discriminator = None

        self.alarm_ids = alarm_ids
        if force_clear is not None:
            self.force_clear = force_clear
        if notes is not None:
            self.notes = notes

    @property
    def alarm_ids(self):
        """Gets the alarm_ids of this AcknowledgeRequestBody.  # noqa: E501

        The *alarmIds* of the alarm instances which should be acknowledged.  # noqa: E501

        :return: The alarm_ids of this AcknowledgeRequestBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._alarm_ids

    @alarm_ids.setter
    def alarm_ids(self, alarm_ids):
        """Sets the alarm_ids of this AcknowledgeRequestBody.

        The *alarmIds* of the alarm instances which should be acknowledged.  # noqa: E501

        :param alarm_ids: The alarm_ids of this AcknowledgeRequestBody.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and alarm_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `alarm_ids`, must not be `None`")  # noqa: E501

        self._alarm_ids = alarm_ids

    @property
    def force_clear(self):
        """Gets the force_clear of this AcknowledgeRequestBody.  # noqa: E501

        Whether or not the affected alarm instances should have their *clear* field set to true.  # noqa: E501

        :return: The force_clear of this AcknowledgeRequestBody.  # noqa: E501
        :rtype: bool
        """
        return self._force_clear

    @force_clear.setter
    def force_clear(self, force_clear):
        """Sets the force_clear of this AcknowledgeRequestBody.

        Whether or not the affected alarm instances should have their *clear* field set to true.  # noqa: E501

        :param force_clear: The force_clear of this AcknowledgeRequestBody.  # noqa: E501
        :type: bool
        """

        self._force_clear = force_clear

    @property
    def notes(self):
        """Gets the notes of this AcknowledgeRequestBody.  # noqa: E501

        Notes which should be added to the alarm instances.  # noqa: E501

        :return: The notes of this AcknowledgeRequestBody.  # noqa: E501
        :rtype: list[AlarmNote]
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this AcknowledgeRequestBody.

        Notes which should be added to the alarm instances.  # noqa: E501

        :param notes: The notes of this AcknowledgeRequestBody.  # noqa: E501
        :type: list[AlarmNote]
        """

        self._notes = notes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AcknowledgeRequestBody):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AcknowledgeRequestBody):
            return True

        return self.to_dict() != other.to_dict()
