# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class AcknowledgeResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'acknowledged': 'list[str]',
        'already_acknowledged': 'list[str]',
        'not_found': 'list[str]'
    }

    attribute_map = {
        'acknowledged': 'acknowledged',
        'already_acknowledged': 'alreadyAcknowledged',
        'not_found': 'notFound'
    }

    def __init__(self, acknowledged=None, already_acknowledged=None, not_found=None, local_vars_configuration=None):  # noqa: E501
        """AcknowledgeResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._acknowledged = None
        self._already_acknowledged = None
        self._not_found = None
        self.discriminator = None

        if acknowledged is not None:
            self.acknowledged = acknowledged
        if already_acknowledged is not None:
            self.already_acknowledged = already_acknowledged
        if not_found is not None:
            self.not_found = not_found

    @property
    def acknowledged(self):
        """Gets the acknowledged of this AcknowledgeResponse.  # noqa: E501

        The *alarmId*s which were successfully acknowledged.  # noqa: E501

        :return: The acknowledged of this AcknowledgeResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._acknowledged

    @acknowledged.setter
    def acknowledged(self, acknowledged):
        """Sets the acknowledged of this AcknowledgeResponse.

        The *alarmId*s which were successfully acknowledged.  # noqa: E501

        :param acknowledged: The acknowledged of this AcknowledgeResponse.  # noqa: E501
        :type: list[str]
        """

        self._acknowledged = acknowledged

    @property
    def already_acknowledged(self):
        """Gets the already_acknowledged of this AcknowledgeResponse.  # noqa: E501

        The *alarmId*s which had already been previously acknowledged.  # noqa: E501

        :return: The already_acknowledged of this AcknowledgeResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._already_acknowledged

    @already_acknowledged.setter
    def already_acknowledged(self, already_acknowledged):
        """Sets the already_acknowledged of this AcknowledgeResponse.

        The *alarmId*s which had already been previously acknowledged.  # noqa: E501

        :param already_acknowledged: The already_acknowledged of this AcknowledgeResponse.  # noqa: E501
        :type: list[str]
        """

        self._already_acknowledged = already_acknowledged

    @property
    def not_found(self):
        """Gets the not_found of this AcknowledgeResponse.  # noqa: E501

        A collection of *alarmId*s for which no active alarm instances were found.  # noqa: E501

        :return: The not_found of this AcknowledgeResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._not_found

    @not_found.setter
    def not_found(self, not_found):
        """Sets the not_found of this AcknowledgeResponse.

        A collection of *alarmId*s for which no active alarm instances were found.  # noqa: E501

        :param not_found: The not_found of this AcknowledgeResponse.  # noqa: E501
        :type: list[str]
        """

        self._not_found = not_found

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AcknowledgeResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AcknowledgeResponse):
            return True

        return self.to_dict() != other.to_dict()
