# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class AlarmInstance(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'instance_id': 'str',
        'alarm_id': 'str',
        'workspace': 'str',
        'active': 'bool',
        'clear': 'bool',
        'acknowledged': 'bool',
        'acknowledged_at': 'datetime',
        'acknowledged_by': 'str',
        'occurred_at': 'datetime',
        'updated_at': 'datetime',
        'created_by': 'str',
        'transitions': 'list[AlarmTransition]',
        'transition_overflow_count': 'int',
        'notification_strategy_ids': 'list[str]',
        'current_severity_level': 'int',
        'highest_severity_level': 'int',
        'channel': 'str',
        'condition': 'str',
        'display_name': 'str',
        'description': 'str',
        'keywords': 'list[str]',
        'notes': 'list[AlarmNote]',
        'properties': 'dict(str, str)',
        'resource_type': 'str'
    }

    attribute_map = {
        'instance_id': 'instanceId',
        'alarm_id': 'alarmId',
        'workspace': 'workspace',
        'active': 'active',
        'clear': 'clear',
        'acknowledged': 'acknowledged',
        'acknowledged_at': 'acknowledgedAt',
        'acknowledged_by': 'acknowledgedBy',
        'occurred_at': 'occurredAt',
        'updated_at': 'updatedAt',
        'created_by': 'createdBy',
        'transitions': 'transitions',
        'transition_overflow_count': 'transitionOverflowCount',
        'notification_strategy_ids': 'notificationStrategyIds',
        'current_severity_level': 'currentSeverityLevel',
        'highest_severity_level': 'highestSeverityLevel',
        'channel': 'channel',
        'condition': 'condition',
        'display_name': 'displayName',
        'description': 'description',
        'keywords': 'keywords',
        'notes': 'notes',
        'properties': 'properties',
        'resource_type': 'resourceType'
    }

    def __init__(self, instance_id=None, alarm_id=None, workspace=None, active=None, clear=None, acknowledged=None, acknowledged_at=None, acknowledged_by=None, occurred_at=None, updated_at=None, created_by=None, transitions=None, transition_overflow_count=None, notification_strategy_ids=None, current_severity_level=None, highest_severity_level=None, channel=None, condition=None, display_name=None, description=None, keywords=None, notes=None, properties=None, resource_type=None, local_vars_configuration=None):  # noqa: E501
        """AlarmInstance - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._instance_id = None
        self._alarm_id = None
        self._workspace = None
        self._active = None
        self._clear = None
        self._acknowledged = None
        self._acknowledged_at = None
        self._acknowledged_by = None
        self._occurred_at = None
        self._updated_at = None
        self._created_by = None
        self._transitions = None
        self._transition_overflow_count = None
        self._notification_strategy_ids = None
        self._current_severity_level = None
        self._highest_severity_level = None
        self._channel = None
        self._condition = None
        self._display_name = None
        self._description = None
        self._keywords = None
        self._notes = None
        self._properties = None
        self._resource_type = None
        self.discriminator = None

        if instance_id is not None:
            self.instance_id = instance_id
        self.alarm_id = alarm_id
        if workspace is not None:
            self.workspace = workspace
        if active is not None:
            self.active = active
        if clear is not None:
            self.clear = clear
        if acknowledged is not None:
            self.acknowledged = acknowledged
        if acknowledged_at is not None:
            self.acknowledged_at = acknowledged_at
        if acknowledged_by is not None:
            self.acknowledged_by = acknowledged_by
        if occurred_at is not None:
            self.occurred_at = occurred_at
        if updated_at is not None:
            self.updated_at = updated_at
        if created_by is not None:
            self.created_by = created_by
        if transitions is not None:
            self.transitions = transitions
        if transition_overflow_count is not None:
            self.transition_overflow_count = transition_overflow_count
        if notification_strategy_ids is not None:
            self.notification_strategy_ids = notification_strategy_ids
        if current_severity_level is not None:
            self.current_severity_level = current_severity_level
        if highest_severity_level is not None:
            self.highest_severity_level = highest_severity_level
        if channel is not None:
            self.channel = channel
        if condition is not None:
            self.condition = condition
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if keywords is not None:
            self.keywords = keywords
        if notes is not None:
            self.notes = notes
        if properties is not None:
            self.properties = properties
        if resource_type is not None:
            self.resource_type = resource_type

    @property
    def instance_id(self):
        """Gets the instance_id of this AlarmInstance.  # noqa: E501

        The unique ID of a particular instance of an alarm.  # noqa: E501

        :return: The instance_id of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._instance_id

    @instance_id.setter
    def instance_id(self, instance_id):
        """Sets the instance_id of this AlarmInstance.

        The unique ID of a particular instance of an alarm.  # noqa: E501

        :param instance_id: The instance_id of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._instance_id = instance_id

    @property
    def alarm_id(self):
        """Gets the alarm_id of this AlarmInstance.  # noqa: E501

        A value meant to uniquely identify the particular process or condition tracked by an alarm. For example, alarm instances created by the Tag Rule Engine Service have their *alarmIds* set to the concatenation of the path of the tag which caused the rule to be triggered and the ID of the rule.  # noqa: E501

        :return: The alarm_id of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._alarm_id

    @alarm_id.setter
    def alarm_id(self, alarm_id):
        """Sets the alarm_id of this AlarmInstance.

        A value meant to uniquely identify the particular process or condition tracked by an alarm. For example, alarm instances created by the Tag Rule Engine Service have their *alarmIds* set to the concatenation of the path of the tag which caused the rule to be triggered and the ID of the rule.  # noqa: E501

        :param alarm_id: The alarm_id of this AlarmInstance.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and alarm_id is None:  # noqa: E501
            raise ValueError("Invalid value for `alarm_id`, must not be `None`")  # noqa: E501

        self._alarm_id = alarm_id

    @property
    def workspace(self):
        """Gets the workspace of this AlarmInstance.  # noqa: E501

        The ID of the workspace to which this alarm instance belongs. Added in version 3 of the readAlarmInstances operation.  # noqa: E501

        :return: The workspace of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this AlarmInstance.

        The ID of the workspace to which this alarm instance belongs. Added in version 3 of the readAlarmInstances operation.  # noqa: E501

        :param workspace: The workspace of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def active(self):
        """Gets the active of this AlarmInstance.  # noqa: E501

        Whether or not the alarm instance is active. An active alarm deserves human or automated attention. Alarm instances always begin life with *active*/true. This field will be automatically set to false when the *clear* and *acknowledged* fields are set to true.  # noqa: E501

        :return: The active of this AlarmInstance.  # noqa: E501
        :rtype: bool
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this AlarmInstance.

        Whether or not the alarm instance is active. An active alarm deserves human or automated attention. Alarm instances always begin life with *active*/true. This field will be automatically set to false when the *clear* and *acknowledged* fields are set to true.  # noqa: E501

        :param active: The active of this AlarmInstance.  # noqa: E501
        :type: bool
        """

        self._active = active

    @property
    def clear(self):
        """Gets the clear of this AlarmInstance.  # noqa: E501

        When set to true, the condition that triggered the alarm no longer matches the trigger condition. When an alarm instance is created, *clear* is initially set to false. The creator of the alarm (typically a rule engine or application element of some sort) may determine that the trigger condition no longer applies, and may send an update, clearing the condition. Clearing the alarm does not deactivate the alarm, unless the alarm had previously been acknowledged. As long as the alarm is *active*/true, the alarm may transition from *clear*/true to *clear*/false (or vice versa) multiple times.  # noqa: E501

        :return: The clear of this AlarmInstance.  # noqa: E501
        :rtype: bool
        """
        return self._clear

    @clear.setter
    def clear(self, clear):
        """Sets the clear of this AlarmInstance.

        When set to true, the condition that triggered the alarm no longer matches the trigger condition. When an alarm instance is created, *clear* is initially set to false. The creator of the alarm (typically a rule engine or application element of some sort) may determine that the trigger condition no longer applies, and may send an update, clearing the condition. Clearing the alarm does not deactivate the alarm, unless the alarm had previously been acknowledged. As long as the alarm is *active*/true, the alarm may transition from *clear*/true to *clear*/false (or vice versa) multiple times.  # noqa: E501

        :param clear: The clear of this AlarmInstance.  # noqa: E501
        :type: bool
        """

        self._clear = clear

    @property
    def acknowledged(self):
        """Gets the acknowledged of this AlarmInstance.  # noqa: E501

        When set to true, the alarm has been acknowledged by an alarm handler, which is typically a human. Alarm instances always begin life with *acknowledged*/false. Acknowledging an alarm will not affect the *active* flag unless *clear* is also true. When *clear* and *acknowledged* are true, the alarm will become inactive (*active*/false). This field is automatically reset to false when an alarm instance's *highestSeverityLevel* field increases.  # noqa: E501

        :return: The acknowledged of this AlarmInstance.  # noqa: E501
        :rtype: bool
        """
        return self._acknowledged

    @acknowledged.setter
    def acknowledged(self, acknowledged):
        """Sets the acknowledged of this AlarmInstance.

        When set to true, the alarm has been acknowledged by an alarm handler, which is typically a human. Alarm instances always begin life with *acknowledged*/false. Acknowledging an alarm will not affect the *active* flag unless *clear* is also true. When *clear* and *acknowledged* are true, the alarm will become inactive (*active*/false). This field is automatically reset to false when an alarm instance's *highestSeverityLevel* field increases.  # noqa: E501

        :param acknowledged: The acknowledged of this AlarmInstance.  # noqa: E501
        :type: bool
        """

        self._acknowledged = acknowledged

    @property
    def acknowledged_at(self):
        """Gets the acknowledged_at of this AlarmInstance.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the alarm instance was acknowledged. This field will be cleared when an alarm instance's *highestSeverityLevel* field increases.  # noqa: E501

        :return: The acknowledged_at of this AlarmInstance.  # noqa: E501
        :rtype: datetime
        """
        return self._acknowledged_at

    @acknowledged_at.setter
    def acknowledged_at(self, acknowledged_at):
        """Sets the acknowledged_at of this AlarmInstance.

        ISO-8601 formatted timestamp specifying when the alarm instance was acknowledged. This field will be cleared when an alarm instance's *highestSeverityLevel* field increases.  # noqa: E501

        :param acknowledged_at: The acknowledged_at of this AlarmInstance.  # noqa: E501
        :type: datetime
        """

        self._acknowledged_at = acknowledged_at

    @property
    def acknowledged_by(self):
        """Gets the acknowledged_by of this AlarmInstance.  # noqa: E501

        An identifier for who acknowledged a given alarm instance. This field will be cleared when an alarm instance's *highestSeverityLevel* field increases.  # noqa: E501

        :return: The acknowledged_by of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._acknowledged_by

    @acknowledged_by.setter
    def acknowledged_by(self, acknowledged_by):
        """Sets the acknowledged_by of this AlarmInstance.

        An identifier for who acknowledged a given alarm instance. This field will be cleared when an alarm instance's *highestSeverityLevel* field increases.  # noqa: E501

        :param acknowledged_by: The acknowledged_by of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._acknowledged_by = acknowledged_by

    @property
    def occurred_at(self):
        """Gets the occurred_at of this AlarmInstance.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the alarm instance was created  # noqa: E501

        :return: The occurred_at of this AlarmInstance.  # noqa: E501
        :rtype: datetime
        """
        return self._occurred_at

    @occurred_at.setter
    def occurred_at(self, occurred_at):
        """Sets the occurred_at of this AlarmInstance.

        ISO-8601 formatted timestamp specifying when the alarm instance was created  # noqa: E501

        :param occurred_at: The occurred_at of this AlarmInstance.  # noqa: E501
        :type: datetime
        """

        self._occurred_at = occurred_at

    @property
    def updated_at(self):
        """Gets the updated_at of this AlarmInstance.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the alarm instance was last updated  # noqa: E501

        :return: The updated_at of this AlarmInstance.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this AlarmInstance.

        ISO-8601 formatted timestamp specifying when the alarm instance was last updated  # noqa: E501

        :param updated_at: The updated_at of this AlarmInstance.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def created_by(self):
        """Gets the created_by of this AlarmInstance.  # noqa: E501

        An identifier for who or what created a given alarm instance. This is usually used to identify the particular rule engine which requested that a given alarm instance be created.  # noqa: E501

        :return: The created_by of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this AlarmInstance.

        An identifier for who or what created a given alarm instance. This is usually used to identify the particular rule engine which requested that a given alarm instance be created.  # noqa: E501

        :param created_by: The created_by of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def transitions(self):
        """Gets the transitions of this AlarmInstance.  # noqa: E501

        A collection of transitions for a given alarm instance. Transitions record changes to an alarm instance's *clear* flag, as well as increases or decreases in severity. The service stores the first transition and the most recent one hundred other transitions.  # noqa: E501

        :return: The transitions of this AlarmInstance.  # noqa: E501
        :rtype: list[AlarmTransition]
        """
        return self._transitions

    @transitions.setter
    def transitions(self, transitions):
        """Sets the transitions of this AlarmInstance.

        A collection of transitions for a given alarm instance. Transitions record changes to an alarm instance's *clear* flag, as well as increases or decreases in severity. The service stores the first transition and the most recent one hundred other transitions.  # noqa: E501

        :param transitions: The transitions of this AlarmInstance.  # noqa: E501
        :type: list[AlarmTransition]
        """

        self._transitions = transitions

    @property
    def transition_overflow_count(self):
        """Gets the transition_overflow_count of this AlarmInstance.  # noqa: E501

        The number of transitions which overflowed a given alarm instance's *transition's* field  # noqa: E501

        :return: The transition_overflow_count of this AlarmInstance.  # noqa: E501
        :rtype: int
        """
        return self._transition_overflow_count

    @transition_overflow_count.setter
    def transition_overflow_count(self, transition_overflow_count):
        """Sets the transition_overflow_count of this AlarmInstance.

        The number of transitions which overflowed a given alarm instance's *transition's* field  # noqa: E501

        :param transition_overflow_count: The transition_overflow_count of this AlarmInstance.  # noqa: E501
        :type: int
        """

        self._transition_overflow_count = transition_overflow_count

    @property
    def notification_strategy_ids(self):
        """Gets the notification_strategy_ids of this AlarmInstance.  # noqa: E501

        The IDs of the notification strategies which should be triggered if this request results in an alarm instance being created or transitioning to a new highest severity  # noqa: E501

        :return: The notification_strategy_ids of this AlarmInstance.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_strategy_ids

    @notification_strategy_ids.setter
    def notification_strategy_ids(self, notification_strategy_ids):
        """Sets the notification_strategy_ids of this AlarmInstance.

        The IDs of the notification strategies which should be triggered if this request results in an alarm instance being created or transitioning to a new highest severity  # noqa: E501

        :param notification_strategy_ids: The notification_strategy_ids of this AlarmInstance.  # noqa: E501
        :type: list[str]
        """

        self._notification_strategy_ids = notification_strategy_ids

    @property
    def current_severity_level(self):
        """Gets the current_severity_level of this AlarmInstance.  # noqa: E501

        The current severity level of a given alarm instance  # noqa: E501

        :return: The current_severity_level of this AlarmInstance.  # noqa: E501
        :rtype: int
        """
        return self._current_severity_level

    @current_severity_level.setter
    def current_severity_level(self, current_severity_level):
        """Sets the current_severity_level of this AlarmInstance.

        The current severity level of a given alarm instance  # noqa: E501

        :param current_severity_level: The current_severity_level of this AlarmInstance.  # noqa: E501
        :type: int
        """

        self._current_severity_level = current_severity_level

    @property
    def highest_severity_level(self):
        """Gets the highest_severity_level of this AlarmInstance.  # noqa: E501

        The highest severity level that a given alarm instance has ever been in  # noqa: E501

        :return: The highest_severity_level of this AlarmInstance.  # noqa: E501
        :rtype: int
        """
        return self._highest_severity_level

    @highest_severity_level.setter
    def highest_severity_level(self, highest_severity_level):
        """Sets the highest_severity_level of this AlarmInstance.

        The highest severity level that a given alarm instance has ever been in  # noqa: E501

        :param highest_severity_level: The highest_severity_level of this AlarmInstance.  # noqa: E501
        :type: int
        """

        self._highest_severity_level = highest_severity_level

    @property
    def channel(self):
        """Gets the channel of this AlarmInstance.  # noqa: E501

        An identifier for the tag or resource associated with a given alarm instance  # noqa: E501

        :return: The channel of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """Sets the channel of this AlarmInstance.

        An identifier for the tag or resource associated with a given alarm instance  # noqa: E501

        :param channel: The channel of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._channel = channel

    @property
    def condition(self):
        """Gets the condition of this AlarmInstance.  # noqa: E501

        A description of the condition associated with a given alarm instance  # noqa: E501

        :return: The condition of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._condition

    @condition.setter
    def condition(self, condition):
        """Sets the condition of this AlarmInstance.

        A description of the condition associated with a given alarm instance  # noqa: E501

        :param condition: The condition of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._condition = condition

    @property
    def display_name(self):
        """Gets the display_name of this AlarmInstance.  # noqa: E501

        Optional display name for a given alarm instance. Display names do not need to be unique.  # noqa: E501

        :return: The display_name of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this AlarmInstance.

        Optional display name for a given alarm instance. Display names do not need to be unique.  # noqa: E501

        :param display_name: The display_name of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this AlarmInstance.  # noqa: E501

        Optional description text for a given alarm instance  # noqa: E501

        :return: The description of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this AlarmInstance.

        Optional description text for a given alarm instance  # noqa: E501

        :param description: The description of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def keywords(self):
        """Gets the keywords of this AlarmInstance.  # noqa: E501

        Words or phrases associated with an alarm instance. Alarm instances can be tagged with keywords to make it easier to find them with queries.  # noqa: E501

        :return: The keywords of this AlarmInstance.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this AlarmInstance.

        Words or phrases associated with an alarm instance. Alarm instances can be tagged with keywords to make it easier to find them with queries.  # noqa: E501

        :param keywords: The keywords of this AlarmInstance.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def notes(self):
        """Gets the notes of this AlarmInstance.  # noqa: E501

        A collection of notes for a given alarm instance. Notes are set by humans to record information about an alarm after it has been investigated.  # noqa: E501

        :return: The notes of this AlarmInstance.  # noqa: E501
        :rtype: list[AlarmNote]
        """
        return self._notes

    @notes.setter
    def notes(self, notes):
        """Sets the notes of this AlarmInstance.

        A collection of notes for a given alarm instance. Notes are set by humans to record information about an alarm after it has been investigated.  # noqa: E501

        :param notes: The notes of this AlarmInstance.  # noqa: E501
        :type: list[AlarmNote]
        """

        self._notes = notes

    @property
    def properties(self):
        """Gets the properties of this AlarmInstance.  # noqa: E501

        Key-value-pair metadata associated with an alarm instance. Alarm instances can be tagged with properties to make it easier to find them with queries. Additionally, alarm instance properties are used to expand message templates in the notification strategies associated with a given alarm instance.  # noqa: E501

        :return: The properties of this AlarmInstance.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this AlarmInstance.

        Key-value-pair metadata associated with an alarm instance. Alarm instances can be tagged with properties to make it easier to find them with queries. Additionally, alarm instance properties are used to expand message templates in the notification strategies associated with a given alarm instance.  # noqa: E501

        :param properties: The properties of this AlarmInstance.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def resource_type(self):
        """Gets the resource_type of this AlarmInstance.  # noqa: E501

        The type of resource associated with a given alarm instance  # noqa: E501

        :return: The resource_type of this AlarmInstance.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this AlarmInstance.

        The type of resource associated with a given alarm instance  # noqa: E501

        :param resource_type: The resource_type of this AlarmInstance.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlarmInstance):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AlarmInstance):
            return True

        return self.to_dict() != other.to_dict()
