# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class AlarmNote(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'note': 'str',
        'created_at': 'datetime',
        'user': 'str'
    }

    attribute_map = {
        'note': 'note',
        'created_at': 'createdAt',
        'user': 'user'
    }

    def __init__(self, note=None, created_at=None, user=None, local_vars_configuration=None):  # noqa: E501
        """AlarmNote - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._note = None
        self._created_at = None
        self._user = None
        self.discriminator = None

        self.note = note
        if created_at is not None:
            self.created_at = created_at
        if user is not None:
            self.user = user

    @property
    def note(self):
        """Gets the note of this AlarmNote.  # noqa: E501

        Information about a particular alarm instance, such as a description of an investigation into an alarm's root cause.  # noqa: E501

        :return: The note of this AlarmNote.  # noqa: E501
        :rtype: str
        """
        return self._note

    @note.setter
    def note(self, note):
        """Sets the note of this AlarmNote.

        Information about a particular alarm instance, such as a description of an investigation into an alarm's root cause.  # noqa: E501

        :param note: The note of this AlarmNote.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and note is None:  # noqa: E501
            raise ValueError("Invalid value for `note`, must not be `None`")  # noqa: E501

        self._note = note

    @property
    def created_at(self):
        """Gets the created_at of this AlarmNote.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the note was created  # noqa: E501

        :return: The created_at of this AlarmNote.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this AlarmNote.

        ISO-8601 formatted timestamp specifying when the note was created  # noqa: E501

        :param created_at: The created_at of this AlarmNote.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def user(self):
        """Gets the user of this AlarmNote.  # noqa: E501

        The user who created the note  # noqa: E501

        :return: The user of this AlarmNote.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this AlarmNote.

        The user who created the note  # noqa: E501

        :param user: The user of this AlarmNote.  # noqa: E501
        :type: str
        """

        self._user = user

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlarmNote):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AlarmNote):
            return True

        return self.to_dict() != other.to_dict()
