# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class AlarmTransition(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'transition_type': 'AlarmTransitionType',
        'occurred_at': 'datetime',
        'severity_level': 'int',
        'condition': 'str',
        'short_text': 'str',
        'detail_text': 'str',
        'keywords': 'list[str]',
        'properties': 'dict(str, str)'
    }

    attribute_map = {
        'transition_type': 'transitionType',
        'occurred_at': 'occurredAt',
        'severity_level': 'severityLevel',
        'condition': 'condition',
        'short_text': 'shortText',
        'detail_text': 'detailText',
        'keywords': 'keywords',
        'properties': 'properties'
    }

    def __init__(self, transition_type=None, occurred_at=None, severity_level=None, condition=None, short_text=None, detail_text=None, keywords=None, properties=None, local_vars_configuration=None):  # noqa: E501
        """AlarmTransition - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._transition_type = None
        self._occurred_at = None
        self._severity_level = None
        self._condition = None
        self._short_text = None
        self._detail_text = None
        self._keywords = None
        self._properties = None
        self.discriminator = None

        self.transition_type = transition_type
        if occurred_at is not None:
            self.occurred_at = occurred_at
        if severity_level is not None:
            self.severity_level = severity_level
        if condition is not None:
            self.condition = condition
        if short_text is not None:
            self.short_text = short_text
        if detail_text is not None:
            self.detail_text = detail_text
        if keywords is not None:
            self.keywords = keywords
        if properties is not None:
            self.properties = properties

    @property
    def transition_type(self):
        """Gets the transition_type of this AlarmTransition.  # noqa: E501


        :return: The transition_type of this AlarmTransition.  # noqa: E501
        :rtype: AlarmTransitionType
        """
        return self._transition_type

    @transition_type.setter
    def transition_type(self, transition_type):
        """Sets the transition_type of this AlarmTransition.


        :param transition_type: The transition_type of this AlarmTransition.  # noqa: E501
        :type: AlarmTransitionType
        """
        if self.local_vars_configuration.client_side_validation and transition_type is None:  # noqa: E501
            raise ValueError("Invalid value for `transition_type`, must not be `None`")  # noqa: E501

        self._transition_type = transition_type

    @property
    def occurred_at(self):
        """Gets the occurred_at of this AlarmTransition.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the transition occurred  # noqa: E501

        :return: The occurred_at of this AlarmTransition.  # noqa: E501
        :rtype: datetime
        """
        return self._occurred_at

    @occurred_at.setter
    def occurred_at(self, occurred_at):
        """Sets the occurred_at of this AlarmTransition.

        ISO-8601 formatted timestamp specifying when the transition occurred  # noqa: E501

        :param occurred_at: The occurred_at of this AlarmTransition.  # noqa: E501
        :type: datetime
        """

        self._occurred_at = occurred_at

    @property
    def severity_level(self):
        """Gets the severity_level of this AlarmTransition.  # noqa: E501

        The severity of the transition. Valid values for CLEAR transitions are [-1,-1]. Valid values for SET transitions are [1, infinity]. Note that the SystemLink Alarm UI only has display strings for SET severities in the range [1, 4].  # noqa: E501

        :return: The severity_level of this AlarmTransition.  # noqa: E501
        :rtype: int
        """
        return self._severity_level

    @severity_level.setter
    def severity_level(self, severity_level):
        """Sets the severity_level of this AlarmTransition.

        The severity of the transition. Valid values for CLEAR transitions are [-1,-1]. Valid values for SET transitions are [1, infinity]. Note that the SystemLink Alarm UI only has display strings for SET severities in the range [1, 4].  # noqa: E501

        :param severity_level: The severity_level of this AlarmTransition.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                severity_level is not None and severity_level < -1):  # noqa: E501
            raise ValueError("Invalid value for `severity_level`, must be a value greater than or equal to `-1`")  # noqa: E501

        self._severity_level = severity_level

    @property
    def condition(self):
        """Gets the condition of this AlarmTransition.  # noqa: E501

        A description of the condition associated with the transition  # noqa: E501

        :return: The condition of this AlarmTransition.  # noqa: E501
        :rtype: str
        """
        return self._condition

    @condition.setter
    def condition(self, condition):
        """Sets the condition of this AlarmTransition.

        A description of the condition associated with the transition  # noqa: E501

        :param condition: The condition of this AlarmTransition.  # noqa: E501
        :type: str
        """

        self._condition = condition

    @property
    def short_text(self):
        """Gets the short_text of this AlarmTransition.  # noqa: E501

        Short description of the condition  # noqa: E501

        :return: The short_text of this AlarmTransition.  # noqa: E501
        :rtype: str
        """
        return self._short_text

    @short_text.setter
    def short_text(self, short_text):
        """Sets the short_text of this AlarmTransition.

        Short description of the condition  # noqa: E501

        :param short_text: The short_text of this AlarmTransition.  # noqa: E501
        :type: str
        """

        self._short_text = short_text

    @property
    def detail_text(self):
        """Gets the detail_text of this AlarmTransition.  # noqa: E501

        Detailed description of the condition  # noqa: E501

        :return: The detail_text of this AlarmTransition.  # noqa: E501
        :rtype: str
        """
        return self._detail_text

    @detail_text.setter
    def detail_text(self, detail_text):
        """Sets the detail_text of this AlarmTransition.

        Detailed description of the condition  # noqa: E501

        :param detail_text: The detail_text of this AlarmTransition.  # noqa: E501
        :type: str
        """

        self._detail_text = detail_text

    @property
    def keywords(self):
        """Gets the keywords of this AlarmTransition.  # noqa: E501

        Words or phrases associated with a transition. Useful for attaching additional metadata to a given transition which could aid in an investigation into an alarm's root cause in the future.  # noqa: E501

        :return: The keywords of this AlarmTransition.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this AlarmTransition.

        Words or phrases associated with a transition. Useful for attaching additional metadata to a given transition which could aid in an investigation into an alarm's root cause in the future.  # noqa: E501

        :param keywords: The keywords of this AlarmTransition.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def properties(self):
        """Gets the properties of this AlarmTransition.  # noqa: E501

        Key-value-pair metadata associated with a transition. Useful for attaching additional metadata to a given transition which could aid in an investigation into an alarm's root cause in the future.  # noqa: E501

        :return: The properties of this AlarmTransition.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this AlarmTransition.

        Key-value-pair metadata associated with a transition. Useful for attaching additional metadata to a given transition which could aid in an investigation into an alarm's root cause in the future.  # noqa: E501

        :param properties: The properties of this AlarmTransition.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AlarmTransition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AlarmTransition):
            return True

        return self.to_dict() != other.to_dict()
