# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class CreateOrUpdateInstanceRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'alarm_id': 'str',
        'workspace': 'str',
        'transition': 'AlarmTransition',
        'notification_strategy_ids': 'list[str]',
        'created_by': 'str',
        'channel': 'str',
        'resource_type': 'str',
        'display_name': 'str',
        'description': 'str',
        'keywords': 'list[str]',
        'properties': 'dict(str, str)'
    }

    attribute_map = {
        'alarm_id': 'alarmId',
        'workspace': 'workspace',
        'transition': 'transition',
        'notification_strategy_ids': 'notificationStrategyIds',
        'created_by': 'createdBy',
        'channel': 'channel',
        'resource_type': 'resourceType',
        'display_name': 'displayName',
        'description': 'description',
        'keywords': 'keywords',
        'properties': 'properties'
    }

    def __init__(self, alarm_id=None, workspace=None, transition=None, notification_strategy_ids=None, created_by=None, channel=None, resource_type=None, display_name=None, description=None, keywords=None, properties=None, local_vars_configuration=None):  # noqa: E501
        """CreateOrUpdateInstanceRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._alarm_id = None
        self._workspace = None
        self._transition = None
        self._notification_strategy_ids = None
        self._created_by = None
        self._channel = None
        self._resource_type = None
        self._display_name = None
        self._description = None
        self._keywords = None
        self._properties = None
        self.discriminator = None

        self.alarm_id = alarm_id
        if workspace is not None:
            self.workspace = workspace
        self.transition = transition
        if notification_strategy_ids is not None:
            self.notification_strategy_ids = notification_strategy_ids
        if created_by is not None:
            self.created_by = created_by
        if channel is not None:
            self.channel = channel
        if resource_type is not None:
            self.resource_type = resource_type
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if keywords is not None:
            self.keywords = keywords
        if properties is not None:
            self.properties = properties

    @property
    def alarm_id(self):
        """Gets the alarm_id of this CreateOrUpdateInstanceRequest.  # noqa: E501

        A value meant to uniquely identify the particular process or condition tracked by a given alarm within a workspace. For example, alarms created by the Tag Rule Engine Service have their alarmIds set to the concatenation of the path of the tag which caused the rule to be triggered and the ID of the rule.  # noqa: E501

        :return: The alarm_id of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._alarm_id

    @alarm_id.setter
    def alarm_id(self, alarm_id):
        """Sets the alarm_id of this CreateOrUpdateInstanceRequest.

        A value meant to uniquely identify the particular process or condition tracked by a given alarm within a workspace. For example, alarms created by the Tag Rule Engine Service have their alarmIds set to the concatenation of the path of the tag which caused the rule to be triggered and the ID of the rule.  # noqa: E501

        :param alarm_id: The alarm_id of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and alarm_id is None:  # noqa: E501
            raise ValueError("Invalid value for `alarm_id`, must not be `None`")  # noqa: E501

        self._alarm_id = alarm_id

    @property
    def workspace(self):
        """Gets the workspace of this CreateOrUpdateInstanceRequest.  # noqa: E501

        The ID of the workspace in which to create or update the alarm. When not specified, the default workspace is used based on the requesting user. Added in version 2 of the writeAlarmInstances operation.  # noqa: E501

        :return: The workspace of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this CreateOrUpdateInstanceRequest.

        The ID of the workspace in which to create or update the alarm. When not specified, the default workspace is used based on the requesting user. Added in version 2 of the writeAlarmInstances operation.  # noqa: E501

        :param workspace: The workspace of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def transition(self):
        """Gets the transition of this CreateOrUpdateInstanceRequest.  # noqa: E501


        :return: The transition of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: AlarmTransition
        """
        return self._transition

    @transition.setter
    def transition(self, transition):
        """Sets the transition of this CreateOrUpdateInstanceRequest.


        :param transition: The transition of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: AlarmTransition
        """
        if self.local_vars_configuration.client_side_validation and transition is None:  # noqa: E501
            raise ValueError("Invalid value for `transition`, must not be `None`")  # noqa: E501

        self._transition = transition

    @property
    def notification_strategy_ids(self):
        """Gets the notification_strategy_ids of this CreateOrUpdateInstanceRequest.  # noqa: E501

        The IDs of the notification strategies which should be triggered if this request results in an alarm instance being created or transitioning to a new highest severity  # noqa: E501

        :return: The notification_strategy_ids of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_strategy_ids

    @notification_strategy_ids.setter
    def notification_strategy_ids(self, notification_strategy_ids):
        """Sets the notification_strategy_ids of this CreateOrUpdateInstanceRequest.

        The IDs of the notification strategies which should be triggered if this request results in an alarm instance being created or transitioning to a new highest severity  # noqa: E501

        :param notification_strategy_ids: The notification_strategy_ids of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: list[str]
        """

        self._notification_strategy_ids = notification_strategy_ids

    @property
    def created_by(self):
        """Gets the created_by of this CreateOrUpdateInstanceRequest.  # noqa: E501

        An identifier for who or what created a given alarm instance. This is usually used to identify the particular rule engine which requested that a given alarm be created.  # noqa: E501

        :return: The created_by of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._created_by

    @created_by.setter
    def created_by(self, created_by):
        """Sets the created_by of this CreateOrUpdateInstanceRequest.

        An identifier for who or what created a given alarm instance. This is usually used to identify the particular rule engine which requested that a given alarm be created.  # noqa: E501

        :param created_by: The created_by of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._created_by = created_by

    @property
    def channel(self):
        """Gets the channel of this CreateOrUpdateInstanceRequest.  # noqa: E501

        An identifier for the tag or resource associated with the alarm  # noqa: E501

        :return: The channel of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._channel

    @channel.setter
    def channel(self, channel):
        """Sets the channel of this CreateOrUpdateInstanceRequest.

        An identifier for the tag or resource associated with the alarm  # noqa: E501

        :param channel: The channel of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._channel = channel

    @property
    def resource_type(self):
        """Gets the resource_type of this CreateOrUpdateInstanceRequest.  # noqa: E501

        The type of resource associated with the alarm  # noqa: E501

        :return: The resource_type of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this CreateOrUpdateInstanceRequest.

        The type of resource associated with the alarm  # noqa: E501

        :param resource_type: The resource_type of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def display_name(self):
        """Gets the display_name of this CreateOrUpdateInstanceRequest.  # noqa: E501

        Optional display name for a given alarm instance. Display names do not need to be unique.  # noqa: E501

        :return: The display_name of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this CreateOrUpdateInstanceRequest.

        Optional display name for a given alarm instance. Display names do not need to be unique.  # noqa: E501

        :param display_name: The display_name of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this CreateOrUpdateInstanceRequest.  # noqa: E501

        Optional description text for a given alarm instance  # noqa: E501

        :return: The description of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CreateOrUpdateInstanceRequest.

        Optional description text for a given alarm instance  # noqa: E501

        :param description: The description of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def keywords(self):
        """Gets the keywords of this CreateOrUpdateInstanceRequest.  # noqa: E501

        Words or phrases associated with an alarm instance. Alarm instances can be tagged with keywords to make it easier to find them with queries.  # noqa: E501

        :return: The keywords of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this CreateOrUpdateInstanceRequest.

        Words or phrases associated with an alarm instance. Alarm instances can be tagged with keywords to make it easier to find them with queries.  # noqa: E501

        :param keywords: The keywords of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def properties(self):
        """Gets the properties of this CreateOrUpdateInstanceRequest.  # noqa: E501

        Key-value-pair metadata associated with an alarm instance. Alarm instances can be tagged with properties to make it easier to find them with queries. Additionally, alarm instance properties are used to expand message templates in the notification strategies associated with a given alarm instance.  # noqa: E501

        :return: The properties of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this CreateOrUpdateInstanceRequest.

        Key-value-pair metadata associated with an alarm instance. Alarm instances can be tagged with properties to make it easier to find them with queries. Additionally, alarm instance properties are used to expand message templates in the notification strategies associated with a given alarm instance.  # noqa: E501

        :param properties: The properties of this CreateOrUpdateInstanceRequest.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrUpdateInstanceRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateOrUpdateInstanceRequest):
            return True

        return self.to_dict() != other.to_dict()
