# coding: utf-8

"""
    Alarm Web Service

    SystemLink Alarm Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nialarm.configuration import Configuration


class QueryRequestAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'sub_queries': 'list[SubQuery]',
        'return_most_recently_occurred_only': 'bool',
        'order_by': 'str',
        'skip': 'int',
        'take': 'int'
    }

    attribute_map = {
        'sub_queries': 'subQueries',
        'return_most_recently_occurred_only': 'returnMostRecentlyOccurredOnly',
        'order_by': 'orderBy',
        'skip': 'skip',
        'take': 'take'
    }

    def __init__(self, sub_queries=None, return_most_recently_occurred_only=False, order_by='DATE_UPDATED_FORWARD', skip=None, take=None, local_vars_configuration=None):  # noqa: E501
        """QueryRequestAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._sub_queries = None
        self._return_most_recently_occurred_only = None
        self._order_by = None
        self._skip = None
        self._take = None
        self.discriminator = None

        if sub_queries is not None:
            self.sub_queries = sub_queries
        if return_most_recently_occurred_only is not None:
            self.return_most_recently_occurred_only = return_most_recently_occurred_only
        if order_by is not None:
            self.order_by = order_by
        if skip is not None:
            self.skip = skip
        if take is not None:
            self.take = take

    @property
    def sub_queries(self):
        """Gets the sub_queries of this QueryRequestAllOf.  # noqa: E501

        Additional queries. The service will return instances which match any of the queries in the subQueries array. If a top-level query was provided, the top-level query will be AND'ed with each of the sub queries.  # noqa: E501

        :return: The sub_queries of this QueryRequestAllOf.  # noqa: E501
        :rtype: list[SubQuery]
        """
        return self._sub_queries

    @sub_queries.setter
    def sub_queries(self, sub_queries):
        """Sets the sub_queries of this QueryRequestAllOf.

        Additional queries. The service will return instances which match any of the queries in the subQueries array. If a top-level query was provided, the top-level query will be AND'ed with each of the sub queries.  # noqa: E501

        :param sub_queries: The sub_queries of this QueryRequestAllOf.  # noqa: E501
        :type: list[SubQuery]
        """

        self._sub_queries = sub_queries

    @property
    def return_most_recently_occurred_only(self):
        """Gets the return_most_recently_occurred_only of this QueryRequestAllOf.  # noqa: E501

        Whether or not the alarm service should group the instances matched by this query by *alarmId*, and then only return the most recent instance for each grouping. In this context, recency is based on when the alarm instance occurred, not when it was last updated.  # noqa: E501

        :return: The return_most_recently_occurred_only of this QueryRequestAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._return_most_recently_occurred_only

    @return_most_recently_occurred_only.setter
    def return_most_recently_occurred_only(self, return_most_recently_occurred_only):
        """Sets the return_most_recently_occurred_only of this QueryRequestAllOf.

        Whether or not the alarm service should group the instances matched by this query by *alarmId*, and then only return the most recent instance for each grouping. In this context, recency is based on when the alarm instance occurred, not when it was last updated.  # noqa: E501

        :param return_most_recently_occurred_only: The return_most_recently_occurred_only of this QueryRequestAllOf.  # noqa: E501
        :type: bool
        """

        self._return_most_recently_occurred_only = return_most_recently_occurred_only

    @property
    def order_by(self):
        """Gets the order_by of this QueryRequestAllOf.  # noqa: E501

        Whether or not results should be sorted in ascending or descending order relative to the alarm instance's *updatedAt* field.  # noqa: E501

        :return: The order_by of this QueryRequestAllOf.  # noqa: E501
        :rtype: str
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this QueryRequestAllOf.

        Whether or not results should be sorted in ascending or descending order relative to the alarm instance's *updatedAt* field.  # noqa: E501

        :param order_by: The order_by of this QueryRequestAllOf.  # noqa: E501
        :type: str
        """
        allowed_values = ["DATE_UPDATED_FORWARD", "DATE_UPDATED_BACKWARD"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and order_by not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `order_by` ({0}), must be one of {1}"  # noqa: E501
                .format(order_by, allowed_values)
            )

        self._order_by = order_by

    @property
    def skip(self):
        """Gets the skip of this QueryRequestAllOf.  # noqa: E501

        Number of entries to skip in the response list. Typically used in combination with the take parameter to implement pagination.  # noqa: E501

        :return: The skip of this QueryRequestAllOf.  # noqa: E501
        :rtype: int
        """
        return self._skip

    @skip.setter
    def skip(self, skip):
        """Sets the skip of this QueryRequestAllOf.

        Number of entries to skip in the response list. Typically used in combination with the take parameter to implement pagination.  # noqa: E501

        :param skip: The skip of this QueryRequestAllOf.  # noqa: E501
        :type: int
        """

        self._skip = skip

    @property
    def take(self):
        """Gets the take of this QueryRequestAllOf.  # noqa: E501

        Number of entries to include in the response list. Typically used in combination with the skip parameter to implement pagination.  # noqa: E501

        :return: The take of this QueryRequestAllOf.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this QueryRequestAllOf.

        Number of entries to include in the response list. Typically used in combination with the skip parameter to implement pagination.  # noqa: E501

        :param take: The take of this QueryRequestAllOf.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take > 10000):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value less than or equal to `10000`")  # noqa: E501

        self._take = take

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryRequestAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryRequestAllOf):
            return True

        return self.to_dict() != other.to_dict()
