# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class AssetCreateModelAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'location': 'AssetLocationWithPresenceModel',
        'external_calibration': 'ExternalCalibrationWithChecksumModel',
        'discovery_type': 'DiscoveryType',
        'properties': 'dict(str, str)',
        'keywords': 'list[str]'
    }

    attribute_map = {
        'location': 'location',
        'external_calibration': 'externalCalibration',
        'discovery_type': 'discoveryType',
        'properties': 'properties',
        'keywords': 'keywords'
    }

    def __init__(self, location=None, external_calibration=None, discovery_type=None, properties=None, keywords=None, local_vars_configuration=None):  # noqa: E501
        """AssetCreateModelAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._location = None
        self._external_calibration = None
        self._discovery_type = None
        self._properties = None
        self._keywords = None
        self.discriminator = None

        self.location = location
        if external_calibration is not None:
            self.external_calibration = external_calibration
        if discovery_type is not None:
            self.discovery_type = discovery_type
        if properties is not None:
            self.properties = properties
        if keywords is not None:
            self.keywords = keywords

    @property
    def location(self):
        """Gets the location of this AssetCreateModelAllOf.  # noqa: E501


        :return: The location of this AssetCreateModelAllOf.  # noqa: E501
        :rtype: AssetLocationWithPresenceModel
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this AssetCreateModelAllOf.


        :param location: The location of this AssetCreateModelAllOf.  # noqa: E501
        :type: AssetLocationWithPresenceModel
        """
        if self.local_vars_configuration.client_side_validation and location is None:  # noqa: E501
            raise ValueError("Invalid value for `location`, must not be `None`")  # noqa: E501

        self._location = location

    @property
    def external_calibration(self):
        """Gets the external_calibration of this AssetCreateModelAllOf.  # noqa: E501


        :return: The external_calibration of this AssetCreateModelAllOf.  # noqa: E501
        :rtype: ExternalCalibrationWithChecksumModel
        """
        return self._external_calibration

    @external_calibration.setter
    def external_calibration(self, external_calibration):
        """Sets the external_calibration of this AssetCreateModelAllOf.


        :param external_calibration: The external_calibration of this AssetCreateModelAllOf.  # noqa: E501
        :type: ExternalCalibrationWithChecksumModel
        """

        self._external_calibration = external_calibration

    @property
    def discovery_type(self):
        """Gets the discovery_type of this AssetCreateModelAllOf.  # noqa: E501


        :return: The discovery_type of this AssetCreateModelAllOf.  # noqa: E501
        :rtype: DiscoveryType
        """
        return self._discovery_type

    @discovery_type.setter
    def discovery_type(self, discovery_type):
        """Sets the discovery_type of this AssetCreateModelAllOf.


        :param discovery_type: The discovery_type of this AssetCreateModelAllOf.  # noqa: E501
        :type: DiscoveryType
        """

        self._discovery_type = discovery_type

    @property
    def properties(self):
        """Gets the properties of this AssetCreateModelAllOf.  # noqa: E501

        Key-value-pair metadata associated with an asset.  # noqa: E501

        :return: The properties of this AssetCreateModelAllOf.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this AssetCreateModelAllOf.

        Key-value-pair metadata associated with an asset.  # noqa: E501

        :param properties: The properties of this AssetCreateModelAllOf.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def keywords(self):
        """Gets the keywords of this AssetCreateModelAllOf.  # noqa: E501

        Words or phrases associated with an asset.  # noqa: E501

        :return: The keywords of this AssetCreateModelAllOf.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this AssetCreateModelAllOf.

        Words or phrases associated with an asset.  # noqa: E501

        :param keywords: The keywords of this AssetCreateModelAllOf.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetCreateModelAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetCreateModelAllOf):
            return True

        return self.to_dict() != other.to_dict()
