# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class AssetSummaryResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'active': 'int',
        'not_active': 'int',
        'total': 'int',
        'in_use': 'int',
        'not_in_use': 'int',
        'with_alarms': 'int',
        'approaching_recommended_due_date': 'int',
        'past_recommended_due_date': 'int',
        'total_calibrated': 'int'
    }

    attribute_map = {
        'active': 'active',
        'not_active': 'notActive',
        'total': 'total',
        'in_use': 'inUse',
        'not_in_use': 'notInUse',
        'with_alarms': 'withAlarms',
        'approaching_recommended_due_date': 'approachingRecommendedDueDate',
        'past_recommended_due_date': 'pastRecommendedDueDate',
        'total_calibrated': 'totalCalibrated'
    }

    def __init__(self, active=None, not_active=None, total=None, in_use=None, not_in_use=None, with_alarms=None, approaching_recommended_due_date=None, past_recommended_due_date=None, total_calibrated=None, local_vars_configuration=None):  # noqa: E501
        """AssetSummaryResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._active = None
        self._not_active = None
        self._total = None
        self._in_use = None
        self._not_in_use = None
        self._with_alarms = None
        self._approaching_recommended_due_date = None
        self._past_recommended_due_date = None
        self._total_calibrated = None
        self.discriminator = None

        if active is not None:
            self.active = active
        if not_active is not None:
            self.not_active = not_active
        if total is not None:
            self.total = total
        if in_use is not None:
            self.in_use = in_use
        if not_in_use is not None:
            self.not_in_use = not_in_use
        if with_alarms is not None:
            self.with_alarms = with_alarms
        if approaching_recommended_due_date is not None:
            self.approaching_recommended_due_date = approaching_recommended_due_date
        if past_recommended_due_date is not None:
            self.past_recommended_due_date = past_recommended_due_date
        if total_calibrated is not None:
            self.total_calibrated = total_calibrated

    @property
    def active(self):
        """Gets the active of this AssetSummaryResponse.  # noqa: E501

        Number of assets which are active, i.e. present in a connected system.  # noqa: E501

        :return: The active of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._active

    @active.setter
    def active(self, active):
        """Sets the active of this AssetSummaryResponse.

        Number of assets which are active, i.e. present in a connected system.  # noqa: E501

        :param active: The active of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._active = active

    @property
    def not_active(self):
        """Gets the not_active of this AssetSummaryResponse.  # noqa: E501

        Number of assets which are not active.  # noqa: E501

        :return: The not_active of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._not_active

    @not_active.setter
    def not_active(self, not_active):
        """Sets the not_active of this AssetSummaryResponse.

        Number of assets which are not active.  # noqa: E501

        :param not_active: The not_active of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._not_active = not_active

    @property
    def total(self):
        """Gets the total of this AssetSummaryResponse.  # noqa: E501

        Total number of managed assets.  # noqa: E501

        :return: The total of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._total

    @total.setter
    def total(self, total):
        """Sets the total of this AssetSummaryResponse.

        Total number of managed assets.  # noqa: E501

        :param total: The total of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._total = total

    @property
    def in_use(self):
        """Gets the in_use of this AssetSummaryResponse.  # noqa: E501

        Total number of used assets.  # noqa: E501

        :return: The in_use of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._in_use

    @in_use.setter
    def in_use(self, in_use):
        """Sets the in_use of this AssetSummaryResponse.

        Total number of used assets.  # noqa: E501

        :param in_use: The in_use of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._in_use = in_use

    @property
    def not_in_use(self):
        """Gets the not_in_use of this AssetSummaryResponse.  # noqa: E501

        Total number of unused assets.  # noqa: E501

        :return: The not_in_use of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._not_in_use

    @not_in_use.setter
    def not_in_use(self, not_in_use):
        """Sets the not_in_use of this AssetSummaryResponse.

        Total number of unused assets.  # noqa: E501

        :param not_in_use: The not_in_use of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._not_in_use = not_in_use

    @property
    def with_alarms(self):
        """Gets the with_alarms of this AssetSummaryResponse.  # noqa: E501

        Total number of assets with associated alarms.  # noqa: E501

        :return: The with_alarms of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._with_alarms

    @with_alarms.setter
    def with_alarms(self, with_alarms):
        """Sets the with_alarms of this AssetSummaryResponse.

        Total number of assets with associated alarms.  # noqa: E501

        :param with_alarms: The with_alarms of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._with_alarms = with_alarms

    @property
    def approaching_recommended_due_date(self):
        """Gets the approaching_recommended_due_date of this AssetSummaryResponse.  # noqa: E501

        Number of assets approaching calibration date.  # noqa: E501

        :return: The approaching_recommended_due_date of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._approaching_recommended_due_date

    @approaching_recommended_due_date.setter
    def approaching_recommended_due_date(self, approaching_recommended_due_date):
        """Sets the approaching_recommended_due_date of this AssetSummaryResponse.

        Number of assets approaching calibration date.  # noqa: E501

        :param approaching_recommended_due_date: The approaching_recommended_due_date of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._approaching_recommended_due_date = approaching_recommended_due_date

    @property
    def past_recommended_due_date(self):
        """Gets the past_recommended_due_date of this AssetSummaryResponse.  # noqa: E501

        Number of assets past their calibration date.  # noqa: E501

        :return: The past_recommended_due_date of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._past_recommended_due_date

    @past_recommended_due_date.setter
    def past_recommended_due_date(self, past_recommended_due_date):
        """Sets the past_recommended_due_date of this AssetSummaryResponse.

        Number of assets past their calibration date.  # noqa: E501

        :param past_recommended_due_date: The past_recommended_due_date of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._past_recommended_due_date = past_recommended_due_date

    @property
    def total_calibrated(self):
        """Gets the total_calibrated of this AssetSummaryResponse.  # noqa: E501

        Total number of assets supporting calibration.  # noqa: E501

        :return: The total_calibrated of this AssetSummaryResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_calibrated

    @total_calibrated.setter
    def total_calibrated(self, total_calibrated):
        """Sets the total_calibrated of this AssetSummaryResponse.

        Total number of assets supporting calibration.  # noqa: E501

        :param total_calibrated: The total_calibrated of this AssetSummaryResponse.  # noqa: E501
        :type: int
        """

        self._total_calibrated = total_calibrated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetSummaryResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetSummaryResponse):
            return True

        return self.to_dict() != other.to_dict()
