# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class AssetUpdateModelAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'location': 'AssetLocationWithPresenceUpdateModel',
        'external_calibration': 'ExternalCalibrationWithChecksumModel',
        'properties': 'dict(str, str)',
        'keywords': 'list[str]'
    }

    attribute_map = {
        'id': 'id',
        'location': 'location',
        'external_calibration': 'externalCalibration',
        'properties': 'properties',
        'keywords': 'keywords'
    }

    def __init__(self, id=None, location=None, external_calibration=None, properties=None, keywords=None, local_vars_configuration=None):  # noqa: E501
        """AssetUpdateModelAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._location = None
        self._external_calibration = None
        self._properties = None
        self._keywords = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if location is not None:
            self.location = location
        if external_calibration is not None:
            self.external_calibration = external_calibration
        if properties is not None:
            self.properties = properties
        if keywords is not None:
            self.keywords = keywords

    @property
    def id(self):
        """Gets the id of this AssetUpdateModelAllOf.  # noqa: E501

        Unique identifier of the asset.  # noqa: E501

        :return: The id of this AssetUpdateModelAllOf.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this AssetUpdateModelAllOf.

        Unique identifier of the asset.  # noqa: E501

        :param id: The id of this AssetUpdateModelAllOf.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def location(self):
        """Gets the location of this AssetUpdateModelAllOf.  # noqa: E501


        :return: The location of this AssetUpdateModelAllOf.  # noqa: E501
        :rtype: AssetLocationWithPresenceUpdateModel
        """
        return self._location

    @location.setter
    def location(self, location):
        """Sets the location of this AssetUpdateModelAllOf.


        :param location: The location of this AssetUpdateModelAllOf.  # noqa: E501
        :type: AssetLocationWithPresenceUpdateModel
        """

        self._location = location

    @property
    def external_calibration(self):
        """Gets the external_calibration of this AssetUpdateModelAllOf.  # noqa: E501


        :return: The external_calibration of this AssetUpdateModelAllOf.  # noqa: E501
        :rtype: ExternalCalibrationWithChecksumModel
        """
        return self._external_calibration

    @external_calibration.setter
    def external_calibration(self, external_calibration):
        """Sets the external_calibration of this AssetUpdateModelAllOf.


        :param external_calibration: The external_calibration of this AssetUpdateModelAllOf.  # noqa: E501
        :type: ExternalCalibrationWithChecksumModel
        """

        self._external_calibration = external_calibration

    @property
    def properties(self):
        """Gets the properties of this AssetUpdateModelAllOf.  # noqa: E501

        Key-value-pair metadata associated with an asset.  # noqa: E501

        :return: The properties of this AssetUpdateModelAllOf.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this AssetUpdateModelAllOf.

        Key-value-pair metadata associated with an asset.  # noqa: E501

        :param properties: The properties of this AssetUpdateModelAllOf.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def keywords(self):
        """Gets the keywords of this AssetUpdateModelAllOf.  # noqa: E501

        Words or phrases associated with an asset.  # noqa: E501

        :return: The keywords of this AssetUpdateModelAllOf.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this AssetUpdateModelAllOf.

        Words or phrases associated with an asset.  # noqa: E501

        :param keywords: The keywords of this AssetUpdateModelAllOf.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetUpdateModelAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetUpdateModelAllOf):
            return True

        return self.to_dict() != other.to_dict()
