# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class AssetWithAvailabilityHistoryModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'asset_name': 'str',
        'asset_identifier': 'str',
        'availability_history': 'list[OverallAvailabilityInTimespanModel]'
    }

    attribute_map = {
        'asset_name': 'assetName',
        'asset_identifier': 'assetIdentifier',
        'availability_history': 'availabilityHistory'
    }

    def __init__(self, asset_name=None, asset_identifier=None, availability_history=None, local_vars_configuration=None):  # noqa: E501
        """AssetWithAvailabilityHistoryModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._asset_name = None
        self._asset_identifier = None
        self._availability_history = None
        self.discriminator = None

        self.asset_name = asset_name
        self.asset_identifier = asset_identifier
        self.availability_history = availability_history

    @property
    def asset_name(self):
        """Gets the asset_name of this AssetWithAvailabilityHistoryModel.  # noqa: E501

        The asset name for which availability history is computed.  # noqa: E501

        :return: The asset_name of this AssetWithAvailabilityHistoryModel.  # noqa: E501
        :rtype: str
        """
        return self._asset_name

    @asset_name.setter
    def asset_name(self, asset_name):
        """Sets the asset_name of this AssetWithAvailabilityHistoryModel.

        The asset name for which availability history is computed.  # noqa: E501

        :param asset_name: The asset_name of this AssetWithAvailabilityHistoryModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and asset_name is None:  # noqa: E501
            raise ValueError("Invalid value for `asset_name`, must not be `None`")  # noqa: E501

        self._asset_name = asset_name

    @property
    def asset_identifier(self):
        """Gets the asset_identifier of this AssetWithAvailabilityHistoryModel.  # noqa: E501

        The identifier of the asset for which availability history is computed.  # noqa: E501

        :return: The asset_identifier of this AssetWithAvailabilityHistoryModel.  # noqa: E501
        :rtype: str
        """
        return self._asset_identifier

    @asset_identifier.setter
    def asset_identifier(self, asset_identifier):
        """Sets the asset_identifier of this AssetWithAvailabilityHistoryModel.

        The identifier of the asset for which availability history is computed.  # noqa: E501

        :param asset_identifier: The asset_identifier of this AssetWithAvailabilityHistoryModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and asset_identifier is None:  # noqa: E501
            raise ValueError("Invalid value for `asset_identifier`, must not be `None`")  # noqa: E501

        self._asset_identifier = asset_identifier

    @property
    def availability_history(self):
        """Gets the availability_history of this AssetWithAvailabilityHistoryModel.  # noqa: E501

        The availability history for the asset consisting in availability information for each system in which the asset was present.  # noqa: E501

        :return: The availability_history of this AssetWithAvailabilityHistoryModel.  # noqa: E501
        :rtype: list[OverallAvailabilityInTimespanModel]
        """
        return self._availability_history

    @availability_history.setter
    def availability_history(self, availability_history):
        """Sets the availability_history of this AssetWithAvailabilityHistoryModel.

        The availability history for the asset consisting in availability information for each system in which the asset was present.  # noqa: E501

        :param availability_history: The availability_history of this AssetWithAvailabilityHistoryModel.  # noqa: E501
        :type: list[OverallAvailabilityInTimespanModel]
        """
        if self.local_vars_configuration.client_side_validation and availability_history is None:  # noqa: E501
            raise ValueError("Invalid value for `availability_history`, must not be `None`")  # noqa: E501

        self._availability_history = availability_history

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetWithAvailabilityHistoryModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetWithAvailabilityHistoryModel):
            return True

        return self.to_dict() != other.to_dict()
