# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class AssetWithAvailabilityInIntervalModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'asset_name': 'str',
        'asset_identifier': 'str',
        'interval': 'AvailabilityTimeInterval',
        'availability_in_systems': 'list[AssetAvailabilityInSystemModel]'
    }

    attribute_map = {
        'asset_name': 'assetName',
        'asset_identifier': 'assetIdentifier',
        'interval': 'interval',
        'availability_in_systems': 'availabilityInSystems'
    }

    def __init__(self, asset_name=None, asset_identifier=None, interval=None, availability_in_systems=None, local_vars_configuration=None):  # noqa: E501
        """AssetWithAvailabilityInIntervalModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._asset_name = None
        self._asset_identifier = None
        self._interval = None
        self._availability_in_systems = None
        self.discriminator = None

        if asset_name is not None:
            self.asset_name = asset_name
        if asset_identifier is not None:
            self.asset_identifier = asset_identifier
        if interval is not None:
            self.interval = interval
        if availability_in_systems is not None:
            self.availability_in_systems = availability_in_systems

    @property
    def asset_name(self):
        """Gets the asset_name of this AssetWithAvailabilityInIntervalModel.  # noqa: E501

        The asset name for which the availability was computed.  # noqa: E501

        :return: The asset_name of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :rtype: str
        """
        return self._asset_name

    @asset_name.setter
    def asset_name(self, asset_name):
        """Sets the asset_name of this AssetWithAvailabilityInIntervalModel.

        The asset name for which the availability was computed.  # noqa: E501

        :param asset_name: The asset_name of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :type: str
        """

        self._asset_name = asset_name

    @property
    def asset_identifier(self):
        """Gets the asset_identifier of this AssetWithAvailabilityInIntervalModel.  # noqa: E501

        The identifier of the asset for which the availability was computed.  # noqa: E501

        :return: The asset_identifier of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :rtype: str
        """
        return self._asset_identifier

    @asset_identifier.setter
    def asset_identifier(self, asset_identifier):
        """Sets the asset_identifier of this AssetWithAvailabilityInIntervalModel.

        The identifier of the asset for which the availability was computed.  # noqa: E501

        :param asset_identifier: The asset_identifier of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :type: str
        """

        self._asset_identifier = asset_identifier

    @property
    def interval(self):
        """Gets the interval of this AssetWithAvailabilityInIntervalModel.  # noqa: E501


        :return: The interval of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :rtype: AvailabilityTimeInterval
        """
        return self._interval

    @interval.setter
    def interval(self, interval):
        """Sets the interval of this AssetWithAvailabilityInIntervalModel.


        :param interval: The interval of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :type: AvailabilityTimeInterval
        """

        self._interval = interval

    @property
    def availability_in_systems(self):
        """Gets the availability_in_systems of this AssetWithAvailabilityInIntervalModel.  # noqa: E501

        List containing the availability percentage of an asset for each system it was present in during a given time interval.  # noqa: E501

        :return: The availability_in_systems of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :rtype: list[AssetAvailabilityInSystemModel]
        """
        return self._availability_in_systems

    @availability_in_systems.setter
    def availability_in_systems(self, availability_in_systems):
        """Sets the availability_in_systems of this AssetWithAvailabilityInIntervalModel.

        List containing the availability percentage of an asset for each system it was present in during a given time interval.  # noqa: E501

        :param availability_in_systems: The availability_in_systems of this AssetWithAvailabilityInIntervalModel.  # noqa: E501
        :type: list[AssetAvailabilityInSystemModel]
        """

        self._availability_in_systems = availability_in_systems

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AssetWithAvailabilityInIntervalModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AssetWithAvailabilityInIntervalModel):
            return True

        return self.to_dict() != other.to_dict()
