# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class AvailabilityInSystemModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'system_name': 'str',
        'availability_data': 'list[OverallAvailabilityInSystemModel]'
    }

    attribute_map = {
        'system_name': 'systemName',
        'availability_data': 'availabilityData'
    }

    def __init__(self, system_name=None, availability_data=None, local_vars_configuration=None):  # noqa: E501
        """AvailabilityInSystemModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._system_name = None
        self._availability_data = None
        self.discriminator = None

        if system_name is not None:
            self.system_name = system_name
        if availability_data is not None:
            self.availability_data = availability_data

    @property
    def system_name(self):
        """Gets the system_name of this AvailabilityInSystemModel.  # noqa: E501

        Hostname of the system in which the asset was located.  # noqa: E501

        :return: The system_name of this AvailabilityInSystemModel.  # noqa: E501
        :rtype: str
        """
        return self._system_name

    @system_name.setter
    def system_name(self, system_name):
        """Sets the system_name of this AvailabilityInSystemModel.

        Hostname of the system in which the asset was located.  # noqa: E501

        :param system_name: The system_name of this AvailabilityInSystemModel.  # noqa: E501
        :type: str
        """

        self._system_name = system_name

    @property
    def availability_data(self):
        """Gets the availability_data of this AvailabilityInSystemModel.  # noqa: E501

        Collection of asset availability data consisting of timespans and percentage of time the asset was available in each timespan.  # noqa: E501

        :return: The availability_data of this AvailabilityInSystemModel.  # noqa: E501
        :rtype: list[OverallAvailabilityInSystemModel]
        """
        return self._availability_data

    @availability_data.setter
    def availability_data(self, availability_data):
        """Sets the availability_data of this AvailabilityInSystemModel.

        Collection of asset availability data consisting of timespans and percentage of time the asset was available in each timespan.  # noqa: E501

        :param availability_data: The availability_data of this AvailabilityInSystemModel.  # noqa: E501
        :type: list[OverallAvailabilityInSystemModel]
        """

        self._availability_data = availability_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, AvailabilityInSystemModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, AvailabilityInSystemModel):
            return True

        return self.to_dict() != other.to_dict()
