# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class BaseAssetLocationModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'minion_id': 'str',
        'physical_location': 'str',
        'parent': 'str',
        'resource_uri': 'str',
        'slot_number': 'int'
    }

    attribute_map = {
        'minion_id': 'minionId',
        'physical_location': 'physicalLocation',
        'parent': 'parent',
        'resource_uri': 'resourceUri',
        'slot_number': 'slotNumber'
    }

    def __init__(self, minion_id=None, physical_location=None, parent=None, resource_uri=None, slot_number=None, local_vars_configuration=None):  # noqa: E501
        """BaseAssetLocationModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._minion_id = None
        self._physical_location = None
        self._parent = None
        self._resource_uri = None
        self._slot_number = None
        self.discriminator = None

        if minion_id is not None:
            self.minion_id = minion_id
        if physical_location is not None:
            self.physical_location = physical_location
        if parent is not None:
            self.parent = parent
        if resource_uri is not None:
            self.resource_uri = resource_uri
        if slot_number is not None:
            self.slot_number = slot_number

    @property
    def minion_id(self):
        """Gets the minion_id of this BaseAssetLocationModel.  # noqa: E501

        Identifier of the minion where the asset is located.  # noqa: E501

        :return: The minion_id of this BaseAssetLocationModel.  # noqa: E501
        :rtype: str
        """
        return self._minion_id

    @minion_id.setter
    def minion_id(self, minion_id):
        """Sets the minion_id of this BaseAssetLocationModel.

        Identifier of the minion where the asset is located.  # noqa: E501

        :param minion_id: The minion_id of this BaseAssetLocationModel.  # noqa: E501
        :type: str
        """

        self._minion_id = minion_id

    @property
    def physical_location(self):
        """Gets the physical_location of this BaseAssetLocationModel.  # noqa: E501

        Gets or sets the physical location of the asset. An asset can be either in a system, in which case it has a MinionID, or be in a physical location.  # noqa: E501

        :return: The physical_location of this BaseAssetLocationModel.  # noqa: E501
        :rtype: str
        """
        return self._physical_location

    @physical_location.setter
    def physical_location(self, physical_location):
        """Sets the physical_location of this BaseAssetLocationModel.

        Gets or sets the physical location of the asset. An asset can be either in a system, in which case it has a MinionID, or be in a physical location.  # noqa: E501

        :param physical_location: The physical_location of this BaseAssetLocationModel.  # noqa: E501
        :type: str
        """

        self._physical_location = physical_location

    @property
    def parent(self):
        """Gets the parent of this BaseAssetLocationModel.  # noqa: E501

        The parent of the asset.  # noqa: E501

        :return: The parent of this BaseAssetLocationModel.  # noqa: E501
        :rtype: str
        """
        return self._parent

    @parent.setter
    def parent(self, parent):
        """Sets the parent of this BaseAssetLocationModel.

        The parent of the asset.  # noqa: E501

        :param parent: The parent of this BaseAssetLocationModel.  # noqa: E501
        :type: str
        """

        self._parent = parent

    @property
    def resource_uri(self):
        """Gets the resource_uri of this BaseAssetLocationModel.  # noqa: E501

        Identifier of a resource.  # noqa: E501

        :return: The resource_uri of this BaseAssetLocationModel.  # noqa: E501
        :rtype: str
        """
        return self._resource_uri

    @resource_uri.setter
    def resource_uri(self, resource_uri):
        """Sets the resource_uri of this BaseAssetLocationModel.

        Identifier of a resource.  # noqa: E501

        :param resource_uri: The resource_uri of this BaseAssetLocationModel.  # noqa: E501
        :type: str
        """

        self._resource_uri = resource_uri

    @property
    def slot_number(self):
        """Gets the slot_number of this BaseAssetLocationModel.  # noqa: E501

        The number of the slot in which the asset is located.  # noqa: E501

        :return: The slot_number of this BaseAssetLocationModel.  # noqa: E501
        :rtype: int
        """
        return self._slot_number

    @slot_number.setter
    def slot_number(self, slot_number):
        """Sets the slot_number of this BaseAssetLocationModel.

        The number of the slot in which the asset is located.  # noqa: E501

        :param slot_number: The slot_number of this BaseAssetLocationModel.  # noqa: E501
        :type: int
        """

        self._slot_number = slot_number

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BaseAssetLocationModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BaseAssetLocationModel):
            return True

        return self.to_dict() != other.to_dict()
