# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class BaseAssetModelAllOf(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'asset_type': 'AssetType',
        'firmware_version': 'str',
        'hardware_version': 'str',
        'visa_resource_name': 'str',
        'temperature_sensors': 'list[TemperatureSensorModel]',
        'supports_self_calibration': 'bool',
        'supports_external_calibration': 'bool',
        'custom_calibration_interval': 'int',
        'self_calibration': 'SelfCalibrationModel',
        'is_ni_asset': 'bool',
        'workspace': 'str',
        'file_ids': 'list[str]',
        'supports_self_test': 'bool',
        'supports_reset': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'asset_type': 'assetType',
        'firmware_version': 'firmwareVersion',
        'hardware_version': 'hardwareVersion',
        'visa_resource_name': 'visaResourceName',
        'temperature_sensors': 'temperatureSensors',
        'supports_self_calibration': 'supportsSelfCalibration',
        'supports_external_calibration': 'supportsExternalCalibration',
        'custom_calibration_interval': 'customCalibrationInterval',
        'self_calibration': 'selfCalibration',
        'is_ni_asset': 'isNIAsset',
        'workspace': 'workspace',
        'file_ids': 'fileIds',
        'supports_self_test': 'supportsSelfTest',
        'supports_reset': 'supportsReset'
    }

    def __init__(self, name=None, asset_type=None, firmware_version=None, hardware_version=None, visa_resource_name=None, temperature_sensors=None, supports_self_calibration=None, supports_external_calibration=None, custom_calibration_interval=None, self_calibration=None, is_ni_asset=None, workspace=None, file_ids=None, supports_self_test=None, supports_reset=None, local_vars_configuration=None):  # noqa: E501
        """BaseAssetModelAllOf - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._asset_type = None
        self._firmware_version = None
        self._hardware_version = None
        self._visa_resource_name = None
        self._temperature_sensors = None
        self._supports_self_calibration = None
        self._supports_external_calibration = None
        self._custom_calibration_interval = None
        self._self_calibration = None
        self._is_ni_asset = None
        self._workspace = None
        self._file_ids = None
        self._supports_self_test = None
        self._supports_reset = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if asset_type is not None:
            self.asset_type = asset_type
        if firmware_version is not None:
            self.firmware_version = firmware_version
        if hardware_version is not None:
            self.hardware_version = hardware_version
        if visa_resource_name is not None:
            self.visa_resource_name = visa_resource_name
        if temperature_sensors is not None:
            self.temperature_sensors = temperature_sensors
        if supports_self_calibration is not None:
            self.supports_self_calibration = supports_self_calibration
        if supports_external_calibration is not None:
            self.supports_external_calibration = supports_external_calibration
        if custom_calibration_interval is not None:
            self.custom_calibration_interval = custom_calibration_interval
        if self_calibration is not None:
            self.self_calibration = self_calibration
        if is_ni_asset is not None:
            self.is_ni_asset = is_ni_asset
        if workspace is not None:
            self.workspace = workspace
        if file_ids is not None:
            self.file_ids = file_ids
        if supports_self_test is not None:
            self.supports_self_test = supports_self_test
        if supports_reset is not None:
            self.supports_reset = supports_reset

    @property
    def name(self):
        """Gets the name of this BaseAssetModelAllOf.  # noqa: E501

        Name of the asset.  # noqa: E501

        :return: The name of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this BaseAssetModelAllOf.

        Name of the asset.  # noqa: E501

        :param name: The name of this BaseAssetModelAllOf.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def asset_type(self):
        """Gets the asset_type of this BaseAssetModelAllOf.  # noqa: E501


        :return: The asset_type of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: AssetType
        """
        return self._asset_type

    @asset_type.setter
    def asset_type(self, asset_type):
        """Sets the asset_type of this BaseAssetModelAllOf.


        :param asset_type: The asset_type of this BaseAssetModelAllOf.  # noqa: E501
        :type: AssetType
        """

        self._asset_type = asset_type

    @property
    def firmware_version(self):
        """Gets the firmware_version of this BaseAssetModelAllOf.  # noqa: E501

        Firmware version of the asset.  # noqa: E501

        :return: The firmware_version of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: str
        """
        return self._firmware_version

    @firmware_version.setter
    def firmware_version(self, firmware_version):
        """Sets the firmware_version of this BaseAssetModelAllOf.

        Firmware version of the asset.  # noqa: E501

        :param firmware_version: The firmware_version of this BaseAssetModelAllOf.  # noqa: E501
        :type: str
        """

        self._firmware_version = firmware_version

    @property
    def hardware_version(self):
        """Gets the hardware_version of this BaseAssetModelAllOf.  # noqa: E501

        Hardware version of the asset.  # noqa: E501

        :return: The hardware_version of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: str
        """
        return self._hardware_version

    @hardware_version.setter
    def hardware_version(self, hardware_version):
        """Sets the hardware_version of this BaseAssetModelAllOf.

        Hardware version of the asset.  # noqa: E501

        :param hardware_version: The hardware_version of this BaseAssetModelAllOf.  # noqa: E501
        :type: str
        """

        self._hardware_version = hardware_version

    @property
    def visa_resource_name(self):
        """Gets the visa_resource_name of this BaseAssetModelAllOf.  # noqa: E501

        VISA resource name of the asset.  # noqa: E501

        :return: The visa_resource_name of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: str
        """
        return self._visa_resource_name

    @visa_resource_name.setter
    def visa_resource_name(self, visa_resource_name):
        """Sets the visa_resource_name of this BaseAssetModelAllOf.

        VISA resource name of the asset.  # noqa: E501

        :param visa_resource_name: The visa_resource_name of this BaseAssetModelAllOf.  # noqa: E501
        :type: str
        """

        self._visa_resource_name = visa_resource_name

    @property
    def temperature_sensors(self):
        """Gets the temperature_sensors of this BaseAssetModelAllOf.  # noqa: E501

        An array of temperature sensor information.  # noqa: E501

        :return: The temperature_sensors of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: list[TemperatureSensorModel]
        """
        return self._temperature_sensors

    @temperature_sensors.setter
    def temperature_sensors(self, temperature_sensors):
        """Sets the temperature_sensors of this BaseAssetModelAllOf.

        An array of temperature sensor information.  # noqa: E501

        :param temperature_sensors: The temperature_sensors of this BaseAssetModelAllOf.  # noqa: E501
        :type: list[TemperatureSensorModel]
        """

        self._temperature_sensors = temperature_sensors

    @property
    def supports_self_calibration(self):
        """Gets the supports_self_calibration of this BaseAssetModelAllOf.  # noqa: E501

        Whether the asset supports self-calibration.  # noqa: E501

        :return: The supports_self_calibration of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._supports_self_calibration

    @supports_self_calibration.setter
    def supports_self_calibration(self, supports_self_calibration):
        """Sets the supports_self_calibration of this BaseAssetModelAllOf.

        Whether the asset supports self-calibration.  # noqa: E501

        :param supports_self_calibration: The supports_self_calibration of this BaseAssetModelAllOf.  # noqa: E501
        :type: bool
        """

        self._supports_self_calibration = supports_self_calibration

    @property
    def supports_external_calibration(self):
        """Gets the supports_external_calibration of this BaseAssetModelAllOf.  # noqa: E501

        Whether the asset supports external calibration.  # noqa: E501

        :return: The supports_external_calibration of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._supports_external_calibration

    @supports_external_calibration.setter
    def supports_external_calibration(self, supports_external_calibration):
        """Sets the supports_external_calibration of this BaseAssetModelAllOf.

        Whether the asset supports external calibration.  # noqa: E501

        :param supports_external_calibration: The supports_external_calibration of this BaseAssetModelAllOf.  # noqa: E501
        :type: bool
        """

        self._supports_external_calibration = supports_external_calibration

    @property
    def custom_calibration_interval(self):
        """Gets the custom_calibration_interval of this BaseAssetModelAllOf.  # noqa: E501

        The interval represented in months used for computing calibration due date. If not set, the recommended calibration interval from the calibration model is used.  # noqa: E501

        :return: The custom_calibration_interval of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: int
        """
        return self._custom_calibration_interval

    @custom_calibration_interval.setter
    def custom_calibration_interval(self, custom_calibration_interval):
        """Sets the custom_calibration_interval of this BaseAssetModelAllOf.

        The interval represented in months used for computing calibration due date. If not set, the recommended calibration interval from the calibration model is used.  # noqa: E501

        :param custom_calibration_interval: The custom_calibration_interval of this BaseAssetModelAllOf.  # noqa: E501
        :type: int
        """

        self._custom_calibration_interval = custom_calibration_interval

    @property
    def self_calibration(self):
        """Gets the self_calibration of this BaseAssetModelAllOf.  # noqa: E501


        :return: The self_calibration of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: SelfCalibrationModel
        """
        return self._self_calibration

    @self_calibration.setter
    def self_calibration(self, self_calibration):
        """Sets the self_calibration of this BaseAssetModelAllOf.


        :param self_calibration: The self_calibration of this BaseAssetModelAllOf.  # noqa: E501
        :type: SelfCalibrationModel
        """

        self._self_calibration = self_calibration

    @property
    def is_ni_asset(self):
        """Gets the is_ni_asset of this BaseAssetModelAllOf.  # noqa: E501

        Whether this asset is an NI asset (true) or a third-party asset (false).  # noqa: E501

        :return: The is_ni_asset of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._is_ni_asset

    @is_ni_asset.setter
    def is_ni_asset(self, is_ni_asset):
        """Sets the is_ni_asset of this BaseAssetModelAllOf.

        Whether this asset is an NI asset (true) or a third-party asset (false).  # noqa: E501

        :param is_ni_asset: The is_ni_asset of this BaseAssetModelAllOf.  # noqa: E501
        :type: bool
        """

        self._is_ni_asset = is_ni_asset

    @property
    def workspace(self):
        """Gets the workspace of this BaseAssetModelAllOf.  # noqa: E501

        The ID of the workspace containing the asset.  # noqa: E501

        :return: The workspace of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this BaseAssetModelAllOf.

        The ID of the workspace containing the asset.  # noqa: E501

        :param workspace: The workspace of this BaseAssetModelAllOf.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def file_ids(self):
        """Gets the file_ids of this BaseAssetModelAllOf.  # noqa: E501

        The file IDs linked to the asset.  # noqa: E501

        :return: The file_ids of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: list[str]
        """
        return self._file_ids

    @file_ids.setter
    def file_ids(self, file_ids):
        """Sets the file_ids of this BaseAssetModelAllOf.

        The file IDs linked to the asset.  # noqa: E501

        :param file_ids: The file_ids of this BaseAssetModelAllOf.  # noqa: E501
        :type: list[str]
        """

        self._file_ids = file_ids

    @property
    def supports_self_test(self):
        """Gets the supports_self_test of this BaseAssetModelAllOf.  # noqa: E501

        Whether the asset supports self-test.  # noqa: E501

        :return: The supports_self_test of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._supports_self_test

    @supports_self_test.setter
    def supports_self_test(self, supports_self_test):
        """Sets the supports_self_test of this BaseAssetModelAllOf.

        Whether the asset supports self-test.  # noqa: E501

        :param supports_self_test: The supports_self_test of this BaseAssetModelAllOf.  # noqa: E501
        :type: bool
        """

        self._supports_self_test = supports_self_test

    @property
    def supports_reset(self):
        """Gets the supports_reset of this BaseAssetModelAllOf.  # noqa: E501

        Whether the asset supports reset.  # noqa: E501

        :return: The supports_reset of this BaseAssetModelAllOf.  # noqa: E501
        :rtype: bool
        """
        return self._supports_reset

    @supports_reset.setter
    def supports_reset(self, supports_reset):
        """Sets the supports_reset of this BaseAssetModelAllOf.

        Whether the asset supports reset.  # noqa: E501

        :param supports_reset: The supports_reset of this BaseAssetModelAllOf.  # noqa: E501
        :type: bool
        """

        self._supports_reset = supports_reset

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, BaseAssetModelAllOf):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, BaseAssetModelAllOf):
            return True

        return self.to_dict() != other.to_dict()
