# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class CalibrationHistoryModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'temperature_sensors': 'list[TemperatureSensorModel]',
        'is_limited': 'bool',
        'date': 'datetime',
        'recommended_interval': 'int',
        'next_recommended_date': 'datetime',
        'next_custom_due_date': 'datetime',
        'comments': 'str',
        'entry_type': 'CalibrationMode',
        'operator': 'ExternalCalibrationOperatorModel',
        'id': 'str',
        'calibration_type': 'CalibrationType',
        'timestamp': 'datetime'
    }

    attribute_map = {
        'temperature_sensors': 'temperatureSensors',
        'is_limited': 'isLimited',
        'date': 'date',
        'recommended_interval': 'recommendedInterval',
        'next_recommended_date': 'nextRecommendedDate',
        'next_custom_due_date': 'nextCustomDueDate',
        'comments': 'comments',
        'entry_type': 'entryType',
        'operator': 'operator',
        'id': 'id',
        'calibration_type': 'calibrationType',
        'timestamp': 'timestamp'
    }

    def __init__(self, temperature_sensors=None, is_limited=None, date=None, recommended_interval=None, next_recommended_date=None, next_custom_due_date=None, comments=None, entry_type=None, operator=None, id=None, calibration_type=None, timestamp=None, local_vars_configuration=None):  # noqa: E501
        """CalibrationHistoryModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._temperature_sensors = None
        self._is_limited = None
        self._date = None
        self._recommended_interval = None
        self._next_recommended_date = None
        self._next_custom_due_date = None
        self._comments = None
        self._entry_type = None
        self._operator = None
        self._id = None
        self._calibration_type = None
        self._timestamp = None
        self.discriminator = None

        self.temperature_sensors = temperature_sensors
        if is_limited is not None:
            self.is_limited = is_limited
        self.date = date
        self.recommended_interval = recommended_interval
        self.next_recommended_date = next_recommended_date
        if next_custom_due_date is not None:
            self.next_custom_due_date = next_custom_due_date
        if comments is not None:
            self.comments = comments
        if entry_type is not None:
            self.entry_type = entry_type
        if operator is not None:
            self.operator = operator
        self.id = id
        self.calibration_type = calibration_type
        if timestamp is not None:
            self.timestamp = timestamp

    @property
    def temperature_sensors(self):
        """Gets the temperature_sensors of this CalibrationHistoryModel.  # noqa: E501

        An array of temperature sensor information.  # noqa: E501

        :return: The temperature_sensors of this CalibrationHistoryModel.  # noqa: E501
        :rtype: list[TemperatureSensorModel]
        """
        return self._temperature_sensors

    @temperature_sensors.setter
    def temperature_sensors(self, temperature_sensors):
        """Sets the temperature_sensors of this CalibrationHistoryModel.

        An array of temperature sensor information.  # noqa: E501

        :param temperature_sensors: The temperature_sensors of this CalibrationHistoryModel.  # noqa: E501
        :type: list[TemperatureSensorModel]
        """
        if self.local_vars_configuration.client_side_validation and temperature_sensors is None:  # noqa: E501
            raise ValueError("Invalid value for `temperature_sensors`, must not be `None`")  # noqa: E501

        self._temperature_sensors = temperature_sensors

    @property
    def is_limited(self):
        """Gets the is_limited of this CalibrationHistoryModel.  # noqa: E501

        Whether the last external calibration of the asset was a limited calibration.  # noqa: E501

        :return: The is_limited of this CalibrationHistoryModel.  # noqa: E501
        :rtype: bool
        """
        return self._is_limited

    @is_limited.setter
    def is_limited(self, is_limited):
        """Sets the is_limited of this CalibrationHistoryModel.

        Whether the last external calibration of the asset was a limited calibration.  # noqa: E501

        :param is_limited: The is_limited of this CalibrationHistoryModel.  # noqa: E501
        :type: bool
        """

        self._is_limited = is_limited

    @property
    def date(self):
        """Gets the date of this CalibrationHistoryModel.  # noqa: E501

        ISO-8601 formatted timestamp specifying the last date the asset was externally calibrated.  # noqa: E501

        :return: The date of this CalibrationHistoryModel.  # noqa: E501
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """Sets the date of this CalibrationHistoryModel.

        ISO-8601 formatted timestamp specifying the last date the asset was externally calibrated.  # noqa: E501

        :param date: The date of this CalibrationHistoryModel.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and date is None:  # noqa: E501
            raise ValueError("Invalid value for `date`, must not be `None`")  # noqa: E501

        self._date = date

    @property
    def recommended_interval(self):
        """Gets the recommended_interval of this CalibrationHistoryModel.  # noqa: E501

        The manufacturer's recommended calibration interval in months.  # noqa: E501

        :return: The recommended_interval of this CalibrationHistoryModel.  # noqa: E501
        :rtype: int
        """
        return self._recommended_interval

    @recommended_interval.setter
    def recommended_interval(self, recommended_interval):
        """Sets the recommended_interval of this CalibrationHistoryModel.

        The manufacturer's recommended calibration interval in months.  # noqa: E501

        :param recommended_interval: The recommended_interval of this CalibrationHistoryModel.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and recommended_interval is None:  # noqa: E501
            raise ValueError("Invalid value for `recommended_interval`, must not be `None`")  # noqa: E501

        self._recommended_interval = recommended_interval

    @property
    def next_recommended_date(self):
        """Gets the next_recommended_date of this CalibrationHistoryModel.  # noqa: E501

        ISO-8601 formatted timestamp specifying the recommended date for the next external calibration.  # noqa: E501

        :return: The next_recommended_date of this CalibrationHistoryModel.  # noqa: E501
        :rtype: datetime
        """
        return self._next_recommended_date

    @next_recommended_date.setter
    def next_recommended_date(self, next_recommended_date):
        """Sets the next_recommended_date of this CalibrationHistoryModel.

        ISO-8601 formatted timestamp specifying the recommended date for the next external calibration.  # noqa: E501

        :param next_recommended_date: The next_recommended_date of this CalibrationHistoryModel.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and next_recommended_date is None:  # noqa: E501
            raise ValueError("Invalid value for `next_recommended_date`, must not be `None`")  # noqa: E501

        self._next_recommended_date = next_recommended_date

    @property
    def next_custom_due_date(self):
        """Gets the next_custom_due_date of this CalibrationHistoryModel.  # noqa: E501

        ISO-8601 formatted timestamp specifying the date for the next external calibration.  # noqa: E501

        :return: The next_custom_due_date of this CalibrationHistoryModel.  # noqa: E501
        :rtype: datetime
        """
        return self._next_custom_due_date

    @next_custom_due_date.setter
    def next_custom_due_date(self, next_custom_due_date):
        """Sets the next_custom_due_date of this CalibrationHistoryModel.

        ISO-8601 formatted timestamp specifying the date for the next external calibration.  # noqa: E501

        :param next_custom_due_date: The next_custom_due_date of this CalibrationHistoryModel.  # noqa: E501
        :type: datetime
        """

        self._next_custom_due_date = next_custom_due_date

    @property
    def comments(self):
        """Gets the comments of this CalibrationHistoryModel.  # noqa: E501

        Calibration comments provided by an operator.  # noqa: E501

        :return: The comments of this CalibrationHistoryModel.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this CalibrationHistoryModel.

        Calibration comments provided by an operator.  # noqa: E501

        :param comments: The comments of this CalibrationHistoryModel.  # noqa: E501
        :type: str
        """

        self._comments = comments

    @property
    def entry_type(self):
        """Gets the entry_type of this CalibrationHistoryModel.  # noqa: E501


        :return: The entry_type of this CalibrationHistoryModel.  # noqa: E501
        :rtype: CalibrationMode
        """
        return self._entry_type

    @entry_type.setter
    def entry_type(self, entry_type):
        """Sets the entry_type of this CalibrationHistoryModel.


        :param entry_type: The entry_type of this CalibrationHistoryModel.  # noqa: E501
        :type: CalibrationMode
        """

        self._entry_type = entry_type

    @property
    def operator(self):
        """Gets the operator of this CalibrationHistoryModel.  # noqa: E501


        :return: The operator of this CalibrationHistoryModel.  # noqa: E501
        :rtype: ExternalCalibrationOperatorModel
        """
        return self._operator

    @operator.setter
    def operator(self, operator):
        """Sets the operator of this CalibrationHistoryModel.


        :param operator: The operator of this CalibrationHistoryModel.  # noqa: E501
        :type: ExternalCalibrationOperatorModel
        """

        self._operator = operator

    @property
    def id(self):
        """Gets the id of this CalibrationHistoryModel.  # noqa: E501

        The calibration entry identifier.  # noqa: E501

        :return: The id of this CalibrationHistoryModel.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CalibrationHistoryModel.

        The calibration entry identifier.  # noqa: E501

        :param id: The id of this CalibrationHistoryModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def calibration_type(self):
        """Gets the calibration_type of this CalibrationHistoryModel.  # noqa: E501


        :return: The calibration_type of this CalibrationHistoryModel.  # noqa: E501
        :rtype: CalibrationType
        """
        return self._calibration_type

    @calibration_type.setter
    def calibration_type(self, calibration_type):
        """Sets the calibration_type of this CalibrationHistoryModel.


        :param calibration_type: The calibration_type of this CalibrationHistoryModel.  # noqa: E501
        :type: CalibrationType
        """
        if self.local_vars_configuration.client_side_validation and calibration_type is None:  # noqa: E501
            raise ValueError("Invalid value for `calibration_type`, must not be `None`")  # noqa: E501

        self._calibration_type = calibration_type

    @property
    def timestamp(self):
        """Gets the timestamp of this CalibrationHistoryModel.  # noqa: E501

        ISO-8601 formatted timestamp specifying the creation date of the entry.  # noqa: E501

        :return: The timestamp of this CalibrationHistoryModel.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this CalibrationHistoryModel.

        ISO-8601 formatted timestamp specifying the creation date of the entry.  # noqa: E501

        :param timestamp: The timestamp of this CalibrationHistoryModel.  # noqa: E501
        :type: datetime
        """

        self._timestamp = timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalibrationHistoryModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CalibrationHistoryModel):
            return True

        return self.to_dict() != other.to_dict()
