# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class CompareAssetAvailability(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'asset_ids': 'list[str]',
        'start_date': 'str',
        'end_date': 'str'
    }

    attribute_map = {
        'asset_ids': 'assetIds',
        'start_date': 'startDate',
        'end_date': 'endDate'
    }

    def __init__(self, asset_ids=None, start_date=None, end_date=None, local_vars_configuration=None):  # noqa: E501
        """CompareAssetAvailability - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._asset_ids = None
        self._start_date = None
        self._end_date = None
        self.discriminator = None

        self.asset_ids = asset_ids
        self.start_date = start_date
        self.end_date = end_date

    @property
    def asset_ids(self):
        """Gets the asset_ids of this CompareAssetAvailability.  # noqa: E501

        Multiple asset identifiers for which to compare availability history.  # noqa: E501

        :return: The asset_ids of this CompareAssetAvailability.  # noqa: E501
        :rtype: list[str]
        """
        return self._asset_ids

    @asset_ids.setter
    def asset_ids(self, asset_ids):
        """Sets the asset_ids of this CompareAssetAvailability.

        Multiple asset identifiers for which to compare availability history.  # noqa: E501

        :param asset_ids: The asset_ids of this CompareAssetAvailability.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and asset_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `asset_ids`, must not be `None`")  # noqa: E501

        self._asset_ids = asset_ids

    @property
    def start_date(self):
        """Gets the start_date of this CompareAssetAvailability.  # noqa: E501

        A date value which can be used to specify the beginning of a timespan.  This parameter is required to have the \"ISO 8601\" format in order to be considered valid.  The time component of the request is ignored.  # noqa: E501

        :return: The start_date of this CompareAssetAvailability.  # noqa: E501
        :rtype: str
        """
        return self._start_date

    @start_date.setter
    def start_date(self, start_date):
        """Sets the start_date of this CompareAssetAvailability.

        A date value which can be used to specify the beginning of a timespan.  This parameter is required to have the \"ISO 8601\" format in order to be considered valid.  The time component of the request is ignored.  # noqa: E501

        :param start_date: The start_date of this CompareAssetAvailability.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and start_date is None:  # noqa: E501
            raise ValueError("Invalid value for `start_date`, must not be `None`")  # noqa: E501

        self._start_date = start_date

    @property
    def end_date(self):
        """Gets the end_date of this CompareAssetAvailability.  # noqa: E501

        A date value which can be used to specify the end of a timespan. This parameter is required to have the \"ISO 8601\" format in order to be considered valid.  The time component of the request is ignored.  # noqa: E501

        :return: The end_date of this CompareAssetAvailability.  # noqa: E501
        :rtype: str
        """
        return self._end_date

    @end_date.setter
    def end_date(self, end_date):
        """Sets the end_date of this CompareAssetAvailability.

        A date value which can be used to specify the end of a timespan. This parameter is required to have the \"ISO 8601\" format in order to be considered valid.  The time component of the request is ignored.  # noqa: E501

        :param end_date: The end_date of this CompareAssetAvailability.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and end_date is None:  # noqa: E501
            raise ValueError("Invalid value for `end_date`, must not be `None`")  # noqa: E501

        self._end_date = end_date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CompareAssetAvailability):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CompareAssetAvailability):
            return True

        return self.to_dict() != other.to_dict()
