# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class QueryAssetUtilizationHistoryRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'utilization_filter': 'str',
        'asset_filter': 'str',
        'continuation_token': 'str',
        'take': 'int',
        'order_by': 'UtilizationHistoryField',
        'order_by_descending': 'bool'
    }

    attribute_map = {
        'utilization_filter': 'utilizationFilter',
        'asset_filter': 'assetFilter',
        'continuation_token': 'continuationToken',
        'take': 'take',
        'order_by': 'orderBy',
        'order_by_descending': 'orderByDescending'
    }

    def __init__(self, utilization_filter=None, asset_filter=None, continuation_token=None, take=1000, order_by=None, order_by_descending=False, local_vars_configuration=None):  # noqa: E501
        """QueryAssetUtilizationHistoryRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._utilization_filter = None
        self._asset_filter = None
        self._continuation_token = None
        self._take = None
        self._order_by = None
        self._order_by_descending = None
        self.discriminator = None

        if utilization_filter is not None:
            self.utilization_filter = utilization_filter
        if asset_filter is not None:
            self.asset_filter = asset_filter
        if continuation_token is not None:
            self.continuation_token = continuation_token
        if take is not None:
            self.take = take
        if order_by is not None:
            self.order_by = order_by
        if order_by_descending is not None:
            self.order_by_descending = order_by_descending

    @property
    def utilization_filter(self):
        """Gets the utilization_filter of this QueryAssetUtilizationHistoryRequest.  # noqa: E501

        The filter criteria for asset utilization. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]' Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)' Valid asset utilization properties that can be used in the filter: - MinionId: String representing the identifier of a minion in which an asset might be located in. - Category: String representing the utilization task category. - UserName: String representing the name of the operator who utilized the asset. - TaskName: String representing the name of the task. - StartTimestamp:     description: >-       A date time value which can be used to specify the start of an utilization.        This parameter is required to have the \"ISO 8601\" format in order to be considered valid.     type: string     format: date-time     example: '2019-05-20T00:00:00Z' - EndTimestamp:     description: >-       A date time value which can be used to specify the end of an utilization.        This parameter is required to have the \"ISO 8601\" format in order to be considered valid.     type: string     format: date-time     example: '2019-05-20T00:00:00Z'  # noqa: E501

        :return: The utilization_filter of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :rtype: str
        """
        return self._utilization_filter

    @utilization_filter.setter
    def utilization_filter(self, utilization_filter):
        """Sets the utilization_filter of this QueryAssetUtilizationHistoryRequest.

        The filter criteria for asset utilization. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]' Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)' Valid asset utilization properties that can be used in the filter: - MinionId: String representing the identifier of a minion in which an asset might be located in. - Category: String representing the utilization task category. - UserName: String representing the name of the operator who utilized the asset. - TaskName: String representing the name of the task. - StartTimestamp:     description: >-       A date time value which can be used to specify the start of an utilization.        This parameter is required to have the \"ISO 8601\" format in order to be considered valid.     type: string     format: date-time     example: '2019-05-20T00:00:00Z' - EndTimestamp:     description: >-       A date time value which can be used to specify the end of an utilization.        This parameter is required to have the \"ISO 8601\" format in order to be considered valid.     type: string     format: date-time     example: '2019-05-20T00:00:00Z'  # noqa: E501

        :param utilization_filter: The utilization_filter of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :type: str
        """

        self._utilization_filter = utilization_filter

    @property
    def asset_filter(self):
        """Gets the asset_filter of this QueryAssetUtilizationHistoryRequest.  # noqa: E501

        The filter criteria for assets. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset properties that can be used in the filter: - AssetIdentifier: String representing the unique identifier of an asset. - SerialNumber: String representing the serial number of an asset. - ModelName: String representing the model name of an asset. - ModelNumber: Unsigned integer representing the model number of an asset. - VendorName: String representing the vendor name of an asset. - VendorNumber: Unsigned integer representing the vendor number of an asset. - AssetName: String representing the asset name. - FirmwareVersion: String representing the firmware version of an asset. - HardwareVersion: String representing the hardware version of an asset. - BusType: String enumeration representing the bus type of an asset. Possible values are: BUILT_IN_SYSTEM, PCI_PXI, USB, GPIB, VXI, SERIAL, TCP_IP, CRIO, SCXI, CDAQ, SWITCH_BLOCK, SCC, FIRE_WIRE, ACCESSORY, CAN, SWITCH_BLOCK_DEVICE, SLSC. - IsNIAsset: Boolean flag specifying whether the asset is an NI asset or a third-party asset. - Keywords: Collection of string values representing asset metadata keywords. Example: 'Keywords=[\"keyword1\", \"keyword2\"]'. - Properties: Collection of key-value pairs, each key-value pair representing an asset metadata property. Example: 'Properties=[\"key1\":\"value1\", \"key2\":\"value2\"]'. - Location.MinionId: String representing the identifier of the minion in which the asset is located in. - Location.SystemName: String representing the name of the system that the asset is located in. - Location.SlotNumber: Unsigned integer representing the slot number the asset is located in. - Location.AssetState.SystemConnection: String enumeration representing the connection state of the system the asset is currently located in. Possible values are: APPROVED, DISCONNECTED, CONNECTED_UPDATE_PENDING, CONNECTED_UPDATE_SUCCESSFUL, CONNECTED_UPDATE_FAILED, UNSUPPORTED, ACTIVATED. - Location.AssetState.AssetPresence: String enumeration representing the present status of an asset in a system. Possible values are: INITIALIZING, UNKNOWN, NOT_PRESENT, PRESENT. - SupportsSelfCalibration: Boolean flag specifying whether the asset supports self-calibration. - SelfCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was self-calibrated. Example: \"2018-05-20T00:00:00Z\" - SupportsExternalCalibration: Boolean flag specifying whether the asset supports external calibration. - CustomCalibrationInterval: Integer representing the custom calibration interval, in months. - CalibrationStatus: String enumeration representing the calibration status of an asset. Possible values are: OK, APPROACHING_RECOMMENDED_DUE_DATE, PAST_RECOMMENDED_DUE_DATE. - ExternalCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was externally-calibrated. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.NextRecommendedDate: ISO-8601 formatted timestamp string specifying the recommended date for the next external calibration. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.RecommendedInterval: Integer representing the manufacturer-recommended calibration interval, in months. - ExternalCalibration.Comments: String representing any external calibration comments. - ExternalCalibration.IsLimited: Boolean flag specifying whether the last external calibration was a limited calibration. - ExternalCalibration.Operator.DisplayName: String representing the name of the operator which performed an external calibration on a third-party asset.  # noqa: E501

        :return: The asset_filter of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :rtype: str
        """
        return self._asset_filter

    @asset_filter.setter
    def asset_filter(self, asset_filter):
        """Sets the asset_filter of this QueryAssetUtilizationHistoryRequest.

        The filter criteria for assets. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset properties that can be used in the filter: - AssetIdentifier: String representing the unique identifier of an asset. - SerialNumber: String representing the serial number of an asset. - ModelName: String representing the model name of an asset. - ModelNumber: Unsigned integer representing the model number of an asset. - VendorName: String representing the vendor name of an asset. - VendorNumber: Unsigned integer representing the vendor number of an asset. - AssetName: String representing the asset name. - FirmwareVersion: String representing the firmware version of an asset. - HardwareVersion: String representing the hardware version of an asset. - BusType: String enumeration representing the bus type of an asset. Possible values are: BUILT_IN_SYSTEM, PCI_PXI, USB, GPIB, VXI, SERIAL, TCP_IP, CRIO, SCXI, CDAQ, SWITCH_BLOCK, SCC, FIRE_WIRE, ACCESSORY, CAN, SWITCH_BLOCK_DEVICE, SLSC. - IsNIAsset: Boolean flag specifying whether the asset is an NI asset or a third-party asset. - Keywords: Collection of string values representing asset metadata keywords. Example: 'Keywords=[\"keyword1\", \"keyword2\"]'. - Properties: Collection of key-value pairs, each key-value pair representing an asset metadata property. Example: 'Properties=[\"key1\":\"value1\", \"key2\":\"value2\"]'. - Location.MinionId: String representing the identifier of the minion in which the asset is located in. - Location.SystemName: String representing the name of the system that the asset is located in. - Location.SlotNumber: Unsigned integer representing the slot number the asset is located in. - Location.AssetState.SystemConnection: String enumeration representing the connection state of the system the asset is currently located in. Possible values are: APPROVED, DISCONNECTED, CONNECTED_UPDATE_PENDING, CONNECTED_UPDATE_SUCCESSFUL, CONNECTED_UPDATE_FAILED, UNSUPPORTED, ACTIVATED. - Location.AssetState.AssetPresence: String enumeration representing the present status of an asset in a system. Possible values are: INITIALIZING, UNKNOWN, NOT_PRESENT, PRESENT. - SupportsSelfCalibration: Boolean flag specifying whether the asset supports self-calibration. - SelfCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was self-calibrated. Example: \"2018-05-20T00:00:00Z\" - SupportsExternalCalibration: Boolean flag specifying whether the asset supports external calibration. - CustomCalibrationInterval: Integer representing the custom calibration interval, in months. - CalibrationStatus: String enumeration representing the calibration status of an asset. Possible values are: OK, APPROACHING_RECOMMENDED_DUE_DATE, PAST_RECOMMENDED_DUE_DATE. - ExternalCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was externally-calibrated. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.NextRecommendedDate: ISO-8601 formatted timestamp string specifying the recommended date for the next external calibration. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.RecommendedInterval: Integer representing the manufacturer-recommended calibration interval, in months. - ExternalCalibration.Comments: String representing any external calibration comments. - ExternalCalibration.IsLimited: Boolean flag specifying whether the last external calibration was a limited calibration. - ExternalCalibration.Operator.DisplayName: String representing the name of the operator which performed an external calibration on a third-party asset.  # noqa: E501

        :param asset_filter: The asset_filter of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :type: str
        """

        self._asset_filter = asset_filter

    @property
    def continuation_token(self):
        """Gets the continuation_token of this QueryAssetUtilizationHistoryRequest.  # noqa: E501

        A token which allows the user to resume a query at the next item in the matching asset utilization history set. When querying for asset utilization history, a token will be returned if a query may be continued. To obtain the next page of asset utilization history records, pass the token to the service on a subsequent request.  # noqa: E501

        :return: The continuation_token of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this QueryAssetUtilizationHistoryRequest.

        A token which allows the user to resume a query at the next item in the matching asset utilization history set. When querying for asset utilization history, a token will be returned if a query may be continued. To obtain the next page of asset utilization history records, pass the token to the service on a subsequent request.  # noqa: E501

        :param continuation_token: The continuation_token of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :type: str
        """

        self._continuation_token = continuation_token

    @property
    def take(self):
        """Gets the take of this QueryAssetUtilizationHistoryRequest.  # noqa: E501

        The maximum number of asset utilization history records to return.  # noqa: E501

        :return: The take of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this QueryAssetUtilizationHistoryRequest.

        The maximum number of asset utilization history records to return.  # noqa: E501

        :param take: The take of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take < 0):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value greater than or equal to `0`")  # noqa: E501

        self._take = take

    @property
    def order_by(self):
        """Gets the order_by of this QueryAssetUtilizationHistoryRequest.  # noqa: E501


        :return: The order_by of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :rtype: UtilizationHistoryField
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this QueryAssetUtilizationHistoryRequest.


        :param order_by: The order_by of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :type: UtilizationHistoryField
        """

        self._order_by = order_by

    @property
    def order_by_descending(self):
        """Gets the order_by_descending of this QueryAssetUtilizationHistoryRequest.  # noqa: E501

        Whether to return the asset utilization history records in descending order.  # noqa: E501

        :return: The order_by_descending of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :rtype: bool
        """
        return self._order_by_descending

    @order_by_descending.setter
    def order_by_descending(self, order_by_descending):
        """Sets the order_by_descending of this QueryAssetUtilizationHistoryRequest.

        Whether to return the asset utilization history records in descending order.  # noqa: E501

        :param order_by_descending: The order_by_descending of this QueryAssetUtilizationHistoryRequest.  # noqa: E501
        :type: bool
        """

        self._order_by_descending = order_by_descending

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryAssetUtilizationHistoryRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryAssetUtilizationHistoryRequest):
            return True

        return self.to_dict() != other.to_dict()
