# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class QueryAssetUtilizationsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'utilization_filter': 'str',
        'asset_filter': 'str',
        'utilization_intervals': 'list[UtilizationTimeIntervalModel]'
    }

    attribute_map = {
        'utilization_filter': 'utilizationFilter',
        'asset_filter': 'assetFilter',
        'utilization_intervals': 'utilizationIntervals'
    }

    def __init__(self, utilization_filter=None, asset_filter=None, utilization_intervals=None, local_vars_configuration=None):  # noqa: E501
        """QueryAssetUtilizationsRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._utilization_filter = None
        self._asset_filter = None
        self._utilization_intervals = None
        self.discriminator = None

        if utilization_filter is not None:
            self.utilization_filter = utilization_filter
        if asset_filter is not None:
            self.asset_filter = asset_filter
        self.utilization_intervals = utilization_intervals

    @property
    def utilization_filter(self):
        """Gets the utilization_filter of this QueryAssetUtilizationsRequest.  # noqa: E501

        The filter criteria for asset utilization. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset utilization properties that can be used in the filter: - MinionId:  String representing the identifier of a minion in which an asset might be located in. - Category: String representing the utilization task category. - UserName: : String representing the name of the operator who utilized the asset.  # noqa: E501

        :return: The utilization_filter of this QueryAssetUtilizationsRequest.  # noqa: E501
        :rtype: str
        """
        return self._utilization_filter

    @utilization_filter.setter
    def utilization_filter(self, utilization_filter):
        """Sets the utilization_filter of this QueryAssetUtilizationsRequest.

        The filter criteria for asset utilization. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset utilization properties that can be used in the filter: - MinionId:  String representing the identifier of a minion in which an asset might be located in. - Category: String representing the utilization task category. - UserName: : String representing the name of the operator who utilized the asset.  # noqa: E501

        :param utilization_filter: The utilization_filter of this QueryAssetUtilizationsRequest.  # noqa: E501
        :type: str
        """

        self._utilization_filter = utilization_filter

    @property
    def asset_filter(self):
        """Gets the asset_filter of this QueryAssetUtilizationsRequest.  # noqa: E501

        The filter criteria for assets. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset properties that can be used in the filter: - AssetIdentifier: String representing the unique identifier of an asset. - SerialNumber: String representing the serial number of an asset. - ModelName: String representing the model name of an asset. - ModelNumber: Unsigned integer representing the model number of an asset. - VendorName: String representing the vendor name of an asset. - VendorNumber: Unsigned integer representing the vendor number of an asset. - AssetName: String representing the asset name. - FirmwareVersion: String representing the firmware version of an asset. - HardwareVersion: String representing the hardware version of an asset. - BusType: String enumeration representing the bus type of an asset. Possible values are: BUILT_IN_SYSTEM, PCI_PXI, USB, GPIB, VXI, SERIAL, TCP_IP, CRIO, SCXI, CDAQ, SWITCH_BLOCK, SCC, FIRE_WIRE, ACCESSORY, CAN, SWITCH_BLOCK_DEVICE, SLSC. - IsNIAsset: Boolean flag specifying whether the asset is an NI asset or a third-party asset. - Keywords: Collection of string values representing asset metadata keywords. Example: 'Keywords=[\"keyword1\", \"keyword2\"]'. - Properties: Collection of key-value pairs, each key-value pair representing an asset metadata property. Example: 'Properties=[\"key1\":\"value1\", \"key2\":\"value2\"]'. - Location.MinionId: String representing the identifier of the minion in which the asset is located in. - Location.SystemName: String representing the name of the system that the asset is located in. - Location.SlotNumber: Unsigned integer representing the slot number the asset is located in. - Location.AssetState.SystemConnection: String enumeration representing the connection state of the system the asset is currently located in. Possible values are: APPROVED, DISCONNECTED, CONNECTED_UPDATE_PENDING, CONNECTED_UPDATE_SUCCESSFUL, CONNECTED_UPDATE_FAILED, UNSUPPORTED, ACTIVATED. - Location.AssetState.AssetPresence: String enumeration representing the present status of an asset in a system. Possible values are: INITIALIZING, UNKNOWN, NOT_PRESENT, PRESENT. - SupportsSelfCalibration: Boolean flag specifying whether the asset supports self-calibration. - SelfCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was self-calibrated. Example: \"2018-05-20T00:00:00Z\" - SupportsExternalCalibration: Boolean flag specifying whether the asset supports external calibration. - CustomCalibrationInterval: Integer representing the custom calibration interval, in months. - CalibrationStatus: String enumeration representing the calibration status of an asset. Possible values are: OK, APPROACHING_RECOMMENDED_DUE_DATE, PAST_RECOMMENDED_DUE_DATE. - ExternalCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was externally-calibrated. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.NextRecommendedDate: ISO-8601 formatted timestamp string specifying the recommended date for the next external calibration. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.RecommendedInterval: Integer representing the manufacturer-recommended calibration interval, in months. - ExternalCalibration.Comments: String representing any external calibration comments. - ExternalCalibration.IsLimited: Boolean flag specifying whether the last external calibration was a limited calibration. - ExternalCalibration.Operator.DisplayName: String representing the name of the operator which performed an external calibration on a third-party asset.  # noqa: E501

        :return: The asset_filter of this QueryAssetUtilizationsRequest.  # noqa: E501
        :rtype: str
        """
        return self._asset_filter

    @asset_filter.setter
    def asset_filter(self, asset_filter):
        """Sets the asset_filter of this QueryAssetUtilizationsRequest.

        The filter criteria for assets. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset properties that can be used in the filter: - AssetIdentifier: String representing the unique identifier of an asset. - SerialNumber: String representing the serial number of an asset. - ModelName: String representing the model name of an asset. - ModelNumber: Unsigned integer representing the model number of an asset. - VendorName: String representing the vendor name of an asset. - VendorNumber: Unsigned integer representing the vendor number of an asset. - AssetName: String representing the asset name. - FirmwareVersion: String representing the firmware version of an asset. - HardwareVersion: String representing the hardware version of an asset. - BusType: String enumeration representing the bus type of an asset. Possible values are: BUILT_IN_SYSTEM, PCI_PXI, USB, GPIB, VXI, SERIAL, TCP_IP, CRIO, SCXI, CDAQ, SWITCH_BLOCK, SCC, FIRE_WIRE, ACCESSORY, CAN, SWITCH_BLOCK_DEVICE, SLSC. - IsNIAsset: Boolean flag specifying whether the asset is an NI asset or a third-party asset. - Keywords: Collection of string values representing asset metadata keywords. Example: 'Keywords=[\"keyword1\", \"keyword2\"]'. - Properties: Collection of key-value pairs, each key-value pair representing an asset metadata property. Example: 'Properties=[\"key1\":\"value1\", \"key2\":\"value2\"]'. - Location.MinionId: String representing the identifier of the minion in which the asset is located in. - Location.SystemName: String representing the name of the system that the asset is located in. - Location.SlotNumber: Unsigned integer representing the slot number the asset is located in. - Location.AssetState.SystemConnection: String enumeration representing the connection state of the system the asset is currently located in. Possible values are: APPROVED, DISCONNECTED, CONNECTED_UPDATE_PENDING, CONNECTED_UPDATE_SUCCESSFUL, CONNECTED_UPDATE_FAILED, UNSUPPORTED, ACTIVATED. - Location.AssetState.AssetPresence: String enumeration representing the present status of an asset in a system. Possible values are: INITIALIZING, UNKNOWN, NOT_PRESENT, PRESENT. - SupportsSelfCalibration: Boolean flag specifying whether the asset supports self-calibration. - SelfCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was self-calibrated. Example: \"2018-05-20T00:00:00Z\" - SupportsExternalCalibration: Boolean flag specifying whether the asset supports external calibration. - CustomCalibrationInterval: Integer representing the custom calibration interval, in months. - CalibrationStatus: String enumeration representing the calibration status of an asset. Possible values are: OK, APPROACHING_RECOMMENDED_DUE_DATE, PAST_RECOMMENDED_DUE_DATE. - ExternalCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was externally-calibrated. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.NextRecommendedDate: ISO-8601 formatted timestamp string specifying the recommended date for the next external calibration. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.RecommendedInterval: Integer representing the manufacturer-recommended calibration interval, in months. - ExternalCalibration.Comments: String representing any external calibration comments. - ExternalCalibration.IsLimited: Boolean flag specifying whether the last external calibration was a limited calibration. - ExternalCalibration.Operator.DisplayName: String representing the name of the operator which performed an external calibration on a third-party asset.  # noqa: E501

        :param asset_filter: The asset_filter of this QueryAssetUtilizationsRequest.  # noqa: E501
        :type: str
        """

        self._asset_filter = asset_filter

    @property
    def utilization_intervals(self):
        """Gets the utilization_intervals of this QueryAssetUtilizationsRequest.  # noqa: E501

        Multiple time intervals for which to retrieve asset utilization.  # noqa: E501

        :return: The utilization_intervals of this QueryAssetUtilizationsRequest.  # noqa: E501
        :rtype: list[UtilizationTimeIntervalModel]
        """
        return self._utilization_intervals

    @utilization_intervals.setter
    def utilization_intervals(self, utilization_intervals):
        """Sets the utilization_intervals of this QueryAssetUtilizationsRequest.

        Multiple time intervals for which to retrieve asset utilization.  # noqa: E501

        :param utilization_intervals: The utilization_intervals of this QueryAssetUtilizationsRequest.  # noqa: E501
        :type: list[UtilizationTimeIntervalModel]
        """
        if self.local_vars_configuration.client_side_validation and utilization_intervals is None:  # noqa: E501
            raise ValueError("Invalid value for `utilization_intervals`, must not be `None`")  # noqa: E501

        self._utilization_intervals = utilization_intervals

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryAssetUtilizationsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryAssetUtilizationsRequest):
            return True

        return self.to_dict() != other.to_dict()
