# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class QueryAssetsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ids': 'list[str]',
        'response_format': 'ResponseFormat',
        'destination': 'Destination',
        'file_ingestion_workspace': 'str',
        'skip': 'int',
        'take': 'int',
        'calibratable_only': 'bool',
        'filter': 'str'
    }

    attribute_map = {
        'ids': 'ids',
        'response_format': 'responseFormat',
        'destination': 'destination',
        'file_ingestion_workspace': 'fileIngestionWorkspace',
        'skip': 'skip',
        'take': 'take',
        'calibratable_only': 'calibratableOnly',
        'filter': 'filter'
    }

    def __init__(self, ids=None, response_format=None, destination=None, file_ingestion_workspace=None, skip=0, take=1000, calibratable_only=False, filter=None, local_vars_configuration=None):  # noqa: E501
        """QueryAssetsRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ids = None
        self._response_format = None
        self._destination = None
        self._file_ingestion_workspace = None
        self._skip = None
        self._take = None
        self._calibratable_only = None
        self._filter = None
        self.discriminator = None

        if ids is not None:
            self.ids = ids
        if response_format is not None:
            self.response_format = response_format
        if destination is not None:
            self.destination = destination
        if file_ingestion_workspace is not None:
            self.file_ingestion_workspace = file_ingestion_workspace
        if skip is not None:
            self.skip = skip
        if take is not None:
            self.take = take
        if calibratable_only is not None:
            self.calibratable_only = calibratable_only
        if filter is not None:
            self.filter = filter

    @property
    def ids(self):
        """Gets the ids of this QueryAssetsRequest.  # noqa: E501

        Identifiers of the assets to be retrieved.  # noqa: E501

        :return: The ids of this QueryAssetsRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """Sets the ids of this QueryAssetsRequest.

        Identifiers of the assets to be retrieved.  # noqa: E501

        :param ids: The ids of this QueryAssetsRequest.  # noqa: E501
        :type: list[str]
        """

        self._ids = ids

    @property
    def response_format(self):
        """Gets the response_format of this QueryAssetsRequest.  # noqa: E501


        :return: The response_format of this QueryAssetsRequest.  # noqa: E501
        :rtype: ResponseFormat
        """
        return self._response_format

    @response_format.setter
    def response_format(self, response_format):
        """Sets the response_format of this QueryAssetsRequest.


        :param response_format: The response_format of this QueryAssetsRequest.  # noqa: E501
        :type: ResponseFormat
        """

        self._response_format = response_format

    @property
    def destination(self):
        """Gets the destination of this QueryAssetsRequest.  # noqa: E501


        :return: The destination of this QueryAssetsRequest.  # noqa: E501
        :rtype: Destination
        """
        return self._destination

    @destination.setter
    def destination(self, destination):
        """Sets the destination of this QueryAssetsRequest.


        :param destination: The destination of this QueryAssetsRequest.  # noqa: E501
        :type: Destination
        """

        self._destination = destination

    @property
    def file_ingestion_workspace(self):
        """Gets the file_ingestion_workspace of this QueryAssetsRequest.  # noqa: E501

        The ID of the workspace to put the file into, if the destination is \"FILE_SERVICE\".  # noqa: E501

        :return: The file_ingestion_workspace of this QueryAssetsRequest.  # noqa: E501
        :rtype: str
        """
        return self._file_ingestion_workspace

    @file_ingestion_workspace.setter
    def file_ingestion_workspace(self, file_ingestion_workspace):
        """Sets the file_ingestion_workspace of this QueryAssetsRequest.

        The ID of the workspace to put the file into, if the destination is \"FILE_SERVICE\".  # noqa: E501

        :param file_ingestion_workspace: The file_ingestion_workspace of this QueryAssetsRequest.  # noqa: E501
        :type: str
        """

        self._file_ingestion_workspace = file_ingestion_workspace

    @property
    def skip(self):
        """Gets the skip of this QueryAssetsRequest.  # noqa: E501

        The number of resources to skip in the result when paging. For example, a list of 100 resources with a skip value of 50 will return entries 51 through 100.  # noqa: E501

        :return: The skip of this QueryAssetsRequest.  # noqa: E501
        :rtype: int
        """
        return self._skip

    @skip.setter
    def skip(self, skip):
        """Sets the skip of this QueryAssetsRequest.

        The number of resources to skip in the result when paging. For example, a list of 100 resources with a skip value of 50 will return entries 51 through 100.  # noqa: E501

        :param skip: The skip of this QueryAssetsRequest.  # noqa: E501
        :type: int
        """

        self._skip = skip

    @property
    def take(self):
        """Gets the take of this QueryAssetsRequest.  # noqa: E501

        How many resources to return in the result, or -1 to take all. The default is 1000. For example, a list of 100 resources with a take value of 25 will return entries 1 through 25.  # noqa: E501

        :return: The take of this QueryAssetsRequest.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this QueryAssetsRequest.

        How many resources to return in the result, or -1 to take all. The default is 1000. For example, a list of 100 resources with a take value of 25 will return entries 1 through 25.  # noqa: E501

        :param take: The take of this QueryAssetsRequest.  # noqa: E501
        :type: int
        """

        self._take = take

    @property
    def calibratable_only(self):
        """Gets the calibratable_only of this QueryAssetsRequest.  # noqa: E501

        Whether to generate a report with calibrated asset specific columns. When the destination is \"DOWNLOAD or \"FILE_SERVICE\" this property is used as follows: - It determines the type of the report. When true, the file will be a calibration report. If this is false, the file will be an asset report.  - If asset IDs property or the filter string are in the request, this property will not be used for filtering. If no asset IDs are in the request and the filter string is unspecified, setting this property to true will generate a report only for the calibrated assets.  # noqa: E501

        :return: The calibratable_only of this QueryAssetsRequest.  # noqa: E501
        :rtype: bool
        """
        return self._calibratable_only

    @calibratable_only.setter
    def calibratable_only(self, calibratable_only):
        """Sets the calibratable_only of this QueryAssetsRequest.

        Whether to generate a report with calibrated asset specific columns. When the destination is \"DOWNLOAD or \"FILE_SERVICE\" this property is used as follows: - It determines the type of the report. When true, the file will be a calibration report. If this is false, the file will be an asset report.  - If asset IDs property or the filter string are in the request, this property will not be used for filtering. If no asset IDs are in the request and the filter string is unspecified, setting this property to true will generate a report only for the calibrated assets.  # noqa: E501

        :param calibratable_only: The calibratable_only of this QueryAssetsRequest.  # noqa: E501
        :type: bool
        """

        self._calibratable_only = calibratable_only

    @property
    def filter(self):
        """Gets the filter of this QueryAssetsRequest.  # noqa: E501

        The filter criteria for assets. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset properties that can be used in the filter: - AssetIdentifier: String representing the unique identifier of an asset. - SerialNumber: String representing the serial number of an asset. - ModelName: String representing the model name of an asset. - ModelNumber: Unsigned integer representing the model number of an asset. - VendorName: String representing the vendor name of an asset. - VendorNumber: Unsigned integer representing the vendor number of an asset. - AssetName: String representing the asset name. - FirmwareVersion: String representing the firmware version of an asset. - HardwareVersion: String representing the hardware version of an asset. - BusType: String enumeration representing the bus type of an asset. Possible values are: BUILT_IN_SYSTEM, PCI_PXI, USB, GPIB, VXI, SERIAL, TCP_IP, CRIO, SCXI, CDAQ, SWITCH_BLOCK, SCC, FIRE_WIRE, ACCESSORY, CAN, SWITCH_BLOCK_DEVICE, SLSC. - IsNIAsset: Boolean flag specifying whether the asset is an NI asset or a third-party asset. - Keywords: Collection of string values representing asset metadata keywords. Example: 'Keywords=[\"keyword1\", \"keyword2\"]'. - Properties: Collection of key-value pairs, each key-value pair representing an asset metadata property. Example: 'Properties=[\"key1\":\"value1\", \"key2\":\"value2\"]'. - Location.MinionId: String representing the identifier of the minion in which the asset is located in. - Location.SystemName: String representing the name of the system that the asset is located in. - Location.SlotNumber: Unsigned integer representing the slot number the asset is located in. - Location.AssetState.SystemConnection: String enumeration representing the connection state of the system the asset is currently located in. Possible values are: APPROVED, DISCONNECTED, CONNECTED_UPDATE_PENDING, CONNECTED_UPDATE_SUCCESSFUL, CONNECTED_UPDATE_FAILED, UNSUPPORTED, ACTIVATED. - Location.AssetState.AssetPresence: String enumeration representing the present status of an asset in a system. Possible values are: INITIALIZING, UNKNOWN, NOT_PRESENT, PRESENT. - SupportsSelfCalibration: Boolean flag specifying whether the asset supports self-calibration. - SelfCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was self-calibrated. Example: \"2018-05-20T00:00:00Z\" - SupportsExternalCalibration: Boolean flag specifying whether the asset supports external calibration. - CustomCalibrationInterval: Integer representing the custom calibration interval, in months. - CalibrationStatus: String enumeration representing the calibration status of an asset. Possible values are: OK, APPROACHING_RECOMMENDED_DUE_DATE, PAST_RECOMMENDED_DUE_DATE. - ExternalCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was externally-calibrated. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.NextRecommendedDate: ISO-8601 formatted timestamp string specifying the recommended date for the next external calibration. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.RecommendedInterval: Integer representing the manufacturer-recommended calibration interval, in months. - ExternalCalibration.Comments: String representing any external calibration comments. - ExternalCalibration.IsLimited: Boolean flag specifying whether the last external calibration was a limited calibration. - ExternalCalibration.Operator.DisplayName: String representing the name of the operator which performed an external calibration on a third-party asset.  # noqa: E501

        :return: The filter of this QueryAssetsRequest.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this QueryAssetsRequest.

        The filter criteria for assets. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and'. Example: 'x and y' - Logical OR operator 'or'. Example: 'x or y' - Contains operator '.Contains()', used to check whether a string contains another string. Example: 'x.Contains(y)' - Does not contain operator '!.Contains()', used to check whether a string does not contain another string. Example: '!x.Contains(y)'  Valid asset properties that can be used in the filter: - AssetIdentifier: String representing the unique identifier of an asset. - SerialNumber: String representing the serial number of an asset. - ModelName: String representing the model name of an asset. - ModelNumber: Unsigned integer representing the model number of an asset. - VendorName: String representing the vendor name of an asset. - VendorNumber: Unsigned integer representing the vendor number of an asset. - AssetName: String representing the asset name. - FirmwareVersion: String representing the firmware version of an asset. - HardwareVersion: String representing the hardware version of an asset. - BusType: String enumeration representing the bus type of an asset. Possible values are: BUILT_IN_SYSTEM, PCI_PXI, USB, GPIB, VXI, SERIAL, TCP_IP, CRIO, SCXI, CDAQ, SWITCH_BLOCK, SCC, FIRE_WIRE, ACCESSORY, CAN, SWITCH_BLOCK_DEVICE, SLSC. - IsNIAsset: Boolean flag specifying whether the asset is an NI asset or a third-party asset. - Keywords: Collection of string values representing asset metadata keywords. Example: 'Keywords=[\"keyword1\", \"keyword2\"]'. - Properties: Collection of key-value pairs, each key-value pair representing an asset metadata property. Example: 'Properties=[\"key1\":\"value1\", \"key2\":\"value2\"]'. - Location.MinionId: String representing the identifier of the minion in which the asset is located in. - Location.SystemName: String representing the name of the system that the asset is located in. - Location.SlotNumber: Unsigned integer representing the slot number the asset is located in. - Location.AssetState.SystemConnection: String enumeration representing the connection state of the system the asset is currently located in. Possible values are: APPROVED, DISCONNECTED, CONNECTED_UPDATE_PENDING, CONNECTED_UPDATE_SUCCESSFUL, CONNECTED_UPDATE_FAILED, UNSUPPORTED, ACTIVATED. - Location.AssetState.AssetPresence: String enumeration representing the present status of an asset in a system. Possible values are: INITIALIZING, UNKNOWN, NOT_PRESENT, PRESENT. - SupportsSelfCalibration: Boolean flag specifying whether the asset supports self-calibration. - SelfCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was self-calibrated. Example: \"2018-05-20T00:00:00Z\" - SupportsExternalCalibration: Boolean flag specifying whether the asset supports external calibration. - CustomCalibrationInterval: Integer representing the custom calibration interval, in months. - CalibrationStatus: String enumeration representing the calibration status of an asset. Possible values are: OK, APPROACHING_RECOMMENDED_DUE_DATE, PAST_RECOMMENDED_DUE_DATE. - ExternalCalibration.CalibrationDate: ISO-8601 formatted timestamp string specifying the last date the asset was externally-calibrated. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.NextRecommendedDate: ISO-8601 formatted timestamp string specifying the recommended date for the next external calibration. Example: \"2018-05-20T00:00:00Z\" - ExternalCalibration.RecommendedInterval: Integer representing the manufacturer-recommended calibration interval, in months. - ExternalCalibration.Comments: String representing any external calibration comments. - ExternalCalibration.IsLimited: Boolean flag specifying whether the last external calibration was a limited calibration. - ExternalCalibration.Operator.DisplayName: String representing the name of the operator which performed an external calibration on a third-party asset.  # noqa: E501

        :param filter: The filter of this QueryAssetsRequest.  # noqa: E501
        :type: str
        """

        self._filter = filter

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryAssetsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryAssetsRequest):
            return True

        return self.to_dict() != other.to_dict()
