# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class SelfCalibrationModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'temperature_sensors': 'list[TemperatureSensorModel]',
        'is_limited': 'bool',
        'date': 'datetime'
    }

    attribute_map = {
        'temperature_sensors': 'temperatureSensors',
        'is_limited': 'isLimited',
        'date': 'date'
    }

    def __init__(self, temperature_sensors=None, is_limited=None, date=None, local_vars_configuration=None):  # noqa: E501
        """SelfCalibrationModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._temperature_sensors = None
        self._is_limited = None
        self._date = None
        self.discriminator = None

        if temperature_sensors is not None:
            self.temperature_sensors = temperature_sensors
        if is_limited is not None:
            self.is_limited = is_limited
        self.date = date

    @property
    def temperature_sensors(self):
        """Gets the temperature_sensors of this SelfCalibrationModel.  # noqa: E501

        An array of temperature sensor information.  # noqa: E501

        :return: The temperature_sensors of this SelfCalibrationModel.  # noqa: E501
        :rtype: list[TemperatureSensorModel]
        """
        return self._temperature_sensors

    @temperature_sensors.setter
    def temperature_sensors(self, temperature_sensors):
        """Sets the temperature_sensors of this SelfCalibrationModel.

        An array of temperature sensor information.  # noqa: E501

        :param temperature_sensors: The temperature_sensors of this SelfCalibrationModel.  # noqa: E501
        :type: list[TemperatureSensorModel]
        """

        self._temperature_sensors = temperature_sensors

    @property
    def is_limited(self):
        """Gets the is_limited of this SelfCalibrationModel.  # noqa: E501

        Whether the last self-calibration of the asset was a limited calibration.  # noqa: E501

        :return: The is_limited of this SelfCalibrationModel.  # noqa: E501
        :rtype: bool
        """
        return self._is_limited

    @is_limited.setter
    def is_limited(self, is_limited):
        """Sets the is_limited of this SelfCalibrationModel.

        Whether the last self-calibration of the asset was a limited calibration.  # noqa: E501

        :param is_limited: The is_limited of this SelfCalibrationModel.  # noqa: E501
        :type: bool
        """

        self._is_limited = is_limited

    @property
    def date(self):
        """Gets the date of this SelfCalibrationModel.  # noqa: E501

        ISO-8601 formatted timestamp specifying the last date the asset was self-calibrated.  # noqa: E501

        :return: The date of this SelfCalibrationModel.  # noqa: E501
        :rtype: datetime
        """
        return self._date

    @date.setter
    def date(self, date):
        """Sets the date of this SelfCalibrationModel.

        ISO-8601 formatted timestamp specifying the last date the asset was self-calibrated.  # noqa: E501

        :param date: The date of this SelfCalibrationModel.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and date is None:  # noqa: E501
            raise ValueError("Invalid value for `date`, must not be `None`")  # noqa: E501

        self._date = date

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SelfCalibrationModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SelfCalibrationModel):
            return True

        return self.to_dict() != other.to_dict()
