# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class StartUtilizationRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'utilization_identifier': 'str',
        'minion_id': 'str',
        'asset_identifications': 'list[AssetIdentificationModel]',
        'utilization_category': 'str',
        'task_name': 'str',
        'user_name': 'str',
        'utilization_timestamp': 'datetime'
    }

    attribute_map = {
        'utilization_identifier': 'utilizationIdentifier',
        'minion_id': 'minionId',
        'asset_identifications': 'assetIdentifications',
        'utilization_category': 'utilizationCategory',
        'task_name': 'taskName',
        'user_name': 'userName',
        'utilization_timestamp': 'utilizationTimestamp'
    }

    def __init__(self, utilization_identifier=None, minion_id=None, asset_identifications=None, utilization_category=None, task_name=None, user_name=None, utilization_timestamp=None, local_vars_configuration=None):  # noqa: E501
        """StartUtilizationRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._utilization_identifier = None
        self._minion_id = None
        self._asset_identifications = None
        self._utilization_category = None
        self._task_name = None
        self._user_name = None
        self._utilization_timestamp = None
        self.discriminator = None

        self.utilization_identifier = utilization_identifier
        self.minion_id = minion_id
        self.asset_identifications = asset_identifications
        self.utilization_category = utilization_category
        if task_name is not None:
            self.task_name = task_name
        if user_name is not None:
            self.user_name = user_name
        self.utilization_timestamp = utilization_timestamp

    @property
    def utilization_identifier(self):
        """Gets the utilization_identifier of this StartUtilizationRequest.  # noqa: E501

        String representing the unique identifier of an asset utilization history record.  # noqa: E501

        :return: The utilization_identifier of this StartUtilizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._utilization_identifier

    @utilization_identifier.setter
    def utilization_identifier(self, utilization_identifier):
        """Sets the utilization_identifier of this StartUtilizationRequest.

        String representing the unique identifier of an asset utilization history record.  # noqa: E501

        :param utilization_identifier: The utilization_identifier of this StartUtilizationRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and utilization_identifier is None:  # noqa: E501
            raise ValueError("Invalid value for `utilization_identifier`, must not be `None`")  # noqa: E501

        self._utilization_identifier = utilization_identifier

    @property
    def minion_id(self):
        """Gets the minion_id of this StartUtilizationRequest.  # noqa: E501

        Identifier of the minion where the utilized assets are located.  # noqa: E501

        :return: The minion_id of this StartUtilizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._minion_id

    @minion_id.setter
    def minion_id(self, minion_id):
        """Sets the minion_id of this StartUtilizationRequest.

        Identifier of the minion where the utilized assets are located.  # noqa: E501

        :param minion_id: The minion_id of this StartUtilizationRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and minion_id is None:  # noqa: E501
            raise ValueError("Invalid value for `minion_id`, must not be `None`")  # noqa: E501

        self._minion_id = minion_id

    @property
    def asset_identifications(self):
        """Gets the asset_identifications of this StartUtilizationRequest.  # noqa: E501

        Array of the identification information for the assets which are utilized.  # noqa: E501

        :return: The asset_identifications of this StartUtilizationRequest.  # noqa: E501
        :rtype: list[AssetIdentificationModel]
        """
        return self._asset_identifications

    @asset_identifications.setter
    def asset_identifications(self, asset_identifications):
        """Sets the asset_identifications of this StartUtilizationRequest.

        Array of the identification information for the assets which are utilized.  # noqa: E501

        :param asset_identifications: The asset_identifications of this StartUtilizationRequest.  # noqa: E501
        :type: list[AssetIdentificationModel]
        """
        if self.local_vars_configuration.client_side_validation and asset_identifications is None:  # noqa: E501
            raise ValueError("Invalid value for `asset_identifications`, must not be `None`")  # noqa: E501

        self._asset_identifications = asset_identifications

    @property
    def utilization_category(self):
        """Gets the utilization_category of this StartUtilizationRequest.  # noqa: E501

        String representing the utilization category.  # noqa: E501

        :return: The utilization_category of this StartUtilizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._utilization_category

    @utilization_category.setter
    def utilization_category(self, utilization_category):
        """Sets the utilization_category of this StartUtilizationRequest.

        String representing the utilization category.  # noqa: E501

        :param utilization_category: The utilization_category of this StartUtilizationRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and utilization_category is None:  # noqa: E501
            raise ValueError("Invalid value for `utilization_category`, must not be `None`")  # noqa: E501

        self._utilization_category = utilization_category

    @property
    def task_name(self):
        """Gets the task_name of this StartUtilizationRequest.  # noqa: E501

        String representing the name of the task.  # noqa: E501

        :return: The task_name of this StartUtilizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._task_name

    @task_name.setter
    def task_name(self, task_name):
        """Sets the task_name of this StartUtilizationRequest.

        String representing the name of the task.  # noqa: E501

        :param task_name: The task_name of this StartUtilizationRequest.  # noqa: E501
        :type: str
        """

        self._task_name = task_name

    @property
    def user_name(self):
        """Gets the user_name of this StartUtilizationRequest.  # noqa: E501

        String representing the name of the operator who utilized the asset.  # noqa: E501

        :return: The user_name of this StartUtilizationRequest.  # noqa: E501
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this StartUtilizationRequest.

        String representing the name of the operator who utilized the asset.  # noqa: E501

        :param user_name: The user_name of this StartUtilizationRequest.  # noqa: E501
        :type: str
        """

        self._user_name = user_name

    @property
    def utilization_timestamp(self):
        """Gets the utilization_timestamp of this StartUtilizationRequest.  # noqa: E501

        A date time value which can be used to specify the start of an utilization. This parameter must have the \"ISO 8601\" format in order to be considered valid.  # noqa: E501

        :return: The utilization_timestamp of this StartUtilizationRequest.  # noqa: E501
        :rtype: datetime
        """
        return self._utilization_timestamp

    @utilization_timestamp.setter
    def utilization_timestamp(self, utilization_timestamp):
        """Sets the utilization_timestamp of this StartUtilizationRequest.

        A date time value which can be used to specify the start of an utilization. This parameter must have the \"ISO 8601\" format in order to be considered valid.  # noqa: E501

        :param utilization_timestamp: The utilization_timestamp of this StartUtilizationRequest.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and utilization_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `utilization_timestamp`, must not be `None`")  # noqa: E501

        self._utilization_timestamp = utilization_timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StartUtilizationRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StartUtilizationRequest):
            return True

        return self.to_dict() != other.to_dict()
