# coding: utf-8

"""
    Asset Performance Management Web Service

    Asset Performance Management HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapm.configuration import Configuration


class UtilizationWithPercentageModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'start_timestamp': 'datetime',
        'end_timestamp': 'datetime',
        'asset_identifier': 'str',
        'asset_name': 'str',
        'minion_id': 'str',
        'category': 'str',
        'percentage': 'float'
    }

    attribute_map = {
        'start_timestamp': 'startTimestamp',
        'end_timestamp': 'endTimestamp',
        'asset_identifier': 'assetIdentifier',
        'asset_name': 'assetName',
        'minion_id': 'minionId',
        'category': 'category',
        'percentage': 'percentage'
    }

    def __init__(self, start_timestamp=None, end_timestamp=None, asset_identifier=None, asset_name=None, minion_id=None, category=None, percentage=None, local_vars_configuration=None):  # noqa: E501
        """UtilizationWithPercentageModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._start_timestamp = None
        self._end_timestamp = None
        self._asset_identifier = None
        self._asset_name = None
        self._minion_id = None
        self._category = None
        self._percentage = None
        self.discriminator = None

        self.start_timestamp = start_timestamp
        self.end_timestamp = end_timestamp
        self.asset_identifier = asset_identifier
        if asset_name is not None:
            self.asset_name = asset_name
        if minion_id is not None:
            self.minion_id = minion_id
        if category is not None:
            self.category = category
        self.percentage = percentage

    @property
    def start_timestamp(self):
        """Gets the start_timestamp of this UtilizationWithPercentageModel.  # noqa: E501

        A date time value representing the beginning of an asset utilization interval. This parameter has the \"ISO 8601\" format in order to be considered valid.  # noqa: E501

        :return: The start_timestamp of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: datetime
        """
        return self._start_timestamp

    @start_timestamp.setter
    def start_timestamp(self, start_timestamp):
        """Sets the start_timestamp of this UtilizationWithPercentageModel.

        A date time value representing the beginning of an asset utilization interval. This parameter has the \"ISO 8601\" format in order to be considered valid.  # noqa: E501

        :param start_timestamp: The start_timestamp of this UtilizationWithPercentageModel.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and start_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `start_timestamp`, must not be `None`")  # noqa: E501

        self._start_timestamp = start_timestamp

    @property
    def end_timestamp(self):
        """Gets the end_timestamp of this UtilizationWithPercentageModel.  # noqa: E501

        A date time value representing the end of an asset utilization interval. This parameter has the \"ISO 8601\" format in order to be considered valid.  # noqa: E501

        :return: The end_timestamp of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: datetime
        """
        return self._end_timestamp

    @end_timestamp.setter
    def end_timestamp(self, end_timestamp):
        """Sets the end_timestamp of this UtilizationWithPercentageModel.

        A date time value representing the end of an asset utilization interval. This parameter has the \"ISO 8601\" format in order to be considered valid.  # noqa: E501

        :param end_timestamp: The end_timestamp of this UtilizationWithPercentageModel.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and end_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `end_timestamp`, must not be `None`")  # noqa: E501

        self._end_timestamp = end_timestamp

    @property
    def asset_identifier(self):
        """Gets the asset_identifier of this UtilizationWithPercentageModel.  # noqa: E501

        String representing the unique identifier of an asset.  # noqa: E501

        :return: The asset_identifier of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: str
        """
        return self._asset_identifier

    @asset_identifier.setter
    def asset_identifier(self, asset_identifier):
        """Sets the asset_identifier of this UtilizationWithPercentageModel.

        String representing the unique identifier of an asset.  # noqa: E501

        :param asset_identifier: The asset_identifier of this UtilizationWithPercentageModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and asset_identifier is None:  # noqa: E501
            raise ValueError("Invalid value for `asset_identifier`, must not be `None`")  # noqa: E501

        self._asset_identifier = asset_identifier

    @property
    def asset_name(self):
        """Gets the asset_name of this UtilizationWithPercentageModel.  # noqa: E501

        String representing the name of an asset.  # noqa: E501

        :return: The asset_name of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: str
        """
        return self._asset_name

    @asset_name.setter
    def asset_name(self, asset_name):
        """Sets the asset_name of this UtilizationWithPercentageModel.

        String representing the name of an asset.  # noqa: E501

        :param asset_name: The asset_name of this UtilizationWithPercentageModel.  # noqa: E501
        :type: str
        """

        self._asset_name = asset_name

    @property
    def minion_id(self):
        """Gets the minion_id of this UtilizationWithPercentageModel.  # noqa: E501

        Identifier of the minion where the asset is located.  # noqa: E501

        :return: The minion_id of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: str
        """
        return self._minion_id

    @minion_id.setter
    def minion_id(self, minion_id):
        """Sets the minion_id of this UtilizationWithPercentageModel.

        Identifier of the minion where the asset is located.  # noqa: E501

        :param minion_id: The minion_id of this UtilizationWithPercentageModel.  # noqa: E501
        :type: str
        """

        self._minion_id = minion_id

    @property
    def category(self):
        """Gets the category of this UtilizationWithPercentageModel.  # noqa: E501

        String representing the utilization task category.  # noqa: E501

        :return: The category of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this UtilizationWithPercentageModel.

        String representing the utilization task category.  # noqa: E501

        :param category: The category of this UtilizationWithPercentageModel.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def percentage(self):
        """Gets the percentage of this UtilizationWithPercentageModel.  # noqa: E501

        Percentage of time that the asset was utilized in the specified time interval.  # noqa: E501

        :return: The percentage of this UtilizationWithPercentageModel.  # noqa: E501
        :rtype: float
        """
        return self._percentage

    @percentage.setter
    def percentage(self, percentage):
        """Sets the percentage of this UtilizationWithPercentageModel.

        Percentage of time that the asset was utilized in the specified time interval.  # noqa: E501

        :param percentage: The percentage of this UtilizationWithPercentageModel.  # noqa: E501
        :type: float
        """
        if self.local_vars_configuration.client_side_validation and percentage is None:  # noqa: E501
            raise ValueError("Invalid value for `percentage`, must not be `None`")  # noqa: E501

        self._percentage = percentage

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UtilizationWithPercentageModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UtilizationWithPercentageModel):
            return True

        return self.to_dict() != other.to_dict()
