# coding: utf-8

"""
    Asset Performance Management Rule Web Service

    Create and manage calibration rules for assets.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapmrule.configuration import Configuration


class CalibrationRulePutRequestModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'display_name': 'str',
        'description': 'str',
        'disabled': 'bool',
        'instance_display_name_template': 'str',
        'instance_description_template': 'str',
        'severity_levels': 'list[CalibrationSeverityModel]'
    }

    attribute_map = {
        'display_name': 'displayName',
        'description': 'description',
        'disabled': 'disabled',
        'instance_display_name_template': 'instanceDisplayNameTemplate',
        'instance_description_template': 'instanceDescriptionTemplate',
        'severity_levels': 'severityLevels'
    }

    def __init__(self, display_name=None, description=None, disabled=None, instance_display_name_template=None, instance_description_template=None, severity_levels=None, local_vars_configuration=None):  # noqa: E501
        """CalibrationRulePutRequestModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._display_name = None
        self._description = None
        self._disabled = None
        self._instance_display_name_template = None
        self._instance_description_template = None
        self._severity_levels = None
        self.discriminator = None

        self.display_name = display_name
        self.description = description
        self.disabled = disabled
        self.instance_display_name_template = instance_display_name_template
        self.instance_description_template = instance_description_template
        self.severity_levels = severity_levels

    @property
    def display_name(self):
        """Gets the display_name of this CalibrationRulePutRequestModel.  # noqa: E501

        Display name of the rule.  # noqa: E501

        :return: The display_name of this CalibrationRulePutRequestModel.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this CalibrationRulePutRequestModel.

        Display name of the rule.  # noqa: E501

        :param display_name: The display_name of this CalibrationRulePutRequestModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and display_name is None:  # noqa: E501
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this CalibrationRulePutRequestModel.  # noqa: E501

        Description of what the rule does.  # noqa: E501

        :return: The description of this CalibrationRulePutRequestModel.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this CalibrationRulePutRequestModel.

        Description of what the rule does.  # noqa: E501

        :param description: The description of this CalibrationRulePutRequestModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and description is None:  # noqa: E501
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501

        self._description = description

    @property
    def disabled(self):
        """Gets the disabled of this CalibrationRulePutRequestModel.  # noqa: E501

        Whether or not the rule is disabled.  # noqa: E501

        :return: The disabled of this CalibrationRulePutRequestModel.  # noqa: E501
        :rtype: bool
        """
        return self._disabled

    @disabled.setter
    def disabled(self, disabled):
        """Sets the disabled of this CalibrationRulePutRequestModel.

        Whether or not the rule is disabled.  # noqa: E501

        :param disabled: The disabled of this CalibrationRulePutRequestModel.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and disabled is None:  # noqa: E501
            raise ValueError("Invalid value for `disabled`, must not be `None`")  # noqa: E501

        self._disabled = disabled

    @property
    def instance_display_name_template(self):
        """Gets the instance_display_name_template of this CalibrationRulePutRequestModel.  # noqa: E501

        Template used for the display name that appears on an alarm instance created by this rule.  # noqa: E501

        :return: The instance_display_name_template of this CalibrationRulePutRequestModel.  # noqa: E501
        :rtype: str
        """
        return self._instance_display_name_template

    @instance_display_name_template.setter
    def instance_display_name_template(self, instance_display_name_template):
        """Sets the instance_display_name_template of this CalibrationRulePutRequestModel.

        Template used for the display name that appears on an alarm instance created by this rule.  # noqa: E501

        :param instance_display_name_template: The instance_display_name_template of this CalibrationRulePutRequestModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and instance_display_name_template is None:  # noqa: E501
            raise ValueError("Invalid value for `instance_display_name_template`, must not be `None`")  # noqa: E501

        self._instance_display_name_template = instance_display_name_template

    @property
    def instance_description_template(self):
        """Gets the instance_description_template of this CalibrationRulePutRequestModel.  # noqa: E501

        Template used for the description that appears on an alarm instance created by this rule.  # noqa: E501

        :return: The instance_description_template of this CalibrationRulePutRequestModel.  # noqa: E501
        :rtype: str
        """
        return self._instance_description_template

    @instance_description_template.setter
    def instance_description_template(self, instance_description_template):
        """Sets the instance_description_template of this CalibrationRulePutRequestModel.

        Template used for the description that appears on an alarm instance created by this rule.  # noqa: E501

        :param instance_description_template: The instance_description_template of this CalibrationRulePutRequestModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and instance_description_template is None:  # noqa: E501
            raise ValueError("Invalid value for `instance_description_template`, must not be `None`")  # noqa: E501

        self._instance_description_template = instance_description_template

    @property
    def severity_levels(self):
        """Gets the severity_levels of this CalibrationRulePutRequestModel.  # noqa: E501

        Severity levels for the alarm rule.  # noqa: E501

        :return: The severity_levels of this CalibrationRulePutRequestModel.  # noqa: E501
        :rtype: list[CalibrationSeverityModel]
        """
        return self._severity_levels

    @severity_levels.setter
    def severity_levels(self, severity_levels):
        """Sets the severity_levels of this CalibrationRulePutRequestModel.

        Severity levels for the alarm rule.  # noqa: E501

        :param severity_levels: The severity_levels of this CalibrationRulePutRequestModel.  # noqa: E501
        :type: list[CalibrationSeverityModel]
        """
        if self.local_vars_configuration.client_side_validation and severity_levels is None:  # noqa: E501
            raise ValueError("Invalid value for `severity_levels`, must not be `None`")  # noqa: E501

        self._severity_levels = severity_levels

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalibrationRulePutRequestModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CalibrationRulePutRequestModel):
            return True

        return self.to_dict() != other.to_dict()
