# coding: utf-8

"""
    Asset Performance Management Rule Web Service

    Create and manage calibration rules for assets.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapmrule.configuration import Configuration


class CalibrationRulesResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'calibration_rules': 'list[CalibrationRuleModel]',
        'total_count': 'int'
    }

    attribute_map = {
        'calibration_rules': 'calibrationRules',
        'total_count': 'totalCount'
    }

    def __init__(self, calibration_rules=None, total_count=None, local_vars_configuration=None):  # noqa: E501
        """CalibrationRulesResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._calibration_rules = None
        self._total_count = None
        self.discriminator = None

        self.calibration_rules = calibration_rules
        self.total_count = total_count

    @property
    def calibration_rules(self):
        """Gets the calibration_rules of this CalibrationRulesResponse.  # noqa: E501

        Array of calibration rules.  # noqa: E501

        :return: The calibration_rules of this CalibrationRulesResponse.  # noqa: E501
        :rtype: list[CalibrationRuleModel]
        """
        return self._calibration_rules

    @calibration_rules.setter
    def calibration_rules(self, calibration_rules):
        """Sets the calibration_rules of this CalibrationRulesResponse.

        Array of calibration rules.  # noqa: E501

        :param calibration_rules: The calibration_rules of this CalibrationRulesResponse.  # noqa: E501
        :type: list[CalibrationRuleModel]
        """
        if self.local_vars_configuration.client_side_validation and calibration_rules is None:  # noqa: E501
            raise ValueError("Invalid value for `calibration_rules`, must not be `None`")  # noqa: E501

        self._calibration_rules = calibration_rules

    @property
    def total_count(self):
        """Gets the total_count of this CalibrationRulesResponse.  # noqa: E501

        The total number of calibration rules.  # noqa: E501

        :return: The total_count of this CalibrationRulesResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this CalibrationRulesResponse.

        The total number of calibration rules.  # noqa: E501

        :param total_count: The total_count of this CalibrationRulesResponse.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and total_count is None:  # noqa: E501
            raise ValueError("Invalid value for `total_count`, must not be `None`")  # noqa: E501

        self._total_count = total_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalibrationRulesResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CalibrationRulesResponse):
            return True

        return self.to_dict() != other.to_dict()
