# coding: utf-8

"""
    Asset Performance Management Rule Web Service

    Create and manage calibration rules for assets.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapmrule.configuration import Configuration


class CalibrationSeverityModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'severity_level': 'int',
        'notification_strategy_ids': 'list[str]',
        'days_until_calibration_due': 'int'
    }

    attribute_map = {
        'name': 'name',
        'severity_level': 'severityLevel',
        'notification_strategy_ids': 'notificationStrategyIds',
        'days_until_calibration_due': 'daysUntilCalibrationDue'
    }

    def __init__(self, name=None, severity_level=None, notification_strategy_ids=None, days_until_calibration_due=None, local_vars_configuration=None):  # noqa: E501
        """CalibrationSeverityModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._severity_level = None
        self._notification_strategy_ids = None
        self._days_until_calibration_due = None
        self.discriminator = None

        self.name = name
        self.severity_level = severity_level
        if notification_strategy_ids is not None:
            self.notification_strategy_ids = notification_strategy_ids
        self.days_until_calibration_due = days_until_calibration_due

    @property
    def name(self):
        """Gets the name of this CalibrationSeverityModel.  # noqa: E501

        The name of the severity.  # noqa: E501

        :return: The name of this CalibrationSeverityModel.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CalibrationSeverityModel.

        The name of the severity.  # noqa: E501

        :param name: The name of this CalibrationSeverityModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def severity_level(self):
        """Gets the severity_level of this CalibrationSeverityModel.  # noqa: E501

        The level of the severity.  # noqa: E501

        :return: The severity_level of this CalibrationSeverityModel.  # noqa: E501
        :rtype: int
        """
        return self._severity_level

    @severity_level.setter
    def severity_level(self, severity_level):
        """Sets the severity_level of this CalibrationSeverityModel.

        The level of the severity.  # noqa: E501

        :param severity_level: The severity_level of this CalibrationSeverityModel.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and severity_level is None:  # noqa: E501
            raise ValueError("Invalid value for `severity_level`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                severity_level is not None and severity_level > 4):  # noqa: E501
            raise ValueError("Invalid value for `severity_level`, must be a value less than or equal to `4`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                severity_level is not None and severity_level < 1):  # noqa: E501
            raise ValueError("Invalid value for `severity_level`, must be a value greater than or equal to `1`")  # noqa: E501

        self._severity_level = severity_level

    @property
    def notification_strategy_ids(self):
        """Gets the notification_strategy_ids of this CalibrationSeverityModel.  # noqa: E501

        The unique identifiers for notification strategies to use when this rule is triggered for an asset.  # noqa: E501

        :return: The notification_strategy_ids of this CalibrationSeverityModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_strategy_ids

    @notification_strategy_ids.setter
    def notification_strategy_ids(self, notification_strategy_ids):
        """Sets the notification_strategy_ids of this CalibrationSeverityModel.

        The unique identifiers for notification strategies to use when this rule is triggered for an asset.  # noqa: E501

        :param notification_strategy_ids: The notification_strategy_ids of this CalibrationSeverityModel.  # noqa: E501
        :type: list[str]
        """

        self._notification_strategy_ids = notification_strategy_ids

    @property
    def days_until_calibration_due(self):
        """Gets the days_until_calibration_due of this CalibrationSeverityModel.  # noqa: E501

        The number of days until recommended calibration due date to trigger the alarm.  # noqa: E501

        :return: The days_until_calibration_due of this CalibrationSeverityModel.  # noqa: E501
        :rtype: int
        """
        return self._days_until_calibration_due

    @days_until_calibration_due.setter
    def days_until_calibration_due(self, days_until_calibration_due):
        """Sets the days_until_calibration_due of this CalibrationSeverityModel.

        The number of days until recommended calibration due date to trigger the alarm.  # noqa: E501

        :param days_until_calibration_due: The days_until_calibration_due of this CalibrationSeverityModel.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and days_until_calibration_due is None:  # noqa: E501
            raise ValueError("Invalid value for `days_until_calibration_due`, must not be `None`")  # noqa: E501

        self._days_until_calibration_due = days_until_calibration_due

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CalibrationSeverityModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CalibrationSeverityModel):
            return True

        return self.to_dict() != other.to_dict()
