# coding: utf-8

"""
    Asset Performance Management Rule Web Service

    Create and manage calibration rules for assets.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niapmrule.configuration import Configuration


class RuleStateUpdateModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'rule_ids': 'list[str]',
        'disabled': 'bool'
    }

    attribute_map = {
        'rule_ids': 'ruleIds',
        'disabled': 'disabled'
    }

    def __init__(self, rule_ids=None, disabled=None, local_vars_configuration=None):  # noqa: E501
        """RuleStateUpdateModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._rule_ids = None
        self._disabled = None
        self.discriminator = None

        self.rule_ids = rule_ids
        self.disabled = disabled

    @property
    def rule_ids(self):
        """Gets the rule_ids of this RuleStateUpdateModel.  # noqa: E501

        Array containing the rule identifiers on which to set the enable/disable state.  # noqa: E501

        :return: The rule_ids of this RuleStateUpdateModel.  # noqa: E501
        :rtype: list[str]
        """
        return self._rule_ids

    @rule_ids.setter
    def rule_ids(self, rule_ids):
        """Sets the rule_ids of this RuleStateUpdateModel.

        Array containing the rule identifiers on which to set the enable/disable state.  # noqa: E501

        :param rule_ids: The rule_ids of this RuleStateUpdateModel.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and rule_ids is None:  # noqa: E501
            raise ValueError("Invalid value for `rule_ids`, must not be `None`")  # noqa: E501

        self._rule_ids = rule_ids

    @property
    def disabled(self):
        """Gets the disabled of this RuleStateUpdateModel.  # noqa: E501

        Whether or not to disable all the specified rules.  # noqa: E501

        :return: The disabled of this RuleStateUpdateModel.  # noqa: E501
        :rtype: bool
        """
        return self._disabled

    @disabled.setter
    def disabled(self, disabled):
        """Sets the disabled of this RuleStateUpdateModel.

        Whether or not to disable all the specified rules.  # noqa: E501

        :param disabled: The disabled of this RuleStateUpdateModel.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and disabled is None:  # noqa: E501
            raise ValueError("Invalid value for `disabled`, must not be `None`")  # noqa: E501

        self._disabled = disabled

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RuleStateUpdateModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RuleStateUpdateModel):
            return True

        return self.to_dict() != other.to_dict()
