# coding: utf-8

"""
    SystemLink File Service

    Upload and download files from a SystemLink server  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nifile.configuration import Configuration


class FileMetadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'dict(str, Link)',
        'created': 'datetime',
        'id': 'str',
        'path': 'str',
        'properties': 'dict(str, str)',
        'meta_data_revision': 'int',
        'service_group': 'str',
        'size': 'int',
        'size64': 'int',
        'workspace': 'str',
        'last_updated_timestamp': 'datetime'
    }

    attribute_map = {
        'links': '_links',
        'created': 'created',
        'id': 'id',
        'path': 'path',
        'properties': 'properties',
        'meta_data_revision': 'metaDataRevision',
        'service_group': 'serviceGroup',
        'size': 'size',
        'size64': 'size64',
        'workspace': 'workspace',
        'last_updated_timestamp': 'lastUpdatedTimestamp'
    }

    def __init__(self, links=None, created=None, id=None, path=None, properties=None, meta_data_revision=None, service_group=None, size=None, size64=None, workspace=None, last_updated_timestamp=None, local_vars_configuration=None):  # noqa: E501
        """FileMetadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._created = None
        self._id = None
        self._path = None
        self._properties = None
        self._meta_data_revision = None
        self._service_group = None
        self._size = None
        self._size64 = None
        self._workspace = None
        self._last_updated_timestamp = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if created is not None:
            self.created = created
        if id is not None:
            self.id = id
        if path is not None:
            self.path = path
        if properties is not None:
            self.properties = properties
        if meta_data_revision is not None:
            self.meta_data_revision = meta_data_revision
        if service_group is not None:
            self.service_group = service_group
        if size is not None:
            self.size = size
        if size64 is not None:
            self.size64 = size64
        if workspace is not None:
            self.workspace = workspace
        if last_updated_timestamp is not None:
            self.last_updated_timestamp = last_updated_timestamp

    @property
    def links(self):
        """Gets the links of this FileMetadata.  # noqa: E501

        The links to access and manipulate the file: - data: Link to download the file using a GET request - delete: Link to delete the file using a DELETE request - self: Link to the file's metadata - updateMetadata: Link to update the file's metadata using a POST request  # noqa: E501

        :return: The links of this FileMetadata.  # noqa: E501
        :rtype: dict(str, Link)
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this FileMetadata.

        The links to access and manipulate the file: - data: Link to download the file using a GET request - delete: Link to delete the file using a DELETE request - self: Link to the file's metadata - updateMetadata: Link to update the file's metadata using a POST request  # noqa: E501

        :param links: The links of this FileMetadata.  # noqa: E501
        :type: dict(str, Link)
        """

        self._links = links

    @property
    def created(self):
        """Gets the created of this FileMetadata.  # noqa: E501

        The date and time the file was created in the file service  # noqa: E501

        :return: The created of this FileMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this FileMetadata.

        The date and time the file was created in the file service  # noqa: E501

        :param created: The created of this FileMetadata.  # noqa: E501
        :type: datetime
        """

        self._created = created

    @property
    def id(self):
        """Gets the id of this FileMetadata.  # noqa: E501

        The file's ID within the service group  # noqa: E501

        :return: The id of this FileMetadata.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this FileMetadata.

        The file's ID within the service group  # noqa: E501

        :param id: The id of this FileMetadata.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def path(self):
        """Gets the path of this FileMetadata.  # noqa: E501

        The path to the file on the server.  This field is returned only if the user has associated privileges to view file paths.  # noqa: E501

        :return: The path of this FileMetadata.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this FileMetadata.

        The path to the file on the server.  This field is returned only if the user has associated privileges to view file paths.  # noqa: E501

        :param path: The path of this FileMetadata.  # noqa: E501
        :type: str
        """

        self._path = path

    @property
    def properties(self):
        """Gets the properties of this FileMetadata.  # noqa: E501

        The file's properties  # noqa: E501

        :return: The properties of this FileMetadata.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this FileMetadata.

        The file's properties  # noqa: E501

        :param properties: The properties of this FileMetadata.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def meta_data_revision(self):
        """Gets the meta_data_revision of this FileMetadata.  # noqa: E501

        The file's properties revision number. When a file is uploaded, the revision number starts at 1. Every time metadata is updated, the revision number is incremented by 1. New in version 3 of the listFiles operation.  # noqa: E501

        :return: The meta_data_revision of this FileMetadata.  # noqa: E501
        :rtype: int
        """
        return self._meta_data_revision

    @meta_data_revision.setter
    def meta_data_revision(self, meta_data_revision):
        """Sets the meta_data_revision of this FileMetadata.

        The file's properties revision number. When a file is uploaded, the revision number starts at 1. Every time metadata is updated, the revision number is incremented by 1. New in version 3 of the listFiles operation.  # noqa: E501

        :param meta_data_revision: The meta_data_revision of this FileMetadata.  # noqa: E501
        :type: int
        """

        self._meta_data_revision = meta_data_revision

    @property
    def service_group(self):
        """Gets the service_group of this FileMetadata.  # noqa: E501

        The service group that owns the file  # noqa: E501

        :return: The service_group of this FileMetadata.  # noqa: E501
        :rtype: str
        """
        return self._service_group

    @service_group.setter
    def service_group(self, service_group):
        """Sets the service_group of this FileMetadata.

        The service group that owns the file  # noqa: E501

        :param service_group: The service_group of this FileMetadata.  # noqa: E501
        :type: str
        """

        self._service_group = service_group

    @property
    def size(self):
        """Gets the size of this FileMetadata.  # noqa: E501

        The 32-bit file size in bytes. If the value is larger than a 32-bit integer, this value is -1 and the size64 parameter contains the correct value.  # noqa: E501

        :return: The size of this FileMetadata.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this FileMetadata.

        The 32-bit file size in bytes. If the value is larger than a 32-bit integer, this value is -1 and the size64 parameter contains the correct value.  # noqa: E501

        :param size: The size of this FileMetadata.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def size64(self):
        """Gets the size64 of this FileMetadata.  # noqa: E501

        The 64-bit file size in bytes  # noqa: E501

        :return: The size64 of this FileMetadata.  # noqa: E501
        :rtype: int
        """
        return self._size64

    @size64.setter
    def size64(self, size64):
        """Sets the size64 of this FileMetadata.

        The 64-bit file size in bytes  # noqa: E501

        :param size64: The size64 of this FileMetadata.  # noqa: E501
        :type: int
        """

        self._size64 = size64

    @property
    def workspace(self):
        """Gets the workspace of this FileMetadata.  # noqa: E501

        The workspace the file belongs to  # noqa: E501

        :return: The workspace of this FileMetadata.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this FileMetadata.

        The workspace the file belongs to  # noqa: E501

        :param workspace: The workspace of this FileMetadata.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def last_updated_timestamp(self):
        """Gets the last_updated_timestamp of this FileMetadata.  # noqa: E501

        The date and time the file was last updated in the file service  # noqa: E501

        :return: The last_updated_timestamp of this FileMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_timestamp

    @last_updated_timestamp.setter
    def last_updated_timestamp(self, last_updated_timestamp):
        """Sets the last_updated_timestamp of this FileMetadata.

        The date and time the file was last updated in the file service  # noqa: E501

        :param last_updated_timestamp: The last_updated_timestamp of this FileMetadata.  # noqa: E501
        :type: datetime
        """

        self._last_updated_timestamp = last_updated_timestamp

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FileMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FileMetadata):
            return True

        return self.to_dict() != other.to_dict()
