# coding: utf-8

"""
    SystemLink File Service

    Upload and download files from a SystemLink server  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nifile.configuration import Configuration


class QueryResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'links': 'dict(str, Link)',
        'available_files': 'list[FileMetadata]',
        'total_count': 'int'
    }

    attribute_map = {
        'links': '_links',
        'available_files': 'availableFiles',
        'total_count': 'totalCount'
    }

    def __init__(self, links=None, available_files=None, total_count=None, local_vars_configuration=None):  # noqa: E501
        """QueryResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._links = None
        self._available_files = None
        self._total_count = None
        self.discriminator = None

        if links is not None:
            self.links = links
        if available_files is not None:
            self.available_files = available_files
        if total_count is not None:
            self.total_count = total_count

    @property
    def links(self):
        """Gets the links of this QueryResponse.  # noqa: E501

        The links that apply to the collection of files for a service group: - deleteFiles: Link to delete multiple files from the service group using a POST - query: Link to query for available files in the service group using a POST - search: Link to retrieve a filtered list of files in the service group using a GET - self: Link to the current service group - upload: Link to upload files to the service group using a POST  # noqa: E501

        :return: The links of this QueryResponse.  # noqa: E501
        :rtype: dict(str, Link)
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this QueryResponse.

        The links that apply to the collection of files for a service group: - deleteFiles: Link to delete multiple files from the service group using a POST - query: Link to query for available files in the service group using a POST - search: Link to retrieve a filtered list of files in the service group using a GET - self: Link to the current service group - upload: Link to upload files to the service group using a POST  # noqa: E501

        :param links: The links of this QueryResponse.  # noqa: E501
        :type: dict(str, Link)
        """

        self._links = links

    @property
    def available_files(self):
        """Gets the available_files of this QueryResponse.  # noqa: E501

        The list of files returned by the query  # noqa: E501

        :return: The available_files of this QueryResponse.  # noqa: E501
        :rtype: list[FileMetadata]
        """
        return self._available_files

    @available_files.setter
    def available_files(self, available_files):
        """Sets the available_files of this QueryResponse.

        The list of files returned by the query  # noqa: E501

        :param available_files: The available_files of this QueryResponse.  # noqa: E501
        :type: list[FileMetadata]
        """

        self._available_files = available_files

    @property
    def total_count(self):
        """Gets the total_count of this QueryResponse.  # noqa: E501

        The total number of files that match the query regardless of skip and take values  # noqa: E501

        :return: The total_count of this QueryResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this QueryResponse.

        The total number of files that match the query regardless of skip and take values  # noqa: E501

        :param total_count: The total_count of this QueryResponse.  # noqa: E501
        :type: int
        """

        self._total_count = total_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryResponse):
            return True

        return self.to_dict() != other.to_dict()
