# coding: utf-8

"""
    SystemLink File Service

    Upload and download files from a SystemLink server  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nifile.configuration import Configuration


class UpdateMetadataRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'replace_existing': 'bool',
        'expected_revision': 'int',
        'properties': 'dict(str, str)',
        'workspace': 'str'
    }

    attribute_map = {
        'replace_existing': 'replaceExisting',
        'expected_revision': 'expectedRevision',
        'properties': 'properties',
        'workspace': 'workspace'
    }

    def __init__(self, replace_existing=None, expected_revision=None, properties=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """UpdateMetadataRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._replace_existing = None
        self._expected_revision = None
        self._properties = None
        self._workspace = None
        self.discriminator = None

        self.replace_existing = replace_existing
        if expected_revision is not None:
            self.expected_revision = expected_revision
        self.properties = properties
        if workspace is not None:
            self.workspace = workspace

    @property
    def replace_existing(self):
        """Gets the replace_existing of this UpdateMetadataRequest.  # noqa: E501

        Determines whether the current list should be entirely replaced by the specified list or merged with the existing list.  # noqa: E501

        :return: The replace_existing of this UpdateMetadataRequest.  # noqa: E501
        :rtype: bool
        """
        return self._replace_existing

    @replace_existing.setter
    def replace_existing(self, replace_existing):
        """Sets the replace_existing of this UpdateMetadataRequest.

        Determines whether the current list should be entirely replaced by the specified list or merged with the existing list.  # noqa: E501

        :param replace_existing: The replace_existing of this UpdateMetadataRequest.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and replace_existing is None:  # noqa: E501
            raise ValueError("Invalid value for `replace_existing`, must not be `None`")  # noqa: E501

        self._replace_existing = replace_existing

    @property
    def expected_revision(self):
        """Gets the expected_revision of this UpdateMetadataRequest.  # noqa: E501

        This is an optional value. When specified, this is an integer that should be set to match the last known revision number of the metadata. If it doesn't match at the time of execution, the update request will be rejected. This is used to ensure that changes to this file metadata are correctly using the previous state.  # noqa: E501

        :return: The expected_revision of this UpdateMetadataRequest.  # noqa: E501
        :rtype: int
        """
        return self._expected_revision

    @expected_revision.setter
    def expected_revision(self, expected_revision):
        """Sets the expected_revision of this UpdateMetadataRequest.

        This is an optional value. When specified, this is an integer that should be set to match the last known revision number of the metadata. If it doesn't match at the time of execution, the update request will be rejected. This is used to ensure that changes to this file metadata are correctly using the previous state.  # noqa: E501

        :param expected_revision: The expected_revision of this UpdateMetadataRequest.  # noqa: E501
        :type: int
        """

        self._expected_revision = expected_revision

    @property
    def properties(self):
        """Gets the properties of this UpdateMetadataRequest.  # noqa: E501

        The properties to set. A map of key value properties containing the metadata to be attached. Predefined: - Name: This is an optional property for renaming the file. When specified, the file will be renamed.  # noqa: E501

        :return: The properties of this UpdateMetadataRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this UpdateMetadataRequest.

        The properties to set. A map of key value properties containing the metadata to be attached. Predefined: - Name: This is an optional property for renaming the file. When specified, the file will be renamed.  # noqa: E501

        :param properties: The properties of this UpdateMetadataRequest.  # noqa: E501
        :type: dict(str, str)
        """
        if self.local_vars_configuration.client_side_validation and properties is None:  # noqa: E501
            raise ValueError("Invalid value for `properties`, must not be `None`")  # noqa: E501

        self._properties = properties

    @property
    def workspace(self):
        """Gets the workspace of this UpdateMetadataRequest.  # noqa: E501

        This is an optional value. When specified, the workspace of the metadata will be updated to the new value.  # noqa: E501

        :return: The workspace of this UpdateMetadataRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this UpdateMetadataRequest.

        This is an optional value. When specified, the workspace of the metadata will be updated to the new value.  # noqa: E501

        :param workspace: The workspace of this UpdateMetadataRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateMetadataRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateMetadataRequest):
            return True

        return self.to_dict() != other.to_dict()
