# coding: utf-8

"""
    SystemLink File Service

    Upload and download files from a SystemLink server  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nifile.configuration import Configuration


class V1OperationsOperations(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'delete_files': 'Operation',
        'download_data': 'Operation',
        'list_files': 'Operation',
        'query_files': 'Operation',
        'update_metadata': 'Operation',
        'upload_files': 'Operation'
    }

    attribute_map = {
        'delete_files': 'deleteFiles',
        'download_data': 'downloadData',
        'list_files': 'listFiles',
        'query_files': 'queryFiles',
        'update_metadata': 'updateMetadata',
        'upload_files': 'uploadFiles'
    }

    def __init__(self, delete_files=None, download_data=None, list_files=None, query_files=None, update_metadata=None, upload_files=None, local_vars_configuration=None):  # noqa: E501
        """V1OperationsOperations - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._delete_files = None
        self._download_data = None
        self._list_files = None
        self._query_files = None
        self._update_metadata = None
        self._upload_files = None
        self.discriminator = None

        if delete_files is not None:
            self.delete_files = delete_files
        if download_data is not None:
            self.download_data = download_data
        if list_files is not None:
            self.list_files = list_files
        if query_files is not None:
            self.query_files = query_files
        if update_metadata is not None:
            self.update_metadata = update_metadata
        if upload_files is not None:
            self.upload_files = upload_files

    @property
    def delete_files(self):
        """Gets the delete_files of this V1OperationsOperations.  # noqa: E501


        :return: The delete_files of this V1OperationsOperations.  # noqa: E501
        :rtype: Operation
        """
        return self._delete_files

    @delete_files.setter
    def delete_files(self, delete_files):
        """Sets the delete_files of this V1OperationsOperations.


        :param delete_files: The delete_files of this V1OperationsOperations.  # noqa: E501
        :type: Operation
        """

        self._delete_files = delete_files

    @property
    def download_data(self):
        """Gets the download_data of this V1OperationsOperations.  # noqa: E501


        :return: The download_data of this V1OperationsOperations.  # noqa: E501
        :rtype: Operation
        """
        return self._download_data

    @download_data.setter
    def download_data(self, download_data):
        """Sets the download_data of this V1OperationsOperations.


        :param download_data: The download_data of this V1OperationsOperations.  # noqa: E501
        :type: Operation
        """

        self._download_data = download_data

    @property
    def list_files(self):
        """Gets the list_files of this V1OperationsOperations.  # noqa: E501


        :return: The list_files of this V1OperationsOperations.  # noqa: E501
        :rtype: Operation
        """
        return self._list_files

    @list_files.setter
    def list_files(self, list_files):
        """Sets the list_files of this V1OperationsOperations.


        :param list_files: The list_files of this V1OperationsOperations.  # noqa: E501
        :type: Operation
        """

        self._list_files = list_files

    @property
    def query_files(self):
        """Gets the query_files of this V1OperationsOperations.  # noqa: E501


        :return: The query_files of this V1OperationsOperations.  # noqa: E501
        :rtype: Operation
        """
        return self._query_files

    @query_files.setter
    def query_files(self, query_files):
        """Sets the query_files of this V1OperationsOperations.


        :param query_files: The query_files of this V1OperationsOperations.  # noqa: E501
        :type: Operation
        """

        self._query_files = query_files

    @property
    def update_metadata(self):
        """Gets the update_metadata of this V1OperationsOperations.  # noqa: E501


        :return: The update_metadata of this V1OperationsOperations.  # noqa: E501
        :rtype: Operation
        """
        return self._update_metadata

    @update_metadata.setter
    def update_metadata(self, update_metadata):
        """Sets the update_metadata of this V1OperationsOperations.


        :param update_metadata: The update_metadata of this V1OperationsOperations.  # noqa: E501
        :type: Operation
        """

        self._update_metadata = update_metadata

    @property
    def upload_files(self):
        """Gets the upload_files of this V1OperationsOperations.  # noqa: E501


        :return: The upload_files of this V1OperationsOperations.  # noqa: E501
        :rtype: Operation
        """
        return self._upload_files

    @upload_files.setter
    def upload_files(self, upload_files):
        """Sets the upload_files of this V1OperationsOperations.


        :param upload_files: The upload_files of this V1OperationsOperations.  # noqa: E501
        :type: Operation
        """

        self._upload_files = upload_files

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V1OperationsOperations):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V1OperationsOperations):
            return True

        return self.to_dict() != other.to_dict()
