# coding: utf-8

"""
    SystemLink Message Service

    Send and receive messages between systems using a publish-subscribe model.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nimessage.configuration import Configuration


class MaxQueueSizeBytes(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'max_queue_size_bytes': 'int'
    }

    attribute_map = {
        'max_queue_size_bytes': 'maxQueueSizeBytes'
    }

    def __init__(self, max_queue_size_bytes=None, local_vars_configuration=None):  # noqa: E501
        """MaxQueueSizeBytes - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._max_queue_size_bytes = None
        self.discriminator = None

        self.max_queue_size_bytes = max_queue_size_bytes

    @property
    def max_queue_size_bytes(self):
        """Gets the max_queue_size_bytes of this MaxQueueSizeBytes.  # noqa: E501

        Maximum queue size (in bytes)  # noqa: E501

        :return: The max_queue_size_bytes of this MaxQueueSizeBytes.  # noqa: E501
        :rtype: int
        """
        return self._max_queue_size_bytes

    @max_queue_size_bytes.setter
    def max_queue_size_bytes(self, max_queue_size_bytes):
        """Sets the max_queue_size_bytes of this MaxQueueSizeBytes.

        Maximum queue size (in bytes)  # noqa: E501

        :param max_queue_size_bytes: The max_queue_size_bytes of this MaxQueueSizeBytes.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and max_queue_size_bytes is None:  # noqa: E501
            raise ValueError("Invalid value for `max_queue_size_bytes`, must not be `None`")  # noqa: E501

        self._max_queue_size_bytes = max_queue_size_bytes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, MaxQueueSizeBytes):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, MaxQueueSizeBytes):
            return True

        return self.to_dict() != other.to_dict()
