# coding: utf-8

"""
    SystemLink Message Service

    Send and receive messages between systems using a publish-subscribe model.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nimessage.configuration import Configuration


class WebSocketUnsubscribe(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'action': 'str',
        'topic': 'str'
    }

    attribute_map = {
        'action': 'action',
        'topic': 'topic'
    }

    def __init__(self, action=None, topic=None, local_vars_configuration=None):  # noqa: E501
        """WebSocketUnsubscribe - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._action = None
        self._topic = None
        self.discriminator = None

        self.action = action
        self.topic = topic

    @property
    def action(self):
        """Gets the action of this WebSocketUnsubscribe.  # noqa: E501

        Action to perform. Must be set to \"unsubscribe\".  # noqa: E501

        :return: The action of this WebSocketUnsubscribe.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this WebSocketUnsubscribe.

        Action to perform. Must be set to \"unsubscribe\".  # noqa: E501

        :param action: The action of this WebSocketUnsubscribe.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and action is None:  # noqa: E501
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501
        allowed_values = ["unsubscribe"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and action not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def topic(self):
        """Gets the topic of this WebSocketUnsubscribe.  # noqa: E501

        Topic to unsubscribe from  # noqa: E501

        :return: The topic of this WebSocketUnsubscribe.  # noqa: E501
        :rtype: str
        """
        return self._topic

    @topic.setter
    def topic(self, topic):
        """Sets the topic of this WebSocketUnsubscribe.

        Topic to unsubscribe from  # noqa: E501

        :param topic: The topic of this WebSocketUnsubscribe.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and topic is None:  # noqa: E501
            raise ValueError("Invalid value for `topic`, must not be `None`")  # noqa: E501

        self._topic = topic

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WebSocketUnsubscribe):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WebSocketUnsubscribe):
            return True

        return self.to_dict() != other.to_dict()
