# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class CreateExecution(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'notebook_path': 'str',
        'parameters': 'dict(str, object)',
        'timeout': 'int',
        'result_cache_period': 'int',
        'export_format': 'NotebookExportFormat',
        'export_options': 'NotebookExportOptions'
    }

    attribute_map = {
        'notebook_path': 'notebookPath',
        'parameters': 'parameters',
        'timeout': 'timeout',
        'result_cache_period': 'resultCachePeriod',
        'export_format': 'exportFormat',
        'export_options': 'exportOptions'
    }

    def __init__(self, notebook_path=None, parameters=None, timeout=3600, result_cache_period=86400, export_format=None, export_options=None, local_vars_configuration=None):  # noqa: E501
        """CreateExecution - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._notebook_path = None
        self._parameters = None
        self._timeout = None
        self._result_cache_period = None
        self._export_format = None
        self._export_options = None
        self.discriminator = None

        self.notebook_path = notebook_path
        if parameters is not None:
            self.parameters = parameters
        if timeout is not None:
            self.timeout = timeout
        if result_cache_period is not None:
            self.result_cache_period = result_cache_period
        if export_format is not None:
            self.export_format = export_format
        if export_options is not None:
            self.export_options = export_options

    @property
    def notebook_path(self):
        """Gets the notebook_path of this CreateExecution.  # noqa: E501

        The notebook path associated with the execution.  # noqa: E501

        :return: The notebook_path of this CreateExecution.  # noqa: E501
        :rtype: str
        """
        return self._notebook_path

    @notebook_path.setter
    def notebook_path(self, notebook_path):
        """Sets the notebook_path of this CreateExecution.

        The notebook path associated with the execution.  # noqa: E501

        :param notebook_path: The notebook_path of this CreateExecution.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and notebook_path is None:  # noqa: E501
            raise ValueError("Invalid value for `notebook_path`, must not be `None`")  # noqa: E501

        self._notebook_path = notebook_path

    @property
    def parameters(self):
        """Gets the parameters of this CreateExecution.  # noqa: E501

        The input parameters for this execution of the notebook. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :return: The parameters of this CreateExecution.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this CreateExecution.

        The input parameters for this execution of the notebook. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :param parameters: The parameters of this CreateExecution.  # noqa: E501
        :type: dict(str, object)
        """

        self._parameters = parameters

    @property
    def timeout(self):
        """Gets the timeout of this CreateExecution.  # noqa: E501

        The number of seconds the execution runs before it aborts if uncompleted. The timer starts once status is IN_PROGRESS. 0 means infinite. The default is 1 hour (3600 seconds).  # noqa: E501

        :return: The timeout of this CreateExecution.  # noqa: E501
        :rtype: int
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """Sets the timeout of this CreateExecution.

        The number of seconds the execution runs before it aborts if uncompleted. The timer starts once status is IN_PROGRESS. 0 means infinite. The default is 1 hour (3600 seconds).  # noqa: E501

        :param timeout: The timeout of this CreateExecution.  # noqa: E501
        :type: int
        """

        self._timeout = timeout

    @property
    def result_cache_period(self):
        """Gets the result_cache_period of this CreateExecution.  # noqa: E501

        The period of time, in seconds, when the result of a previous notebook execution can be used as the result of the current notebook execution. Results will only be reused if the notebook paths and input parameters match. A value of 0 means that the service will not reuse results from any previous notebook executions. A value of -1 means that the service will always reuse results if possible. If not possible, return an error. This prevents actual execution of a notebook. The default is 24 hours (86400 seconds).  # noqa: E501

        :return: The result_cache_period of this CreateExecution.  # noqa: E501
        :rtype: int
        """
        return self._result_cache_period

    @result_cache_period.setter
    def result_cache_period(self, result_cache_period):
        """Sets the result_cache_period of this CreateExecution.

        The period of time, in seconds, when the result of a previous notebook execution can be used as the result of the current notebook execution. Results will only be reused if the notebook paths and input parameters match. A value of 0 means that the service will not reuse results from any previous notebook executions. A value of -1 means that the service will always reuse results if possible. If not possible, return an error. This prevents actual execution of a notebook. The default is 24 hours (86400 seconds).  # noqa: E501

        :param result_cache_period: The result_cache_period of this CreateExecution.  # noqa: E501
        :type: int
        """

        self._result_cache_period = result_cache_period

    @property
    def export_format(self):
        """Gets the export_format of this CreateExecution.  # noqa: E501


        :return: The export_format of this CreateExecution.  # noqa: E501
        :rtype: NotebookExportFormat
        """
        return self._export_format

    @export_format.setter
    def export_format(self, export_format):
        """Sets the export_format of this CreateExecution.


        :param export_format: The export_format of this CreateExecution.  # noqa: E501
        :type: NotebookExportFormat
        """

        self._export_format = export_format

    @property
    def export_options(self):
        """Gets the export_options of this CreateExecution.  # noqa: E501


        :return: The export_options of this CreateExecution.  # noqa: E501
        :rtype: NotebookExportOptions
        """
        return self._export_options

    @export_options.setter
    def export_options(self, export_options):
        """Sets the export_options of this CreateExecution.


        :param export_options: The export_options of this CreateExecution.  # noqa: E501
        :type: NotebookExportOptions
        """

        self._export_options = export_options

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateExecution):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateExecution):
            return True

        return self.to_dict() != other.to_dict()
