# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class CreateExecutionOperation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'available': 'bool',
        'version': 'int',
        'export_formats': 'list[NotebookExportFormat]'
    }

    attribute_map = {
        'available': 'available',
        'version': 'version',
        'export_formats': 'exportFormats'
    }

    def __init__(self, available=None, version=1, export_formats=None, local_vars_configuration=None):  # noqa: E501
        """CreateExecutionOperation - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._available = None
        self._version = None
        self._export_formats = None
        self.discriminator = None

        self.available = available
        if version is not None:
            self.version = version
        if export_formats is not None:
            self.export_formats = export_formats

    @property
    def available(self):
        """Gets the available of this CreateExecutionOperation.  # noqa: E501

        Whether the operation is available to the caller  # noqa: E501

        :return: The available of this CreateExecutionOperation.  # noqa: E501
        :rtype: bool
        """
        return self._available

    @available.setter
    def available(self, available):
        """Sets the available of this CreateExecutionOperation.

        Whether the operation is available to the caller  # noqa: E501

        :param available: The available of this CreateExecutionOperation.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and available is None:  # noqa: E501
            raise ValueError("Invalid value for `available`, must not be `None`")  # noqa: E501

        self._available = available

    @property
    def version(self):
        """Gets the version of this CreateExecutionOperation.  # noqa: E501

        Version of the available operation  # noqa: E501

        :return: The version of this CreateExecutionOperation.  # noqa: E501
        :rtype: int
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this CreateExecutionOperation.

        Version of the available operation  # noqa: E501

        :param version: The version of this CreateExecutionOperation.  # noqa: E501
        :type: int
        """

        self._version = version

    @property
    def export_formats(self):
        """Gets the export_formats of this CreateExecutionOperation.  # noqa: E501

        List of export formats  # noqa: E501

        :return: The export_formats of this CreateExecutionOperation.  # noqa: E501
        :rtype: list[NotebookExportFormat]
        """
        return self._export_formats

    @export_formats.setter
    def export_formats(self, export_formats):
        """Sets the export_formats of this CreateExecutionOperation.

        List of export formats  # noqa: E501

        :param export_formats: The export_formats of this CreateExecutionOperation.  # noqa: E501
        :type: list[NotebookExportFormat]
        """

        self._export_formats = export_formats

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateExecutionOperation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateExecutionOperation):
            return True

        return self.to_dict() != other.to_dict()
