# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class Execution(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'notebook_path': 'str',
        'parameters': 'dict(str, object)',
        'metadata': 'dict(str, object)',
        'execution_hash': 'str',
        'timeout': 'int',
        'status': 'ExecutionStatus',
        'queued_at': 'datetime',
        'started_at': 'datetime',
        'completed_at': 'datetime',
        'exception': 'str',
        'result': 'dict(str, object)',
        'cached_result': 'bool',
        'export_file_id': 'str'
    }

    attribute_map = {
        'id': 'id',
        'notebook_path': 'notebookPath',
        'parameters': 'parameters',
        'metadata': 'metadata',
        'execution_hash': 'executionHash',
        'timeout': 'timeout',
        'status': 'status',
        'queued_at': 'queuedAt',
        'started_at': 'startedAt',
        'completed_at': 'completedAt',
        'exception': 'exception',
        'result': 'result',
        'cached_result': 'cachedResult',
        'export_file_id': 'exportFileId'
    }

    def __init__(self, id=None, notebook_path=None, parameters=None, metadata=None, execution_hash=None, timeout=None, status=None, queued_at=None, started_at=None, completed_at=None, exception=None, result=None, cached_result=None, export_file_id=None, local_vars_configuration=None):  # noqa: E501
        """Execution - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._notebook_path = None
        self._parameters = None
        self._metadata = None
        self._execution_hash = None
        self._timeout = None
        self._status = None
        self._queued_at = None
        self._started_at = None
        self._completed_at = None
        self._exception = None
        self._result = None
        self._cached_result = None
        self._export_file_id = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if notebook_path is not None:
            self.notebook_path = notebook_path
        if parameters is not None:
            self.parameters = parameters
        if metadata is not None:
            self.metadata = metadata
        if execution_hash is not None:
            self.execution_hash = execution_hash
        if timeout is not None:
            self.timeout = timeout
        if status is not None:
            self.status = status
        if queued_at is not None:
            self.queued_at = queued_at
        if started_at is not None:
            self.started_at = started_at
        if completed_at is not None:
            self.completed_at = completed_at
        if exception is not None:
            self.exception = exception
        if result is not None:
            self.result = result
        if cached_result is not None:
            self.cached_result = cached_result
        if export_file_id is not None:
            self.export_file_id = export_file_id

    @property
    def id(self):
        """Gets the id of this Execution.  # noqa: E501

        Execution ID  # noqa: E501

        :return: The id of this Execution.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Execution.

        Execution ID  # noqa: E501

        :param id: The id of this Execution.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def notebook_path(self):
        """Gets the notebook_path of this Execution.  # noqa: E501

        Notebook path associated with the execution  # noqa: E501

        :return: The notebook_path of this Execution.  # noqa: E501
        :rtype: str
        """
        return self._notebook_path

    @notebook_path.setter
    def notebook_path(self, notebook_path):
        """Sets the notebook_path of this Execution.

        Notebook path associated with the execution  # noqa: E501

        :param notebook_path: The notebook_path of this Execution.  # noqa: E501
        :type: str
        """

        self._notebook_path = notebook_path

    @property
    def parameters(self):
        """Gets the parameters of this Execution.  # noqa: E501

        Input parameters for this execution of the notebook. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :return: The parameters of this Execution.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this Execution.

        Input parameters for this execution of the notebook. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :param parameters: The parameters of this Execution.  # noqa: E501
        :type: dict(str, object)
        """

        self._parameters = parameters

    @property
    def metadata(self):
        """Gets the metadata of this Execution.  # noqa: E501

        Metadata associated with the notebook, at time of execution.  # noqa: E501

        :return: The metadata of this Execution.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Execution.

        Metadata associated with the notebook, at time of execution.  # noqa: E501

        :param metadata: The metadata of this Execution.  # noqa: E501
        :type: dict(str, object)
        """

        self._metadata = metadata

    @property
    def execution_hash(self):
        """Gets the execution_hash of this Execution.  # noqa: E501

        Execution hashes are used internally to identify a distinct execution, where if this hash matches, it means that the result may be reused. This hash is based on information including the notebook path, the last modified timestamp of the notebook, and the given parameters of the notebook overriding the default parameters of the notebook.  # noqa: E501

        :return: The execution_hash of this Execution.  # noqa: E501
        :rtype: str
        """
        return self._execution_hash

    @execution_hash.setter
    def execution_hash(self, execution_hash):
        """Sets the execution_hash of this Execution.

        Execution hashes are used internally to identify a distinct execution, where if this hash matches, it means that the result may be reused. This hash is based on information including the notebook path, the last modified timestamp of the notebook, and the given parameters of the notebook overriding the default parameters of the notebook.  # noqa: E501

        :param execution_hash: The execution_hash of this Execution.  # noqa: E501
        :type: str
        """

        self._execution_hash = execution_hash

    @property
    def timeout(self):
        """Gets the timeout of this Execution.  # noqa: E501

        The number of seconds the execution runs before it aborts if uncompleted. The timer starts once status is IN_PROGRESS. 0 means infinite.  # noqa: E501

        :return: The timeout of this Execution.  # noqa: E501
        :rtype: int
        """
        return self._timeout

    @timeout.setter
    def timeout(self, timeout):
        """Sets the timeout of this Execution.

        The number of seconds the execution runs before it aborts if uncompleted. The timer starts once status is IN_PROGRESS. 0 means infinite.  # noqa: E501

        :param timeout: The timeout of this Execution.  # noqa: E501
        :type: int
        """

        self._timeout = timeout

    @property
    def status(self):
        """Gets the status of this Execution.  # noqa: E501


        :return: The status of this Execution.  # noqa: E501
        :rtype: ExecutionStatus
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Execution.


        :param status: The status of this Execution.  # noqa: E501
        :type: ExecutionStatus
        """

        self._status = status

    @property
    def queued_at(self):
        """Gets the queued_at of this Execution.  # noqa: E501

        Timestamp of when the notebook execution was queued  # noqa: E501

        :return: The queued_at of this Execution.  # noqa: E501
        :rtype: datetime
        """
        return self._queued_at

    @queued_at.setter
    def queued_at(self, queued_at):
        """Sets the queued_at of this Execution.

        Timestamp of when the notebook execution was queued  # noqa: E501

        :param queued_at: The queued_at of this Execution.  # noqa: E501
        :type: datetime
        """

        self._queued_at = queued_at

    @property
    def started_at(self):
        """Gets the started_at of this Execution.  # noqa: E501

        Timestamp of when the notebook execution was started  # noqa: E501

        :return: The started_at of this Execution.  # noqa: E501
        :rtype: datetime
        """
        return self._started_at

    @started_at.setter
    def started_at(self, started_at):
        """Sets the started_at of this Execution.

        Timestamp of when the notebook execution was started  # noqa: E501

        :param started_at: The started_at of this Execution.  # noqa: E501
        :type: datetime
        """

        self._started_at = started_at

    @property
    def completed_at(self):
        """Gets the completed_at of this Execution.  # noqa: E501

        Timestamp of when the notebook execution was completed  # noqa: E501

        :return: The completed_at of this Execution.  # noqa: E501
        :rtype: datetime
        """
        return self._completed_at

    @completed_at.setter
    def completed_at(self, completed_at):
        """Sets the completed_at of this Execution.

        Timestamp of when the notebook execution was completed  # noqa: E501

        :param completed_at: The completed_at of this Execution.  # noqa: E501
        :type: datetime
        """

        self._completed_at = completed_at

    @property
    def exception(self):
        """Gets the exception of this Execution.  # noqa: E501

        Exception information. This is used only when status is FAILED.  # noqa: E501

        :return: The exception of this Execution.  # noqa: E501
        :rtype: str
        """
        return self._exception

    @exception.setter
    def exception(self, exception):
        """Sets the exception of this Execution.

        Exception information. This is used only when status is FAILED.  # noqa: E501

        :param exception: The exception of this Execution.  # noqa: E501
        :type: str
        """

        self._exception = exception

    @property
    def result(self):
        """Gets the result of this Execution.  # noqa: E501

        Information about the result of an execution of a Jupyter notebook. This is used only when the status of the execution is SUCCEEDED.  # noqa: E501

        :return: The result of this Execution.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this Execution.

        Information about the result of an execution of a Jupyter notebook. This is used only when the status of the execution is SUCCEEDED.  # noqa: E501

        :param result: The result of this Execution.  # noqa: E501
        :type: dict(str, object)
        """

        self._result = result

    @property
    def cached_result(self):
        """Gets the cached_result of this Execution.  # noqa: E501

        Whether or not the service is using a cached result instead of running a new execution  # noqa: E501

        :return: The cached_result of this Execution.  # noqa: E501
        :rtype: bool
        """
        return self._cached_result

    @cached_result.setter
    def cached_result(self, cached_result):
        """Sets the cached_result of this Execution.

        Whether or not the service is using a cached result instead of running a new execution  # noqa: E501

        :param cached_result: The cached_result of this Execution.  # noqa: E501
        :type: bool
        """

        self._cached_result = cached_result

    @property
    def export_file_id(self):
        """Gets the export_file_id of this Execution.  # noqa: E501

        File ID of notebook report exported to the File Ingestion Service.  # noqa: E501

        :return: The export_file_id of this Execution.  # noqa: E501
        :rtype: str
        """
        return self._export_file_id

    @export_file_id.setter
    def export_file_id(self, export_file_id):
        """Sets the export_file_id of this Execution.

        File ID of notebook report exported to the File Ingestion Service.  # noqa: E501

        :param export_file_id: The export_file_id of this Execution.  # noqa: E501
        :type: str
        """

        self._export_file_id = export_file_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Execution):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Execution):
            return True

        return self.to_dict() != other.to_dict()
