# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class ExecutionAdvancedQuery(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'filter': 'str',
        'order_by': 'ExecutionSortField',
        'descending': 'bool',
        'projection': 'list[ExecutionField]',
        'skip': 'int',
        'take': 'int',
        'return_count': 'bool'
    }

    attribute_map = {
        'filter': 'filter',
        'order_by': 'orderBy',
        'descending': 'descending',
        'projection': 'projection',
        'skip': 'skip',
        'take': 'take',
        'return_count': 'returnCount'
    }

    def __init__(self, filter=None, order_by=None, descending=False, projection=None, skip=0, take=1000, return_count=False, local_vars_configuration=None):  # noqa: E501
        """ExecutionAdvancedQuery - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._filter = None
        self._order_by = None
        self._descending = None
        self._projection = None
        self._skip = None
        self._take = None
        self._return_count = None
        self.discriminator = None

        if filter is not None:
            self.filter = filter
        if order_by is not None:
            self.order_by = order_by
        if descending is not None:
            self.descending = descending
        if projection is not None:
            self.projection = projection
        if skip is not None:
            self.skip = skip
        if take is not None:
            self.take = take
        if return_count is not None:
            self.return_count = return_count

    @property
    def filter(self):
        """Gets the filter of this ExecutionAdvancedQuery.  # noqa: E501

        The query filter in Dynamic Linq  # noqa: E501

        :return: The filter of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this ExecutionAdvancedQuery.

        The query filter in Dynamic Linq  # noqa: E501

        :param filter: The filter of this ExecutionAdvancedQuery.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def order_by(self):
        """Gets the order_by of this ExecutionAdvancedQuery.  # noqa: E501


        :return: The order_by of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: ExecutionSortField
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this ExecutionAdvancedQuery.


        :param order_by: The order_by of this ExecutionAdvancedQuery.  # noqa: E501
        :type: ExecutionSortField
        """

        self._order_by = order_by

    @property
    def descending(self):
        """Gets the descending of this ExecutionAdvancedQuery.  # noqa: E501

        -> Whether to return the notebook executions in descending order.  # noqa: E501

        :return: The descending of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: bool
        """
        return self._descending

    @descending.setter
    def descending(self, descending):
        """Sets the descending of this ExecutionAdvancedQuery.

        -> Whether to return the notebook executions in descending order.  # noqa: E501

        :param descending: The descending of this ExecutionAdvancedQuery.  # noqa: E501
        :type: bool
        """

        self._descending = descending

    @property
    def projection(self):
        """Gets the projection of this ExecutionAdvancedQuery.  # noqa: E501

        Array of execution fields. If this is not specified, the query returns a result with the execution objects containing all available fields. If this is specified, the query returns a result with the execution objects containing only the fields that are both specified and available.  # noqa: E501

        :return: The projection of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: list[ExecutionField]
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this ExecutionAdvancedQuery.

        Array of execution fields. If this is not specified, the query returns a result with the execution objects containing all available fields. If this is specified, the query returns a result with the execution objects containing only the fields that are both specified and available.  # noqa: E501

        :param projection: The projection of this ExecutionAdvancedQuery.  # noqa: E501
        :type: list[ExecutionField]
        """

        self._projection = projection

    @property
    def skip(self):
        """Gets the skip of this ExecutionAdvancedQuery.  # noqa: E501

        The number of notebook executions to skip over when returning the result. Used for paging.  # noqa: E501

        :return: The skip of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: int
        """
        return self._skip

    @skip.setter
    def skip(self, skip):
        """Sets the skip of this ExecutionAdvancedQuery.

        The number of notebook executions to skip over when returning the result. Used for paging.  # noqa: E501

        :param skip: The skip of this ExecutionAdvancedQuery.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                skip is not None and skip < 0):  # noqa: E501
            raise ValueError("Invalid value for `skip`, must be a value greater than or equal to `0`")  # noqa: E501

        self._skip = skip

    @property
    def take(self):
        """Gets the take of this ExecutionAdvancedQuery.  # noqa: E501

        The maximum number of notebook executions to return.  # noqa: E501

        :return: The take of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this ExecutionAdvancedQuery.

        The maximum number of notebook executions to return.  # noqa: E501

        :param take: The take of this ExecutionAdvancedQuery.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take < 0):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value greater than or equal to `0`")  # noqa: E501

        self._take = take

    @property
    def return_count(self):
        """Gets the return_count of this ExecutionAdvancedQuery.  # noqa: E501

        Whether to return the total number of notebook executions which match the provided filter, disregarding the take value.  # noqa: E501

        :return: The return_count of this ExecutionAdvancedQuery.  # noqa: E501
        :rtype: bool
        """
        return self._return_count

    @return_count.setter
    def return_count(self, return_count):
        """Sets the return_count of this ExecutionAdvancedQuery.

        Whether to return the total number of notebook executions which match the provided filter, disregarding the take value.  # noqa: E501

        :param return_count: The return_count of this ExecutionAdvancedQuery.  # noqa: E501
        :type: bool
        """

        self._return_count = return_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExecutionAdvancedQuery):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExecutionAdvancedQuery):
            return True

        return self.to_dict() != other.to_dict()
