# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class ExecutionHashInformation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'notebook_path': 'str',
        'parameters': 'dict(str, object)'
    }

    attribute_map = {
        'notebook_path': 'notebookPath',
        'parameters': 'parameters'
    }

    def __init__(self, notebook_path=None, parameters=None, local_vars_configuration=None):  # noqa: E501
        """ExecutionHashInformation - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._notebook_path = None
        self._parameters = None
        self.discriminator = None

        self.notebook_path = notebook_path
        if parameters is not None:
            self.parameters = parameters

    @property
    def notebook_path(self):
        """Gets the notebook_path of this ExecutionHashInformation.  # noqa: E501

        The notebook path associated with the execution.  # noqa: E501

        :return: The notebook_path of this ExecutionHashInformation.  # noqa: E501
        :rtype: str
        """
        return self._notebook_path

    @notebook_path.setter
    def notebook_path(self, notebook_path):
        """Sets the notebook_path of this ExecutionHashInformation.

        The notebook path associated with the execution.  # noqa: E501

        :param notebook_path: The notebook_path of this ExecutionHashInformation.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and notebook_path is None:  # noqa: E501
            raise ValueError("Invalid value for `notebook_path`, must not be `None`")  # noqa: E501

        self._notebook_path = notebook_path

    @property
    def parameters(self):
        """Gets the parameters of this ExecutionHashInformation.  # noqa: E501

        The input parameters for the execution of the notebook. The keys are strings and the values can be of any valid JSON type. The hash is calculated, in part, by applying these input parameters on top of the default parameters of the notebook. Hence, if the value of an input parameter matches the value of the default parameter, the resulting hash is the same whether or not that input parameter is present.  # noqa: E501

        :return: The parameters of this ExecutionHashInformation.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this ExecutionHashInformation.

        The input parameters for the execution of the notebook. The keys are strings and the values can be of any valid JSON type. The hash is calculated, in part, by applying these input parameters on top of the default parameters of the notebook. Hence, if the value of an input parameter matches the value of the default parameter, the resulting hash is the same whether or not that input parameter is present.  # noqa: E501

        :param parameters: The parameters of this ExecutionHashInformation.  # noqa: E501
        :type: dict(str, object)
        """

        self._parameters = parameters

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExecutionHashInformation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExecutionHashInformation):
            return True

        return self.to_dict() != other.to_dict()
