# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class ExecutionQueryObject(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ids': 'list[str]',
        'notebook_paths': 'list[str]',
        'parameters': 'list[dict(str, object)]',
        'timeout_query': 'list[IntegerQueryObject]',
        'execution_hashes': 'list[ExecutionHashInformation]',
        'statuses': 'list[ExecutionStatus]',
        'queued_at_query': 'list[TimeQueryObject]',
        'started_at_query': 'list[TimeQueryObject]',
        'completed_at_query': 'list[TimeQueryObject]',
        'sort_by': 'list[ExecutionSortDefinitionObject]',
        'projection': 'list[ExecutionField]'
    }

    attribute_map = {
        'ids': 'ids',
        'notebook_paths': 'notebookPaths',
        'parameters': 'parameters',
        'timeout_query': 'timeoutQuery',
        'execution_hashes': 'executionHashes',
        'statuses': 'statuses',
        'queued_at_query': 'queuedAtQuery',
        'started_at_query': 'startedAtQuery',
        'completed_at_query': 'completedAtQuery',
        'sort_by': 'sortBy',
        'projection': 'projection'
    }

    def __init__(self, ids=None, notebook_paths=None, parameters=None, timeout_query=None, execution_hashes=None, statuses=None, queued_at_query=None, started_at_query=None, completed_at_query=None, sort_by=None, projection=None, local_vars_configuration=None):  # noqa: E501
        """ExecutionQueryObject - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ids = None
        self._notebook_paths = None
        self._parameters = None
        self._timeout_query = None
        self._execution_hashes = None
        self._statuses = None
        self._queued_at_query = None
        self._started_at_query = None
        self._completed_at_query = None
        self._sort_by = None
        self._projection = None
        self.discriminator = None

        if ids is not None:
            self.ids = ids
        if notebook_paths is not None:
            self.notebook_paths = notebook_paths
        if parameters is not None:
            self.parameters = parameters
        if timeout_query is not None:
            self.timeout_query = timeout_query
        if execution_hashes is not None:
            self.execution_hashes = execution_hashes
        if statuses is not None:
            self.statuses = statuses
        if queued_at_query is not None:
            self.queued_at_query = queued_at_query
        if started_at_query is not None:
            self.started_at_query = started_at_query
        if completed_at_query is not None:
            self.completed_at_query = completed_at_query
        if sort_by is not None:
            self.sort_by = sort_by
        if projection is not None:
            self.projection = projection

    @property
    def ids(self):
        """Gets the ids of this ExecutionQueryObject.  # noqa: E501

        Array of execution IDs.  # noqa: E501

        :return: The ids of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """Sets the ids of this ExecutionQueryObject.

        Array of execution IDs.  # noqa: E501

        :param ids: The ids of this ExecutionQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._ids = ids

    @property
    def notebook_paths(self):
        """Gets the notebook_paths of this ExecutionQueryObject.  # noqa: E501

        Array of notebook paths.  # noqa: E501

        :return: The notebook_paths of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._notebook_paths

    @notebook_paths.setter
    def notebook_paths(self, notebook_paths):
        """Sets the notebook_paths of this ExecutionQueryObject.

        Array of notebook paths.  # noqa: E501

        :param notebook_paths: The notebook_paths of this ExecutionQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._notebook_paths = notebook_paths

    @property
    def parameters(self):
        """Gets the parameters of this ExecutionQueryObject.  # noqa: E501

        Array of input parameter dictionaries. When querying, entries within the same dictionary must all match (an \"and\" relationship within dictionaries). Only one of the dictionaries needs to match the query (an \"or\" relationship between different dictionaries).  # noqa: E501

        :return: The parameters of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[dict(str, object)]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this ExecutionQueryObject.

        Array of input parameter dictionaries. When querying, entries within the same dictionary must all match (an \"and\" relationship within dictionaries). Only one of the dictionaries needs to match the query (an \"or\" relationship between different dictionaries).  # noqa: E501

        :param parameters: The parameters of this ExecutionQueryObject.  # noqa: E501
        :type: list[dict(str, object)]
        """

        self._parameters = parameters

    @property
    def timeout_query(self):
        """Gets the timeout_query of this ExecutionQueryObject.  # noqa: E501

        Array of integer query objects for the execution's timeout  # noqa: E501

        :return: The timeout_query of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[IntegerQueryObject]
        """
        return self._timeout_query

    @timeout_query.setter
    def timeout_query(self, timeout_query):
        """Sets the timeout_query of this ExecutionQueryObject.

        Array of integer query objects for the execution's timeout  # noqa: E501

        :param timeout_query: The timeout_query of this ExecutionQueryObject.  # noqa: E501
        :type: list[IntegerQueryObject]
        """

        self._timeout_query = timeout_query

    @property
    def execution_hashes(self):
        """Gets the execution_hashes of this ExecutionQueryObject.  # noqa: E501

        Array of objects used to calculate execution hashes. Execution hashes are used internally to identify a distinct execution, where if this hash matches, it means that the result may be reused. This hash is based on information including the notebook path, the last modified timestamp of the notebook, and the given parameters of the notebook overriding the default parameters of the notebook.  # noqa: E501

        :return: The execution_hashes of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[ExecutionHashInformation]
        """
        return self._execution_hashes

    @execution_hashes.setter
    def execution_hashes(self, execution_hashes):
        """Sets the execution_hashes of this ExecutionQueryObject.

        Array of objects used to calculate execution hashes. Execution hashes are used internally to identify a distinct execution, where if this hash matches, it means that the result may be reused. This hash is based on information including the notebook path, the last modified timestamp of the notebook, and the given parameters of the notebook overriding the default parameters of the notebook.  # noqa: E501

        :param execution_hashes: The execution_hashes of this ExecutionQueryObject.  # noqa: E501
        :type: list[ExecutionHashInformation]
        """

        self._execution_hashes = execution_hashes

    @property
    def statuses(self):
        """Gets the statuses of this ExecutionQueryObject.  # noqa: E501

        Array of execution statuses.  # noqa: E501

        :return: The statuses of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[ExecutionStatus]
        """
        return self._statuses

    @statuses.setter
    def statuses(self, statuses):
        """Sets the statuses of this ExecutionQueryObject.

        Array of execution statuses.  # noqa: E501

        :param statuses: The statuses of this ExecutionQueryObject.  # noqa: E501
        :type: list[ExecutionStatus]
        """

        self._statuses = statuses

    @property
    def queued_at_query(self):
        """Gets the queued_at_query of this ExecutionQueryObject.  # noqa: E501

        Array of time query objects for the execution's queue timestamp  # noqa: E501

        :return: The queued_at_query of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._queued_at_query

    @queued_at_query.setter
    def queued_at_query(self, queued_at_query):
        """Sets the queued_at_query of this ExecutionQueryObject.

        Array of time query objects for the execution's queue timestamp  # noqa: E501

        :param queued_at_query: The queued_at_query of this ExecutionQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._queued_at_query = queued_at_query

    @property
    def started_at_query(self):
        """Gets the started_at_query of this ExecutionQueryObject.  # noqa: E501

        Array of time query objects for the execution's started timestamp  # noqa: E501

        :return: The started_at_query of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._started_at_query

    @started_at_query.setter
    def started_at_query(self, started_at_query):
        """Sets the started_at_query of this ExecutionQueryObject.

        Array of time query objects for the execution's started timestamp  # noqa: E501

        :param started_at_query: The started_at_query of this ExecutionQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._started_at_query = started_at_query

    @property
    def completed_at_query(self):
        """Gets the completed_at_query of this ExecutionQueryObject.  # noqa: E501

        Array of time query objects for the execution's completed timestamp  # noqa: E501

        :return: The completed_at_query of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._completed_at_query

    @completed_at_query.setter
    def completed_at_query(self, completed_at_query):
        """Sets the completed_at_query of this ExecutionQueryObject.

        Array of time query objects for the execution's completed timestamp  # noqa: E501

        :param completed_at_query: The completed_at_query of this ExecutionQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._completed_at_query = completed_at_query

    @property
    def sort_by(self):
        """Gets the sort_by of this ExecutionQueryObject.  # noqa: E501

        Array of execution sort definition objects that define how to sort the results  # noqa: E501

        :return: The sort_by of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[ExecutionSortDefinitionObject]
        """
        return self._sort_by

    @sort_by.setter
    def sort_by(self, sort_by):
        """Sets the sort_by of this ExecutionQueryObject.

        Array of execution sort definition objects that define how to sort the results  # noqa: E501

        :param sort_by: The sort_by of this ExecutionQueryObject.  # noqa: E501
        :type: list[ExecutionSortDefinitionObject]
        """

        self._sort_by = sort_by

    @property
    def projection(self):
        """Gets the projection of this ExecutionQueryObject.  # noqa: E501

        Array of execution fields. If this is not specified, the query returns a result with the execution objects containing all available fields. If this is specified, the query returns a result with the execution objects containing only the fields that are both specified and available.  # noqa: E501

        :return: The projection of this ExecutionQueryObject.  # noqa: E501
        :rtype: list[ExecutionField]
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this ExecutionQueryObject.

        Array of execution fields. If this is not specified, the query returns a result with the execution objects containing all available fields. If this is specified, the query returns a result with the execution objects containing only the fields that are both specified and available.  # noqa: E501

        :param projection: The projection of this ExecutionQueryObject.  # noqa: E501
        :type: list[ExecutionField]
        """

        self._projection = projection

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ExecutionQueryObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ExecutionQueryObject):
            return True

        return self.to_dict() != other.to_dict()
