# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class Notebook(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'path': 'str',
        'created_at': 'datetime',
        'updated_at': 'datetime',
        'parameters': 'dict(str, object)',
        'metadata': 'dict(str, object)'
    }

    attribute_map = {
        'path': 'path',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt',
        'parameters': 'parameters',
        'metadata': 'metadata'
    }

    def __init__(self, path=None, created_at=None, updated_at=None, parameters=None, metadata=None, local_vars_configuration=None):  # noqa: E501
        """Notebook - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._path = None
        self._created_at = None
        self._updated_at = None
        self._parameters = None
        self._metadata = None
        self.discriminator = None

        if path is not None:
            self.path = path
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at
        if parameters is not None:
            self.parameters = parameters
        if metadata is not None:
            self.metadata = metadata

    @property
    def path(self):
        """Gets the path of this Notebook.  # noqa: E501

        The notebook path.  # noqa: E501

        :return: The path of this Notebook.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this Notebook.

        The notebook path.  # noqa: E501

        :param path: The path of this Notebook.  # noqa: E501
        :type: str
        """

        self._path = path

    @property
    def created_at(self):
        """Gets the created_at of this Notebook.  # noqa: E501

        File timestamp of when the notebook was created  # noqa: E501

        :return: The created_at of this Notebook.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this Notebook.

        File timestamp of when the notebook was created  # noqa: E501

        :param created_at: The created_at of this Notebook.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this Notebook.  # noqa: E501

        File timestamp of when the notebook was last modified  # noqa: E501

        :return: The updated_at of this Notebook.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this Notebook.

        File timestamp of when the notebook was last modified  # noqa: E501

        :param updated_at: The updated_at of this Notebook.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def parameters(self):
        """Gets the parameters of this Notebook.  # noqa: E501

        Input parameters of this notebook and their default values. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :return: The parameters of this Notebook.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this Notebook.

        Input parameters of this notebook and their default values. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :param parameters: The parameters of this Notebook.  # noqa: E501
        :type: dict(str, object)
        """

        self._parameters = parameters

    @property
    def metadata(self):
        """Gets the metadata of this Notebook.  # noqa: E501

        Metadata associated with this notebook. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :return: The metadata of this Notebook.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Notebook.

        Metadata associated with this notebook. The keys are strings and the values can be of any valid JSON type.  # noqa: E501

        :param metadata: The metadata of this Notebook.  # noqa: E501
        :type: dict(str, object)
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Notebook):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Notebook):
            return True

        return self.to_dict() != other.to_dict()
