# coding: utf-8

"""
    Notebook Execution Service

    Execute Jupyter notebooks.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.ninbexec.configuration import Configuration


class NotebookQueryObject(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'paths': 'list[str]',
        'created_at_query': 'list[TimeQueryObject]',
        'updated_at_query': 'list[TimeQueryObject]',
        'parameters': 'list[dict(str, object)]',
        'metadata': 'list[dict(str, object)]',
        'metadata_array_contains': 'list[list[ArrayContainsObject]]',
        'sort_by': 'list[NotebookSortDefinitionObject]',
        'projection': 'list[NotebookField]'
    }

    attribute_map = {
        'paths': 'paths',
        'created_at_query': 'createdAtQuery',
        'updated_at_query': 'updatedAtQuery',
        'parameters': 'parameters',
        'metadata': 'metadata',
        'metadata_array_contains': 'metadataArrayContains',
        'sort_by': 'sortBy',
        'projection': 'projection'
    }

    def __init__(self, paths=None, created_at_query=None, updated_at_query=None, parameters=None, metadata=None, metadata_array_contains=None, sort_by=None, projection=None, local_vars_configuration=None):  # noqa: E501
        """NotebookQueryObject - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._paths = None
        self._created_at_query = None
        self._updated_at_query = None
        self._parameters = None
        self._metadata = None
        self._metadata_array_contains = None
        self._sort_by = None
        self._projection = None
        self.discriminator = None

        if paths is not None:
            self.paths = paths
        if created_at_query is not None:
            self.created_at_query = created_at_query
        if updated_at_query is not None:
            self.updated_at_query = updated_at_query
        if parameters is not None:
            self.parameters = parameters
        if metadata is not None:
            self.metadata = metadata
        if metadata_array_contains is not None:
            self.metadata_array_contains = metadata_array_contains
        if sort_by is not None:
            self.sort_by = sort_by
        if projection is not None:
            self.projection = projection

    @property
    def paths(self):
        """Gets the paths of this NotebookQueryObject.  # noqa: E501

        Array of notebook paths  # noqa: E501

        :return: The paths of this NotebookQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._paths

    @paths.setter
    def paths(self, paths):
        """Sets the paths of this NotebookQueryObject.

        Array of notebook paths  # noqa: E501

        :param paths: The paths of this NotebookQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._paths = paths

    @property
    def created_at_query(self):
        """Gets the created_at_query of this NotebookQueryObject.  # noqa: E501

        Array of time query objects for when the notebook was created  # noqa: E501

        :return: The created_at_query of this NotebookQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._created_at_query

    @created_at_query.setter
    def created_at_query(self, created_at_query):
        """Sets the created_at_query of this NotebookQueryObject.

        Array of time query objects for when the notebook was created  # noqa: E501

        :param created_at_query: The created_at_query of this NotebookQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._created_at_query = created_at_query

    @property
    def updated_at_query(self):
        """Gets the updated_at_query of this NotebookQueryObject.  # noqa: E501

        Array of time query objects for when the notebook was modified  # noqa: E501

        :return: The updated_at_query of this NotebookQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._updated_at_query

    @updated_at_query.setter
    def updated_at_query(self, updated_at_query):
        """Sets the updated_at_query of this NotebookQueryObject.

        Array of time query objects for when the notebook was modified  # noqa: E501

        :param updated_at_query: The updated_at_query of this NotebookQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._updated_at_query = updated_at_query

    @property
    def parameters(self):
        """Gets the parameters of this NotebookQueryObject.  # noqa: E501

        Array of input parameter dictionaries and their default values. When querying, entries in the same dictionary must all match (an \"and\" relationship within dictionaries). Only one of the dictionaries need to match the query (an \"or\" relationship between different dictionaries).  # noqa: E501

        :return: The parameters of this NotebookQueryObject.  # noqa: E501
        :rtype: list[dict(str, object)]
        """
        return self._parameters

    @parameters.setter
    def parameters(self, parameters):
        """Sets the parameters of this NotebookQueryObject.

        Array of input parameter dictionaries and their default values. When querying, entries in the same dictionary must all match (an \"and\" relationship within dictionaries). Only one of the dictionaries need to match the query (an \"or\" relationship between different dictionaries).  # noqa: E501

        :param parameters: The parameters of this NotebookQueryObject.  # noqa: E501
        :type: list[dict(str, object)]
        """

        self._parameters = parameters

    @property
    def metadata(self):
        """Gets the metadata of this NotebookQueryObject.  # noqa: E501

        Array of metadata dictionaries to query for. When querying, entries within the same dictionary must all match (an \"and\" relationship within dictionaries). Only one of the dictionaries need to match the query (an \"or\" relationship between different dictionaries).  # noqa: E501

        :return: The metadata of this NotebookQueryObject.  # noqa: E501
        :rtype: list[dict(str, object)]
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this NotebookQueryObject.

        Array of metadata dictionaries to query for. When querying, entries within the same dictionary must all match (an \"and\" relationship within dictionaries). Only one of the dictionaries need to match the query (an \"or\" relationship between different dictionaries).  # noqa: E501

        :param metadata: The metadata of this NotebookQueryObject.  # noqa: E501
        :type: list[dict(str, object)]
        """

        self._metadata = metadata

    @property
    def metadata_array_contains(self):
        """Gets the metadata_array_contains of this NotebookQueryObject.  # noqa: E501

        This is a specialized query on the metadata dictionary. It is designed to query one or more arrays inside the metadata dictionary such that these arrays contain at least one instance of the specified value. It is represented by an array of an array of objects referred to as 'Array Contains Objects'. When querying, all elements of the inner array of 'Array Contains Objects' must match (an \"and\" relationship within the inner array). Only one element in the outer array needs to match (an \"or\" relationship within the outer array).  # noqa: E501

        :return: The metadata_array_contains of this NotebookQueryObject.  # noqa: E501
        :rtype: list[list[ArrayContainsObject]]
        """
        return self._metadata_array_contains

    @metadata_array_contains.setter
    def metadata_array_contains(self, metadata_array_contains):
        """Sets the metadata_array_contains of this NotebookQueryObject.

        This is a specialized query on the metadata dictionary. It is designed to query one or more arrays inside the metadata dictionary such that these arrays contain at least one instance of the specified value. It is represented by an array of an array of objects referred to as 'Array Contains Objects'. When querying, all elements of the inner array of 'Array Contains Objects' must match (an \"and\" relationship within the inner array). Only one element in the outer array needs to match (an \"or\" relationship within the outer array).  # noqa: E501

        :param metadata_array_contains: The metadata_array_contains of this NotebookQueryObject.  # noqa: E501
        :type: list[list[ArrayContainsObject]]
        """

        self._metadata_array_contains = metadata_array_contains

    @property
    def sort_by(self):
        """Gets the sort_by of this NotebookQueryObject.  # noqa: E501

        Array of notebook sort definition objects to define how to sort the results  # noqa: E501

        :return: The sort_by of this NotebookQueryObject.  # noqa: E501
        :rtype: list[NotebookSortDefinitionObject]
        """
        return self._sort_by

    @sort_by.setter
    def sort_by(self, sort_by):
        """Sets the sort_by of this NotebookQueryObject.

        Array of notebook sort definition objects to define how to sort the results  # noqa: E501

        :param sort_by: The sort_by of this NotebookQueryObject.  # noqa: E501
        :type: list[NotebookSortDefinitionObject]
        """

        self._sort_by = sort_by

    @property
    def projection(self):
        """Gets the projection of this NotebookQueryObject.  # noqa: E501

        Array of notebook fields. If you specify an array, the query returns a result with the notebook objects containing the fields that are both specified and available. If you do not specify an array, the query will return a result with the notebook objects containing all available fields.  # noqa: E501

        :return: The projection of this NotebookQueryObject.  # noqa: E501
        :rtype: list[NotebookField]
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this NotebookQueryObject.

        Array of notebook fields. If you specify an array, the query returns a result with the notebook objects containing the fields that are both specified and available. If you do not specify an array, the query will return a result with the notebook objects containing all available fields.  # noqa: E501

        :param projection: The projection of this NotebookQueryObject.  # noqa: E501
        :type: list[NotebookField]
        """

        self._projection = projection

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NotebookQueryObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NotebookQueryObject):
            return True

        return self.to_dict() != other.to_dict()
