# coding: utf-8

"""
    OpcClientService HTTP APIs

    OpcClientService HTTP APIs  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niopcclient.configuration import Configuration


class NewMonitoredItem(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'display_name': 'str',
        'opc_node_id': 'str',
        'direction': 'MonitoredItemDirectionEnum',
        'opc_sampling_interval': 'int',
        'opc_queue_size': 'int'
    }

    attribute_map = {
        'display_name': 'displayName',
        'opc_node_id': 'opcNodeId',
        'direction': 'direction',
        'opc_sampling_interval': 'opcSamplingInterval',
        'opc_queue_size': 'opcQueueSize'
    }

    def __init__(self, display_name=None, opc_node_id=None, direction=None, opc_sampling_interval=0, opc_queue_size=1000, local_vars_configuration=None):  # noqa: E501
        """NewMonitoredItem - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._display_name = None
        self._opc_node_id = None
        self._direction = None
        self._opc_sampling_interval = None
        self._opc_queue_size = None
        self.discriminator = None

        self.display_name = display_name
        self.opc_node_id = opc_node_id
        if direction is not None:
            self.direction = direction
        if opc_sampling_interval is not None:
            self.opc_sampling_interval = opc_sampling_interval
        if opc_queue_size is not None:
            self.opc_queue_size = opc_queue_size

    @property
    def display_name(self):
        """Gets the display_name of this NewMonitoredItem.  # noqa: E501

        Name of the SystemLink tag to be created for this monitored item  # noqa: E501

        :return: The display_name of this NewMonitoredItem.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this NewMonitoredItem.

        Name of the SystemLink tag to be created for this monitored item  # noqa: E501

        :param display_name: The display_name of this NewMonitoredItem.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and display_name is None:  # noqa: E501
            raise ValueError("Invalid value for `display_name`, must not be `None`")  # noqa: E501

        self._display_name = display_name

    @property
    def opc_node_id(self):
        """Gets the opc_node_id of this NewMonitoredItem.  # noqa: E501

        OPC Node Id for the node on the OPC UA server  # noqa: E501

        :return: The opc_node_id of this NewMonitoredItem.  # noqa: E501
        :rtype: str
        """
        return self._opc_node_id

    @opc_node_id.setter
    def opc_node_id(self, opc_node_id):
        """Sets the opc_node_id of this NewMonitoredItem.

        OPC Node Id for the node on the OPC UA server  # noqa: E501

        :param opc_node_id: The opc_node_id of this NewMonitoredItem.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and opc_node_id is None:  # noqa: E501
            raise ValueError("Invalid value for `opc_node_id`, must not be `None`")  # noqa: E501

        self._opc_node_id = opc_node_id

    @property
    def direction(self):
        """Gets the direction of this NewMonitoredItem.  # noqa: E501


        :return: The direction of this NewMonitoredItem.  # noqa: E501
        :rtype: MonitoredItemDirectionEnum
        """
        return self._direction

    @direction.setter
    def direction(self, direction):
        """Sets the direction of this NewMonitoredItem.


        :param direction: The direction of this NewMonitoredItem.  # noqa: E501
        :type: MonitoredItemDirectionEnum
        """

        self._direction = direction

    @property
    def opc_sampling_interval(self):
        """Gets the opc_sampling_interval of this NewMonitoredItem.  # noqa: E501

        Sampling interval at which the OPC UA server should sample the values  # noqa: E501

        :return: The opc_sampling_interval of this NewMonitoredItem.  # noqa: E501
        :rtype: int
        """
        return self._opc_sampling_interval

    @opc_sampling_interval.setter
    def opc_sampling_interval(self, opc_sampling_interval):
        """Sets the opc_sampling_interval of this NewMonitoredItem.

        Sampling interval at which the OPC UA server should sample the values  # noqa: E501

        :param opc_sampling_interval: The opc_sampling_interval of this NewMonitoredItem.  # noqa: E501
        :type: int
        """

        self._opc_sampling_interval = opc_sampling_interval

    @property
    def opc_queue_size(self):
        """Gets the opc_queue_size of this NewMonitoredItem.  # noqa: E501

        Queue size that the OPC server should reserve for this node  # noqa: E501

        :return: The opc_queue_size of this NewMonitoredItem.  # noqa: E501
        :rtype: int
        """
        return self._opc_queue_size

    @opc_queue_size.setter
    def opc_queue_size(self, opc_queue_size):
        """Sets the opc_queue_size of this NewMonitoredItem.

        Queue size that the OPC server should reserve for this node  # noqa: E501

        :param opc_queue_size: The opc_queue_size of this NewMonitoredItem.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                opc_queue_size is not None and opc_queue_size < 0):  # noqa: E501
            raise ValueError("Invalid value for `opc_queue_size`, must be a value greater than or equal to `0`")  # noqa: E501

        self._opc_queue_size = opc_queue_size

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewMonitoredItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NewMonitoredItem):
            return True

        return self.to_dict() != other.to_dict()
