# coding: utf-8

"""
    OpcClientService HTTP APIs

    OpcClientService HTTP APIs  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niopcclient.configuration import Configuration


class NewSessionRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'url': 'str',
        'monitoring_interval': 'int',
        'use_discovery_certificate': 'bool',
        'endpoint': 'SelectedEndpointModel'
    }

    attribute_map = {
        'name': 'name',
        'url': 'url',
        'monitoring_interval': 'monitoringInterval',
        'use_discovery_certificate': 'useDiscoveryCertificate',
        'endpoint': 'endpoint'
    }

    def __init__(self, name=None, url=None, monitoring_interval=10000, use_discovery_certificate=None, endpoint=None, local_vars_configuration=None):  # noqa: E501
        """NewSessionRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._url = None
        self._monitoring_interval = None
        self._use_discovery_certificate = None
        self._endpoint = None
        self.discriminator = None

        self.name = name
        self.url = url
        if monitoring_interval is not None:
            self.monitoring_interval = monitoring_interval
        self.use_discovery_certificate = use_discovery_certificate
        self.endpoint = endpoint

    @property
    def name(self):
        """Gets the name of this NewSessionRequest.  # noqa: E501

        Name of the OPC UA session  # noqa: E501

        :return: The name of this NewSessionRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this NewSessionRequest.

        Name of the OPC UA session  # noqa: E501

        :param name: The name of this NewSessionRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def url(self):
        """Gets the url of this NewSessionRequest.  # noqa: E501

        URL of the OPC UA server  # noqa: E501

        :return: The url of this NewSessionRequest.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this NewSessionRequest.

        URL of the OPC UA server  # noqa: E501

        :param url: The url of this NewSessionRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and url is None:  # noqa: E501
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def monitoring_interval(self):
        """Gets the monitoring_interval of this NewSessionRequest.  # noqa: E501

        Publishing interval, in milliseconds, for monitoring nodes. Must be greater than or equal to 1000.  # noqa: E501

        :return: The monitoring_interval of this NewSessionRequest.  # noqa: E501
        :rtype: int
        """
        return self._monitoring_interval

    @monitoring_interval.setter
    def monitoring_interval(self, monitoring_interval):
        """Sets the monitoring_interval of this NewSessionRequest.

        Publishing interval, in milliseconds, for monitoring nodes. Must be greater than or equal to 1000.  # noqa: E501

        :param monitoring_interval: The monitoring_interval of this NewSessionRequest.  # noqa: E501
        :type: int
        """

        self._monitoring_interval = monitoring_interval

    @property
    def use_discovery_certificate(self):
        """Gets the use_discovery_certificate of this NewSessionRequest.  # noqa: E501

        If set to true, the SSL certificate provided by discovery server is used  # noqa: E501

        :return: The use_discovery_certificate of this NewSessionRequest.  # noqa: E501
        :rtype: bool
        """
        return self._use_discovery_certificate

    @use_discovery_certificate.setter
    def use_discovery_certificate(self, use_discovery_certificate):
        """Sets the use_discovery_certificate of this NewSessionRequest.

        If set to true, the SSL certificate provided by discovery server is used  # noqa: E501

        :param use_discovery_certificate: The use_discovery_certificate of this NewSessionRequest.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and use_discovery_certificate is None:  # noqa: E501
            raise ValueError("Invalid value for `use_discovery_certificate`, must not be `None`")  # noqa: E501

        self._use_discovery_certificate = use_discovery_certificate

    @property
    def endpoint(self):
        """Gets the endpoint of this NewSessionRequest.  # noqa: E501


        :return: The endpoint of this NewSessionRequest.  # noqa: E501
        :rtype: SelectedEndpointModel
        """
        return self._endpoint

    @endpoint.setter
    def endpoint(self, endpoint):
        """Sets the endpoint of this NewSessionRequest.


        :param endpoint: The endpoint of this NewSessionRequest.  # noqa: E501
        :type: SelectedEndpointModel
        """
        if self.local_vars_configuration.client_side_validation and endpoint is None:  # noqa: E501
            raise ValueError("Invalid value for `endpoint`, must not be `None`")  # noqa: E501

        self._endpoint = endpoint

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, NewSessionRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, NewSessionRequest):
            return True

        return self.to_dict() != other.to_dict()
