# coding: utf-8

"""
    OpcClientService HTTP APIs

    OpcClientService HTTP APIs  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niopcclient.configuration import Configuration


class OpcNode(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'display_name': 'str',
        'browse_path': 'str',
        'is_leaf': 'bool',
        'opc_nodes': 'list[OpcNode]'
    }

    attribute_map = {
        'id': 'id',
        'display_name': 'displayName',
        'browse_path': 'browsePath',
        'is_leaf': 'isLeaf',
        'opc_nodes': 'opcNodes'
    }

    def __init__(self, id=None, display_name=None, browse_path=None, is_leaf=None, opc_nodes=None, local_vars_configuration=None):  # noqa: E501
        """OpcNode - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._display_name = None
        self._browse_path = None
        self._is_leaf = None
        self._opc_nodes = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if display_name is not None:
            self.display_name = display_name
        if browse_path is not None:
            self.browse_path = browse_path
        if is_leaf is not None:
            self.is_leaf = is_leaf
        if opc_nodes is not None:
            self.opc_nodes = opc_nodes

    @property
    def id(self):
        """Gets the id of this OpcNode.  # noqa: E501

        NodeId of the node on the OPC UA server  # noqa: E501

        :return: The id of this OpcNode.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this OpcNode.

        NodeId of the node on the OPC UA server  # noqa: E501

        :param id: The id of this OpcNode.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def display_name(self):
        """Gets the display_name of this OpcNode.  # noqa: E501

        Display name of the node on the OPC UA server  # noqa: E501

        :return: The display_name of this OpcNode.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this OpcNode.

        Display name of the node on the OPC UA server  # noqa: E501

        :param display_name: The display_name of this OpcNode.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def browse_path(self):
        """Gets the browse_path of this OpcNode.  # noqa: E501

        Browse path of the node on the OPC UA server  # noqa: E501

        :return: The browse_path of this OpcNode.  # noqa: E501
        :rtype: str
        """
        return self._browse_path

    @browse_path.setter
    def browse_path(self, browse_path):
        """Sets the browse_path of this OpcNode.

        Browse path of the node on the OPC UA server  # noqa: E501

        :param browse_path: The browse_path of this OpcNode.  # noqa: E501
        :type: str
        """

        self._browse_path = browse_path

    @property
    def is_leaf(self):
        """Gets the is_leaf of this OpcNode.  # noqa: E501

        If set to true then the node doesn't have any child nodes  # noqa: E501

        :return: The is_leaf of this OpcNode.  # noqa: E501
        :rtype: bool
        """
        return self._is_leaf

    @is_leaf.setter
    def is_leaf(self, is_leaf):
        """Sets the is_leaf of this OpcNode.

        If set to true then the node doesn't have any child nodes  # noqa: E501

        :param is_leaf: The is_leaf of this OpcNode.  # noqa: E501
        :type: bool
        """

        self._is_leaf = is_leaf

    @property
    def opc_nodes(self):
        """Gets the opc_nodes of this OpcNode.  # noqa: E501

        child nodes of the node  # noqa: E501

        :return: The opc_nodes of this OpcNode.  # noqa: E501
        :rtype: list[OpcNode]
        """
        return self._opc_nodes

    @opc_nodes.setter
    def opc_nodes(self, opc_nodes):
        """Sets the opc_nodes of this OpcNode.

        child nodes of the node  # noqa: E501

        :param opc_nodes: The opc_nodes of this OpcNode.  # noqa: E501
        :type: list[OpcNode]
        """

        self._opc_nodes = opc_nodes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OpcNode):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OpcNode):
            return True

        return self.to_dict() != other.to_dict()
