# coding: utf-8

"""
    OpcClientService HTTP APIs

    OpcClientService HTTP APIs  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niopcclient.configuration import Configuration


class SelectedEndpointModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'security_mode': 'SecurityModeEnum',
        'security_policy': 'str',
        'token_type': 'UserTokenTypeEnum',
        'user_token_security_policy': 'str',
        'user_name': 'str',
        'password': 'str',
        'x509_certificate_data': 'str'
    }

    attribute_map = {
        'security_mode': 'securityMode',
        'security_policy': 'securityPolicy',
        'token_type': 'tokenType',
        'user_token_security_policy': 'userTokenSecurityPolicy',
        'user_name': 'userName',
        'password': 'password',
        'x509_certificate_data': 'x509CertificateData'
    }

    def __init__(self, security_mode=None, security_policy=None, token_type=None, user_token_security_policy='', user_name='', password='', x509_certificate_data='', local_vars_configuration=None):  # noqa: E501
        """SelectedEndpointModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._security_mode = None
        self._security_policy = None
        self._token_type = None
        self._user_token_security_policy = None
        self._user_name = None
        self._password = None
        self._x509_certificate_data = None
        self.discriminator = None

        self.security_mode = security_mode
        self.security_policy = security_policy
        self.token_type = token_type
        if user_token_security_policy is not None:
            self.user_token_security_policy = user_token_security_policy
        if user_name is not None:
            self.user_name = user_name
        if password is not None:
            self.password = password
        if x509_certificate_data is not None:
            self.x509_certificate_data = x509_certificate_data

    @property
    def security_mode(self):
        """Gets the security_mode of this SelectedEndpointModel.  # noqa: E501


        :return: The security_mode of this SelectedEndpointModel.  # noqa: E501
        :rtype: SecurityModeEnum
        """
        return self._security_mode

    @security_mode.setter
    def security_mode(self, security_mode):
        """Sets the security_mode of this SelectedEndpointModel.


        :param security_mode: The security_mode of this SelectedEndpointModel.  # noqa: E501
        :type: SecurityModeEnum
        """
        if self.local_vars_configuration.client_side_validation and security_mode is None:  # noqa: E501
            raise ValueError("Invalid value for `security_mode`, must not be `None`")  # noqa: E501

        self._security_mode = security_mode

    @property
    def security_policy(self):
        """Gets the security_policy of this SelectedEndpointModel.  # noqa: E501

        Security policy used by the endpoint  # noqa: E501

        :return: The security_policy of this SelectedEndpointModel.  # noqa: E501
        :rtype: str
        """
        return self._security_policy

    @security_policy.setter
    def security_policy(self, security_policy):
        """Sets the security_policy of this SelectedEndpointModel.

        Security policy used by the endpoint  # noqa: E501

        :param security_policy: The security_policy of this SelectedEndpointModel.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and security_policy is None:  # noqa: E501
            raise ValueError("Invalid value for `security_policy`, must not be `None`")  # noqa: E501

        self._security_policy = security_policy

    @property
    def token_type(self):
        """Gets the token_type of this SelectedEndpointModel.  # noqa: E501


        :return: The token_type of this SelectedEndpointModel.  # noqa: E501
        :rtype: UserTokenTypeEnum
        """
        return self._token_type

    @token_type.setter
    def token_type(self, token_type):
        """Sets the token_type of this SelectedEndpointModel.


        :param token_type: The token_type of this SelectedEndpointModel.  # noqa: E501
        :type: UserTokenTypeEnum
        """
        if self.local_vars_configuration.client_side_validation and token_type is None:  # noqa: E501
            raise ValueError("Invalid value for `token_type`, must not be `None`")  # noqa: E501

        self._token_type = token_type

    @property
    def user_token_security_policy(self):
        """Gets the user_token_security_policy of this SelectedEndpointModel.  # noqa: E501

        Security policy used by the endpoint for encrypting the user identification information  # noqa: E501

        :return: The user_token_security_policy of this SelectedEndpointModel.  # noqa: E501
        :rtype: str
        """
        return self._user_token_security_policy

    @user_token_security_policy.setter
    def user_token_security_policy(self, user_token_security_policy):
        """Sets the user_token_security_policy of this SelectedEndpointModel.

        Security policy used by the endpoint for encrypting the user identification information  # noqa: E501

        :param user_token_security_policy: The user_token_security_policy of this SelectedEndpointModel.  # noqa: E501
        :type: str
        """

        self._user_token_security_policy = user_token_security_policy

    @property
    def user_name(self):
        """Gets the user_name of this SelectedEndpointModel.  # noqa: E501

        user name  # noqa: E501

        :return: The user_name of this SelectedEndpointModel.  # noqa: E501
        :rtype: str
        """
        return self._user_name

    @user_name.setter
    def user_name(self, user_name):
        """Sets the user_name of this SelectedEndpointModel.

        user name  # noqa: E501

        :param user_name: The user_name of this SelectedEndpointModel.  # noqa: E501
        :type: str
        """

        self._user_name = user_name

    @property
    def password(self):
        """Gets the password of this SelectedEndpointModel.  # noqa: E501

        password. Request objects should contain the actual password. Response objects will contain the encrypted password.  # noqa: E501

        :return: The password of this SelectedEndpointModel.  # noqa: E501
        :rtype: str
        """
        return self._password

    @password.setter
    def password(self, password):
        """Sets the password of this SelectedEndpointModel.

        password. Request objects should contain the actual password. Response objects will contain the encrypted password.  # noqa: E501

        :param password: The password of this SelectedEndpointModel.  # noqa: E501
        :type: str
        """

        self._password = password

    @property
    def x509_certificate_data(self):
        """Gets the x509_certificate_data of this SelectedEndpointModel.  # noqa: E501

        certificate to authenticate the user  # noqa: E501

        :return: The x509_certificate_data of this SelectedEndpointModel.  # noqa: E501
        :rtype: str
        """
        return self._x509_certificate_data

    @x509_certificate_data.setter
    def x509_certificate_data(self, x509_certificate_data):
        """Sets the x509_certificate_data of this SelectedEndpointModel.

        certificate to authenticate the user  # noqa: E501

        :param x509_certificate_data: The x509_certificate_data of this SelectedEndpointModel.  # noqa: E501
        :type: str
        """
        if (self.local_vars_configuration.client_side_validation and
                x509_certificate_data is not None and not re.search(r'^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$', x509_certificate_data)):  # noqa: E501
            raise ValueError(r"Invalid value for `x509_certificate_data`, must be a follow pattern or equal to `/^(?:[A-Za-z0-9+\/]{4})*(?:[A-Za-z0-9+\/]{2}==|[A-Za-z0-9+\/]{3}=)?$/`")  # noqa: E501

        self._x509_certificate_data = x509_certificate_data

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SelectedEndpointModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SelectedEndpointModel):
            return True

        return self.to_dict() != other.to_dict()
