# coding: utf-8

"""
    OpcClientService HTTP APIs

    OpcClientService HTTP APIs  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niopcclient.configuration import Configuration


class SessionEndpointModel(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'security_mode': 'SecurityModeEnum',
        'security_policy': 'str',
        'certificate_info': 'SslCertificateInfoModel',
        'supported_user_identities': 'list[SessionUserToken]'
    }

    attribute_map = {
        'security_mode': 'securityMode',
        'security_policy': 'securityPolicy',
        'certificate_info': 'certificateInfo',
        'supported_user_identities': 'supportedUserIdentities'
    }

    def __init__(self, security_mode=None, security_policy=None, certificate_info=None, supported_user_identities=None, local_vars_configuration=None):  # noqa: E501
        """SessionEndpointModel - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._security_mode = None
        self._security_policy = None
        self._certificate_info = None
        self._supported_user_identities = None
        self.discriminator = None

        if security_mode is not None:
            self.security_mode = security_mode
        if security_policy is not None:
            self.security_policy = security_policy
        if certificate_info is not None:
            self.certificate_info = certificate_info
        if supported_user_identities is not None:
            self.supported_user_identities = supported_user_identities

    @property
    def security_mode(self):
        """Gets the security_mode of this SessionEndpointModel.  # noqa: E501


        :return: The security_mode of this SessionEndpointModel.  # noqa: E501
        :rtype: SecurityModeEnum
        """
        return self._security_mode

    @security_mode.setter
    def security_mode(self, security_mode):
        """Sets the security_mode of this SessionEndpointModel.


        :param security_mode: The security_mode of this SessionEndpointModel.  # noqa: E501
        :type: SecurityModeEnum
        """

        self._security_mode = security_mode

    @property
    def security_policy(self):
        """Gets the security_policy of this SessionEndpointModel.  # noqa: E501

        Security policy used by the endpoint  # noqa: E501

        :return: The security_policy of this SessionEndpointModel.  # noqa: E501
        :rtype: str
        """
        return self._security_policy

    @security_policy.setter
    def security_policy(self, security_policy):
        """Sets the security_policy of this SessionEndpointModel.

        Security policy used by the endpoint  # noqa: E501

        :param security_policy: The security_policy of this SessionEndpointModel.  # noqa: E501
        :type: str
        """

        self._security_policy = security_policy

    @property
    def certificate_info(self):
        """Gets the certificate_info of this SessionEndpointModel.  # noqa: E501


        :return: The certificate_info of this SessionEndpointModel.  # noqa: E501
        :rtype: SslCertificateInfoModel
        """
        return self._certificate_info

    @certificate_info.setter
    def certificate_info(self, certificate_info):
        """Sets the certificate_info of this SessionEndpointModel.


        :param certificate_info: The certificate_info of this SessionEndpointModel.  # noqa: E501
        :type: SslCertificateInfoModel
        """

        self._certificate_info = certificate_info

    @property
    def supported_user_identities(self):
        """Gets the supported_user_identities of this SessionEndpointModel.  # noqa: E501

        List of user authentication schemes supported by the endpoint  # noqa: E501

        :return: The supported_user_identities of this SessionEndpointModel.  # noqa: E501
        :rtype: list[SessionUserToken]
        """
        return self._supported_user_identities

    @supported_user_identities.setter
    def supported_user_identities(self, supported_user_identities):
        """Sets the supported_user_identities of this SessionEndpointModel.

        List of user authentication schemes supported by the endpoint  # noqa: E501

        :param supported_user_identities: The supported_user_identities of this SessionEndpointModel.  # noqa: E501
        :type: list[SessionUserToken]
        """

        self._supported_user_identities = supported_user_identities

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SessionEndpointModel):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SessionEndpointModel):
            return True

        return self.to_dict() != other.to_dict()
