# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from systemlink.clients.nirepo.api_client import ApiClient
from systemlink.clients.nirepo.exceptions import (
    ApiTypeError,
    ApiValueError
)


class FilesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def download_files(self, path_to_file, **kwargs):  # noqa: E501
        """Download files located in Package Repository  # noqa: E501

        Download files located in Package Repository.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_files(path_to_file, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str path_to_file: The path to the file to download. (required)
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: file
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.download_files_with_http_info(path_to_file, **kwargs)  # noqa: E501

    def download_files_with_http_info(self, path_to_file, **kwargs):  # noqa: E501
        """Download files located in Package Repository  # noqa: E501

        Download files located in Package Repository.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.download_files_with_http_info(path_to_file, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str path_to_file: The path to the file to download. (required)
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: tuple(file, status_code(int), headers(HTTPHeaderDict))
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['path_to_file']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method download_files" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'path_to_file' is set
        if self.api_client.client_side_validation and ('path_to_file' not in local_var_params or  # noqa: E501
                                                        local_var_params['path_to_file'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `path_to_file` when calling `download_files`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'path_to_file' in local_var_params:
            path_params['pathToFile'] = local_var_params['path_to_file']  # noqa: E501

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/octet-stream'])  # noqa: E501

        # Authentication setting
        auth_settings = ['apiKeyAuth', 'basicAuth', 'cookieAuth']  # noqa: E501

        return self.api_client.call_api(
            '/v1/files/{pathToFile}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='file',  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
