# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class Feed(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'feed_name': 'str',
        'name': 'str',
        'directory_uri': 'str',
        'description': 'str',
        'platform': 'Platform',
        'workspace': 'str',
        'package_references': 'list[str]',
        'package_sources': 'list[str]',
        'last_updated': 'datetime',
        'ready': 'bool'
    }

    attribute_map = {
        'id': 'id',
        'feed_name': 'feedName',
        'name': 'name',
        'directory_uri': 'directoryUri',
        'description': 'description',
        'platform': 'platform',
        'workspace': 'workspace',
        'package_references': 'packageReferences',
        'package_sources': 'packageSources',
        'last_updated': 'lastUpdated',
        'ready': 'ready'
    }

    def __init__(self, id=None, feed_name=None, name=None, directory_uri=None, description=None, platform=None, workspace=None, package_references=None, package_sources=None, last_updated=None, ready=None, local_vars_configuration=None):  # noqa: E501
        """Feed - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._feed_name = None
        self._name = None
        self._directory_uri = None
        self._description = None
        self._platform = None
        self._workspace = None
        self._package_references = None
        self._package_sources = None
        self._last_updated = None
        self._ready = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if feed_name is not None:
            self.feed_name = feed_name
        if name is not None:
            self.name = name
        if directory_uri is not None:
            self.directory_uri = directory_uri
        if description is not None:
            self.description = description
        if platform is not None:
            self.platform = platform
        if workspace is not None:
            self.workspace = workspace
        if package_references is not None:
            self.package_references = package_references
        if package_sources is not None:
            self.package_sources = package_sources
        if last_updated is not None:
            self.last_updated = last_updated
        if ready is not None:
            self.ready = ready

    @property
    def id(self):
        """Gets the id of this Feed.  # noqa: E501

        The unique ID of this feed.  # noqa: E501

        :return: The id of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Feed.

        The unique ID of this feed.  # noqa: E501

        :param id: The id of this Feed.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def feed_name(self):
        """Gets the feed_name of this Feed.  # noqa: E501

        The name of this feed.  # noqa: E501

        :return: The feed_name of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._feed_name

    @feed_name.setter
    def feed_name(self, feed_name):
        """Sets the feed_name of this Feed.

        The name of this feed.  # noqa: E501

        :param feed_name: The feed_name of this Feed.  # noqa: E501
        :type: str
        """

        self._feed_name = feed_name

    @property
    def name(self):
        """Gets the name of this Feed.  # noqa: E501

        The name of this feed.  # noqa: E501

        :return: The name of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Feed.

        The name of this feed.  # noqa: E501

        :param name: The name of this Feed.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def directory_uri(self):
        """Gets the directory_uri of this Feed.  # noqa: E501

        The location of this feed.  # noqa: E501

        :return: The directory_uri of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._directory_uri

    @directory_uri.setter
    def directory_uri(self, directory_uri):
        """Sets the directory_uri of this Feed.

        The location of this feed.  # noqa: E501

        :param directory_uri: The directory_uri of this Feed.  # noqa: E501
        :type: str
        """

        self._directory_uri = directory_uri

    @property
    def description(self):
        """Gets the description of this Feed.  # noqa: E501

        The description of this feed.  # noqa: E501

        :return: The description of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this Feed.

        The description of this feed.  # noqa: E501

        :param description: The description of this Feed.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def platform(self):
        """Gets the platform of this Feed.  # noqa: E501


        :return: The platform of this Feed.  # noqa: E501
        :rtype: Platform
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this Feed.


        :param platform: The platform of this Feed.  # noqa: E501
        :type: Platform
        """

        self._platform = platform

    @property
    def workspace(self):
        """Gets the workspace of this Feed.  # noqa: E501

        The workspace's id where the feed belongs to  # noqa: E501

        :return: The workspace of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this Feed.

        The workspace's id where the feed belongs to  # noqa: E501

        :param workspace: The workspace of this Feed.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def package_references(self):
        """Gets the package_references of this Feed.  # noqa: E501

        An array containing the IDs of the packages in this feed.  # noqa: E501

        :return: The package_references of this Feed.  # noqa: E501
        :rtype: list[str]
        """
        return self._package_references

    @package_references.setter
    def package_references(self, package_references):
        """Sets the package_references of this Feed.

        An array containing the IDs of the packages in this feed.  # noqa: E501

        :param package_references: The package_references of this Feed.  # noqa: E501
        :type: list[str]
        """

        self._package_references = package_references

    @property
    def package_sources(self):
        """Gets the package_sources of this Feed.  # noqa: E501

        IDs and/or external URIs of package sources  # noqa: E501

        :return: The package_sources of this Feed.  # noqa: E501
        :rtype: list[str]
        """
        return self._package_sources

    @package_sources.setter
    def package_sources(self, package_sources):
        """Sets the package_sources of this Feed.

        IDs and/or external URIs of package sources  # noqa: E501

        :param package_sources: The package_sources of this Feed.  # noqa: E501
        :type: list[str]
        """

        self._package_sources = package_sources

    @property
    def last_updated(self):
        """Gets the last_updated of this Feed.  # noqa: E501

        The date this feed was last updated at.  # noqa: E501

        :return: The last_updated of this Feed.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this Feed.

        The date this feed was last updated at.  # noqa: E501

        :param last_updated: The last_updated of this Feed.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def ready(self):
        """Gets the ready of this Feed.  # noqa: E501

        If the job that creates this feed is complete.  # noqa: E501

        :return: The ready of this Feed.  # noqa: E501
        :rtype: bool
        """
        return self._ready

    @ready.setter
    def ready(self, ready):
        """Sets the ready of this Feed.

        If the job that creates this feed is complete.  # noqa: E501

        :param ready: The ready of this Feed.  # noqa: E501
        :type: bool
        """

        self._ready = ready

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Feed):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Feed):
            return True

        return self.to_dict() != other.to_dict()
