# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class FeedDataWithURI(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'feed_name': 'str',
        'name': 'str',
        'description': 'str',
        'platform': 'Platform',
        'workspace': 'str',
        'uri': 'str'
    }

    attribute_map = {
        'feed_name': 'feedName',
        'name': 'name',
        'description': 'description',
        'platform': 'platform',
        'workspace': 'workspace',
        'uri': 'uri'
    }

    def __init__(self, feed_name=None, name=None, description=None, platform=None, workspace=None, uri=None, local_vars_configuration=None):  # noqa: E501
        """FeedDataWithURI - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._feed_name = None
        self._name = None
        self._description = None
        self._platform = None
        self._workspace = None
        self._uri = None
        self.discriminator = None

        if feed_name is not None:
            self.feed_name = feed_name
        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if platform is not None:
            self.platform = platform
        if workspace is not None:
            self.workspace = workspace
        if uri is not None:
            self.uri = uri

    @property
    def feed_name(self):
        """Gets the feed_name of this FeedDataWithURI.  # noqa: E501

        The name of this feed.  # noqa: E501

        :return: The feed_name of this FeedDataWithURI.  # noqa: E501
        :rtype: str
        """
        return self._feed_name

    @feed_name.setter
    def feed_name(self, feed_name):
        """Sets the feed_name of this FeedDataWithURI.

        The name of this feed.  # noqa: E501

        :param feed_name: The feed_name of this FeedDataWithURI.  # noqa: E501
        :type: str
        """

        self._feed_name = feed_name

    @property
    def name(self):
        """Gets the name of this FeedDataWithURI.  # noqa: E501

        The name of the feed.  # noqa: E501

        :return: The name of this FeedDataWithURI.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this FeedDataWithURI.

        The name of the feed.  # noqa: E501

        :param name: The name of this FeedDataWithURI.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this FeedDataWithURI.  # noqa: E501

        A short description of the feed.  # noqa: E501

        :return: The description of this FeedDataWithURI.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this FeedDataWithURI.

        A short description of the feed.  # noqa: E501

        :param description: The description of this FeedDataWithURI.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def platform(self):
        """Gets the platform of this FeedDataWithURI.  # noqa: E501


        :return: The platform of this FeedDataWithURI.  # noqa: E501
        :rtype: Platform
        """
        return self._platform

    @platform.setter
    def platform(self, platform):
        """Sets the platform of this FeedDataWithURI.


        :param platform: The platform of this FeedDataWithURI.  # noqa: E501
        :type: Platform
        """

        self._platform = platform

    @property
    def workspace(self):
        """Gets the workspace of this FeedDataWithURI.  # noqa: E501

        The workspace's id where the feed belongs to  # noqa: E501

        :return: The workspace of this FeedDataWithURI.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this FeedDataWithURI.

        The workspace's id where the feed belongs to  # noqa: E501

        :param workspace: The workspace of this FeedDataWithURI.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def uri(self):
        """Gets the uri of this FeedDataWithURI.  # noqa: E501

        The path of the feed to replicate. Appending /Packages to the URI should yield the \"Packages\" file of the feed.  # noqa: E501

        :return: The uri of this FeedDataWithURI.  # noqa: E501
        :rtype: str
        """
        return self._uri

    @uri.setter
    def uri(self, uri):
        """Sets the uri of this FeedDataWithURI.

        The path of the feed to replicate. Appending /Packages to the URI should yield the \"Packages\" file of the feed.  # noqa: E501

        :param uri: The uri of this FeedDataWithURI.  # noqa: E501
        :type: str
        """

        self._uri = uri

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, FeedDataWithURI):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, FeedDataWithURI):
            return True

        return self.to_dict() != other.to_dict()
