# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class Job(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'operation': 'str',
        'status': 'str',
        'error': 'JobError',
        'created': 'datetime',
        'resource_id': 'str',
        'resource_ids': 'list[str]',
        'return_type': 'str'
    }

    attribute_map = {
        'id': 'id',
        'operation': 'operation',
        'status': 'status',
        'error': 'error',
        'created': 'created',
        'resource_id': 'resourceId',
        'resource_ids': 'resourceIds',
        'return_type': 'returnType'
    }

    def __init__(self, id=None, operation=None, status=None, error=None, created=None, resource_id=None, resource_ids=None, return_type=None, local_vars_configuration=None):  # noqa: E501
        """Job - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._operation = None
        self._status = None
        self._error = None
        self._created = None
        self._resource_id = None
        self._resource_ids = None
        self._return_type = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if operation is not None:
            self.operation = operation
        if status is not None:
            self.status = status
        if error is not None:
            self.error = error
        if created is not None:
            self.created = created
        if resource_id is not None:
            self.resource_id = resource_id
        if resource_ids is not None:
            self.resource_ids = resource_ids
        if return_type is not None:
            self.return_type = return_type

    @property
    def id(self):
        """Gets the id of this Job.  # noqa: E501

        The unique ID of the job. Use this to get more information about the job as it runs.  # noqa: E501

        :return: The id of this Job.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Job.

        The unique ID of the job. Use this to get more information about the job as it runs.  # noqa: E501

        :param id: The id of this Job.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def operation(self):
        """Gets the operation of this Job.  # noqa: E501

        The type of the job that is going to be executeed.  # noqa: E501

        :return: The operation of this Job.  # noqa: E501
        :rtype: str
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """Sets the operation of this Job.

        The type of the job that is going to be executeed.  # noqa: E501

        :param operation: The operation of this Job.  # noqa: E501
        :type: str
        """
        allowed_values = ["CREATE_FEED", "CLONE_FEED", "REPLICATE_FEED", "UPDATE_FEED", "DELETE_FEED", "IMPORT_FEEDS", "REMOVE_PACKAGE_REFERENCES", "DELETE_PACKAGE", "ADD_PACKAGE_REFERENCES", "UPLOAD_PACKAGE", "CHECK_FOR_UPDATES", "APPLY_UPDATES", "CLEAN_FEED", "REPLICATE_STORE_ITEM", "IMPORT_STORE_ITEMS", "IMPORT_PACKAGES", "JOB_OPERATION_COUNT"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and operation not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `operation` ({0}), must be one of {1}"  # noqa: E501
                .format(operation, allowed_values)
            )

        self._operation = operation

    @property
    def status(self):
        """Gets the status of this Job.  # noqa: E501

        The state in which the job is in.  # noqa: E501

        :return: The status of this Job.  # noqa: E501
        :rtype: str
        """
        return self._status

    @status.setter
    def status(self, status):
        """Sets the status of this Job.

        The state in which the job is in.  # noqa: E501

        :param status: The status of this Job.  # noqa: E501
        :type: str
        """
        allowed_values = ["PENDING", "RUNNING", "SUCCEEDED", "FAILED", "COMPLETED_WITH_ERROR"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and status not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `status` ({0}), must be one of {1}"  # noqa: E501
                .format(status, allowed_values)
            )

        self._status = status

    @property
    def error(self):
        """Gets the error of this Job.  # noqa: E501


        :return: The error of this Job.  # noqa: E501
        :rtype: JobError
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this Job.


        :param error: The error of this Job.  # noqa: E501
        :type: JobError
        """

        self._error = error

    @property
    def created(self):
        """Gets the created of this Job.  # noqa: E501

        The date when the job was created.  # noqa: E501

        :return: The created of this Job.  # noqa: E501
        :rtype: datetime
        """
        return self._created

    @created.setter
    def created(self, created):
        """Sets the created of this Job.

        The date when the job was created.  # noqa: E501

        :param created: The created of this Job.  # noqa: E501
        :type: datetime
        """

        self._created = created

    @property
    def resource_id(self):
        """Gets the resource_id of this Job.  # noqa: E501

        The ID of the feed or package which this job created or modified.  # noqa: E501

        :return: The resource_id of this Job.  # noqa: E501
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this Job.

        The ID of the feed or package which this job created or modified.  # noqa: E501

        :param resource_id: The resource_id of this Job.  # noqa: E501
        :type: str
        """

        self._resource_id = resource_id

    @property
    def resource_ids(self):
        """Gets the resource_ids of this Job.  # noqa: E501


        :return: The resource_ids of this Job.  # noqa: E501
        :rtype: list[str]
        """
        return self._resource_ids

    @resource_ids.setter
    def resource_ids(self, resource_ids):
        """Sets the resource_ids of this Job.


        :param resource_ids: The resource_ids of this Job.  # noqa: E501
        :type: list[str]
        """

        self._resource_ids = resource_ids

    @property
    def return_type(self):
        """Gets the return_type of this Job.  # noqa: E501

        The type of resource, such as a package or feed, that this job will return when completed.  # noqa: E501

        :return: The return_type of this Job.  # noqa: E501
        :rtype: str
        """
        return self._return_type

    @return_type.setter
    def return_type(self, return_type):
        """Sets the return_type of this Job.

        The type of resource, such as a package or feed, that this job will return when completed.  # noqa: E501

        :param return_type: The return_type of this Job.  # noqa: E501
        :type: str
        """
        allowed_values = ["FEED", "FEEDS", "PACKAGE", "UPDATE_DESCRIPTORS", "SIMPLE"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and return_type not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `return_type` ({0}), must be one of {1}"  # noqa: E501
                .format(return_type, allowed_values)
            )

        self._return_type = return_type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Job):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Job):
            return True

        return self.to_dict() != other.to_dict()
