# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class Package(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'file_uri': 'str',
        'feed_references': 'list[str]',
        'last_updated': 'datetime',
        'metadata': 'PackageMetadata'
    }

    attribute_map = {
        'id': 'id',
        'file_uri': 'fileUri',
        'feed_references': 'feedReferences',
        'last_updated': 'lastUpdated',
        'metadata': 'metadata'
    }

    def __init__(self, id=None, file_uri=None, feed_references=None, last_updated=None, metadata=None, local_vars_configuration=None):  # noqa: E501
        """Package - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._file_uri = None
        self._feed_references = None
        self._last_updated = None
        self._metadata = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if file_uri is not None:
            self.file_uri = file_uri
        if feed_references is not None:
            self.feed_references = feed_references
        if last_updated is not None:
            self.last_updated = last_updated
        if metadata is not None:
            self.metadata = metadata

    @property
    def id(self):
        """Gets the id of this Package.  # noqa: E501

        The ID of this package. This is used to reference this package in the service.  # noqa: E501

        :return: The id of this Package.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Package.

        The ID of this package. This is used to reference this package in the service.  # noqa: E501

        :param id: The id of this Package.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def file_uri(self):
        """Gets the file_uri of this Package.  # noqa: E501

        The location of the file for this package.  # noqa: E501

        :return: The file_uri of this Package.  # noqa: E501
        :rtype: str
        """
        return self._file_uri

    @file_uri.setter
    def file_uri(self, file_uri):
        """Sets the file_uri of this Package.

        The location of the file for this package.  # noqa: E501

        :param file_uri: The file_uri of this Package.  # noqa: E501
        :type: str
        """

        self._file_uri = file_uri

    @property
    def feed_references(self):
        """Gets the feed_references of this Package.  # noqa: E501

        An array containing the IDs of the feeds which reference this package.  # noqa: E501

        :return: The feed_references of this Package.  # noqa: E501
        :rtype: list[str]
        """
        return self._feed_references

    @feed_references.setter
    def feed_references(self, feed_references):
        """Sets the feed_references of this Package.

        An array containing the IDs of the feeds which reference this package.  # noqa: E501

        :param feed_references: The feed_references of this Package.  # noqa: E501
        :type: list[str]
        """

        self._feed_references = feed_references

    @property
    def last_updated(self):
        """Gets the last_updated of this Package.  # noqa: E501

        The date this package was last updated.  # noqa: E501

        :return: The last_updated of this Package.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this Package.

        The date this package was last updated.  # noqa: E501

        :param last_updated: The last_updated of this Package.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    @property
    def metadata(self):
        """Gets the metadata of this Package.  # noqa: E501


        :return: The metadata of this Package.  # noqa: E501
        :rtype: PackageMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Package.


        :param metadata: The metadata of this Package.  # noqa: E501
        :type: PackageMetadata
        """

        self._metadata = metadata

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Package):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Package):
            return True

        return self.to_dict() != other.to_dict()
