# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class PackageImportDescriptor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'architecture': 'str',
        'description': 'str',
        'feed_uri': 'str',
        'package_name': 'str',
        'package_uri': 'str',
        'version': 'str'
    }

    attribute_map = {
        'architecture': 'architecture',
        'description': 'description',
        'feed_uri': 'feedUri',
        'package_name': 'packageName',
        'package_uri': 'packageUri',
        'version': 'version'
    }

    def __init__(self, architecture=None, description=None, feed_uri=None, package_name=None, package_uri=None, version=None, local_vars_configuration=None):  # noqa: E501
        """PackageImportDescriptor - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._architecture = None
        self._description = None
        self._feed_uri = None
        self._package_name = None
        self._package_uri = None
        self._version = None
        self.discriminator = None

        if architecture is not None:
            self.architecture = architecture
        if description is not None:
            self.description = description
        if feed_uri is not None:
            self.feed_uri = feed_uri
        if package_name is not None:
            self.package_name = package_name
        if package_uri is not None:
            self.package_uri = package_uri
        if version is not None:
            self.version = version

    @property
    def architecture(self):
        """Gets the architecture of this PackageImportDescriptor.  # noqa: E501

        The architecture of the package.  # noqa: E501

        :return: The architecture of this PackageImportDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this PackageImportDescriptor.

        The architecture of the package.  # noqa: E501

        :param architecture: The architecture of this PackageImportDescriptor.  # noqa: E501
        :type: str
        """

        self._architecture = architecture

    @property
    def description(self):
        """Gets the description of this PackageImportDescriptor.  # noqa: E501

        The description of the package.  # noqa: E501

        :return: The description of this PackageImportDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PackageImportDescriptor.

        The description of the package.  # noqa: E501

        :param description: The description of this PackageImportDescriptor.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def feed_uri(self):
        """Gets the feed_uri of this PackageImportDescriptor.  # noqa: E501

        The path to the feed.  # noqa: E501

        :return: The feed_uri of this PackageImportDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._feed_uri

    @feed_uri.setter
    def feed_uri(self, feed_uri):
        """Sets the feed_uri of this PackageImportDescriptor.

        The path to the feed.  # noqa: E501

        :param feed_uri: The feed_uri of this PackageImportDescriptor.  # noqa: E501
        :type: str
        """

        self._feed_uri = feed_uri

    @property
    def package_name(self):
        """Gets the package_name of this PackageImportDescriptor.  # noqa: E501

        The package name.  # noqa: E501

        :return: The package_name of this PackageImportDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._package_name

    @package_name.setter
    def package_name(self, package_name):
        """Sets the package_name of this PackageImportDescriptor.

        The package name.  # noqa: E501

        :param package_name: The package_name of this PackageImportDescriptor.  # noqa: E501
        :type: str
        """

        self._package_name = package_name

    @property
    def package_uri(self):
        """Gets the package_uri of this PackageImportDescriptor.  # noqa: E501

        The path to the package.  # noqa: E501

        :return: The package_uri of this PackageImportDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._package_uri

    @package_uri.setter
    def package_uri(self, package_uri):
        """Sets the package_uri of this PackageImportDescriptor.

        The path to the package.  # noqa: E501

        :param package_uri: The package_uri of this PackageImportDescriptor.  # noqa: E501
        :type: str
        """

        self._package_uri = package_uri

    @property
    def version(self):
        """Gets the version of this PackageImportDescriptor.  # noqa: E501

        The package version.  # noqa: E501

        :return: The version of this PackageImportDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PackageImportDescriptor.

        The package version.  # noqa: E501

        :param version: The version of this PackageImportDescriptor.  # noqa: E501
        :type: str
        """

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PackageImportDescriptor):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PackageImportDescriptor):
            return True

        return self.to_dict() != other.to_dict()
