# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class PackageMetadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'package_name': 'str',
        'version': 'str',
        'architecture': 'str',
        'breaks': 'list[str]',
        'conflicts': 'list[str]',
        'depends': 'list[str]',
        'description': 'str',
        'enhances': 'list[str]',
        'essential': 'bool',
        'file_name': 'str',
        'homepage': 'str',
        'installed_size': 'int',
        'maintainer': 'str',
        'predepends': 'list[str]',
        'priority': 'int',
        'provides': 'list[str]',
        'recommends': 'list[str]',
        'release_notes': 'str',
        'replaces': 'list[str]',
        'section': 'str',
        'size': 'int',
        'source': 'str',
        'suggests': 'list[str]',
        'tags': 'str',
        'attributes': 'object'
    }

    attribute_map = {
        'package_name': 'packageName',
        'version': 'version',
        'architecture': 'architecture',
        'breaks': 'breaks',
        'conflicts': 'conflicts',
        'depends': 'depends',
        'description': 'description',
        'enhances': 'enhances',
        'essential': 'essential',
        'file_name': 'fileName',
        'homepage': 'homepage',
        'installed_size': 'installedSize',
        'maintainer': 'maintainer',
        'predepends': 'predepends',
        'priority': 'priority',
        'provides': 'provides',
        'recommends': 'recommends',
        'release_notes': 'releaseNotes',
        'replaces': 'replaces',
        'section': 'section',
        'size': 'size',
        'source': 'source',
        'suggests': 'suggests',
        'tags': 'tags',
        'attributes': 'attributes'
    }

    def __init__(self, package_name=None, version=None, architecture=None, breaks=None, conflicts=None, depends=None, description=None, enhances=None, essential=None, file_name=None, homepage=None, installed_size=None, maintainer=None, predepends=None, priority=None, provides=None, recommends=None, release_notes=None, replaces=None, section=None, size=None, source=None, suggests=None, tags=None, attributes=None, local_vars_configuration=None):  # noqa: E501
        """PackageMetadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._package_name = None
        self._version = None
        self._architecture = None
        self._breaks = None
        self._conflicts = None
        self._depends = None
        self._description = None
        self._enhances = None
        self._essential = None
        self._file_name = None
        self._homepage = None
        self._installed_size = None
        self._maintainer = None
        self._predepends = None
        self._priority = None
        self._provides = None
        self._recommends = None
        self._release_notes = None
        self._replaces = None
        self._section = None
        self._size = None
        self._source = None
        self._suggests = None
        self._tags = None
        self._attributes = None
        self.discriminator = None

        if package_name is not None:
            self.package_name = package_name
        if version is not None:
            self.version = version
        if architecture is not None:
            self.architecture = architecture
        if breaks is not None:
            self.breaks = breaks
        if conflicts is not None:
            self.conflicts = conflicts
        if depends is not None:
            self.depends = depends
        if description is not None:
            self.description = description
        if enhances is not None:
            self.enhances = enhances
        if essential is not None:
            self.essential = essential
        if file_name is not None:
            self.file_name = file_name
        if homepage is not None:
            self.homepage = homepage
        if installed_size is not None:
            self.installed_size = installed_size
        if maintainer is not None:
            self.maintainer = maintainer
        if predepends is not None:
            self.predepends = predepends
        if priority is not None:
            self.priority = priority
        if provides is not None:
            self.provides = provides
        if recommends is not None:
            self.recommends = recommends
        if release_notes is not None:
            self.release_notes = release_notes
        if replaces is not None:
            self.replaces = replaces
        if section is not None:
            self.section = section
        if size is not None:
            self.size = size
        if source is not None:
            self.source = source
        if suggests is not None:
            self.suggests = suggests
        if tags is not None:
            self.tags = tags
        if attributes is not None:
            self.attributes = attributes

    @property
    def package_name(self):
        """Gets the package_name of this PackageMetadata.  # noqa: E501

        The name of the package.  # noqa: E501

        :return: The package_name of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._package_name

    @package_name.setter
    def package_name(self, package_name):
        """Sets the package_name of this PackageMetadata.

        The name of the package.  # noqa: E501

        :param package_name: The package_name of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._package_name = package_name

    @property
    def version(self):
        """Gets the version of this PackageMetadata.  # noqa: E501

        The version of the package.  # noqa: E501

        :return: The version of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this PackageMetadata.

        The version of the package.  # noqa: E501

        :param version: The version of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._version = version

    @property
    def architecture(self):
        """Gets the architecture of this PackageMetadata.  # noqa: E501

        The architecture of the package.  # noqa: E501

        :return: The architecture of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this PackageMetadata.

        The architecture of the package.  # noqa: E501

        :param architecture: The architecture of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._architecture = architecture

    @property
    def breaks(self):
        """Gets the breaks of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package breaks.  # noqa: E501

        :return: The breaks of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._breaks

    @breaks.setter
    def breaks(self, breaks):
        """Sets the breaks of this PackageMetadata.

        An array containing information about other packages this package breaks.  # noqa: E501

        :param breaks: The breaks of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._breaks = breaks

    @property
    def conflicts(self):
        """Gets the conflicts of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package conflicts with.  # noqa: E501

        :return: The conflicts of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._conflicts

    @conflicts.setter
    def conflicts(self, conflicts):
        """Sets the conflicts of this PackageMetadata.

        An array containing information about other packages this package conflicts with.  # noqa: E501

        :param conflicts: The conflicts of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._conflicts = conflicts

    @property
    def depends(self):
        """Gets the depends of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package depends on.  # noqa: E501

        :return: The depends of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._depends

    @depends.setter
    def depends(self, depends):
        """Sets the depends of this PackageMetadata.

        An array containing information about other packages this package depends on.  # noqa: E501

        :param depends: The depends of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._depends = depends

    @property
    def description(self):
        """Gets the description of this PackageMetadata.  # noqa: E501

        The description of the package.  # noqa: E501

        :return: The description of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this PackageMetadata.

        The description of the package.  # noqa: E501

        :param description: The description of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def enhances(self):
        """Gets the enhances of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package enhances.  # noqa: E501

        :return: The enhances of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._enhances

    @enhances.setter
    def enhances(self, enhances):
        """Sets the enhances of this PackageMetadata.

        An array containing information about other packages this package enhances.  # noqa: E501

        :param enhances: The enhances of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._enhances = enhances

    @property
    def essential(self):
        """Gets the essential of this PackageMetadata.  # noqa: E501

        Whether this package is essential.  # noqa: E501

        :return: The essential of this PackageMetadata.  # noqa: E501
        :rtype: bool
        """
        return self._essential

    @essential.setter
    def essential(self, essential):
        """Sets the essential of this PackageMetadata.

        Whether this package is essential.  # noqa: E501

        :param essential: The essential of this PackageMetadata.  # noqa: E501
        :type: bool
        """

        self._essential = essential

    @property
    def file_name(self):
        """Gets the file_name of this PackageMetadata.  # noqa: E501

        The location of the file, including the file extension. Depending on the selected platform, the following package extensions are available: .nipkg for windows feeds, .ipk and .deb for ni-linux-rt feeds.   # noqa: E501

        :return: The file_name of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this PackageMetadata.

        The location of the file, including the file extension. Depending on the selected platform, the following package extensions are available: .nipkg for windows feeds, .ipk and .deb for ni-linux-rt feeds.   # noqa: E501

        :param file_name: The file_name of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._file_name = file_name

    @property
    def homepage(self):
        """Gets the homepage of this PackageMetadata.  # noqa: E501

        The website of the maintainers for this package.  # noqa: E501

        :return: The homepage of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._homepage

    @homepage.setter
    def homepage(self, homepage):
        """Sets the homepage of this PackageMetadata.

        The website of the maintainers for this package.  # noqa: E501

        :param homepage: The homepage of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._homepage = homepage

    @property
    def installed_size(self):
        """Gets the installed_size of this PackageMetadata.  # noqa: E501

        The size of this package after install.  # noqa: E501

        :return: The installed_size of this PackageMetadata.  # noqa: E501
        :rtype: int
        """
        return self._installed_size

    @installed_size.setter
    def installed_size(self, installed_size):
        """Sets the installed_size of this PackageMetadata.

        The size of this package after install.  # noqa: E501

        :param installed_size: The installed_size of this PackageMetadata.  # noqa: E501
        :type: int
        """

        self._installed_size = installed_size

    @property
    def maintainer(self):
        """Gets the maintainer of this PackageMetadata.  # noqa: E501

        The maintainer of this package.  # noqa: E501

        :return: The maintainer of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._maintainer

    @maintainer.setter
    def maintainer(self, maintainer):
        """Sets the maintainer of this PackageMetadata.

        The maintainer of this package.  # noqa: E501

        :param maintainer: The maintainer of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._maintainer = maintainer

    @property
    def predepends(self):
        """Gets the predepends of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package predepends.  # noqa: E501

        :return: The predepends of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._predepends

    @predepends.setter
    def predepends(self, predepends):
        """Sets the predepends of this PackageMetadata.

        An array containing information about other packages this package predepends.  # noqa: E501

        :param predepends: The predepends of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._predepends = predepends

    @property
    def priority(self):
        """Gets the priority of this PackageMetadata.  # noqa: E501

        The priority of the package.  # noqa: E501

        :return: The priority of this PackageMetadata.  # noqa: E501
        :rtype: int
        """
        return self._priority

    @priority.setter
    def priority(self, priority):
        """Sets the priority of this PackageMetadata.

        The priority of the package.  # noqa: E501

        :param priority: The priority of this PackageMetadata.  # noqa: E501
        :type: int
        """

        self._priority = priority

    @property
    def provides(self):
        """Gets the provides of this PackageMetadata.  # noqa: E501

        An array containing information about other packages that this package provides.  # noqa: E501

        :return: The provides of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._provides

    @provides.setter
    def provides(self, provides):
        """Sets the provides of this PackageMetadata.

        An array containing information about other packages that this package provides.  # noqa: E501

        :param provides: The provides of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._provides = provides

    @property
    def recommends(self):
        """Gets the recommends of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package recommends.  # noqa: E501

        :return: The recommends of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._recommends

    @recommends.setter
    def recommends(self, recommends):
        """Sets the recommends of this PackageMetadata.

        An array containing information about other packages this package recommends.  # noqa: E501

        :param recommends: The recommends of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._recommends = recommends

    @property
    def release_notes(self):
        """Gets the release_notes of this PackageMetadata.  # noqa: E501

        A page containing the release notes of the package.  # noqa: E501

        :return: The release_notes of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._release_notes

    @release_notes.setter
    def release_notes(self, release_notes):
        """Sets the release_notes of this PackageMetadata.

        A page containing the release notes of the package.  # noqa: E501

        :param release_notes: The release_notes of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._release_notes = release_notes

    @property
    def replaces(self):
        """Gets the replaces of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package replaces.  # noqa: E501

        :return: The replaces of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._replaces

    @replaces.setter
    def replaces(self, replaces):
        """Sets the replaces of this PackageMetadata.

        An array containing information about other packages this package replaces.  # noqa: E501

        :param replaces: The replaces of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._replaces = replaces

    @property
    def section(self):
        """Gets the section of this PackageMetadata.  # noqa: E501

        The section of the package.  # noqa: E501

        :return: The section of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._section

    @section.setter
    def section(self, section):
        """Sets the section of this PackageMetadata.

        The section of the package.  # noqa: E501

        :param section: The section of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._section = section

    @property
    def size(self):
        """Gets the size of this PackageMetadata.  # noqa: E501

        The size of the package in bytes.  # noqa: E501

        :return: The size of this PackageMetadata.  # noqa: E501
        :rtype: int
        """
        return self._size

    @size.setter
    def size(self, size):
        """Sets the size of this PackageMetadata.

        The size of the package in bytes.  # noqa: E501

        :param size: The size of this PackageMetadata.  # noqa: E501
        :type: int
        """

        self._size = size

    @property
    def source(self):
        """Gets the source of this PackageMetadata.  # noqa: E501

        The source of this package, if any.  # noqa: E501

        :return: The source of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._source

    @source.setter
    def source(self, source):
        """Sets the source of this PackageMetadata.

        The source of this package, if any.  # noqa: E501

        :param source: The source of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._source = source

    @property
    def suggests(self):
        """Gets the suggests of this PackageMetadata.  # noqa: E501

        An array containing information about other packages this package suggests.  # noqa: E501

        :return: The suggests of this PackageMetadata.  # noqa: E501
        :rtype: list[str]
        """
        return self._suggests

    @suggests.setter
    def suggests(self, suggests):
        """Sets the suggests of this PackageMetadata.

        An array containing information about other packages this package suggests.  # noqa: E501

        :param suggests: The suggests of this PackageMetadata.  # noqa: E501
        :type: list[str]
        """

        self._suggests = suggests

    @property
    def tags(self):
        """Gets the tags of this PackageMetadata.  # noqa: E501

        Tags of the package.  # noqa: E501

        :return: The tags of this PackageMetadata.  # noqa: E501
        :rtype: str
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this PackageMetadata.

        Tags of the package.  # noqa: E501

        :param tags: The tags of this PackageMetadata.  # noqa: E501
        :type: str
        """

        self._tags = tags

    @property
    def attributes(self):
        """Gets the attributes of this PackageMetadata.  # noqa: E501

        Attributes of the package.  # noqa: E501

        :return: The attributes of this PackageMetadata.  # noqa: E501
        :rtype: object
        """
        return self._attributes

    @attributes.setter
    def attributes(self, attributes):
        """Sets the attributes of this PackageMetadata.

        Attributes of the package.  # noqa: E501

        :param attributes: The attributes of this PackageMetadata.  # noqa: E501
        :type: object
        """

        self._attributes = attributes

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PackageMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PackageMetadata):
            return True

        return self.to_dict() != other.to_dict()
