# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class SoftwareInformation(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'store_item_id': 'str',
        'product_name': 'str',
        'short_description': 'str',
        'download_item_version': 'str',
        'package_name': 'str',
        'package_version': 'str',
        'feeds': 'list[FeedNameAndUri]'
    }

    attribute_map = {
        'store_item_id': 'storeItemId',
        'product_name': 'productName',
        'short_description': 'shortDescription',
        'download_item_version': 'downloadItemVersion',
        'package_name': 'packageName',
        'package_version': 'packageVersion',
        'feeds': 'feeds'
    }

    def __init__(self, store_item_id=None, product_name=None, short_description=None, download_item_version=None, package_name=None, package_version=None, feeds=None, local_vars_configuration=None):  # noqa: E501
        """SoftwareInformation - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._store_item_id = None
        self._product_name = None
        self._short_description = None
        self._download_item_version = None
        self._package_name = None
        self._package_version = None
        self._feeds = None
        self.discriminator = None

        if store_item_id is not None:
            self.store_item_id = store_item_id
        if product_name is not None:
            self.product_name = product_name
        if short_description is not None:
            self.short_description = short_description
        if download_item_version is not None:
            self.download_item_version = download_item_version
        if package_name is not None:
            self.package_name = package_name
        if package_version is not None:
            self.package_version = package_version
        if feeds is not None:
            self.feeds = feeds

    @property
    def store_item_id(self):
        """Gets the store_item_id of this SoftwareInformation.  # noqa: E501

        The ID of this element.  # noqa: E501

        :return: The store_item_id of this SoftwareInformation.  # noqa: E501
        :rtype: str
        """
        return self._store_item_id

    @store_item_id.setter
    def store_item_id(self, store_item_id):
        """Sets the store_item_id of this SoftwareInformation.

        The ID of this element.  # noqa: E501

        :param store_item_id: The store_item_id of this SoftwareInformation.  # noqa: E501
        :type: str
        """

        self._store_item_id = store_item_id

    @property
    def product_name(self):
        """Gets the product_name of this SoftwareInformation.  # noqa: E501

        The name of one the products contained in the software suite.  # noqa: E501

        :return: The product_name of this SoftwareInformation.  # noqa: E501
        :rtype: str
        """
        return self._product_name

    @product_name.setter
    def product_name(self, product_name):
        """Sets the product_name of this SoftwareInformation.

        The name of one the products contained in the software suite.  # noqa: E501

        :param product_name: The product_name of this SoftwareInformation.  # noqa: E501
        :type: str
        """

        self._product_name = product_name

    @property
    def short_description(self):
        """Gets the short_description of this SoftwareInformation.  # noqa: E501

        A short description of the product.  # noqa: E501

        :return: The short_description of this SoftwareInformation.  # noqa: E501
        :rtype: str
        """
        return self._short_description

    @short_description.setter
    def short_description(self, short_description):
        """Sets the short_description of this SoftwareInformation.

        A short description of the product.  # noqa: E501

        :param short_description: The short_description of this SoftwareInformation.  # noqa: E501
        :type: str
        """

        self._short_description = short_description

    @property
    def download_item_version(self):
        """Gets the download_item_version of this SoftwareInformation.  # noqa: E501

        The item version number.  # noqa: E501

        :return: The download_item_version of this SoftwareInformation.  # noqa: E501
        :rtype: str
        """
        return self._download_item_version

    @download_item_version.setter
    def download_item_version(self, download_item_version):
        """Sets the download_item_version of this SoftwareInformation.

        The item version number.  # noqa: E501

        :param download_item_version: The download_item_version of this SoftwareInformation.  # noqa: E501
        :type: str
        """

        self._download_item_version = download_item_version

    @property
    def package_name(self):
        """Gets the package_name of this SoftwareInformation.  # noqa: E501

        The name of the package to install.  # noqa: E501

        :return: The package_name of this SoftwareInformation.  # noqa: E501
        :rtype: str
        """
        return self._package_name

    @package_name.setter
    def package_name(self, package_name):
        """Sets the package_name of this SoftwareInformation.

        The name of the package to install.  # noqa: E501

        :param package_name: The package_name of this SoftwareInformation.  # noqa: E501
        :type: str
        """

        self._package_name = package_name

    @property
    def package_version(self):
        """Gets the package_version of this SoftwareInformation.  # noqa: E501

        The version of the package to install.  # noqa: E501

        :return: The package_version of this SoftwareInformation.  # noqa: E501
        :rtype: str
        """
        return self._package_version

    @package_version.setter
    def package_version(self, package_version):
        """Sets the package_version of this SoftwareInformation.

        The version of the package to install.  # noqa: E501

        :param package_version: The package_version of this SoftwareInformation.  # noqa: E501
        :type: str
        """

        self._package_version = package_version

    @property
    def feeds(self):
        """Gets the feeds of this SoftwareInformation.  # noqa: E501

        The feeds where the suite contents are located at.  # noqa: E501

        :return: The feeds of this SoftwareInformation.  # noqa: E501
        :rtype: list[FeedNameAndUri]
        """
        return self._feeds

    @feeds.setter
    def feeds(self, feeds):
        """Sets the feeds of this SoftwareInformation.

        The feeds where the suite contents are located at.  # noqa: E501

        :param feeds: The feeds of this SoftwareInformation.  # noqa: E501
        :type: list[FeedNameAndUri]
        """

        self._feeds = feeds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SoftwareInformation):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SoftwareInformation):
            return True

        return self.to_dict() != other.to_dict()
