# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class StoreDownloadItems(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'download_item_version': 'str',
        'product_versioned_id': 'str',
        'store_item_installers': 'list[StoreItemInstaller]'
    }

    attribute_map = {
        'download_item_version': 'downloadItemVersion',
        'product_versioned_id': 'productVersionedId',
        'store_item_installers': 'storeItemInstallers'
    }

    def __init__(self, download_item_version=None, product_versioned_id=None, store_item_installers=None, local_vars_configuration=None):  # noqa: E501
        """StoreDownloadItems - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._download_item_version = None
        self._product_versioned_id = None
        self._store_item_installers = None
        self.discriminator = None

        if download_item_version is not None:
            self.download_item_version = download_item_version
        if product_versioned_id is not None:
            self.product_versioned_id = product_versioned_id
        if store_item_installers is not None:
            self.store_item_installers = store_item_installers

    @property
    def download_item_version(self):
        """Gets the download_item_version of this StoreDownloadItems.  # noqa: E501

        The version of the download item.  # noqa: E501

        :return: The download_item_version of this StoreDownloadItems.  # noqa: E501
        :rtype: str
        """
        return self._download_item_version

    @download_item_version.setter
    def download_item_version(self, download_item_version):
        """Sets the download_item_version of this StoreDownloadItems.

        The version of the download item.  # noqa: E501

        :param download_item_version: The download_item_version of this StoreDownloadItems.  # noqa: E501
        :type: str
        """

        self._download_item_version = download_item_version

    @property
    def product_versioned_id(self):
        """Gets the product_versioned_id of this StoreDownloadItems.  # noqa: E501

        The ID of the product.  # noqa: E501

        :return: The product_versioned_id of this StoreDownloadItems.  # noqa: E501
        :rtype: str
        """
        return self._product_versioned_id

    @product_versioned_id.setter
    def product_versioned_id(self, product_versioned_id):
        """Sets the product_versioned_id of this StoreDownloadItems.

        The ID of the product.  # noqa: E501

        :param product_versioned_id: The product_versioned_id of this StoreDownloadItems.  # noqa: E501
        :type: str
        """

        self._product_versioned_id = product_versioned_id

    @property
    def store_item_installers(self):
        """Gets the store_item_installers of this StoreDownloadItems.  # noqa: E501


        :return: The store_item_installers of this StoreDownloadItems.  # noqa: E501
        :rtype: list[StoreItemInstaller]
        """
        return self._store_item_installers

    @store_item_installers.setter
    def store_item_installers(self, store_item_installers):
        """Sets the store_item_installers of this StoreDownloadItems.


        :param store_item_installers: The store_item_installers of this StoreDownloadItems.  # noqa: E501
        :type: list[StoreItemInstaller]
        """

        self._store_item_installers = store_item_installers

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StoreDownloadItems):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StoreDownloadItems):
            return True

        return self.to_dict() != other.to_dict()
