# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class StoreItemDescriptor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'store_item_id': 'str',
        'download_item_version': 'str',
        'store_item_installer_guid': 'str'
    }

    attribute_map = {
        'store_item_id': 'storeItemId',
        'download_item_version': 'downloadItemVersion',
        'store_item_installer_guid': 'storeItemInstallerGuid'
    }

    def __init__(self, store_item_id=None, download_item_version=None, store_item_installer_guid=None, local_vars_configuration=None):  # noqa: E501
        """StoreItemDescriptor - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._store_item_id = None
        self._download_item_version = None
        self._store_item_installer_guid = None
        self.discriminator = None

        if store_item_id is not None:
            self.store_item_id = store_item_id
        if download_item_version is not None:
            self.download_item_version = download_item_version
        if store_item_installer_guid is not None:
            self.store_item_installer_guid = store_item_installer_guid

    @property
    def store_item_id(self):
        """Gets the store_item_id of this StoreItemDescriptor.  # noqa: E501

        The ID of the store item to replicate.  # noqa: E501

        :return: The store_item_id of this StoreItemDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._store_item_id

    @store_item_id.setter
    def store_item_id(self, store_item_id):
        """Sets the store_item_id of this StoreItemDescriptor.

        The ID of the store item to replicate.  # noqa: E501

        :param store_item_id: The store_item_id of this StoreItemDescriptor.  # noqa: E501
        :type: str
        """

        self._store_item_id = store_item_id

    @property
    def download_item_version(self):
        """Gets the download_item_version of this StoreItemDescriptor.  # noqa: E501

        The version of the store item to replicate.  # noqa: E501

        :return: The download_item_version of this StoreItemDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._download_item_version

    @download_item_version.setter
    def download_item_version(self, download_item_version):
        """Sets the download_item_version of this StoreItemDescriptor.

        The version of the store item to replicate.  # noqa: E501

        :param download_item_version: The download_item_version of this StoreItemDescriptor.  # noqa: E501
        :type: str
        """

        self._download_item_version = download_item_version

    @property
    def store_item_installer_guid(self):
        """Gets the store_item_installer_guid of this StoreItemDescriptor.  # noqa: E501

        Value uniquely identifying the specific store item installer to replicate.  # noqa: E501

        :return: The store_item_installer_guid of this StoreItemDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._store_item_installer_guid

    @store_item_installer_guid.setter
    def store_item_installer_guid(self, store_item_installer_guid):
        """Sets the store_item_installer_guid of this StoreItemDescriptor.

        Value uniquely identifying the specific store item installer to replicate.  # noqa: E501

        :param store_item_installer_guid: The store_item_installer_guid of this StoreItemDescriptor.  # noqa: E501
        :type: str
        """

        self._store_item_installer_guid = store_item_installer_guid

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StoreItemDescriptor):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StoreItemDescriptor):
            return True

        return self.to_dict() != other.to_dict()
