# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class StoreItemInstaller(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'guid': 'str',
        'bitnesses': 'list[ArchitectureInformation]',
        'languages': 'list[LanguageInformation]',
        'suite_contents': 'list[SoftwareInformation]',
        'feeds': 'list[FeedNameAndUri]'
    }

    attribute_map = {
        'guid': 'guid',
        'bitnesses': 'bitnesses',
        'languages': 'languages',
        'suite_contents': 'suiteContents',
        'feeds': 'feeds'
    }

    def __init__(self, guid=None, bitnesses=None, languages=None, suite_contents=None, feeds=None, local_vars_configuration=None):  # noqa: E501
        """StoreItemInstaller - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._guid = None
        self._bitnesses = None
        self._languages = None
        self._suite_contents = None
        self._feeds = None
        self.discriminator = None

        if guid is not None:
            self.guid = guid
        if bitnesses is not None:
            self.bitnesses = bitnesses
        if languages is not None:
            self.languages = languages
        if suite_contents is not None:
            self.suite_contents = suite_contents
        if feeds is not None:
            self.feeds = feeds

    @property
    def guid(self):
        """Gets the guid of this StoreItemInstaller.  # noqa: E501

        The global unique identifier (GUID) of the store item.  # noqa: E501

        :return: The guid of this StoreItemInstaller.  # noqa: E501
        :rtype: str
        """
        return self._guid

    @guid.setter
    def guid(self, guid):
        """Sets the guid of this StoreItemInstaller.

        The global unique identifier (GUID) of the store item.  # noqa: E501

        :param guid: The guid of this StoreItemInstaller.  # noqa: E501
        :type: str
        """

        self._guid = guid

    @property
    def bitnesses(self):
        """Gets the bitnesses of this StoreItemInstaller.  # noqa: E501

        An array containing information about the possible architectures the software can run on.  # noqa: E501

        :return: The bitnesses of this StoreItemInstaller.  # noqa: E501
        :rtype: list[ArchitectureInformation]
        """
        return self._bitnesses

    @bitnesses.setter
    def bitnesses(self, bitnesses):
        """Sets the bitnesses of this StoreItemInstaller.

        An array containing information about the possible architectures the software can run on.  # noqa: E501

        :param bitnesses: The bitnesses of this StoreItemInstaller.  # noqa: E501
        :type: list[ArchitectureInformation]
        """

        self._bitnesses = bitnesses

    @property
    def languages(self):
        """Gets the languages of this StoreItemInstaller.  # noqa: E501

        An array containing objects that offer information about the supported locale of the product.  # noqa: E501

        :return: The languages of this StoreItemInstaller.  # noqa: E501
        :rtype: list[LanguageInformation]
        """
        return self._languages

    @languages.setter
    def languages(self, languages):
        """Sets the languages of this StoreItemInstaller.

        An array containing objects that offer information about the supported locale of the product.  # noqa: E501

        :param languages: The languages of this StoreItemInstaller.  # noqa: E501
        :type: list[LanguageInformation]
        """

        self._languages = languages

    @property
    def suite_contents(self):
        """Gets the suite_contents of this StoreItemInstaller.  # noqa: E501

        Array of descriptions about what this store item contains.  # noqa: E501

        :return: The suite_contents of this StoreItemInstaller.  # noqa: E501
        :rtype: list[SoftwareInformation]
        """
        return self._suite_contents

    @suite_contents.setter
    def suite_contents(self, suite_contents):
        """Sets the suite_contents of this StoreItemInstaller.

        Array of descriptions about what this store item contains.  # noqa: E501

        :param suite_contents: The suite_contents of this StoreItemInstaller.  # noqa: E501
        :type: list[SoftwareInformation]
        """

        self._suite_contents = suite_contents

    @property
    def feeds(self):
        """Gets the feeds of this StoreItemInstaller.  # noqa: E501

        The feeds where the suite contents are located at.  # noqa: E501

        :return: The feeds of this StoreItemInstaller.  # noqa: E501
        :rtype: list[FeedNameAndUri]
        """
        return self._feeds

    @feeds.setter
    def feeds(self, feeds):
        """Sets the feeds of this StoreItemInstaller.

        The feeds where the suite contents are located at.  # noqa: E501

        :param feeds: The feeds of this StoreItemInstaller.  # noqa: E501
        :type: list[FeedNameAndUri]
        """

        self._feeds = feeds

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StoreItemInstaller):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StoreItemInstaller):
            return True

        return self.to_dict() != other.to_dict()
