# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class StoreItemsExtendedResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'items': 'list[StoreItem]',
        'page_size': 'int',
        'page_number': 'int',
        'total_pages': 'int',
        'total_items': 'int'
    }

    attribute_map = {
        'items': 'items',
        'page_size': 'pageSize',
        'page_number': 'pageNumber',
        'total_pages': 'totalPages',
        'total_items': 'totalItems'
    }

    def __init__(self, items=None, page_size=None, page_number=None, total_pages=None, total_items=None, local_vars_configuration=None):  # noqa: E501
        """StoreItemsExtendedResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._items = None
        self._page_size = None
        self._page_number = None
        self._total_pages = None
        self._total_items = None
        self.discriminator = None

        if items is not None:
            self.items = items
        if page_size is not None:
            self.page_size = page_size
        if page_number is not None:
            self.page_number = page_number
        if total_pages is not None:
            self.total_pages = total_pages
        if total_items is not None:
            self.total_items = total_items

    @property
    def items(self):
        """Gets the items of this StoreItemsExtendedResponse.  # noqa: E501


        :return: The items of this StoreItemsExtendedResponse.  # noqa: E501
        :rtype: list[StoreItem]
        """
        return self._items

    @items.setter
    def items(self, items):
        """Sets the items of this StoreItemsExtendedResponse.


        :param items: The items of this StoreItemsExtendedResponse.  # noqa: E501
        :type: list[StoreItem]
        """

        self._items = items

    @property
    def page_size(self):
        """Gets the page_size of this StoreItemsExtendedResponse.  # noqa: E501

        The number of the records contained by one page. Maximum is 1000.  # noqa: E501

        :return: The page_size of this StoreItemsExtendedResponse.  # noqa: E501
        :rtype: int
        """
        return self._page_size

    @page_size.setter
    def page_size(self, page_size):
        """Sets the page_size of this StoreItemsExtendedResponse.

        The number of the records contained by one page. Maximum is 1000.  # noqa: E501

        :param page_size: The page_size of this StoreItemsExtendedResponse.  # noqa: E501
        :type: int
        """

        self._page_size = page_size

    @property
    def page_number(self):
        """Gets the page_number of this StoreItemsExtendedResponse.  # noqa: E501

        The number of the current page.  # noqa: E501

        :return: The page_number of this StoreItemsExtendedResponse.  # noqa: E501
        :rtype: int
        """
        return self._page_number

    @page_number.setter
    def page_number(self, page_number):
        """Sets the page_number of this StoreItemsExtendedResponse.

        The number of the current page.  # noqa: E501

        :param page_number: The page_number of this StoreItemsExtendedResponse.  # noqa: E501
        :type: int
        """

        self._page_number = page_number

    @property
    def total_pages(self):
        """Gets the total_pages of this StoreItemsExtendedResponse.  # noqa: E501

        The total number of pages.  # noqa: E501

        :return: The total_pages of this StoreItemsExtendedResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_pages

    @total_pages.setter
    def total_pages(self, total_pages):
        """Sets the total_pages of this StoreItemsExtendedResponse.

        The total number of pages.  # noqa: E501

        :param total_pages: The total_pages of this StoreItemsExtendedResponse.  # noqa: E501
        :type: int
        """

        self._total_pages = total_pages

    @property
    def total_items(self):
        """Gets the total_items of this StoreItemsExtendedResponse.  # noqa: E501

        The total number of items.  # noqa: E501

        :return: The total_items of this StoreItemsExtendedResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_items

    @total_items.setter
    def total_items(self, total_items):
        """Sets the total_items of this StoreItemsExtendedResponse.

        The total number of items.  # noqa: E501

        :param total_items: The total_items of this StoreItemsExtendedResponse.  # noqa: E501
        :type: int
        """

        self._total_items = total_items

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StoreItemsExtendedResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StoreItemsExtendedResponse):
            return True

        return self.to_dict() != other.to_dict()
