# coding: utf-8

"""
    Package Repository Service

    Manages a repository of packages  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nirepo.configuration import Configuration


class UpdateDescriptor(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'package_name': 'str',
        'operation': 'str',
        'from_version': 'str',
        'to_version': 'str',
        'package_uri': 'str',
        'package_id': 'str',
        'package_to_replace': 'str',
        'destination_feed_id': 'str',
        'is_local': 'bool'
    }

    attribute_map = {
        'package_name': 'packageName',
        'operation': 'operation',
        'from_version': 'fromVersion',
        'to_version': 'toVersion',
        'package_uri': 'packageUri',
        'package_id': 'packageId',
        'package_to_replace': 'packageToReplace',
        'destination_feed_id': 'destinationFeedId',
        'is_local': 'isLocal'
    }

    def __init__(self, package_name=None, operation='ADD', from_version=None, to_version=None, package_uri=None, package_id=None, package_to_replace=None, destination_feed_id=None, is_local=None, local_vars_configuration=None):  # noqa: E501
        """UpdateDescriptor - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._package_name = None
        self._operation = None
        self._from_version = None
        self._to_version = None
        self._package_uri = None
        self._package_id = None
        self._package_to_replace = None
        self._destination_feed_id = None
        self._is_local = None
        self.discriminator = None

        if package_name is not None:
            self.package_name = package_name
        if operation is not None:
            self.operation = operation
        if from_version is not None:
            self.from_version = from_version
        if to_version is not None:
            self.to_version = to_version
        if package_uri is not None:
            self.package_uri = package_uri
        if package_id is not None:
            self.package_id = package_id
        if package_to_replace is not None:
            self.package_to_replace = package_to_replace
        if destination_feed_id is not None:
            self.destination_feed_id = destination_feed_id
        if is_local is not None:
            self.is_local = is_local

    @property
    def package_name(self):
        """Gets the package_name of this UpdateDescriptor.  # noqa: E501

        The name of the package.  # noqa: E501

        :return: The package_name of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._package_name

    @package_name.setter
    def package_name(self, package_name):
        """Sets the package_name of this UpdateDescriptor.

        The name of the package.  # noqa: E501

        :param package_name: The package_name of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._package_name = package_name

    @property
    def operation(self):
        """Gets the operation of this UpdateDescriptor.  # noqa: E501

        The operation type.  # noqa: E501

        :return: The operation of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._operation

    @operation.setter
    def operation(self, operation):
        """Sets the operation of this UpdateDescriptor.

        The operation type.  # noqa: E501

        :param operation: The operation of this UpdateDescriptor.  # noqa: E501
        :type: str
        """
        allowed_values = ["ADD", "UPGRADE"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and operation not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `operation` ({0}), must be one of {1}"  # noqa: E501
                .format(operation, allowed_values)
            )

        self._operation = operation

    @property
    def from_version(self):
        """Gets the from_version of this UpdateDescriptor.  # noqa: E501

        The old version of the package.  # noqa: E501

        :return: The from_version of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._from_version

    @from_version.setter
    def from_version(self, from_version):
        """Sets the from_version of this UpdateDescriptor.

        The old version of the package.  # noqa: E501

        :param from_version: The from_version of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._from_version = from_version

    @property
    def to_version(self):
        """Gets the to_version of this UpdateDescriptor.  # noqa: E501

        The new version of the package.  # noqa: E501

        :return: The to_version of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._to_version

    @to_version.setter
    def to_version(self, to_version):
        """Sets the to_version of this UpdateDescriptor.

        The new version of the package.  # noqa: E501

        :param to_version: The to_version of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._to_version = to_version

    @property
    def package_uri(self):
        """Gets the package_uri of this UpdateDescriptor.  # noqa: E501

        The path to the package.  # noqa: E501

        :return: The package_uri of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._package_uri

    @package_uri.setter
    def package_uri(self, package_uri):
        """Sets the package_uri of this UpdateDescriptor.

        The path to the package.  # noqa: E501

        :param package_uri: The package_uri of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._package_uri = package_uri

    @property
    def package_id(self):
        """Gets the package_id of this UpdateDescriptor.  # noqa: E501

        The unique ID of the package.  # noqa: E501

        :return: The package_id of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._package_id

    @package_id.setter
    def package_id(self, package_id):
        """Sets the package_id of this UpdateDescriptor.

        The unique ID of the package.  # noqa: E501

        :param package_id: The package_id of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._package_id = package_id

    @property
    def package_to_replace(self):
        """Gets the package_to_replace of this UpdateDescriptor.  # noqa: E501

        The ID of the package which will replace another package.  # noqa: E501

        :return: The package_to_replace of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._package_to_replace

    @package_to_replace.setter
    def package_to_replace(self, package_to_replace):
        """Sets the package_to_replace of this UpdateDescriptor.

        The ID of the package which will replace another package.  # noqa: E501

        :param package_to_replace: The package_to_replace of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._package_to_replace = package_to_replace

    @property
    def destination_feed_id(self):
        """Gets the destination_feed_id of this UpdateDescriptor.  # noqa: E501

        The ID of the feed which will be modified.  # noqa: E501

        :return: The destination_feed_id of this UpdateDescriptor.  # noqa: E501
        :rtype: str
        """
        return self._destination_feed_id

    @destination_feed_id.setter
    def destination_feed_id(self, destination_feed_id):
        """Sets the destination_feed_id of this UpdateDescriptor.

        The ID of the feed which will be modified.  # noqa: E501

        :param destination_feed_id: The destination_feed_id of this UpdateDescriptor.  # noqa: E501
        :type: str
        """

        self._destination_feed_id = destination_feed_id

    @property
    def is_local(self):
        """Gets the is_local of this UpdateDescriptor.  # noqa: E501

        Whether it is local or remote.  # noqa: E501

        :return: The is_local of this UpdateDescriptor.  # noqa: E501
        :rtype: bool
        """
        return self._is_local

    @is_local.setter
    def is_local(self, is_local):
        """Sets the is_local of this UpdateDescriptor.

        Whether it is local or remote.  # noqa: E501

        :param is_local: The is_local of this UpdateDescriptor.  # noqa: E501
        :type: bool
        """

        self._is_local = is_local

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateDescriptor):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateDescriptor):
            return True

        return self.to_dict() != other.to_dict()
