# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class CancelJobRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'jid': 'str',
        'system_id': 'str'
    }

    attribute_map = {
        'jid': 'jid',
        'system_id': 'systemId'
    }

    def __init__(self, jid=None, system_id=None, local_vars_configuration=None):  # noqa: E501
        """CancelJobRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._jid = None
        self._system_id = None
        self.discriminator = None

        self.jid = jid
        self.system_id = system_id

    @property
    def jid(self):
        """Gets the jid of this CancelJobRequest.  # noqa: E501

        The job ID of the job to cancel.  # noqa: E501

        :return: The jid of this CancelJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._jid

    @jid.setter
    def jid(self, jid):
        """Sets the jid of this CancelJobRequest.

        The job ID of the job to cancel.  # noqa: E501

        :param jid: The jid of this CancelJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and jid is None:  # noqa: E501
            raise ValueError("Invalid value for `jid`, must not be `None`")  # noqa: E501

        self._jid = jid

    @property
    def system_id(self):
        """Gets the system_id of this CancelJobRequest.  # noqa: E501

        The system ID on which the job is canceled.  # noqa: E501

        :return: The system_id of this CancelJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._system_id

    @system_id.setter
    def system_id(self, system_id):
        """Sets the system_id of this CancelJobRequest.

        The system ID on which the job is canceled.  # noqa: E501

        :param system_id: The system_id of this CancelJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and system_id is None:  # noqa: E501
            raise ValueError("Invalid value for `system_id`, must not be `None`")  # noqa: E501

        self._system_id = system_id

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CancelJobRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CancelJobRequest):
            return True

        return self.to_dict() != other.to_dict()
