# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class Job(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'jid': 'str',
        'id': 'str',
        'created_timestamp': 'datetime',
        'last_updated_timestamp': 'datetime',
        'dispatched_timestamp': 'datetime',
        'state': 'JobState',
        'metadata': 'dict(str, object)',
        'config': 'JobConfig',
        'result': 'JobResult'
    }

    attribute_map = {
        'jid': 'jid',
        'id': 'id',
        'created_timestamp': 'createdTimestamp',
        'last_updated_timestamp': 'lastUpdatedTimestamp',
        'dispatched_timestamp': 'dispatchedTimestamp',
        'state': 'state',
        'metadata': 'metadata',
        'config': 'config',
        'result': 'result'
    }

    def __init__(self, jid=None, id=None, created_timestamp=None, last_updated_timestamp=None, dispatched_timestamp=None, state=None, metadata=None, config=None, result=None, local_vars_configuration=None):  # noqa: E501
        """Job - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._jid = None
        self._id = None
        self._created_timestamp = None
        self._last_updated_timestamp = None
        self._dispatched_timestamp = None
        self._state = None
        self._metadata = None
        self._config = None
        self._result = None
        self.discriminator = None

        self.jid = jid
        self.id = id
        self.created_timestamp = created_timestamp
        self.last_updated_timestamp = last_updated_timestamp
        if dispatched_timestamp is not None:
            self.dispatched_timestamp = dispatched_timestamp
        self.state = state
        if metadata is not None:
            self.metadata = metadata
        self.config = config
        if result is not None:
            self.result = result

    @property
    def jid(self):
        """Gets the jid of this Job.  # noqa: E501

        ID of the job.  # noqa: E501

        :return: The jid of this Job.  # noqa: E501
        :rtype: str
        """
        return self._jid

    @jid.setter
    def jid(self, jid):
        """Sets the jid of this Job.

        ID of the job.  # noqa: E501

        :param jid: The jid of this Job.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and jid is None:  # noqa: E501
            raise ValueError("Invalid value for `jid`, must not be `None`")  # noqa: E501

        self._jid = jid

    @property
    def id(self):
        """Gets the id of this Job.  # noqa: E501

        ID of the system.  # noqa: E501

        :return: The id of this Job.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Job.

        ID of the system.  # noqa: E501

        :param id: The id of this Job.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_timestamp(self):
        """Gets the created_timestamp of this Job.  # noqa: E501

        The date when the job was created.  # noqa: E501

        :return: The created_timestamp of this Job.  # noqa: E501
        :rtype: datetime
        """
        return self._created_timestamp

    @created_timestamp.setter
    def created_timestamp(self, created_timestamp):
        """Sets the created_timestamp of this Job.

        The date when the job was created.  # noqa: E501

        :param created_timestamp: The created_timestamp of this Job.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `created_timestamp`, must not be `None`")  # noqa: E501

        self._created_timestamp = created_timestamp

    @property
    def last_updated_timestamp(self):
        """Gets the last_updated_timestamp of this Job.  # noqa: E501

        The date when the job was last updated.  # noqa: E501

        :return: The last_updated_timestamp of this Job.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_timestamp

    @last_updated_timestamp.setter
    def last_updated_timestamp(self, last_updated_timestamp):
        """Sets the last_updated_timestamp of this Job.

        The date when the job was last updated.  # noqa: E501

        :param last_updated_timestamp: The last_updated_timestamp of this Job.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and last_updated_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `last_updated_timestamp`, must not be `None`")  # noqa: E501

        self._last_updated_timestamp = last_updated_timestamp

    @property
    def dispatched_timestamp(self):
        """Gets the dispatched_timestamp of this Job.  # noqa: E501

        The date when the job was actually sent to the system.  # noqa: E501

        :return: The dispatched_timestamp of this Job.  # noqa: E501
        :rtype: datetime
        """
        return self._dispatched_timestamp

    @dispatched_timestamp.setter
    def dispatched_timestamp(self, dispatched_timestamp):
        """Sets the dispatched_timestamp of this Job.

        The date when the job was actually sent to the system.  # noqa: E501

        :param dispatched_timestamp: The dispatched_timestamp of this Job.  # noqa: E501
        :type: datetime
        """

        self._dispatched_timestamp = dispatched_timestamp

    @property
    def state(self):
        """Gets the state of this Job.  # noqa: E501


        :return: The state of this Job.  # noqa: E501
        :rtype: JobState
        """
        return self._state

    @state.setter
    def state(self, state):
        """Sets the state of this Job.


        :param state: The state of this Job.  # noqa: E501
        :type: JobState
        """
        if self.local_vars_configuration.client_side_validation and state is None:  # noqa: E501
            raise ValueError("Invalid value for `state`, must not be `None`")  # noqa: E501

        self._state = state

    @property
    def metadata(self):
        """Gets the metadata of this Job.  # noqa: E501

        Job metadata.  # noqa: E501

        :return: The metadata of this Job.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this Job.

        Job metadata.  # noqa: E501

        :param metadata: The metadata of this Job.  # noqa: E501
        :type: dict(str, object)
        """

        self._metadata = metadata

    @property
    def config(self):
        """Gets the config of this Job.  # noqa: E501


        :return: The config of this Job.  # noqa: E501
        :rtype: JobConfig
        """
        return self._config

    @config.setter
    def config(self, config):
        """Sets the config of this Job.


        :param config: The config of this Job.  # noqa: E501
        :type: JobConfig
        """
        if self.local_vars_configuration.client_side_validation and config is None:  # noqa: E501
            raise ValueError("Invalid value for `config`, must not be `None`")  # noqa: E501

        self._config = config

    @property
    def result(self):
        """Gets the result of this Job.  # noqa: E501


        :return: The result of this Job.  # noqa: E501
        :rtype: JobResult
        """
        return self._result

    @result.setter
    def result(self, result):
        """Sets the result of this Job.


        :param result: The result of this Job.  # noqa: E501
        :type: JobResult
        """

        self._result = result

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Job):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Job):
            return True

        return self.to_dict() != other.to_dict()
