# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class JobConfig(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'user': 'str',
        'tgt': 'list[str]',
        'fun': 'list[str]',
        'arg': 'list[list[object]]'
    }

    attribute_map = {
        'user': 'user',
        'tgt': 'tgt',
        'fun': 'fun',
        'arg': 'arg'
    }

    def __init__(self, user=None, tgt=None, fun=None, arg=None, local_vars_configuration=None):  # noqa: E501
        """JobConfig - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._user = None
        self._tgt = None
        self._fun = None
        self._arg = None
        self.discriminator = None

        self.user = user
        self.tgt = tgt
        self.fun = fun
        if arg is not None:
            self.arg = arg

    @property
    def user(self):
        """Gets the user of this JobConfig.  # noqa: E501

        User who created the job.  # noqa: E501

        :return: The user of this JobConfig.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this JobConfig.

        User who created the job.  # noqa: E501

        :param user: The user of this JobConfig.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and user is None:  # noqa: E501
            raise ValueError("Invalid value for `user`, must not be `None`")  # noqa: E501

        self._user = user

    @property
    def tgt(self):
        """Gets the tgt of this JobConfig.  # noqa: E501


        :return: The tgt of this JobConfig.  # noqa: E501
        :rtype: list[str]
        """
        return self._tgt

    @tgt.setter
    def tgt(self, tgt):
        """Sets the tgt of this JobConfig.


        :param tgt: The tgt of this JobConfig.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and tgt is None:  # noqa: E501
            raise ValueError("Invalid value for `tgt`, must not be `None`")  # noqa: E501

        self._tgt = tgt

    @property
    def fun(self):
        """Gets the fun of this JobConfig.  # noqa: E501

        An array of strings each representing an execution module function.  # noqa: E501

        :return: The fun of this JobConfig.  # noqa: E501
        :rtype: list[str]
        """
        return self._fun

    @fun.setter
    def fun(self, fun):
        """Sets the fun of this JobConfig.

        An array of strings each representing an execution module function.  # noqa: E501

        :param fun: The fun of this JobConfig.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and fun is None:  # noqa: E501
            raise ValueError("Invalid value for `fun`, must not be `None`")  # noqa: E501

        self._fun = fun

    @property
    def arg(self):
        """Gets the arg of this JobConfig.  # noqa: E501

        An array of arrays of variable type elements that are arguments to the function specified by the \"fun\" property. If at least one function requires arguments, an array must be provided for each function, even if it is empty. Keyword arguments may be provided as a parameter of type object with at least one property of type boolean, \"__kwarg__\", that is evaluated to true.  # noqa: E501

        :return: The arg of this JobConfig.  # noqa: E501
        :rtype: list[list[object]]
        """
        return self._arg

    @arg.setter
    def arg(self, arg):
        """Sets the arg of this JobConfig.

        An array of arrays of variable type elements that are arguments to the function specified by the \"fun\" property. If at least one function requires arguments, an array must be provided for each function, even if it is empty. Keyword arguments may be provided as a parameter of type object with at least one property of type boolean, \"__kwarg__\", that is evaluated to true.  # noqa: E501

        :param arg: The arg of this JobConfig.  # noqa: E501
        :type: list[list[object]]
        """

        self._arg = arg

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobConfig):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, JobConfig):
            return True

        return self.to_dict() != other.to_dict()
