# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class JobResult(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        '_return': 'list[object]',
        'retcode': 'list[int]',
        'success': 'list[bool]'
    }

    attribute_map = {
        '_return': 'return',
        'retcode': 'retcode',
        'success': 'success'
    }

    def __init__(self, _return=None, retcode=None, success=None, local_vars_configuration=None):  # noqa: E501
        """JobResult - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self.__return = None
        self._retcode = None
        self._success = None
        self.discriminator = None

        if _return is not None:
            self._return = _return
        if retcode is not None:
            self.retcode = retcode
        self.success = success

    @property
    def _return(self):
        """Gets the _return of this JobResult.  # noqa: E501

        An array of objects representing return values for each executed function.  # noqa: E501

        :return: The _return of this JobResult.  # noqa: E501
        :rtype: list[object]
        """
        return self.__return

    @_return.setter
    def _return(self, _return):
        """Sets the _return of this JobResult.

        An array of objects representing return values for each executed function.  # noqa: E501

        :param _return: The _return of this JobResult.  # noqa: E501
        :type: list[object]
        """

        self.__return = _return

    @property
    def retcode(self):
        """Gets the retcode of this JobResult.  # noqa: E501

        An array of integers representing code values for each executed function.  # noqa: E501

        :return: The retcode of this JobResult.  # noqa: E501
        :rtype: list[int]
        """
        return self._retcode

    @retcode.setter
    def retcode(self, retcode):
        """Sets the retcode of this JobResult.

        An array of integers representing code values for each executed function.  # noqa: E501

        :param retcode: The retcode of this JobResult.  # noqa: E501
        :type: list[int]
        """

        self._retcode = retcode

    @property
    def success(self):
        """Gets the success of this JobResult.  # noqa: E501

        An array of booleans representing success values for each executed function.  # noqa: E501

        :return: The success of this JobResult.  # noqa: E501
        :rtype: list[bool]
        """
        return self._success

    @success.setter
    def success(self, success):
        """Sets the success of this JobResult.

        An array of booleans representing success values for each executed function.  # noqa: E501

        :param success: The success of this JobResult.  # noqa: E501
        :type: list[bool]
        """
        if self.local_vars_configuration.client_side_validation and success is None:  # noqa: E501
            raise ValueError("Invalid value for `success`, must not be `None`")  # noqa: E501

        self._success = success

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, JobResult):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, JobResult):
            return True

        return self.to_dict() != other.to_dict()
