# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class KeyRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'action': 'KeyAction',
        'key': 'str',
        'workspace': 'str'
    }

    attribute_map = {
        'id': 'id',
        'action': 'action',
        'key': 'key',
        'workspace': 'workspace'
    }

    def __init__(self, id=None, action=None, key=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """KeyRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._action = None
        self._key = None
        self._workspace = None
        self.discriminator = None

        self.id = id
        self.action = action
        if key is not None:
            self.key = key
        if workspace is not None:
            self.workspace = workspace

    @property
    def id(self):
        """Gets the id of this KeyRequest.  # noqa: E501

        A string representing the system ID.  # noqa: E501

        :return: The id of this KeyRequest.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this KeyRequest.

        A string representing the system ID.  # noqa: E501

        :param id: The id of this KeyRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def action(self):
        """Gets the action of this KeyRequest.  # noqa: E501


        :return: The action of this KeyRequest.  # noqa: E501
        :rtype: KeyAction
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this KeyRequest.


        :param action: The action of this KeyRequest.  # noqa: E501
        :type: KeyAction
        """
        if self.local_vars_configuration.client_side_validation and action is None:  # noqa: E501
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501

        self._action = action

    @property
    def key(self):
        """Gets the key of this KeyRequest.  # noqa: E501

        A string representing the public authorization key. If this field is specified, verification that the system ID is associated with this auth key will happen before the desired action is executed.  # noqa: E501

        :return: The key of this KeyRequest.  # noqa: E501
        :rtype: str
        """
        return self._key

    @key.setter
    def key(self, key):
        """Sets the key of this KeyRequest.

        A string representing the public authorization key. If this field is specified, verification that the system ID is associated with this auth key will happen before the desired action is executed.  # noqa: E501

        :param key: The key of this KeyRequest.  # noqa: E501
        :type: str
        """

        self._key = key

    @property
    def workspace(self):
        """Gets the workspace of this KeyRequest.  # noqa: E501

        The ID of the workspace.  # noqa: E501

        :return: The workspace of this KeyRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this KeyRequest.

        The ID of the workspace.  # noqa: E501

        :param workspace: The workspace of this KeyRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, KeyRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, KeyRequest):
            return True

        return self.to_dict() != other.to_dict()
