# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class ManagedSystem(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'created_timestamp': 'datetime',
        'last_updated_timestamp': 'datetime',
        'alias': 'str',
        'workspace': 'str',
        'activation': 'ManagedSystemActivation',
        'connected': 'ManagedSystemConnected',
        'grains': 'ManagedSystemDataPropertyMap',
        'packages': 'ManagedSystemPackagesData',
        'feeds': 'ManagedSystemDataPropertyMap',
        'sysapi': 'ManagedSystemSysApiData',
        'groups': 'ManagedSystemGroups',
        'keywords': 'ManagedSystemKeywords',
        'properties': 'ManagedSystemProperties'
    }

    attribute_map = {
        'id': 'id',
        'created_timestamp': 'createdTimestamp',
        'last_updated_timestamp': 'lastUpdatedTimestamp',
        'alias': 'alias',
        'workspace': 'workspace',
        'activation': 'activation',
        'connected': 'connected',
        'grains': 'grains',
        'packages': 'packages',
        'feeds': 'feeds',
        'sysapi': 'sysapi',
        'groups': 'groups',
        'keywords': 'keywords',
        'properties': 'properties'
    }

    def __init__(self, id=None, created_timestamp=None, last_updated_timestamp=None, alias=None, workspace=None, activation=None, connected=None, grains=None, packages=None, feeds=None, sysapi=None, groups=None, keywords=None, properties=None, local_vars_configuration=None):  # noqa: E501
        """ManagedSystem - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._created_timestamp = None
        self._last_updated_timestamp = None
        self._alias = None
        self._workspace = None
        self._activation = None
        self._connected = None
        self._grains = None
        self._packages = None
        self._feeds = None
        self._sysapi = None
        self._groups = None
        self._keywords = None
        self._properties = None
        self.discriminator = None

        self.id = id
        self.created_timestamp = created_timestamp
        self.last_updated_timestamp = last_updated_timestamp
        if alias is not None:
            self.alias = alias
        self.workspace = workspace
        if activation is not None:
            self.activation = activation
        self.connected = connected
        if grains is not None:
            self.grains = grains
        if packages is not None:
            self.packages = packages
        if feeds is not None:
            self.feeds = feeds
        if sysapi is not None:
            self.sysapi = sysapi
        if groups is not None:
            self.groups = groups
        if keywords is not None:
            self.keywords = keywords
        if properties is not None:
            self.properties = properties

    @property
    def id(self):
        """Gets the id of this ManagedSystem.  # noqa: E501

        The ID of the system.  # noqa: E501

        :return: The id of this ManagedSystem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ManagedSystem.

        The ID of the system.  # noqa: E501

        :param id: The id of this ManagedSystem.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def created_timestamp(self):
        """Gets the created_timestamp of this ManagedSystem.  # noqa: E501

        The time when the system was registered.  # noqa: E501

        :return: The created_timestamp of this ManagedSystem.  # noqa: E501
        :rtype: datetime
        """
        return self._created_timestamp

    @created_timestamp.setter
    def created_timestamp(self, created_timestamp):
        """Sets the created_timestamp of this ManagedSystem.

        The time when the system was registered.  # noqa: E501

        :param created_timestamp: The created_timestamp of this ManagedSystem.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `created_timestamp`, must not be `None`")  # noqa: E501

        self._created_timestamp = created_timestamp

    @property
    def last_updated_timestamp(self):
        """Gets the last_updated_timestamp of this ManagedSystem.  # noqa: E501

        Last time when the system information updated.  # noqa: E501

        :return: The last_updated_timestamp of this ManagedSystem.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_timestamp

    @last_updated_timestamp.setter
    def last_updated_timestamp(self, last_updated_timestamp):
        """Sets the last_updated_timestamp of this ManagedSystem.

        Last time when the system information updated.  # noqa: E501

        :param last_updated_timestamp: The last_updated_timestamp of this ManagedSystem.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and last_updated_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `last_updated_timestamp`, must not be `None`")  # noqa: E501

        self._last_updated_timestamp = last_updated_timestamp

    @property
    def alias(self):
        """Gets the alias of this ManagedSystem.  # noqa: E501

        The alias of the system.  # noqa: E501

        :return: The alias of this ManagedSystem.  # noqa: E501
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Sets the alias of this ManagedSystem.

        The alias of the system.  # noqa: E501

        :param alias: The alias of this ManagedSystem.  # noqa: E501
        :type: str
        """

        self._alias = alias

    @property
    def workspace(self):
        """Gets the workspace of this ManagedSystem.  # noqa: E501

        The ID of the workspace.  # noqa: E501

        :return: The workspace of this ManagedSystem.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this ManagedSystem.

        The ID of the workspace.  # noqa: E501

        :param workspace: The workspace of this ManagedSystem.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and workspace is None:  # noqa: E501
            raise ValueError("Invalid value for `workspace`, must not be `None`")  # noqa: E501

        self._workspace = workspace

    @property
    def activation(self):
        """Gets the activation of this ManagedSystem.  # noqa: E501


        :return: The activation of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemActivation
        """
        return self._activation

    @activation.setter
    def activation(self, activation):
        """Sets the activation of this ManagedSystem.


        :param activation: The activation of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemActivation
        """

        self._activation = activation

    @property
    def connected(self):
        """Gets the connected of this ManagedSystem.  # noqa: E501


        :return: The connected of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemConnected
        """
        return self._connected

    @connected.setter
    def connected(self, connected):
        """Sets the connected of this ManagedSystem.


        :param connected: The connected of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemConnected
        """
        if self.local_vars_configuration.client_side_validation and connected is None:  # noqa: E501
            raise ValueError("Invalid value for `connected`, must not be `None`")  # noqa: E501

        self._connected = connected

    @property
    def grains(self):
        """Gets the grains of this ManagedSystem.  # noqa: E501


        :return: The grains of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemDataPropertyMap
        """
        return self._grains

    @grains.setter
    def grains(self, grains):
        """Sets the grains of this ManagedSystem.


        :param grains: The grains of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemDataPropertyMap
        """

        self._grains = grains

    @property
    def packages(self):
        """Gets the packages of this ManagedSystem.  # noqa: E501


        :return: The packages of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemPackagesData
        """
        return self._packages

    @packages.setter
    def packages(self, packages):
        """Sets the packages of this ManagedSystem.


        :param packages: The packages of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemPackagesData
        """

        self._packages = packages

    @property
    def feeds(self):
        """Gets the feeds of this ManagedSystem.  # noqa: E501


        :return: The feeds of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemDataPropertyMap
        """
        return self._feeds

    @feeds.setter
    def feeds(self, feeds):
        """Sets the feeds of this ManagedSystem.


        :param feeds: The feeds of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemDataPropertyMap
        """

        self._feeds = feeds

    @property
    def sysapi(self):
        """Gets the sysapi of this ManagedSystem.  # noqa: E501


        :return: The sysapi of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemSysApiData
        """
        return self._sysapi

    @sysapi.setter
    def sysapi(self, sysapi):
        """Sets the sysapi of this ManagedSystem.


        :param sysapi: The sysapi of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemSysApiData
        """

        self._sysapi = sysapi

    @property
    def groups(self):
        """Gets the groups of this ManagedSystem.  # noqa: E501


        :return: The groups of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemGroups
        """
        return self._groups

    @groups.setter
    def groups(self, groups):
        """Sets the groups of this ManagedSystem.


        :param groups: The groups of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemGroups
        """

        self._groups = groups

    @property
    def keywords(self):
        """Gets the keywords of this ManagedSystem.  # noqa: E501


        :return: The keywords of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemKeywords
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this ManagedSystem.


        :param keywords: The keywords of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemKeywords
        """

        self._keywords = keywords

    @property
    def properties(self):
        """Gets the properties of this ManagedSystem.  # noqa: E501


        :return: The properties of this ManagedSystem.  # noqa: E501
        :rtype: ManagedSystemProperties
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this ManagedSystem.


        :param properties: The properties of this ManagedSystem.  # noqa: E501
        :type: ManagedSystemProperties
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ManagedSystem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ManagedSystem):
            return True

        return self.to_dict() != other.to_dict()
