# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class ManagedSystemActivationData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'activated': 'bool',
        'license_name': 'str',
        'license_version': 'str'
    }

    attribute_map = {
        'activated': 'activated',
        'license_name': 'licenseName',
        'license_version': 'licenseVersion'
    }

    def __init__(self, activated=None, license_name=None, license_version=None, local_vars_configuration=None):  # noqa: E501
        """ManagedSystemActivationData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._activated = None
        self._license_name = None
        self._license_version = None
        self.discriminator = None

        self.activated = activated
        if license_name is not None:
            self.license_name = license_name
        if license_version is not None:
            self.license_version = license_version

    @property
    def activated(self):
        """Gets the activated of this ManagedSystemActivationData.  # noqa: E501

        Whether the system is activated or not.  # noqa: E501

        :return: The activated of this ManagedSystemActivationData.  # noqa: E501
        :rtype: bool
        """
        return self._activated

    @activated.setter
    def activated(self, activated):
        """Sets the activated of this ManagedSystemActivationData.

        Whether the system is activated or not.  # noqa: E501

        :param activated: The activated of this ManagedSystemActivationData.  # noqa: E501
        :type: bool
        """
        if self.local_vars_configuration.client_side_validation and activated is None:  # noqa: E501
            raise ValueError("Invalid value for `activated`, must not be `None`")  # noqa: E501

        self._activated = activated

    @property
    def license_name(self):
        """Gets the license_name of this ManagedSystemActivationData.  # noqa: E501

        The name of the license.  # noqa: E501

        :return: The license_name of this ManagedSystemActivationData.  # noqa: E501
        :rtype: str
        """
        return self._license_name

    @license_name.setter
    def license_name(self, license_name):
        """Sets the license_name of this ManagedSystemActivationData.

        The name of the license.  # noqa: E501

        :param license_name: The license_name of this ManagedSystemActivationData.  # noqa: E501
        :type: str
        """

        self._license_name = license_name

    @property
    def license_version(self):
        """Gets the license_version of this ManagedSystemActivationData.  # noqa: E501

        The license version.  # noqa: E501

        :return: The license_version of this ManagedSystemActivationData.  # noqa: E501
        :rtype: str
        """
        return self._license_version

    @license_version.setter
    def license_version(self, license_version):
        """Sets the license_version of this ManagedSystemActivationData.

        The license version.  # noqa: E501

        :param license_version: The license_version of this ManagedSystemActivationData.  # noqa: E501
        :type: str
        """

        self._license_version = license_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ManagedSystemActivationData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ManagedSystemActivationData):
            return True

        return self.to_dict() != other.to_dict()
