# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class ManagedSystemsSummary(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'connected_count': 'int',
        'disconnected_count': 'int'
    }

    attribute_map = {
        'connected_count': 'connectedCount',
        'disconnected_count': 'disconnectedCount'
    }

    def __init__(self, connected_count=None, disconnected_count=None, local_vars_configuration=None):  # noqa: E501
        """ManagedSystemsSummary - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._connected_count = None
        self._disconnected_count = None
        self.discriminator = None

        self.connected_count = connected_count
        self.disconnected_count = disconnected_count

    @property
    def connected_count(self):
        """Gets the connected_count of this ManagedSystemsSummary.  # noqa: E501

        Number of the connected systems.  # noqa: E501

        :return: The connected_count of this ManagedSystemsSummary.  # noqa: E501
        :rtype: int
        """
        return self._connected_count

    @connected_count.setter
    def connected_count(self, connected_count):
        """Sets the connected_count of this ManagedSystemsSummary.

        Number of the connected systems.  # noqa: E501

        :param connected_count: The connected_count of this ManagedSystemsSummary.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and connected_count is None:  # noqa: E501
            raise ValueError("Invalid value for `connected_count`, must not be `None`")  # noqa: E501

        self._connected_count = connected_count

    @property
    def disconnected_count(self):
        """Gets the disconnected_count of this ManagedSystemsSummary.  # noqa: E501

        Number of the disconnected systems.  # noqa: E501

        :return: The disconnected_count of this ManagedSystemsSummary.  # noqa: E501
        :rtype: int
        """
        return self._disconnected_count

    @disconnected_count.setter
    def disconnected_count(self, disconnected_count):
        """Sets the disconnected_count of this ManagedSystemsSummary.

        Number of the disconnected systems.  # noqa: E501

        :param disconnected_count: The disconnected_count of this ManagedSystemsSummary.  # noqa: E501
        :type: int
        """
        if self.local_vars_configuration.client_side_validation and disconnected_count is None:  # noqa: E501
            raise ValueError("Invalid value for `disconnected_count`, must not be `None`")  # noqa: E501

        self._disconnected_count = disconnected_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ManagedSystemsSummary):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ManagedSystemsSummary):
            return True

        return self.to_dict() != other.to_dict()
