# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class QueryAvailablePackagesRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'return_duplicates': 'bool',
        'system_configurations': 'list[SystemConfiguration]'
    }

    attribute_map = {
        'return_duplicates': 'returnDuplicates',
        'system_configurations': 'systemConfigurations'
    }

    def __init__(self, return_duplicates=False, system_configurations=None, local_vars_configuration=None):  # noqa: E501
        """QueryAvailablePackagesRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._return_duplicates = None
        self._system_configurations = None
        self.discriminator = None

        if return_duplicates is not None:
            self.return_duplicates = return_duplicates
        self.system_configurations = system_configurations

    @property
    def return_duplicates(self):
        """Gets the return_duplicates of this QueryAvailablePackagesRequest.  # noqa: E501

        A boolean representing whether to return packages of equal version for each architecture.  # noqa: E501

        :return: The return_duplicates of this QueryAvailablePackagesRequest.  # noqa: E501
        :rtype: bool
        """
        return self._return_duplicates

    @return_duplicates.setter
    def return_duplicates(self, return_duplicates):
        """Sets the return_duplicates of this QueryAvailablePackagesRequest.

        A boolean representing whether to return packages of equal version for each architecture.  # noqa: E501

        :param return_duplicates: The return_duplicates of this QueryAvailablePackagesRequest.  # noqa: E501
        :type: bool
        """

        self._return_duplicates = return_duplicates

    @property
    def system_configurations(self):
        """Gets the system_configurations of this QueryAvailablePackagesRequest.  # noqa: E501

        An array of system configurations.  # noqa: E501

        :return: The system_configurations of this QueryAvailablePackagesRequest.  # noqa: E501
        :rtype: list[SystemConfiguration]
        """
        return self._system_configurations

    @system_configurations.setter
    def system_configurations(self, system_configurations):
        """Sets the system_configurations of this QueryAvailablePackagesRequest.

        An array of system configurations.  # noqa: E501

        :param system_configurations: The system_configurations of this QueryAvailablePackagesRequest.  # noqa: E501
        :type: list[SystemConfiguration]
        """
        if self.local_vars_configuration.client_side_validation and system_configurations is None:  # noqa: E501
            raise ValueError("Invalid value for `system_configurations`, must not be `None`")  # noqa: E501

        self._system_configurations = system_configurations

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryAvailablePackagesRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryAvailablePackagesRequest):
            return True

        return self.to_dict() != other.to_dict()
