# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class QueryJobsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'skip': 'int',
        'take': 'int',
        'filter': 'str',
        'projection': 'str',
        'order_by': 'str'
    }

    attribute_map = {
        'skip': 'skip',
        'take': 'take',
        'filter': 'filter',
        'projection': 'projection',
        'order_by': 'orderBy'
    }

    def __init__(self, skip=0, take=None, filter=None, projection=None, order_by=None, local_vars_configuration=None):  # noqa: E501
        """QueryJobsRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._skip = None
        self._take = None
        self._filter = None
        self._projection = None
        self._order_by = None
        self.discriminator = None

        if skip is not None:
            self.skip = skip
        if take is not None:
            self.take = take
        if filter is not None:
            self.filter = filter
        if projection is not None:
            self.projection = projection
        if order_by is not None:
            self.order_by = order_by

    @property
    def skip(self):
        """Gets the skip of this QueryJobsRequest.  # noqa: E501

        The number of resources to skip.  # noqa: E501

        :return: The skip of this QueryJobsRequest.  # noqa: E501
        :rtype: int
        """
        return self._skip

    @skip.setter
    def skip(self, skip):
        """Sets the skip of this QueryJobsRequest.

        The number of resources to skip.  # noqa: E501

        :param skip: The skip of this QueryJobsRequest.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                skip is not None and skip < 0):  # noqa: E501
            raise ValueError("Invalid value for `skip`, must be a value greater than or equal to `0`")  # noqa: E501

        self._skip = skip

    @property
    def take(self):
        """Gets the take of this QueryJobsRequest.  # noqa: E501

        The number of resources to return. The maximum value is 1000.  # noqa: E501

        :return: The take of this QueryJobsRequest.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this QueryJobsRequest.

        The number of resources to return. The maximum value is 1000.  # noqa: E501

        :param take: The take of this QueryJobsRequest.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take > 1000):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value less than or equal to `1000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take < 0):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value greater than or equal to `0`")  # noqa: E501

        self._take = take

    @property
    def filter(self):
        """Gets the filter of this QueryJobsRequest.  # noqa: E501

        The filter criteria for jobs or systems. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and' or '&&'. Example: 'x and y' - Logical OR operator 'or' or '||'. Example: 'x or y' - Contains operator '.Contains()', used to check if a list contains an element. Example: 'x.Contains(y)' - Not Contains operator '!.Contains()', used to check if a list does not contain an element. Example: '!x.Contains(y)'  Valid job properties that can be used in the filter: - jid : String representing the ID of the job. - id : String representing the ID of the system. - createdTimestamp: ISO-8601 formatted timestamp string specifying the date when the job was created. - lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the job was updated. - dispatchedTimestamp: ISO-8601 formatted timestamp string specifying the date when the job was actually sent to the system. - state: String representing the state of the job. - metadata: Object containg the the metadata of job. Example: metadata.queued - config.user: String representing the user who created the job. - config.tgt: List of strings representing the targeted systems. Example: config.tgt.Contains(\"id\") - config.fun: List of strings representing the functions to be executed within the job. Example: config.fun.Contains(\"nisysmgmt.set_blackout\") - config.arg: An array of arrays of variable type elements that are arguments to the function specified by the \"fun\" property. Example: config.arg[0].Contains(\"test\") - result.return: An array of objects representing return values for each executed function. Example:   result.return[0].Contains(\"Success\")  - result.retcode: An array of integers representing code values for each executed function. Example: result.retcode - result.success: An array of booleans representing success values for each executed function. Example:   result.success.Contains(false)  # noqa: E501

        :return: The filter of this QueryJobsRequest.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this QueryJobsRequest.

        The filter criteria for jobs or systems. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and' or '&&'. Example: 'x and y' - Logical OR operator 'or' or '||'. Example: 'x or y' - Contains operator '.Contains()', used to check if a list contains an element. Example: 'x.Contains(y)' - Not Contains operator '!.Contains()', used to check if a list does not contain an element. Example: '!x.Contains(y)'  Valid job properties that can be used in the filter: - jid : String representing the ID of the job. - id : String representing the ID of the system. - createdTimestamp: ISO-8601 formatted timestamp string specifying the date when the job was created. - lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the job was updated. - dispatchedTimestamp: ISO-8601 formatted timestamp string specifying the date when the job was actually sent to the system. - state: String representing the state of the job. - metadata: Object containg the the metadata of job. Example: metadata.queued - config.user: String representing the user who created the job. - config.tgt: List of strings representing the targeted systems. Example: config.tgt.Contains(\"id\") - config.fun: List of strings representing the functions to be executed within the job. Example: config.fun.Contains(\"nisysmgmt.set_blackout\") - config.arg: An array of arrays of variable type elements that are arguments to the function specified by the \"fun\" property. Example: config.arg[0].Contains(\"test\") - result.return: An array of objects representing return values for each executed function. Example:   result.return[0].Contains(\"Success\")  - result.retcode: An array of integers representing code values for each executed function. Example: result.retcode - result.success: An array of booleans representing success values for each executed function. Example:   result.success.Contains(false)  # noqa: E501

        :param filter: The filter of this QueryJobsRequest.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def projection(self):
        """Gets the projection of this QueryJobsRequest.  # noqa: E501

        Specifies the projection for resources. Use this field to receive specific properties of the model. Examples:     - 'new(id,jid,state)'     - 'new(id,jid,config.user as user)'     - 'new(id,jid,state,lastUpdatedTimestamp,metadata.queued as queued)'  # noqa: E501

        :return: The projection of this QueryJobsRequest.  # noqa: E501
        :rtype: str
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this QueryJobsRequest.

        Specifies the projection for resources. Use this field to receive specific properties of the model. Examples:     - 'new(id,jid,state)'     - 'new(id,jid,config.user as user)'     - 'new(id,jid,state,lastUpdatedTimestamp,metadata.queued as queued)'  # noqa: E501

        :param projection: The projection of this QueryJobsRequest.  # noqa: E501
        :type: str
        """

        self._projection = projection

    @property
    def order_by(self):
        """Gets the order_by of this QueryJobsRequest.  # noqa: E501

        The order in which data returns.  # noqa: E501

        :return: The order_by of this QueryJobsRequest.  # noqa: E501
        :rtype: str
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this QueryJobsRequest.

        The order in which data returns.  # noqa: E501

        :param order_by: The order_by of this QueryJobsRequest.  # noqa: E501
        :type: str
        """

        self._order_by = order_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryJobsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryJobsRequest):
            return True

        return self.to_dict() != other.to_dict()
