# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class QuerySystemsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'skip': 'int',
        'take': 'int',
        'filter': 'str',
        'projection': 'str',
        'order_by': 'str'
    }

    attribute_map = {
        'skip': 'skip',
        'take': 'take',
        'filter': 'filter',
        'projection': 'projection',
        'order_by': 'orderBy'
    }

    def __init__(self, skip=0, take=None, filter=None, projection=None, order_by=None, local_vars_configuration=None):  # noqa: E501
        """QuerySystemsRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._skip = None
        self._take = None
        self._filter = None
        self._projection = None
        self._order_by = None
        self.discriminator = None

        if skip is not None:
            self.skip = skip
        if take is not None:
            self.take = take
        if filter is not None:
            self.filter = filter
        if projection is not None:
            self.projection = projection
        if order_by is not None:
            self.order_by = order_by

    @property
    def skip(self):
        """Gets the skip of this QuerySystemsRequest.  # noqa: E501

        The number of resources to skip.  # noqa: E501

        :return: The skip of this QuerySystemsRequest.  # noqa: E501
        :rtype: int
        """
        return self._skip

    @skip.setter
    def skip(self, skip):
        """Sets the skip of this QuerySystemsRequest.

        The number of resources to skip.  # noqa: E501

        :param skip: The skip of this QuerySystemsRequest.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                skip is not None and skip < 0):  # noqa: E501
            raise ValueError("Invalid value for `skip`, must be a value greater than or equal to `0`")  # noqa: E501

        self._skip = skip

    @property
    def take(self):
        """Gets the take of this QuerySystemsRequest.  # noqa: E501

        The number of resources to return. The maximum value is 1000.  # noqa: E501

        :return: The take of this QuerySystemsRequest.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this QuerySystemsRequest.

        The number of resources to return. The maximum value is 1000.  # noqa: E501

        :param take: The take of this QuerySystemsRequest.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take > 1000):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value less than or equal to `1000`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take < 0):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value greater than or equal to `0`")  # noqa: E501

        self._take = take

    @property
    def filter(self):
        """Gets the filter of this QuerySystemsRequest.  # noqa: E501

        The filter criteria for jobs or systems. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and' or '&&'. Example: 'x and y' - Logical OR operator 'or' or '||'. Example: 'x or y' - Contains operator '.Contains()', used to check if a list contains an element. Example: 'x.Contains(y)' - Not Contains operator '!.Contains()', used to check if a list does not contain an element. Example: '!x.Contains(y)'  Valid system properties that can be used in the filter: - id : String representing the ID of the system. - createdTimestamp: ISO-8601 formatted timestamp string specifying the date when the system was registered. - lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system was updated. - alias: String representing the alias of the system. - activation.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system activation was updated. - activation.data.activated: Boolean representing whether the system is activated or not. - activation.data.licenseName: String representing the name of the license. - activation.data.licenseVersion: String representing the license version. - connected.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system connection was updated. - connected.data.state: String representing the state of the system. - grains.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system grains were updated. - grains.data: Dictionary of string to object representing general information about the system. Example: grains.data.os == \"Windows\" or DateTime(grains.data.boottime) > \"2021-06-01T08:20:09.512Z\" - packages.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system installed packages were updated. - packages.data: Dictionary representing software packages installed on the system. Example: packages.data.ni-package-manager-upgrader.version: String representing the installed version of ni-package-manager-upgrader package. - feeds.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system configured feeds were updated. - feeds.data: Dictionary representing the feeds configured on the system. - sysapi.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system sysapi data was updated. - sysapi.data: Dictionary representing system API information of a system. - groups.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system groups data was updated. - groups.data: Array of strings representing the IDs of the groups the system is assigned to. Example: groups.data.Contains(\"id\") - keywords.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system keywords were updated. - keywords.data: Array of strings representing the keywords of the system. Example: keywords.data.Contains(\"test\") - properties.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system properties were updated. - properties.data: Dictionary of string to string representing metadata information about a system. Example: properties.data.owner == \"admin\"  # noqa: E501

        :return: The filter of this QuerySystemsRequest.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this QuerySystemsRequest.

        The filter criteria for jobs or systems. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parenthesis can be used around filters to better define the order of operations. Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and' or '&&'. Example: 'x and y' - Logical OR operator 'or' or '||'. Example: 'x or y' - Contains operator '.Contains()', used to check if a list contains an element. Example: 'x.Contains(y)' - Not Contains operator '!.Contains()', used to check if a list does not contain an element. Example: '!x.Contains(y)'  Valid system properties that can be used in the filter: - id : String representing the ID of the system. - createdTimestamp: ISO-8601 formatted timestamp string specifying the date when the system was registered. - lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system was updated. - alias: String representing the alias of the system. - activation.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system activation was updated. - activation.data.activated: Boolean representing whether the system is activated or not. - activation.data.licenseName: String representing the name of the license. - activation.data.licenseVersion: String representing the license version. - connected.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system connection was updated. - connected.data.state: String representing the state of the system. - grains.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system grains were updated. - grains.data: Dictionary of string to object representing general information about the system. Example: grains.data.os == \"Windows\" or DateTime(grains.data.boottime) > \"2021-06-01T08:20:09.512Z\" - packages.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system installed packages were updated. - packages.data: Dictionary representing software packages installed on the system. Example: packages.data.ni-package-manager-upgrader.version: String representing the installed version of ni-package-manager-upgrader package. - feeds.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system configured feeds were updated. - feeds.data: Dictionary representing the feeds configured on the system. - sysapi.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system sysapi data was updated. - sysapi.data: Dictionary representing system API information of a system. - groups.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system groups data was updated. - groups.data: Array of strings representing the IDs of the groups the system is assigned to. Example: groups.data.Contains(\"id\") - keywords.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system keywords were updated. - keywords.data: Array of strings representing the keywords of the system. Example: keywords.data.Contains(\"test\") - properties.lastUpdatedTimestamp: ISO-8601 formatted timestamp string specifying the last date the system properties were updated. - properties.data: Dictionary of string to string representing metadata information about a system. Example: properties.data.owner == \"admin\"  # noqa: E501

        :param filter: The filter of this QuerySystemsRequest.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def projection(self):
        """Gets the projection of this QuerySystemsRequest.  # noqa: E501

        Specifies the projection for resources. Use this field to receive specific properties of the model. Examples:     - 'new(id,connected)'     - 'new(id,alias,grains.data.host as host)'     - 'new(id,lastUpdatedTimestamp,properties.data.location as location)'  # noqa: E501

        :return: The projection of this QuerySystemsRequest.  # noqa: E501
        :rtype: str
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this QuerySystemsRequest.

        Specifies the projection for resources. Use this field to receive specific properties of the model. Examples:     - 'new(id,connected)'     - 'new(id,alias,grains.data.host as host)'     - 'new(id,lastUpdatedTimestamp,properties.data.location as location)'  # noqa: E501

        :param projection: The projection of this QuerySystemsRequest.  # noqa: E501
        :type: str
        """

        self._projection = projection

    @property
    def order_by(self):
        """Gets the order_by of this QuerySystemsRequest.  # noqa: E501

        The order in which data returns.  # noqa: E501

        :return: The order_by of this QuerySystemsRequest.  # noqa: E501
        :rtype: str
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this QuerySystemsRequest.

        The order in which data returns.  # noqa: E501

        :param order_by: The order_by of this QuerySystemsRequest.  # noqa: E501
        :type: str
        """

        self._order_by = order_by

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QuerySystemsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QuerySystemsRequest):
            return True

        return self.to_dict() != other.to_dict()
