# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class RegisterSystemsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'systems_credentials': 'list[SystemCredentials]',
        'activate': 'bool',
        'workspaces': 'list[str]'
    }

    attribute_map = {
        'systems_credentials': 'systemsCredentials',
        'activate': 'activate',
        'workspaces': 'workspaces'
    }

    def __init__(self, systems_credentials=None, activate=False, workspaces=None, local_vars_configuration=None):  # noqa: E501
        """RegisterSystemsRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._systems_credentials = None
        self._activate = None
        self._workspaces = None
        self.discriminator = None

        self.systems_credentials = systems_credentials
        if activate is not None:
            self.activate = activate
        if workspaces is not None:
            self.workspaces = workspaces

    @property
    def systems_credentials(self):
        """Gets the systems_credentials of this RegisterSystemsRequest.  # noqa: E501

        An array of objects representing system credentials.  # noqa: E501

        :return: The systems_credentials of this RegisterSystemsRequest.  # noqa: E501
        :rtype: list[SystemCredentials]
        """
        return self._systems_credentials

    @systems_credentials.setter
    def systems_credentials(self, systems_credentials):
        """Sets the systems_credentials of this RegisterSystemsRequest.

        An array of objects representing system credentials.  # noqa: E501

        :param systems_credentials: The systems_credentials of this RegisterSystemsRequest.  # noqa: E501
        :type: list[SystemCredentials]
        """
        if self.local_vars_configuration.client_side_validation and systems_credentials is None:  # noqa: E501
            raise ValueError("Invalid value for `systems_credentials`, must not be `None`")  # noqa: E501

        self._systems_credentials = systems_credentials

    @property
    def activate(self):
        """Gets the activate of this RegisterSystemsRequest.  # noqa: E501

        Whether to activate the systems or not.  # noqa: E501

        :return: The activate of this RegisterSystemsRequest.  # noqa: E501
        :rtype: bool
        """
        return self._activate

    @activate.setter
    def activate(self, activate):
        """Sets the activate of this RegisterSystemsRequest.

        Whether to activate the systems or not.  # noqa: E501

        :param activate: The activate of this RegisterSystemsRequest.  # noqa: E501
        :type: bool
        """

        self._activate = activate

    @property
    def workspaces(self):
        """Gets the workspaces of this RegisterSystemsRequest.  # noqa: E501

        List containing the corresponding workspace for each system credential information.  # noqa: E501

        :return: The workspaces of this RegisterSystemsRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._workspaces

    @workspaces.setter
    def workspaces(self, workspaces):
        """Sets the workspaces of this RegisterSystemsRequest.

        List containing the corresponding workspace for each system credential information.  # noqa: E501

        :param workspaces: The workspaces of this RegisterSystemsRequest.  # noqa: E501
        :type: list[str]
        """

        self._workspaces = workspaces

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RegisterSystemsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RegisterSystemsRequest):
            return True

        return self.to_dict() != other.to_dict()
