# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class SystemConfiguration(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'feed_uris': 'list[str]',
        'os_architectures': 'list[str]'
    }

    attribute_map = {
        'feed_uris': 'feedUris',
        'os_architectures': 'osArchitectures'
    }

    def __init__(self, feed_uris=None, os_architectures=None, local_vars_configuration=None):  # noqa: E501
        """SystemConfiguration - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._feed_uris = None
        self._os_architectures = None
        self.discriminator = None

        self.feed_uris = feed_uris
        if os_architectures is not None:
            self.os_architectures = os_architectures

    @property
    def feed_uris(self):
        """Gets the feed_uris of this SystemConfiguration.  # noqa: E501

        An array of strings representing feed URIs a system(s) has configured.  # noqa: E501

        :return: The feed_uris of this SystemConfiguration.  # noqa: E501
        :rtype: list[str]
        """
        return self._feed_uris

    @feed_uris.setter
    def feed_uris(self, feed_uris):
        """Sets the feed_uris of this SystemConfiguration.

        An array of strings representing feed URIs a system(s) has configured.  # noqa: E501

        :param feed_uris: The feed_uris of this SystemConfiguration.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and feed_uris is None:  # noqa: E501
            raise ValueError("Invalid value for `feed_uris`, must not be `None`")  # noqa: E501

        self._feed_uris = feed_uris

    @property
    def os_architectures(self):
        """Gets the os_architectures of this SystemConfiguration.  # noqa: E501

        An array of strings representing OS architectures supported by a system(s) in descending priority.  # noqa: E501

        :return: The os_architectures of this SystemConfiguration.  # noqa: E501
        :rtype: list[str]
        """
        return self._os_architectures

    @os_architectures.setter
    def os_architectures(self, os_architectures):
        """Sets the os_architectures of this SystemConfiguration.

        An array of strings representing OS architectures supported by a system(s) in descending priority.  # noqa: E501

        :param os_architectures: The os_architectures of this SystemConfiguration.  # noqa: E501
        :type: list[str]
        """

        self._os_architectures = os_architectures

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemConfiguration):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemConfiguration):
            return True

        return self.to_dict() != other.to_dict()
