# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class SystemInfo(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'comments': 'str',
        'cpu_arch': 'str',
        'device_class': 'str',
        'hostname': 'str',
        'ip_address': 'str',
        'last_updated_timestamp': 'datetime',
        'master': 'str',
        'minion_id': 'str',
        'model_name': 'str',
        'model_number': 'str',
        'os_family': 'str',
        'os_release': 'str',
        'serial_number': 'str',
        'vendor_name': 'str',
        'version': 'str'
    }

    attribute_map = {
        'comments': 'comments',
        'cpu_arch': 'cpuArch',
        'device_class': 'deviceClass',
        'hostname': 'hostname',
        'ip_address': 'ipAddress',
        'last_updated_timestamp': 'lastUpdatedTimestamp',
        'master': 'master',
        'minion_id': 'minionId',
        'model_name': 'modelName',
        'model_number': 'modelNumber',
        'os_family': 'osFamily',
        'os_release': 'osRelease',
        'serial_number': 'serialNumber',
        'vendor_name': 'vendorName',
        'version': 'version'
    }

    def __init__(self, comments=None, cpu_arch=None, device_class=None, hostname=None, ip_address=None, last_updated_timestamp=None, master=None, minion_id=None, model_name=None, model_number=None, os_family=None, os_release=None, serial_number=None, vendor_name=None, version=None, local_vars_configuration=None):  # noqa: E501
        """SystemInfo - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._comments = None
        self._cpu_arch = None
        self._device_class = None
        self._hostname = None
        self._ip_address = None
        self._last_updated_timestamp = None
        self._master = None
        self._minion_id = None
        self._model_name = None
        self._model_number = None
        self._os_family = None
        self._os_release = None
        self._serial_number = None
        self._vendor_name = None
        self._version = None
        self.discriminator = None

        self.comments = comments
        self.cpu_arch = cpu_arch
        self.device_class = device_class
        self.hostname = hostname
        self.ip_address = ip_address
        self.last_updated_timestamp = last_updated_timestamp
        self.master = master
        self.minion_id = minion_id
        self.model_name = model_name
        self.model_number = model_number
        self.os_family = os_family
        self.os_release = os_release
        self.serial_number = serial_number
        self.vendor_name = vendor_name
        self.version = version

    @property
    def comments(self):
        """Gets the comments of this SystemInfo.  # noqa: E501

        System description.  # noqa: E501

        :return: The comments of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._comments

    @comments.setter
    def comments(self, comments):
        """Sets the comments of this SystemInfo.

        System description.  # noqa: E501

        :param comments: The comments of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and comments is None:  # noqa: E501
            raise ValueError("Invalid value for `comments`, must not be `None`")  # noqa: E501

        self._comments = comments

    @property
    def cpu_arch(self):
        """Gets the cpu_arch of this SystemInfo.  # noqa: E501

        System CPU architecture.  # noqa: E501

        :return: The cpu_arch of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._cpu_arch

    @cpu_arch.setter
    def cpu_arch(self, cpu_arch):
        """Sets the cpu_arch of this SystemInfo.

        System CPU architecture.  # noqa: E501

        :param cpu_arch: The cpu_arch of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and cpu_arch is None:  # noqa: E501
            raise ValueError("Invalid value for `cpu_arch`, must not be `None`")  # noqa: E501

        self._cpu_arch = cpu_arch

    @property
    def device_class(self):
        """Gets the device_class of this SystemInfo.  # noqa: E501

        System device class.  # noqa: E501

        :return: The device_class of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._device_class

    @device_class.setter
    def device_class(self, device_class):
        """Sets the device_class of this SystemInfo.

        System device class.  # noqa: E501

        :param device_class: The device_class of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and device_class is None:  # noqa: E501
            raise ValueError("Invalid value for `device_class`, must not be `None`")  # noqa: E501

        self._device_class = device_class

    @property
    def hostname(self):
        """Gets the hostname of this SystemInfo.  # noqa: E501

        System hostname.  # noqa: E501

        :return: The hostname of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._hostname

    @hostname.setter
    def hostname(self, hostname):
        """Sets the hostname of this SystemInfo.

        System hostname.  # noqa: E501

        :param hostname: The hostname of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and hostname is None:  # noqa: E501
            raise ValueError("Invalid value for `hostname`, must not be `None`")  # noqa: E501

        self._hostname = hostname

    @property
    def ip_address(self):
        """Gets the ip_address of this SystemInfo.  # noqa: E501

        System IP address.  # noqa: E501

        :return: The ip_address of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._ip_address

    @ip_address.setter
    def ip_address(self, ip_address):
        """Sets the ip_address of this SystemInfo.

        System IP address.  # noqa: E501

        :param ip_address: The ip_address of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and ip_address is None:  # noqa: E501
            raise ValueError("Invalid value for `ip_address`, must not be `None`")  # noqa: E501

        self._ip_address = ip_address

    @property
    def last_updated_timestamp(self):
        """Gets the last_updated_timestamp of this SystemInfo.  # noqa: E501

        Last updated timestamp.  # noqa: E501

        :return: The last_updated_timestamp of this SystemInfo.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_timestamp

    @last_updated_timestamp.setter
    def last_updated_timestamp(self, last_updated_timestamp):
        """Sets the last_updated_timestamp of this SystemInfo.

        Last updated timestamp.  # noqa: E501

        :param last_updated_timestamp: The last_updated_timestamp of this SystemInfo.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and last_updated_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `last_updated_timestamp`, must not be `None`")  # noqa: E501

        self._last_updated_timestamp = last_updated_timestamp

    @property
    def master(self):
        """Gets the master of this SystemInfo.  # noqa: E501

        Master of the system.  # noqa: E501

        :return: The master of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._master

    @master.setter
    def master(self, master):
        """Sets the master of this SystemInfo.

        Master of the system.  # noqa: E501

        :param master: The master of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and master is None:  # noqa: E501
            raise ValueError("Invalid value for `master`, must not be `None`")  # noqa: E501

        self._master = master

    @property
    def minion_id(self):
        """Gets the minion_id of this SystemInfo.  # noqa: E501

        Salt minion_id of the system.  # noqa: E501

        :return: The minion_id of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._minion_id

    @minion_id.setter
    def minion_id(self, minion_id):
        """Sets the minion_id of this SystemInfo.

        Salt minion_id of the system.  # noqa: E501

        :param minion_id: The minion_id of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and minion_id is None:  # noqa: E501
            raise ValueError("Invalid value for `minion_id`, must not be `None`")  # noqa: E501

        self._minion_id = minion_id

    @property
    def model_name(self):
        """Gets the model_name of this SystemInfo.  # noqa: E501

        System model name.  # noqa: E501

        :return: The model_name of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._model_name

    @model_name.setter
    def model_name(self, model_name):
        """Sets the model_name of this SystemInfo.

        System model name.  # noqa: E501

        :param model_name: The model_name of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and model_name is None:  # noqa: E501
            raise ValueError("Invalid value for `model_name`, must not be `None`")  # noqa: E501

        self._model_name = model_name

    @property
    def model_number(self):
        """Gets the model_number of this SystemInfo.  # noqa: E501

        System model number.  # noqa: E501

        :return: The model_number of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._model_number

    @model_number.setter
    def model_number(self, model_number):
        """Sets the model_number of this SystemInfo.

        System model number.  # noqa: E501

        :param model_number: The model_number of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and model_number is None:  # noqa: E501
            raise ValueError("Invalid value for `model_number`, must not be `None`")  # noqa: E501

        self._model_number = model_number

    @property
    def os_family(self):
        """Gets the os_family of this SystemInfo.  # noqa: E501

        System OS family.  # noqa: E501

        :return: The os_family of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._os_family

    @os_family.setter
    def os_family(self, os_family):
        """Sets the os_family of this SystemInfo.

        System OS family.  # noqa: E501

        :param os_family: The os_family of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and os_family is None:  # noqa: E501
            raise ValueError("Invalid value for `os_family`, must not be `None`")  # noqa: E501

        self._os_family = os_family

    @property
    def os_release(self):
        """Gets the os_release of this SystemInfo.  # noqa: E501

        System OS release.  # noqa: E501

        :return: The os_release of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._os_release

    @os_release.setter
    def os_release(self, os_release):
        """Sets the os_release of this SystemInfo.

        System OS release.  # noqa: E501

        :param os_release: The os_release of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and os_release is None:  # noqa: E501
            raise ValueError("Invalid value for `os_release`, must not be `None`")  # noqa: E501

        self._os_release = os_release

    @property
    def serial_number(self):
        """Gets the serial_number of this SystemInfo.  # noqa: E501

        System serial number.  # noqa: E501

        :return: The serial_number of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._serial_number

    @serial_number.setter
    def serial_number(self, serial_number):
        """Sets the serial_number of this SystemInfo.

        System serial number.  # noqa: E501

        :param serial_number: The serial_number of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and serial_number is None:  # noqa: E501
            raise ValueError("Invalid value for `serial_number`, must not be `None`")  # noqa: E501

        self._serial_number = serial_number

    @property
    def vendor_name(self):
        """Gets the vendor_name of this SystemInfo.  # noqa: E501

        System vendor name.  # noqa: E501

        :return: The vendor_name of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._vendor_name

    @vendor_name.setter
    def vendor_name(self, vendor_name):
        """Sets the vendor_name of this SystemInfo.

        System vendor name.  # noqa: E501

        :param vendor_name: The vendor_name of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and vendor_name is None:  # noqa: E501
            raise ValueError("Invalid value for `vendor_name`, must not be `None`")  # noqa: E501

        self._vendor_name = vendor_name

    @property
    def version(self):
        """Gets the version of this SystemInfo.  # noqa: E501

        Salt version.  # noqa: E501

        :return: The version of this SystemInfo.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this SystemInfo.

        Salt version.  # noqa: E501

        :param version: The version of this SystemInfo.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and version is None:  # noqa: E501
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemInfo):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemInfo):
            return True

        return self.to_dict() != other.to_dict()
