# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class SystemPatchRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'keywords': 'list[str]',
        'properties': 'dict(str, str)',
        'alias': 'str',
        'workspace': 'str'
    }

    attribute_map = {
        'keywords': 'keywords',
        'properties': 'properties',
        'alias': 'alias',
        'workspace': 'workspace'
    }

    def __init__(self, keywords=None, properties=None, alias=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """SystemPatchRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._keywords = None
        self._properties = None
        self._alias = None
        self._workspace = None
        self.discriminator = None

        if keywords is not None:
            self.keywords = keywords
        if properties is not None:
            self.properties = properties
        if alias is not None:
            self.alias = alias
        if workspace is not None:
            self.workspace = workspace

    @property
    def keywords(self):
        """Gets the keywords of this SystemPatchRequest.  # noqa: E501

        The new keywords assigned to the system.  # noqa: E501

        :return: The keywords of this SystemPatchRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this SystemPatchRequest.

        The new keywords assigned to the system.  # noqa: E501

        :param keywords: The keywords of this SystemPatchRequest.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def properties(self):
        """Gets the properties of this SystemPatchRequest.  # noqa: E501

        The new properties assigned to the system.  # noqa: E501

        :return: The properties of this SystemPatchRequest.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this SystemPatchRequest.

        The new properties assigned to the system.  # noqa: E501

        :param properties: The properties of this SystemPatchRequest.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def alias(self):
        """Gets the alias of this SystemPatchRequest.  # noqa: E501

        The new  alias of the system.  # noqa: E501

        :return: The alias of this SystemPatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Sets the alias of this SystemPatchRequest.

        The new  alias of the system.  # noqa: E501

        :param alias: The alias of this SystemPatchRequest.  # noqa: E501
        :type: str
        """

        self._alias = alias

    @property
    def workspace(self):
        """Gets the workspace of this SystemPatchRequest.  # noqa: E501

        The ID of the workspace.  # noqa: E501

        :return: The workspace of this SystemPatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this SystemPatchRequest.

        The ID of the workspace.  # noqa: E501

        :param workspace: The workspace of this SystemPatchRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemPatchRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemPatchRequest):
            return True

        return self.to_dict() != other.to_dict()
