# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class SystemsKeys(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'systems_pending': 'dict(str, str)',
        'systems_denied': 'dict(str, str)',
        'systems_approved': 'dict(str, str)',
        'systems_rejected': 'dict(str, str)'
    }

    attribute_map = {
        'systems_pending': 'systemsPending',
        'systems_denied': 'systemsDenied',
        'systems_approved': 'systemsApproved',
        'systems_rejected': 'systemsRejected'
    }

    def __init__(self, systems_pending=None, systems_denied=None, systems_approved=None, systems_rejected=None, local_vars_configuration=None):  # noqa: E501
        """SystemsKeys - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._systems_pending = None
        self._systems_denied = None
        self._systems_approved = None
        self._systems_rejected = None
        self.discriminator = None

        if systems_pending is not None:
            self.systems_pending = systems_pending
        if systems_denied is not None:
            self.systems_denied = systems_denied
        if systems_approved is not None:
            self.systems_approved = systems_approved
        if systems_rejected is not None:
            self.systems_rejected = systems_rejected

    @property
    def systems_pending(self):
        """Gets the systems_pending of this SystemsKeys.  # noqa: E501

        An object of system ID to key pairs that are pending approval or rejection. Keys may be pending when they are not pre-seeded via the automated registration process and attempt to connect to the master.  # noqa: E501

        :return: The systems_pending of this SystemsKeys.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._systems_pending

    @systems_pending.setter
    def systems_pending(self, systems_pending):
        """Sets the systems_pending of this SystemsKeys.

        An object of system ID to key pairs that are pending approval or rejection. Keys may be pending when they are not pre-seeded via the automated registration process and attempt to connect to the master.  # noqa: E501

        :param systems_pending: The systems_pending of this SystemsKeys.  # noqa: E501
        :type: dict(str, str)
        """

        self._systems_pending = systems_pending

    @property
    def systems_denied(self):
        """Gets the systems_denied of this SystemsKeys.  # noqa: E501

        An object of system ID to key pairs that have been denied. A key is denied when a system is trying to connect the master with a different key than the one that is accepted. This can occur if two systems have the same ID or if a key is removed from a system.  # noqa: E501

        :return: The systems_denied of this SystemsKeys.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._systems_denied

    @systems_denied.setter
    def systems_denied(self, systems_denied):
        """Sets the systems_denied of this SystemsKeys.

        An object of system ID to key pairs that have been denied. A key is denied when a system is trying to connect the master with a different key than the one that is accepted. This can occur if two systems have the same ID or if a key is removed from a system.  # noqa: E501

        :param systems_denied: The systems_denied of this SystemsKeys.  # noqa: E501
        :type: dict(str, str)
        """

        self._systems_denied = systems_denied

    @property
    def systems_approved(self):
        """Gets the systems_approved of this SystemsKeys.  # noqa: E501

        An object of system ID to key pairs that have been approved. These could have been approved explicitly by the user or pre-seeded via the automated registration process.  # noqa: E501

        :return: The systems_approved of this SystemsKeys.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._systems_approved

    @systems_approved.setter
    def systems_approved(self, systems_approved):
        """Sets the systems_approved of this SystemsKeys.

        An object of system ID to key pairs that have been approved. These could have been approved explicitly by the user or pre-seeded via the automated registration process.  # noqa: E501

        :param systems_approved: The systems_approved of this SystemsKeys.  # noqa: E501
        :type: dict(str, str)
        """

        self._systems_approved = systems_approved

    @property
    def systems_rejected(self):
        """Gets the systems_rejected of this SystemsKeys.  # noqa: E501

        An object of system ID to key pairs that have been rejected. Keys are rejected explicitly by the user.  # noqa: E501

        :return: The systems_rejected of this SystemsKeys.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._systems_rejected

    @systems_rejected.setter
    def systems_rejected(self, systems_rejected):
        """Sets the systems_rejected of this SystemsKeys.

        An object of system ID to key pairs that have been rejected. Keys are rejected explicitly by the user.  # noqa: E501

        :param systems_rejected: The systems_rejected of this SystemsKeys.  # noqa: E501
        :type: dict(str, str)
        """

        self._systems_rejected = systems_rejected

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemsKeys):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemsKeys):
            return True

        return self.to_dict() != other.to_dict()
