# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class UnregisterSystemsRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'tgt': 'list[str]',
        'force': 'bool'
    }

    attribute_map = {
        'tgt': 'tgt',
        'force': 'force'
    }

    def __init__(self, tgt=None, force=True, local_vars_configuration=None):  # noqa: E501
        """UnregisterSystemsRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._tgt = None
        self._force = None
        self.discriminator = None

        self.tgt = tgt
        if force is not None:
            self.force = force

    @property
    def tgt(self):
        """Gets the tgt of this UnregisterSystemsRequest.  # noqa: E501

        Array of strings representing the IDs of systems to remove from SystemLink Server.  # noqa: E501

        :return: The tgt of this UnregisterSystemsRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._tgt

    @tgt.setter
    def tgt(self, tgt):
        """Sets the tgt of this UnregisterSystemsRequest.

        Array of strings representing the IDs of systems to remove from SystemLink Server.  # noqa: E501

        :param tgt: The tgt of this UnregisterSystemsRequest.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and tgt is None:  # noqa: E501
            raise ValueError("Invalid value for `tgt`, must not be `None`")  # noqa: E501

        self._tgt = tgt

    @property
    def force(self):
        """Gets the force of this UnregisterSystemsRequest.  # noqa: E501

        A Boolean which specifies whether to remove systems from the database immediately (True) or wait until the unregister job returns from systems (False). If True, unregister job failures are not cached.  # noqa: E501

        :return: The force of this UnregisterSystemsRequest.  # noqa: E501
        :rtype: bool
        """
        return self._force

    @force.setter
    def force(self, force):
        """Sets the force of this UnregisterSystemsRequest.

        A Boolean which specifies whether to remove systems from the database immediately (True) or wait until the unregister job returns from systems (False). If True, unregister job failures are not cached.  # noqa: E501

        :param force: The force of this UnregisterSystemsRequest.  # noqa: E501
        :type: bool
        """

        self._force = force

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnregisterSystemsRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UnregisterSystemsRequest):
            return True

        return self.to_dict() != other.to_dict()
