# coding: utf-8

"""
    SystemLink Systems Management

    Systems Management Service HTTP API. Manage and monitor your distributed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisysmgmt.configuration import Configuration


class UnregisterSystemsResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'jid': 'str',
        'removed_ids': 'list[str]',
        'failed_ids': 'list[FailedUnregisterRequest]'
    }

    attribute_map = {
        'jid': 'jid',
        'removed_ids': 'removedIds',
        'failed_ids': 'failedIds'
    }

    def __init__(self, jid=None, removed_ids=None, failed_ids=None, local_vars_configuration=None):  # noqa: E501
        """UnregisterSystemsResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._jid = None
        self._removed_ids = None
        self._failed_ids = None
        self.discriminator = None

        if jid is not None:
            self.jid = jid
        if removed_ids is not None:
            self.removed_ids = removed_ids
        if failed_ids is not None:
            self.failed_ids = failed_ids

    @property
    def jid(self):
        """Gets the jid of this UnregisterSystemsResponse.  # noqa: E501

        The job ID of the unregistration job sent to connected systems.  # noqa: E501

        :return: The jid of this UnregisterSystemsResponse.  # noqa: E501
        :rtype: str
        """
        return self._jid

    @jid.setter
    def jid(self, jid):
        """Sets the jid of this UnregisterSystemsResponse.

        The job ID of the unregistration job sent to connected systems.  # noqa: E501

        :param jid: The jid of this UnregisterSystemsResponse.  # noqa: E501
        :type: str
        """

        self._jid = jid

    @property
    def removed_ids(self):
        """Gets the removed_ids of this UnregisterSystemsResponse.  # noqa: E501

        An array of system IDs removed from the database immediately.  # noqa: E501

        :return: The removed_ids of this UnregisterSystemsResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._removed_ids

    @removed_ids.setter
    def removed_ids(self, removed_ids):
        """Sets the removed_ids of this UnregisterSystemsResponse.

        An array of system IDs removed from the database immediately.  # noqa: E501

        :param removed_ids: The removed_ids of this UnregisterSystemsResponse.  # noqa: E501
        :type: list[str]
        """

        self._removed_ids = removed_ids

    @property
    def failed_ids(self):
        """Gets the failed_ids of this UnregisterSystemsResponse.  # noqa: E501

        An array of objects defining failed unregister operations.  # noqa: E501

        :return: The failed_ids of this UnregisterSystemsResponse.  # noqa: E501
        :rtype: list[FailedUnregisterRequest]
        """
        return self._failed_ids

    @failed_ids.setter
    def failed_ids(self, failed_ids):
        """Sets the failed_ids of this UnregisterSystemsResponse.

        An array of objects defining failed unregister operations.  # noqa: E501

        :param failed_ids: The failed_ids of this UnregisterSystemsResponse.  # noqa: E501
        :type: list[FailedUnregisterRequest]
        """

        self._failed_ids = failed_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UnregisterSystemsResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UnregisterSystemsResponse):
            return True

        return self.to_dict() != other.to_dict()
