# coding: utf-8

"""
    SystemLink Systems State Manager

    Creates and manages states you can apply to managed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisystemsstate.configuration import Configuration


class Feed(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'url': 'str',
        'enabled': 'bool',
        'compressed': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'url': 'url',
        'enabled': 'enabled',
        'compressed': 'compressed'
    }

    def __init__(self, name=None, url=None, enabled=True, compressed=False, local_vars_configuration=None):  # noqa: E501
        """Feed - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._url = None
        self._enabled = None
        self._compressed = None
        self.discriminator = None

        self.name = name
        self.url = url
        if enabled is not None:
            self.enabled = enabled
        if compressed is not None:
            self.compressed = compressed

    @property
    def name(self):
        """Gets the name of this Feed.  # noqa: E501

        Name of the feed.  # noqa: E501

        :return: The name of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Feed.

        Name of the feed.  # noqa: E501

        :param name: The name of this Feed.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def url(self):
        """Gets the url of this Feed.  # noqa: E501

        The url for the repository.  # noqa: E501

        :return: The url of this Feed.  # noqa: E501
        :rtype: str
        """
        return self._url

    @url.setter
    def url(self, url):
        """Sets the url of this Feed.

        The url for the repository.  # noqa: E501

        :param url: The url of this Feed.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and url is None:  # noqa: E501
            raise ValueError("Invalid value for `url`, must not be `None`")  # noqa: E501

        self._url = url

    @property
    def enabled(self):
        """Gets the enabled of this Feed.  # noqa: E501

        Whether the feed is enabled or not.  # noqa: E501

        :return: The enabled of this Feed.  # noqa: E501
        :rtype: bool
        """
        return self._enabled

    @enabled.setter
    def enabled(self, enabled):
        """Sets the enabled of this Feed.

        Whether the feed is enabled or not.  # noqa: E501

        :param enabled: The enabled of this Feed.  # noqa: E501
        :type: bool
        """

        self._enabled = enabled

    @property
    def compressed(self):
        """Gets the compressed of this Feed.  # noqa: E501

        Whether the feed is compressed or not.  # noqa: E501

        :return: The compressed of this Feed.  # noqa: E501
        :rtype: bool
        """
        return self._compressed

    @compressed.setter
    def compressed(self, compressed):
        """Sets the compressed of this Feed.

        Whether the feed is compressed or not.  # noqa: E501

        :param compressed: The compressed of this Feed.  # noqa: E501
        :type: bool
        """

        self._compressed = compressed

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Feed):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Feed):
            return True

        return self.to_dict() != other.to_dict()
