# coding: utf-8

"""
    SystemLink Systems State Manager

    Creates and manages states you can apply to managed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisystemsstate.configuration import Configuration


class StateIDVersionPair(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'state_id': 'str',
        'state_version': 'str'
    }

    attribute_map = {
        'state_id': 'stateID',
        'state_version': 'stateVersion'
    }

    def __init__(self, state_id=None, state_version=None, local_vars_configuration=None):  # noqa: E501
        """StateIDVersionPair - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._state_id = None
        self._state_version = None
        self.discriminator = None

        self.state_id = state_id
        if state_version is not None:
            self.state_version = state_version

    @property
    def state_id(self):
        """Gets the state_id of this StateIDVersionPair.  # noqa: E501

        The ID of the state.  # noqa: E501

        :return: The state_id of this StateIDVersionPair.  # noqa: E501
        :rtype: str
        """
        return self._state_id

    @state_id.setter
    def state_id(self, state_id):
        """Sets the state_id of this StateIDVersionPair.

        The ID of the state.  # noqa: E501

        :param state_id: The state_id of this StateIDVersionPair.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and state_id is None:  # noqa: E501
            raise ValueError("Invalid value for `state_id`, must not be `None`")  # noqa: E501

        self._state_id = state_id

    @property
    def state_version(self):
        """Gets the state_version of this StateIDVersionPair.  # noqa: E501

        The version of the state. The latest package/feed set of the state will be used if the version is not specified.  # noqa: E501

        :return: The state_version of this StateIDVersionPair.  # noqa: E501
        :rtype: str
        """
        return self._state_version

    @state_version.setter
    def state_version(self, state_version):
        """Sets the state_version of this StateIDVersionPair.

        The version of the state. The latest package/feed set of the state will be used if the version is not specified.  # noqa: E501

        :param state_version: The state_version of this StateIDVersionPair.  # noqa: E501
        :type: str
        """

        self._state_version = state_version

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StateIDVersionPair):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StateIDVersionPair):
            return True

        return self.to_dict() != other.to_dict()
