# coding: utf-8

"""
    SystemLink Systems State Manager

    Creates and manages states you can apply to managed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisystemsstate.configuration import Configuration


class StateMetadata(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'name': 'str',
        'file_name': 'str',
        'description': 'str',
        'distribution': 'StateDistribution',
        'architecture': 'StateArchitecture',
        'created_timestamp': 'datetime',
        'last_updated_timestamp': 'datetime',
        'workspace': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'file_name': 'fileName',
        'description': 'description',
        'distribution': 'distribution',
        'architecture': 'architecture',
        'created_timestamp': 'createdTimestamp',
        'last_updated_timestamp': 'lastUpdatedTimestamp',
        'workspace': 'workspace'
    }

    def __init__(self, id=None, name=None, file_name=None, description=None, distribution=None, architecture=None, created_timestamp=None, last_updated_timestamp=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """StateMetadata - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._name = None
        self._file_name = None
        self._description = None
        self._distribution = None
        self._architecture = None
        self._created_timestamp = None
        self._last_updated_timestamp = None
        self._workspace = None
        self.discriminator = None

        self.id = id
        self.name = name
        self.file_name = file_name
        if description is not None:
            self.description = description
        self.distribution = distribution
        self.architecture = architecture
        self.created_timestamp = created_timestamp
        self.last_updated_timestamp = last_updated_timestamp
        self.workspace = workspace

    @property
    def id(self):
        """Gets the id of this StateMetadata.  # noqa: E501

        The ID of the state.  # noqa: E501

        :return: The id of this StateMetadata.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this StateMetadata.

        The ID of the state.  # noqa: E501

        :param id: The id of this StateMetadata.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and id is None:  # noqa: E501
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this StateMetadata.  # noqa: E501

        The name of the state.  # noqa: E501

        :return: The name of this StateMetadata.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this StateMetadata.

        The name of the state.  # noqa: E501

        :param name: The name of this StateMetadata.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def file_name(self):
        """Gets the file_name of this StateMetadata.  # noqa: E501

        The file name of the state.  # noqa: E501

        :return: The file_name of this StateMetadata.  # noqa: E501
        :rtype: str
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this StateMetadata.

        The file name of the state.  # noqa: E501

        :param file_name: The file_name of this StateMetadata.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and file_name is None:  # noqa: E501
            raise ValueError("Invalid value for `file_name`, must not be `None`")  # noqa: E501

        self._file_name = file_name

    @property
    def description(self):
        """Gets the description of this StateMetadata.  # noqa: E501

        The description of the state.  # noqa: E501

        :return: The description of this StateMetadata.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this StateMetadata.

        The description of the state.  # noqa: E501

        :param description: The description of this StateMetadata.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def distribution(self):
        """Gets the distribution of this StateMetadata.  # noqa: E501


        :return: The distribution of this StateMetadata.  # noqa: E501
        :rtype: StateDistribution
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """Sets the distribution of this StateMetadata.


        :param distribution: The distribution of this StateMetadata.  # noqa: E501
        :type: StateDistribution
        """
        if self.local_vars_configuration.client_side_validation and distribution is None:  # noqa: E501
            raise ValueError("Invalid value for `distribution`, must not be `None`")  # noqa: E501

        self._distribution = distribution

    @property
    def architecture(self):
        """Gets the architecture of this StateMetadata.  # noqa: E501


        :return: The architecture of this StateMetadata.  # noqa: E501
        :rtype: StateArchitecture
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this StateMetadata.


        :param architecture: The architecture of this StateMetadata.  # noqa: E501
        :type: StateArchitecture
        """
        if self.local_vars_configuration.client_side_validation and architecture is None:  # noqa: E501
            raise ValueError("Invalid value for `architecture`, must not be `None`")  # noqa: E501

        self._architecture = architecture

    @property
    def created_timestamp(self):
        """Gets the created_timestamp of this StateMetadata.  # noqa: E501

        ISO-8601 formatted timestamp specifying the state creation date.  # noqa: E501

        :return: The created_timestamp of this StateMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._created_timestamp

    @created_timestamp.setter
    def created_timestamp(self, created_timestamp):
        """Sets the created_timestamp of this StateMetadata.

        ISO-8601 formatted timestamp specifying the state creation date.  # noqa: E501

        :param created_timestamp: The created_timestamp of this StateMetadata.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and created_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `created_timestamp`, must not be `None`")  # noqa: E501

        self._created_timestamp = created_timestamp

    @property
    def last_updated_timestamp(self):
        """Gets the last_updated_timestamp of this StateMetadata.  # noqa: E501

        ISO-8601 formatted timestamp specifying the last date that the state was updated.  # noqa: E501

        :return: The last_updated_timestamp of this StateMetadata.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated_timestamp

    @last_updated_timestamp.setter
    def last_updated_timestamp(self, last_updated_timestamp):
        """Sets the last_updated_timestamp of this StateMetadata.

        ISO-8601 formatted timestamp specifying the last date that the state was updated.  # noqa: E501

        :param last_updated_timestamp: The last_updated_timestamp of this StateMetadata.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and last_updated_timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `last_updated_timestamp`, must not be `None`")  # noqa: E501

        self._last_updated_timestamp = last_updated_timestamp

    @property
    def workspace(self):
        """Gets the workspace of this StateMetadata.  # noqa: E501

        The ID of the workspace. This property is available starting with version 3 of the getStates operation.  # noqa: E501

        :return: The workspace of this StateMetadata.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this StateMetadata.

        The ID of the workspace. This property is available starting with version 3 of the getStates operation.  # noqa: E501

        :param workspace: The workspace of this StateMetadata.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and workspace is None:  # noqa: E501
            raise ValueError("Invalid value for `workspace`, must not be `None`")  # noqa: E501

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StateMetadata):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StateMetadata):
            return True

        return self.to_dict() != other.to_dict()
