# coding: utf-8

"""
    SystemLink Systems State Manager

    Creates and manages states you can apply to managed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisystemsstate.configuration import Configuration


class StatePatchRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'description': 'str',
        'distribution': 'StateDistribution',
        'architecture': 'StateArchitecture',
        'feeds': 'list[Feed]',
        'system_image': 'SystemImage',
        'packages': 'list[Package]',
        'change_description': 'str',
        'workspace': 'str'
    }

    attribute_map = {
        'name': 'name',
        'description': 'description',
        'distribution': 'distribution',
        'architecture': 'architecture',
        'feeds': 'feeds',
        'system_image': 'systemImage',
        'packages': 'packages',
        'change_description': 'changeDescription',
        'workspace': 'workspace'
    }

    def __init__(self, name=None, description=None, distribution=None, architecture=None, feeds=None, system_image=None, packages=None, change_description=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """StatePatchRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._description = None
        self._distribution = None
        self._architecture = None
        self._feeds = None
        self._system_image = None
        self._packages = None
        self._change_description = None
        self._workspace = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if description is not None:
            self.description = description
        if distribution is not None:
            self.distribution = distribution
        if architecture is not None:
            self.architecture = architecture
        if feeds is not None:
            self.feeds = feeds
        if system_image is not None:
            self.system_image = system_image
        if packages is not None:
            self.packages = packages
        if change_description is not None:
            self.change_description = change_description
        if workspace is not None:
            self.workspace = workspace

    @property
    def name(self):
        """Gets the name of this StatePatchRequest.  # noqa: E501

        Name of the state.  # noqa: E501

        :return: The name of this StatePatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this StatePatchRequest.

        Name of the state.  # noqa: E501

        :param name: The name of this StatePatchRequest.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def description(self):
        """Gets the description of this StatePatchRequest.  # noqa: E501

        Description of the state.  # noqa: E501

        :return: The description of this StatePatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this StatePatchRequest.

        Description of the state.  # noqa: E501

        :param description: The description of this StatePatchRequest.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def distribution(self):
        """Gets the distribution of this StatePatchRequest.  # noqa: E501


        :return: The distribution of this StatePatchRequest.  # noqa: E501
        :rtype: StateDistribution
        """
        return self._distribution

    @distribution.setter
    def distribution(self, distribution):
        """Sets the distribution of this StatePatchRequest.


        :param distribution: The distribution of this StatePatchRequest.  # noqa: E501
        :type: StateDistribution
        """

        self._distribution = distribution

    @property
    def architecture(self):
        """Gets the architecture of this StatePatchRequest.  # noqa: E501


        :return: The architecture of this StatePatchRequest.  # noqa: E501
        :rtype: StateArchitecture
        """
        return self._architecture

    @architecture.setter
    def architecture(self, architecture):
        """Sets the architecture of this StatePatchRequest.


        :param architecture: The architecture of this StatePatchRequest.  # noqa: E501
        :type: StateArchitecture
        """

        self._architecture = architecture

    @property
    def feeds(self):
        """Gets the feeds of this StatePatchRequest.  # noqa: E501


        :return: The feeds of this StatePatchRequest.  # noqa: E501
        :rtype: list[Feed]
        """
        return self._feeds

    @feeds.setter
    def feeds(self, feeds):
        """Sets the feeds of this StatePatchRequest.


        :param feeds: The feeds of this StatePatchRequest.  # noqa: E501
        :type: list[Feed]
        """

        self._feeds = feeds

    @property
    def system_image(self):
        """Gets the system_image of this StatePatchRequest.  # noqa: E501


        :return: The system_image of this StatePatchRequest.  # noqa: E501
        :rtype: SystemImage
        """
        return self._system_image

    @system_image.setter
    def system_image(self, system_image):
        """Sets the system_image of this StatePatchRequest.


        :param system_image: The system_image of this StatePatchRequest.  # noqa: E501
        :type: SystemImage
        """

        self._system_image = system_image

    @property
    def packages(self):
        """Gets the packages of this StatePatchRequest.  # noqa: E501


        :return: The packages of this StatePatchRequest.  # noqa: E501
        :rtype: list[Package]
        """
        return self._packages

    @packages.setter
    def packages(self, packages):
        """Sets the packages of this StatePatchRequest.


        :param packages: The packages of this StatePatchRequest.  # noqa: E501
        :type: list[Package]
        """

        self._packages = packages

    @property
    def change_description(self):
        """Gets the change_description of this StatePatchRequest.  # noqa: E501

        Description of the change operation.  # noqa: E501

        :return: The change_description of this StatePatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._change_description

    @change_description.setter
    def change_description(self, change_description):
        """Sets the change_description of this StatePatchRequest.

        Description of the change operation.  # noqa: E501

        :param change_description: The change_description of this StatePatchRequest.  # noqa: E501
        :type: str
        """

        self._change_description = change_description

    @property
    def workspace(self):
        """Gets the workspace of this StatePatchRequest.  # noqa: E501

        The ID of the workspace. This property is available starting with version 3 of the createOrUpdateStates operation.  # noqa: E501

        :return: The workspace of this StatePatchRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this StatePatchRequest.

        The ID of the workspace. This property is available starting with version 3 of the createOrUpdateStates operation.  # noqa: E501

        :param workspace: The workspace of this StatePatchRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StatePatchRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StatePatchRequest):
            return True

        return self.to_dict() != other.to_dict()
