# coding: utf-8

"""
    SystemLink Systems State Manager

    Creates and manages states you can apply to managed systems.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nisystemsstate.configuration import Configuration


class SystemImage(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'version': 'str',
        'reinstall': 'bool'
    }

    attribute_map = {
        'name': 'name',
        'version': 'version',
        'reinstall': 'reinstall'
    }

    def __init__(self, name=None, version=None, reinstall=False, local_vars_configuration=None):  # noqa: E501
        """SystemImage - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._version = None
        self._reinstall = None
        self.discriminator = None

        self.name = name
        self.version = version
        if reinstall is not None:
            self.reinstall = reinstall

    @property
    def name(self):
        """Gets the name of this SystemImage.  # noqa: E501

        Name of the system image.  # noqa: E501

        :return: The name of this SystemImage.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this SystemImage.

        Name of the system image.  # noqa: E501

        :param name: The name of this SystemImage.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def version(self):
        """Gets the version of this SystemImage.  # noqa: E501

        Version of the system image.  # noqa: E501

        :return: The version of this SystemImage.  # noqa: E501
        :rtype: str
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this SystemImage.

        Version of the system image.  # noqa: E501

        :param version: The version of this SystemImage.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and version is None:  # noqa: E501
            raise ValueError("Invalid value for `version`, must not be `None`")  # noqa: E501

        self._version = version

    @property
    def reinstall(self):
        """Gets the reinstall of this SystemImage.  # noqa: E501

        Whether the image should be reinstalled if it is already installed.  # noqa: E501

        :return: The reinstall of this SystemImage.  # noqa: E501
        :rtype: bool
        """
        return self._reinstall

    @reinstall.setter
    def reinstall(self, reinstall):
        """Sets the reinstall of this SystemImage.

        Whether the image should be reinstalled if it is already installed.  # noqa: E501

        :param reinstall: The reinstall of this SystemImage.  # noqa: E501
        :type: bool
        """

        self._reinstall = reinstall

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SystemImage):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SystemImage):
            return True

        return self.to_dict() != other.to_dict()
