# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class GetTagsWithValuesResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'total_count': 'int',
        'tags_with_values': 'list[TagWithValue]'
    }

    attribute_map = {
        'total_count': 'totalCount',
        'tags_with_values': 'tagsWithValues'
    }

    def __init__(self, total_count=None, tags_with_values=None, local_vars_configuration=None):  # noqa: E501
        """GetTagsWithValuesResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._total_count = None
        self._tags_with_values = None
        self.discriminator = None

        if total_count is not None:
            self.total_count = total_count
        if tags_with_values is not None:
            self.tags_with_values = tags_with_values

    @property
    def total_count(self):
        """Gets the total_count of this GetTagsWithValuesResponse.  # noqa: E501

        Total number of tags which match a given query  # noqa: E501

        :return: The total_count of this GetTagsWithValuesResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this GetTagsWithValuesResponse.

        Total number of tags which match a given query  # noqa: E501

        :param total_count: The total_count of this GetTagsWithValuesResponse.  # noqa: E501
        :type: int
        """

        self._total_count = total_count

    @property
    def tags_with_values(self):
        """Gets the tags_with_values of this GetTagsWithValuesResponse.  # noqa: E501

        List of tags with their current and aggregate values  # noqa: E501

        :return: The tags_with_values of this GetTagsWithValuesResponse.  # noqa: E501
        :rtype: list[TagWithValue]
        """
        return self._tags_with_values

    @tags_with_values.setter
    def tags_with_values(self, tags_with_values):
        """Sets the tags_with_values of this GetTagsWithValuesResponse.

        List of tags with their current and aggregate values  # noqa: E501

        :param tags_with_values: The tags_with_values of this GetTagsWithValuesResponse.  # noqa: E501
        :type: list[TagWithValue]
        """

        self._tags_with_values = tags_with_values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, GetTagsWithValuesResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, GetTagsWithValuesResponse):
            return True

        return self.to_dict() != other.to_dict()
