# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class QueryTagsWithValuesResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'continuation_token': 'str',
        'tags_with_values': 'list[TagWithValue]'
    }

    attribute_map = {
        'continuation_token': 'continuationToken',
        'tags_with_values': 'tagsWithValues'
    }

    def __init__(self, continuation_token=None, tags_with_values=None, local_vars_configuration=None):  # noqa: E501
        """QueryTagsWithValuesResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._continuation_token = None
        self._tags_with_values = None
        self.discriminator = None

        if continuation_token is not None:
            self.continuation_token = continuation_token
        self.tags_with_values = tags_with_values

    @property
    def continuation_token(self):
        """Gets the continuation_token of this QueryTagsWithValuesResponse.  # noqa: E501

        Token to pass to a subsequent query to retrieve the next page of tags  # noqa: E501

        :return: The continuation_token of this QueryTagsWithValuesResponse.  # noqa: E501
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this QueryTagsWithValuesResponse.

        Token to pass to a subsequent query to retrieve the next page of tags  # noqa: E501

        :param continuation_token: The continuation_token of this QueryTagsWithValuesResponse.  # noqa: E501
        :type: str
        """

        self._continuation_token = continuation_token

    @property
    def tags_with_values(self):
        """Gets the tags_with_values of this QueryTagsWithValuesResponse.  # noqa: E501

        List of tags with their current and aggregate values  # noqa: E501

        :return: The tags_with_values of this QueryTagsWithValuesResponse.  # noqa: E501
        :rtype: list[TagWithValue]
        """
        return self._tags_with_values

    @tags_with_values.setter
    def tags_with_values(self, tags_with_values):
        """Sets the tags_with_values of this QueryTagsWithValuesResponse.

        List of tags with their current and aggregate values  # noqa: E501

        :param tags_with_values: The tags_with_values of this QueryTagsWithValuesResponse.  # noqa: E501
        :type: list[TagWithValue]
        """
        if self.local_vars_configuration.client_side_validation and tags_with_values is None:  # noqa: E501
            raise ValueError("Invalid value for `tags_with_values`, must not be `None`")  # noqa: E501

        self._tags_with_values = tags_with_values

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryTagsWithValuesResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryTagsWithValuesResponse):
            return True

        return self.to_dict() != other.to_dict()
