# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class Selection(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'search_paths': 'list[str]',
        'inactivity_timeout': 'int',
        'id': 'str',
        'workspace': 'str'
    }

    attribute_map = {
        'search_paths': 'searchPaths',
        'inactivity_timeout': 'inactivityTimeout',
        'id': 'id',
        'workspace': 'workspace'
    }

    def __init__(self, search_paths=None, inactivity_timeout=None, id=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """Selection - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._search_paths = None
        self._inactivity_timeout = None
        self._id = None
        self._workspace = None
        self.discriminator = None

        self.search_paths = search_paths
        if inactivity_timeout is not None:
            self.inactivity_timeout = inactivity_timeout
        if id is not None:
            self.id = id
        if workspace is not None:
            self.workspace = workspace

    @property
    def search_paths(self):
        """Gets the search_paths of this Selection.  # noqa: E501


        :return: The search_paths of this Selection.  # noqa: E501
        :rtype: list[str]
        """
        return self._search_paths

    @search_paths.setter
    def search_paths(self, search_paths):
        """Sets the search_paths of this Selection.


        :param search_paths: The search_paths of this Selection.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and search_paths is None:  # noqa: E501
            raise ValueError("Invalid value for `search_paths`, must not be `None`")  # noqa: E501

        self._search_paths = search_paths

    @property
    def inactivity_timeout(self):
        """Gets the inactivity_timeout of this Selection.  # noqa: E501

        Inactivity timeout in seconds.  # noqa: E501

        :return: The inactivity_timeout of this Selection.  # noqa: E501
        :rtype: int
        """
        return self._inactivity_timeout

    @inactivity_timeout.setter
    def inactivity_timeout(self, inactivity_timeout):
        """Sets the inactivity_timeout of this Selection.

        Inactivity timeout in seconds.  # noqa: E501

        :param inactivity_timeout: The inactivity_timeout of this Selection.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                inactivity_timeout is not None and inactivity_timeout > 900):  # noqa: E501
            raise ValueError("Invalid value for `inactivity_timeout`, must be a value less than or equal to `900`")  # noqa: E501

        self._inactivity_timeout = inactivity_timeout

    @property
    def id(self):
        """Gets the id of this Selection.  # noqa: E501


        :return: The id of this Selection.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Selection.


        :param id: The id of this Selection.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def workspace(self):
        """Gets the workspace of this Selection.  # noqa: E501

        Workspace of the tags to select.  # noqa: E501

        :return: The workspace of this Selection.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this Selection.

        Workspace of the tags to select.  # noqa: E501

        :param workspace: The workspace of this Selection.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Selection):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Selection):
            return True

        return self.to_dict() != other.to_dict()
