# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class Subscription(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'updates_only': 'bool',
        'tags': 'list[str]',
        'alias': 'str',
        'workspace': 'str'
    }

    attribute_map = {
        'updates_only': 'updatesOnly',
        'tags': 'tags',
        'alias': 'alias',
        'workspace': 'workspace'
    }

    def __init__(self, updates_only=False, tags=None, alias=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """Subscription - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._updates_only = None
        self._tags = None
        self._alias = None
        self._workspace = None
        self.discriminator = None

        if updates_only is not None:
            self.updates_only = updates_only
        self.tags = tags
        if alias is not None:
            self.alias = alias
        if workspace is not None:
            self.workspace = workspace

    @property
    def updates_only(self):
        """Gets the updates_only of this Subscription.  # noqa: E501

        Whether to notify only about updates.  # noqa: E501

        :return: The updates_only of this Subscription.  # noqa: E501
        :rtype: bool
        """
        return self._updates_only

    @updates_only.setter
    def updates_only(self, updates_only):
        """Sets the updates_only of this Subscription.

        Whether to notify only about updates.  # noqa: E501

        :param updates_only: The updates_only of this Subscription.  # noqa: E501
        :type: bool
        """

        self._updates_only = updates_only

    @property
    def tags(self):
        """Gets the tags of this Subscription.  # noqa: E501

        List of subscribed tag paths.  # noqa: E501

        :return: The tags of this Subscription.  # noqa: E501
        :rtype: list[str]
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """Sets the tags of this Subscription.

        List of subscribed tag paths.  # noqa: E501

        :param tags: The tags of this Subscription.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and tags is None:  # noqa: E501
            raise ValueError("Invalid value for `tags`, must not be `None`")  # noqa: E501

        self._tags = tags

    @property
    def alias(self):
        """Gets the alias of this Subscription.  # noqa: E501

        Name of the subscription.  # noqa: E501

        :return: The alias of this Subscription.  # noqa: E501
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Sets the alias of this Subscription.

        Name of the subscription.  # noqa: E501

        :param alias: The alias of this Subscription.  # noqa: E501
        :type: str
        """

        self._alias = alias

    @property
    def workspace(self):
        """Gets the workspace of this Subscription.  # noqa: E501

        Workspace of the tags to subscribe to.  # noqa: E501

        :return: The workspace of this Subscription.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this Subscription.

        Workspace of the tags to subscribe to.  # noqa: E501

        :param workspace: The workspace of this Subscription.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Subscription):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Subscription):
            return True

        return self.to_dict() != other.to_dict()
