# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class Tag(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'type': 'TagType',
        'properties': 'dict(str, str)',
        'path': 'str',
        'keywords': 'list[str]',
        'collect_aggregates': 'bool',
        'workspace': 'str'
    }

    attribute_map = {
        'type': 'type',
        'properties': 'properties',
        'path': 'path',
        'keywords': 'keywords',
        'collect_aggregates': 'collectAggregates',
        'workspace': 'workspace'
    }

    def __init__(self, type=None, properties=None, path=None, keywords=None, collect_aggregates=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """Tag - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._type = None
        self._properties = None
        self._path = None
        self._keywords = None
        self._collect_aggregates = None
        self._workspace = None
        self.discriminator = None

        self.type = type
        if properties is not None:
            self.properties = properties
        self.path = path
        if keywords is not None:
            self.keywords = keywords
        if collect_aggregates is not None:
            self.collect_aggregates = collect_aggregates
        if workspace is not None:
            self.workspace = workspace

    @property
    def type(self):
        """Gets the type of this Tag.  # noqa: E501


        :return: The type of this Tag.  # noqa: E501
        :rtype: TagType
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this Tag.


        :param type: The type of this Tag.  # noqa: E501
        :type: TagType
        """
        if self.local_vars_configuration.client_side_validation and type is None:  # noqa: E501
            raise ValueError("Invalid value for `type`, must not be `None`")  # noqa: E501

        self._type = type

    @property
    def properties(self):
        """Gets the properties of this Tag.  # noqa: E501


        :return: The properties of this Tag.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this Tag.


        :param properties: The properties of this Tag.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def path(self):
        """Gets the path of this Tag.  # noqa: E501


        :return: The path of this Tag.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this Tag.


        :param path: The path of this Tag.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and path is None:  # noqa: E501
            raise ValueError("Invalid value for `path`, must not be `None`")  # noqa: E501

        self._path = path

    @property
    def keywords(self):
        """Gets the keywords of this Tag.  # noqa: E501


        :return: The keywords of this Tag.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this Tag.


        :param keywords: The keywords of this Tag.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def collect_aggregates(self):
        """Gets the collect_aggregates of this Tag.  # noqa: E501


        :return: The collect_aggregates of this Tag.  # noqa: E501
        :rtype: bool
        """
        return self._collect_aggregates

    @collect_aggregates.setter
    def collect_aggregates(self, collect_aggregates):
        """Sets the collect_aggregates of this Tag.


        :param collect_aggregates: The collect_aggregates of this Tag.  # noqa: E501
        :type: bool
        """

        self._collect_aggregates = collect_aggregates

    @property
    def workspace(self):
        """Gets the workspace of this Tag.  # noqa: E501


        :return: The workspace of this Tag.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this Tag.


        :param workspace: The workspace of this Tag.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Tag):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Tag):
            return True

        return self.to_dict() != other.to_dict()
