# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class TagQuery(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'filter': 'str',
        'order_by': 'str',
        'descending': 'bool',
        'projection': 'str',
        'continuation_token': 'str',
        'take': 'float'
    }

    attribute_map = {
        'filter': 'filter',
        'order_by': 'orderBy',
        'descending': 'descending',
        'projection': 'projection',
        'continuation_token': 'continuationToken',
        'take': 'take'
    }

    def __init__(self, filter=None, order_by='PATH', descending=False, projection='', continuation_token=None, take=None, local_vars_configuration=None):  # noqa: E501
        """TagQuery - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._filter = None
        self._order_by = None
        self._descending = None
        self._projection = None
        self._continuation_token = None
        self._take = None
        self.discriminator = None

        if filter is not None:
            self.filter = filter
        if order_by is not None:
            self.order_by = order_by
        if descending is not None:
            self.descending = descending
        if projection is not None:
            self.projection = projection
        if continuation_token is not None:
            self.continuation_token = continuation_token
        if take is not None:
            self.take = take

    @property
    def filter(self):
        """Gets the filter of this TagQuery.  # noqa: E501

        The filter criteria for tags. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parentheses can be used around filters to better define the order of operations.  Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and' or '&&'. Example: 'x and y' - Logical OR operator 'or' or '||'. Example: 'x or y' - Contains operator '.Contains()', which is used to check if a list contains an element. Example: 'x.Contains(y)' - Not Contains operator '!.Contains()', which is used to check if a list does not contain an element. Example: '!x.Contains(y)'  Valid tag properties that can be used in the filter: - path : String representing the tag path. May include glob-style wildcards. - type: Tag type. Example: INT - keywords: Tag keywords. Example: keywords.Contains(x) - properties: Tag properties. Example: properties['x'] = 'y' - workspace : The workspace of the tags. Example: 88974b87-07d4-4f84-b54f-48eec89b11ed  # noqa: E501

        :return: The filter of this TagQuery.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this TagQuery.

        The filter criteria for tags. Consists of a string of queries composed using AND/OR operators. String values and date strings need to be enclosed in double quotes. Parentheses can be used around filters to better define the order of operations.  Filter syntax: '[property name][operator][operand] and [property name][operator][operand]'  Operators: - Equals operator '='. Example: 'x = y' - Not equal operator '!='. Example: 'x != y' - Greater than operator '>'. Example: 'x > y' - Greater than or equal operator '>='. Example: 'x >= y' - Less than operator '<'. Example: 'x < y' - Less than or equal operator '<='. Example: 'x <= y' - Logical AND operator 'and' or '&&'. Example: 'x and y' - Logical OR operator 'or' or '||'. Example: 'x or y' - Contains operator '.Contains()', which is used to check if a list contains an element. Example: 'x.Contains(y)' - Not Contains operator '!.Contains()', which is used to check if a list does not contain an element. Example: '!x.Contains(y)'  Valid tag properties that can be used in the filter: - path : String representing the tag path. May include glob-style wildcards. - type: Tag type. Example: INT - keywords: Tag keywords. Example: keywords.Contains(x) - properties: Tag properties. Example: properties['x'] = 'y' - workspace : The workspace of the tags. Example: 88974b87-07d4-4f84-b54f-48eec89b11ed  # noqa: E501

        :param filter: The filter of this TagQuery.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def order_by(self):
        """Gets the order_by of this TagQuery.  # noqa: E501

        The tag value property to order results by; value and timestamp are from the current tag value. When ordering by value, tags will be grouped by type, first numbers (INT, DOUBLE, U_INT64), then strings, then booleans, then times. Null values will be at the end of the list regardless of type.  # noqa: E501

        :return: The order_by of this TagQuery.  # noqa: E501
        :rtype: str
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this TagQuery.

        The tag value property to order results by; value and timestamp are from the current tag value. When ordering by value, tags will be grouped by type, first numbers (INT, DOUBLE, U_INT64), then strings, then booleans, then times. Null values will be at the end of the list regardless of type.  # noqa: E501

        :param order_by: The order_by of this TagQuery.  # noqa: E501
        :type: str
        """
        allowed_values = ["PATH", "VALUE", "TIMESTAMP", "WORKSPACE"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and order_by not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `order_by` ({0}), must be one of {1}"  # noqa: E501
                .format(order_by, allowed_values)
            )

        self._order_by = order_by

    @property
    def descending(self):
        """Gets the descending of this TagQuery.  # noqa: E501

        A Boolean that determines whether to return the tags in descending order.  # noqa: E501

        :return: The descending of this TagQuery.  # noqa: E501
        :rtype: bool
        """
        return self._descending

    @descending.setter
    def descending(self, descending):
        """Sets the descending of this TagQuery.

        A Boolean that determines whether to return the tags in descending order.  # noqa: E501

        :param descending: The descending of this TagQuery.  # noqa: E501
        :type: bool
        """

        self._descending = descending

    @property
    def projection(self):
        """Gets the projection of this TagQuery.  # noqa: E501

        The tag metadata and value fields to return.  # noqa: E501

        :return: The projection of this TagQuery.  # noqa: E501
        :rtype: str
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this TagQuery.

        The tag metadata and value fields to return.  # noqa: E501

        :param projection: The projection of this TagQuery.  # noqa: E501
        :type: str
        """

        self._projection = projection

    @property
    def continuation_token(self):
        """Gets the continuation_token of this TagQuery.  # noqa: E501

        A token used for resuming a query at the next item in the matching tag set; to obtain the next page of steps, pass the token to the service on a subsequent request.  # noqa: E501

        :return: The continuation_token of this TagQuery.  # noqa: E501
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this TagQuery.

        A token used for resuming a query at the next item in the matching tag set; to obtain the next page of steps, pass the token to the service on a subsequent request.  # noqa: E501

        :param continuation_token: The continuation_token of this TagQuery.  # noqa: E501
        :type: str
        """

        self._continuation_token = continuation_token

    @property
    def take(self):
        """Gets the take of this TagQuery.  # noqa: E501

        Maximum number of tags to return.  # noqa: E501

        :return: The take of this TagQuery.  # noqa: E501
        :rtype: float
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this TagQuery.

        Maximum number of tags to return.  # noqa: E501

        :param take: The take of this TagQuery.  # noqa: E501
        :type: float
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take < -1):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value greater than or equal to `-1`")  # noqa: E501

        self._take = take

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TagQuery):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TagQuery):
            return True

        return self.to_dict() != other.to_dict()
