# coding: utf-8

"""
    SystemLink Tag Service

    Publish and manage timestamped key-value-pair data.  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitag.configuration import Configuration


class V2SubscriptionUpdate(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'updates': 'list[V2SubscriptionTagUpdate]',
        'subscription_id': 'str',
        'nonexistent_tags': 'list[str]',
        'deleted_tags': 'list[str]',
        'created_tags': 'list[str]',
        'alias': 'str'
    }

    attribute_map = {
        'updates': 'updates',
        'subscription_id': 'subscriptionId',
        'nonexistent_tags': 'nonexistentTags',
        'deleted_tags': 'deletedTags',
        'created_tags': 'createdTags',
        'alias': 'alias'
    }

    def __init__(self, updates=None, subscription_id=None, nonexistent_tags=None, deleted_tags=None, created_tags=None, alias=None, local_vars_configuration=None):  # noqa: E501
        """V2SubscriptionUpdate - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._updates = None
        self._subscription_id = None
        self._nonexistent_tags = None
        self._deleted_tags = None
        self._created_tags = None
        self._alias = None
        self.discriminator = None

        if updates is not None:
            self.updates = updates
        if subscription_id is not None:
            self.subscription_id = subscription_id
        if nonexistent_tags is not None:
            self.nonexistent_tags = nonexistent_tags
        if deleted_tags is not None:
            self.deleted_tags = deleted_tags
        if created_tags is not None:
            self.created_tags = created_tags
        if alias is not None:
            self.alias = alias

    @property
    def updates(self):
        """Gets the updates of this V2SubscriptionUpdate.  # noqa: E501


        :return: The updates of this V2SubscriptionUpdate.  # noqa: E501
        :rtype: list[V2SubscriptionTagUpdate]
        """
        return self._updates

    @updates.setter
    def updates(self, updates):
        """Sets the updates of this V2SubscriptionUpdate.


        :param updates: The updates of this V2SubscriptionUpdate.  # noqa: E501
        :type: list[V2SubscriptionTagUpdate]
        """

        self._updates = updates

    @property
    def subscription_id(self):
        """Gets the subscription_id of this V2SubscriptionUpdate.  # noqa: E501


        :return: The subscription_id of this V2SubscriptionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._subscription_id

    @subscription_id.setter
    def subscription_id(self, subscription_id):
        """Sets the subscription_id of this V2SubscriptionUpdate.


        :param subscription_id: The subscription_id of this V2SubscriptionUpdate.  # noqa: E501
        :type: str
        """

        self._subscription_id = subscription_id

    @property
    def nonexistent_tags(self):
        """Gets the nonexistent_tags of this V2SubscriptionUpdate.  # noqa: E501

        List of tags which did not exist.  # noqa: E501

        :return: The nonexistent_tags of this V2SubscriptionUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._nonexistent_tags

    @nonexistent_tags.setter
    def nonexistent_tags(self, nonexistent_tags):
        """Sets the nonexistent_tags of this V2SubscriptionUpdate.

        List of tags which did not exist.  # noqa: E501

        :param nonexistent_tags: The nonexistent_tags of this V2SubscriptionUpdate.  # noqa: E501
        :type: list[str]
        """

        self._nonexistent_tags = nonexistent_tags

    @property
    def deleted_tags(self):
        """Gets the deleted_tags of this V2SubscriptionUpdate.  # noqa: E501

        List of tags which have been deleted.  # noqa: E501

        :return: The deleted_tags of this V2SubscriptionUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._deleted_tags

    @deleted_tags.setter
    def deleted_tags(self, deleted_tags):
        """Sets the deleted_tags of this V2SubscriptionUpdate.

        List of tags which have been deleted.  # noqa: E501

        :param deleted_tags: The deleted_tags of this V2SubscriptionUpdate.  # noqa: E501
        :type: list[str]
        """

        self._deleted_tags = deleted_tags

    @property
    def created_tags(self):
        """Gets the created_tags of this V2SubscriptionUpdate.  # noqa: E501

        List of tags which have been created.  # noqa: E501

        :return: The created_tags of this V2SubscriptionUpdate.  # noqa: E501
        :rtype: list[str]
        """
        return self._created_tags

    @created_tags.setter
    def created_tags(self, created_tags):
        """Sets the created_tags of this V2SubscriptionUpdate.

        List of tags which have been created.  # noqa: E501

        :param created_tags: The created_tags of this V2SubscriptionUpdate.  # noqa: E501
        :type: list[str]
        """

        self._created_tags = created_tags

    @property
    def alias(self):
        """Gets the alias of this V2SubscriptionUpdate.  # noqa: E501

        Name of the subscription.  # noqa: E501

        :return: The alias of this V2SubscriptionUpdate.  # noqa: E501
        :rtype: str
        """
        return self._alias

    @alias.setter
    def alias(self, alias):
        """Sets the alias of this V2SubscriptionUpdate.

        Name of the subscription.  # noqa: E501

        :param alias: The alias of this V2SubscriptionUpdate.  # noqa: E501
        :type: str
        """

        self._alias = alias

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, V2SubscriptionUpdate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, V2SubscriptionUpdate):
            return True

        return self.to_dict() != other.to_dict()
