# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from systemlink.clients.nitaghistorian.api_client import ApiClient
from systemlink.clients.nitaghistorian.exceptions import (
    ApiTypeError,
    ApiValueError
)


class WebSocketApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def open_web_socket_session(self, upgrade, connection, sec_web_socket_version, sec_web_socket_key, **kwargs):  # noqa: E501
        """Open a WebSocket session  # noqa: E501

        Opens a persistent connection to the web server that allows two-way communication using a JSON protocol. After you open a connection, you can query for historical values and subscribe or unsubscribe for notifications when new historical values are recorded. Refer to the *Models* section to access the schema for these actions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.open_web_socket_session(upgrade, connection, sec_web_socket_version, sec_web_socket_key, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str upgrade: (required)
        :param str connection: (required)
        :param str sec_web_socket_version: Protocol version of the WebSocket connection. (required)
        :param str sec_web_socket_key: Randomly selected sixteen-byte base64-encoded string. Used to confirm a valid WebSocket handshake. Must be selected randomly for each new connection. (required)
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        return self.open_web_socket_session_with_http_info(upgrade, connection, sec_web_socket_version, sec_web_socket_key, **kwargs)  # noqa: E501

    def open_web_socket_session_with_http_info(self, upgrade, connection, sec_web_socket_version, sec_web_socket_key, **kwargs):  # noqa: E501
        """Open a WebSocket session  # noqa: E501

        Opens a persistent connection to the web server that allows two-way communication using a JSON protocol. After you open a connection, you can query for historical values and subscribe or unsubscribe for notifications when new historical values are recorded. Refer to the *Models* section to access the schema for these actions.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.open_web_socket_session_with_http_info(upgrade, connection, sec_web_socket_version, sec_web_socket_key, async_req=True)
        >>> result = thread.get()

        :param async_req bool: execute request asynchronously
        :param str upgrade: (required)
        :param str connection: (required)
        :param str sec_web_socket_version: Protocol version of the WebSocket connection. (required)
        :param str sec_web_socket_key: Randomly selected sixteen-byte base64-encoded string. Used to confirm a valid WebSocket handshake. Must be selected randomly for each new connection. (required)
        :param _return_http_data_only: response data without head status code
                                       and headers
        :param _preload_content: if False, the urllib3.HTTPResponse object will
                                 be returned without reading/decoding response
                                 data. Default is True.
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: None
                 If the method is called asynchronously,
                 returns the request thread.
        """

        local_var_params = locals()

        all_params = ['upgrade', 'connection', 'sec_web_socket_version', 'sec_web_socket_key']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        for key, val in six.iteritems(local_var_params['kwargs']):
            if key not in all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method open_web_socket_session" % key
                )
            local_var_params[key] = val
        del local_var_params['kwargs']
        # verify the required parameter 'upgrade' is set
        if self.api_client.client_side_validation and ('upgrade' not in local_var_params or  # noqa: E501
                                                        local_var_params['upgrade'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `upgrade` when calling `open_web_socket_session`")  # noqa: E501
        # verify the required parameter 'connection' is set
        if self.api_client.client_side_validation and ('connection' not in local_var_params or  # noqa: E501
                                                        local_var_params['connection'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `connection` when calling `open_web_socket_session`")  # noqa: E501
        # verify the required parameter 'sec_web_socket_version' is set
        if self.api_client.client_side_validation and ('sec_web_socket_version' not in local_var_params or  # noqa: E501
                                                        local_var_params['sec_web_socket_version'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `sec_web_socket_version` when calling `open_web_socket_session`")  # noqa: E501
        # verify the required parameter 'sec_web_socket_key' is set
        if self.api_client.client_side_validation and ('sec_web_socket_key' not in local_var_params or  # noqa: E501
                                                        local_var_params['sec_web_socket_key'] is None):  # noqa: E501
            raise ApiValueError("Missing the required parameter `sec_web_socket_key` when calling `open_web_socket_session`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}
        if 'upgrade' in local_var_params:
            header_params['Upgrade'] = local_var_params['upgrade']  # noqa: E501
        if 'connection' in local_var_params:
            header_params['Connection'] = local_var_params['connection']  # noqa: E501
        if 'sec_web_socket_version' in local_var_params:
            header_params['Sec-WebSocket-Version'] = local_var_params['sec_web_socket_version']  # noqa: E501
        if 'sec_web_socket_key' in local_var_params:
            header_params['Sec-WebSocket-Key'] = local_var_params['sec_web_socket_key']  # noqa: E501

        form_params = []
        local_var_files = {}

        body_params = None
        # Authentication setting
        auth_settings = ['apiKeyAuth', 'basicAuth']  # noqa: E501

        return self.api_client.call_api(
            '/v2/websocket', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type=None,  # noqa: E501
            auth_settings=auth_settings,
            async_req=local_var_params.get('async_req'),
            _return_http_data_only=local_var_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=local_var_params.get('_preload_content', True),
            _request_timeout=local_var_params.get('_request_timeout'),
            collection_formats=collection_formats)
