# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class ErrorEntry(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'name': 'str',
        'code': 'int',
        'message': 'str',
        'args': 'list[str]',
        'resource_type': 'str',
        'resource_id': 'str',
        'inner_errors': 'list[ErrorEntry]'
    }

    attribute_map = {
        'name': 'name',
        'code': 'code',
        'message': 'message',
        'args': 'args',
        'resource_type': 'resourceType',
        'resource_id': 'resourceId',
        'inner_errors': 'innerErrors'
    }

    def __init__(self, name=None, code=None, message=None, args=None, resource_type=None, resource_id=None, inner_errors=None, local_vars_configuration=None):  # noqa: E501
        """ErrorEntry - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._name = None
        self._code = None
        self._message = None
        self._args = None
        self._resource_type = None
        self._resource_id = None
        self._inner_errors = None
        self.discriminator = None

        if name is not None:
            self.name = name
        if code is not None:
            self.code = code
        if message is not None:
            self.message = message
        if args is not None:
            self.args = args
        if resource_type is not None:
            self.resource_type = resource_type
        if resource_id is not None:
            self.resource_id = resource_id
        if inner_errors is not None:
            self.inner_errors = inner_errors

    @property
    def name(self):
        """Gets the name of this ErrorEntry.  # noqa: E501

        String error code  # noqa: E501

        :return: The name of this ErrorEntry.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this ErrorEntry.

        String error code  # noqa: E501

        :param name: The name of this ErrorEntry.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def code(self):
        """Gets the code of this ErrorEntry.  # noqa: E501

        Numeric error code  # noqa: E501

        :return: The code of this ErrorEntry.  # noqa: E501
        :rtype: int
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this ErrorEntry.

        Numeric error code  # noqa: E501

        :param code: The code of this ErrorEntry.  # noqa: E501
        :type: int
        """

        self._code = code

    @property
    def message(self):
        """Gets the message of this ErrorEntry.  # noqa: E501

        Complete error message  # noqa: E501

        :return: The message of this ErrorEntry.  # noqa: E501
        :rtype: str
        """
        return self._message

    @message.setter
    def message(self, message):
        """Sets the message of this ErrorEntry.

        Complete error message  # noqa: E501

        :param message: The message of this ErrorEntry.  # noqa: E501
        :type: str
        """

        self._message = message

    @property
    def args(self):
        """Gets the args of this ErrorEntry.  # noqa: E501

        Positional argument values for the error code  # noqa: E501

        :return: The args of this ErrorEntry.  # noqa: E501
        :rtype: list[str]
        """
        return self._args

    @args.setter
    def args(self, args):
        """Sets the args of this ErrorEntry.

        Positional argument values for the error code  # noqa: E501

        :param args: The args of this ErrorEntry.  # noqa: E501
        :type: list[str]
        """

        self._args = args

    @property
    def resource_type(self):
        """Gets the resource_type of this ErrorEntry.  # noqa: E501

        Type of resource associated with the error  # noqa: E501

        :return: The resource_type of this ErrorEntry.  # noqa: E501
        :rtype: str
        """
        return self._resource_type

    @resource_type.setter
    def resource_type(self, resource_type):
        """Sets the resource_type of this ErrorEntry.

        Type of resource associated with the error  # noqa: E501

        :param resource_type: The resource_type of this ErrorEntry.  # noqa: E501
        :type: str
        """

        self._resource_type = resource_type

    @property
    def resource_id(self):
        """Gets the resource_id of this ErrorEntry.  # noqa: E501

        Identifier of the resource associated with the error  # noqa: E501

        :return: The resource_id of this ErrorEntry.  # noqa: E501
        :rtype: str
        """
        return self._resource_id

    @resource_id.setter
    def resource_id(self, resource_id):
        """Sets the resource_id of this ErrorEntry.

        Identifier of the resource associated with the error  # noqa: E501

        :param resource_id: The resource_id of this ErrorEntry.  # noqa: E501
        :type: str
        """

        self._resource_id = resource_id

    @property
    def inner_errors(self):
        """Gets the inner_errors of this ErrorEntry.  # noqa: E501


        :return: The inner_errors of this ErrorEntry.  # noqa: E501
        :rtype: list[ErrorEntry]
        """
        return self._inner_errors

    @inner_errors.setter
    def inner_errors(self, inner_errors):
        """Sets the inner_errors of this ErrorEntry.


        :param inner_errors: The inner_errors of this ErrorEntry.  # noqa: E501
        :type: list[ErrorEntry]
        """

        self._inner_errors = inner_errors

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ErrorEntry):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ErrorEntry):
            return True

        return self.to_dict() != other.to_dict()
