# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class HistoricalTagDecimatedQuery(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'paths': 'list[str]',
        'workspace': 'str',
        'start_time': 'datetime',
        'end_time': 'datetime',
        'decimation': 'int',
        'sort_order': 'str'
    }

    attribute_map = {
        'paths': 'paths',
        'workspace': 'workspace',
        'start_time': 'startTime',
        'end_time': 'endTime',
        'decimation': 'decimation',
        'sort_order': 'sortOrder'
    }

    def __init__(self, paths=None, workspace=None, start_time=None, end_time=None, decimation=None, sort_order='ASCENDING', local_vars_configuration=None):  # noqa: E501
        """HistoricalTagDecimatedQuery - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._paths = None
        self._workspace = None
        self._start_time = None
        self._end_time = None
        self._decimation = None
        self._sort_order = None
        self.discriminator = None

        if paths is not None:
            self.paths = paths
        if workspace is not None:
            self.workspace = workspace
        if start_time is not None:
            self.start_time = start_time
        if end_time is not None:
            self.end_time = end_time
        if decimation is not None:
            self.decimation = decimation
        if sort_order is not None:
            self.sort_order = sort_order

    @property
    def paths(self):
        """Gets the paths of this HistoricalTagDecimatedQuery.  # noqa: E501

        One or more paths identifying the tags whose decimated historical values should be returned.  # noqa: E501

        :return: The paths of this HistoricalTagDecimatedQuery.  # noqa: E501
        :rtype: list[str]
        """
        return self._paths

    @paths.setter
    def paths(self, paths):
        """Sets the paths of this HistoricalTagDecimatedQuery.

        One or more paths identifying the tags whose decimated historical values should be returned.  # noqa: E501

        :param paths: The paths of this HistoricalTagDecimatedQuery.  # noqa: E501
        :type: list[str]
        """

        self._paths = paths

    @property
    def workspace(self):
        """Gets the workspace of this HistoricalTagDecimatedQuery.  # noqa: E501

        The workspace ID for querying decimated tag values. If this is not specified, the tag values from the default workspace will be returned.  # noqa: E501

        :return: The workspace of this HistoricalTagDecimatedQuery.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this HistoricalTagDecimatedQuery.

        The workspace ID for querying decimated tag values. If this is not specified, the tag values from the default workspace will be returned.  # noqa: E501

        :param workspace: The workspace of this HistoricalTagDecimatedQuery.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def start_time(self):
        """Gets the start_time of this HistoricalTagDecimatedQuery.  # noqa: E501

        Limits the returned historical values to those written at or after the given time in ISO-8601 format.  # noqa: E501

        :return: The start_time of this HistoricalTagDecimatedQuery.  # noqa: E501
        :rtype: datetime
        """
        return self._start_time

    @start_time.setter
    def start_time(self, start_time):
        """Sets the start_time of this HistoricalTagDecimatedQuery.

        Limits the returned historical values to those written at or after the given time in ISO-8601 format.  # noqa: E501

        :param start_time: The start_time of this HistoricalTagDecimatedQuery.  # noqa: E501
        :type: datetime
        """

        self._start_time = start_time

    @property
    def end_time(self):
        """Gets the end_time of this HistoricalTagDecimatedQuery.  # noqa: E501

        Limits the returned historical values to those written at or before the given time in ISO-8601 format.  # noqa: E501

        :return: The end_time of this HistoricalTagDecimatedQuery.  # noqa: E501
        :rtype: datetime
        """
        return self._end_time

    @end_time.setter
    def end_time(self, end_time):
        """Sets the end_time of this HistoricalTagDecimatedQuery.

        Limits the returned historical values to those written at or before the given time in ISO-8601 format.  # noqa: E501

        :param end_time: The end_time of this HistoricalTagDecimatedQuery.  # noqa: E501
        :type: datetime
        """

        self._end_time = end_time

    @property
    def decimation(self):
        """Gets the decimation of this HistoricalTagDecimatedQuery.  # noqa: E501

        When non-zero, the returned historical values are decimated across requested time span divided into the specified number of equal-sized intervals.  # noqa: E501

        :return: The decimation of this HistoricalTagDecimatedQuery.  # noqa: E501
        :rtype: int
        """
        return self._decimation

    @decimation.setter
    def decimation(self, decimation):
        """Sets the decimation of this HistoricalTagDecimatedQuery.

        When non-zero, the returned historical values are decimated across requested time span divided into the specified number of equal-sized intervals.  # noqa: E501

        :param decimation: The decimation of this HistoricalTagDecimatedQuery.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                decimation is not None and decimation < 0):  # noqa: E501
            raise ValueError("Invalid value for `decimation`, must be a value greater than or equal to `0`")  # noqa: E501

        self._decimation = decimation

    @property
    def sort_order(self):
        """Gets the sort_order of this HistoricalTagDecimatedQuery.  # noqa: E501

        Specifies ascending or descending order to return historical values, based on when each tag was written.  # noqa: E501

        :return: The sort_order of this HistoricalTagDecimatedQuery.  # noqa: E501
        :rtype: str
        """
        return self._sort_order

    @sort_order.setter
    def sort_order(self, sort_order):
        """Sets the sort_order of this HistoricalTagDecimatedQuery.

        Specifies ascending or descending order to return historical values, based on when each tag was written.  # noqa: E501

        :param sort_order: The sort_order of this HistoricalTagDecimatedQuery.  # noqa: E501
        :type: str
        """
        allowed_values = ["ASCENDING", "DESCENDING"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and sort_order not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `sort_order` ({0}), must be one of {1}"  # noqa: E501
                .format(sort_order, allowed_values)
            )

        self._sort_order = sort_order

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HistoricalTagDecimatedQuery):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HistoricalTagDecimatedQuery):
            return True

        return self.to_dict() != other.to_dict()
