# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class HttpQueryResponseBody(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'values': 'list[HttpHistoricalValue]',
        'continuation_token': 'str',
        'workspace': 'str',
        'error': 'ErrorEntry',
        'failed': 'list[str]'
    }

    attribute_map = {
        'values': 'values',
        'continuation_token': 'continuationToken',
        'workspace': 'workspace',
        'error': 'error',
        'failed': 'failed'
    }

    def __init__(self, values=None, continuation_token='', workspace=None, error=None, failed=None, local_vars_configuration=None):  # noqa: E501
        """HttpQueryResponseBody - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._values = None
        self._continuation_token = None
        self._workspace = None
        self._error = None
        self._failed = None
        self.discriminator = None

        if values is not None:
            self.values = values
        if continuation_token is not None:
            self.continuation_token = continuation_token
        if workspace is not None:
            self.workspace = workspace
        if error is not None:
            self.error = error
        if failed is not None:
            self.failed = failed

    @property
    def values(self):
        """Gets the values of this HttpQueryResponseBody.  # noqa: E501

        An array of HttpHistoricalValue elements  # noqa: E501

        :return: The values of this HttpQueryResponseBody.  # noqa: E501
        :rtype: list[HttpHistoricalValue]
        """
        return self._values

    @values.setter
    def values(self, values):
        """Sets the values of this HttpQueryResponseBody.

        An array of HttpHistoricalValue elements  # noqa: E501

        :param values: The values of this HttpQueryResponseBody.  # noqa: E501
        :type: list[HttpHistoricalValue]
        """

        self._values = values

    @property
    def continuation_token(self):
        """Gets the continuation_token of this HttpQueryResponseBody.  # noqa: E501

        For non-decimated queries, a value generated by the server which should be sent in the next request to retrieve the next page of values.  # noqa: E501

        :return: The continuation_token of this HttpQueryResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this HttpQueryResponseBody.

        For non-decimated queries, a value generated by the server which should be sent in the next request to retrieve the next page of values.  # noqa: E501

        :param continuation_token: The continuation_token of this HttpQueryResponseBody.  # noqa: E501
        :type: str
        """

        self._continuation_token = continuation_token

    @property
    def workspace(self):
        """Gets the workspace of this HttpQueryResponseBody.  # noqa: E501

        The workspace ID of the tag values  # noqa: E501

        :return: The workspace of this HttpQueryResponseBody.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this HttpQueryResponseBody.

        The workspace ID of the tag values  # noqa: E501

        :param workspace: The workspace of this HttpQueryResponseBody.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def error(self):
        """Gets the error of this HttpQueryResponseBody.  # noqa: E501


        :return: The error of this HttpQueryResponseBody.  # noqa: E501
        :rtype: ErrorEntry
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this HttpQueryResponseBody.


        :param error: The error of this HttpQueryResponseBody.  # noqa: E501
        :type: ErrorEntry
        """

        self._error = error

    @property
    def failed(self):
        """Gets the failed of this HttpQueryResponseBody.  # noqa: E501

        The paths of the tags that had errors.  # noqa: E501

        :return: The failed of this HttpQueryResponseBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._failed

    @failed.setter
    def failed(self, failed):
        """Sets the failed of this HttpQueryResponseBody.

        The paths of the tags that had errors.  # noqa: E501

        :param failed: The failed of this HttpQueryResponseBody.  # noqa: E501
        :type: list[str]
        """

        self._failed = failed

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, HttpQueryResponseBody):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, HttpQueryResponseBody):
            return True

        return self.to_dict() != other.to_dict()
