# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class InsertValue(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'path': 'str',
        'timestamp': 'datetime',
        'value': 'str',
        'workspace': 'str'
    }

    attribute_map = {
        'path': 'path',
        'timestamp': 'timestamp',
        'value': 'value',
        'workspace': 'workspace'
    }

    def __init__(self, path=None, timestamp=None, value=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """InsertValue - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._path = None
        self._timestamp = None
        self._value = None
        self._workspace = None
        self.discriminator = None

        self.path = path
        self.timestamp = timestamp
        self.value = value
        if workspace is not None:
            self.workspace = workspace

    @property
    def path(self):
        """Gets the path of this InsertValue.  # noqa: E501

        The path of the tag for which to insert the value.  # noqa: E501

        :return: The path of this InsertValue.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this InsertValue.

        The path of the tag for which to insert the value.  # noqa: E501

        :param path: The path of this InsertValue.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and path is None:  # noqa: E501
            raise ValueError("Invalid value for `path`, must not be `None`")  # noqa: E501

        self._path = path

    @property
    def timestamp(self):
        """Gets the timestamp of this InsertValue.  # noqa: E501

        The timestamp for the new value in ISO-8601 format.  # noqa: E501

        :return: The timestamp of this InsertValue.  # noqa: E501
        :rtype: datetime
        """
        return self._timestamp

    @timestamp.setter
    def timestamp(self, timestamp):
        """Sets the timestamp of this InsertValue.

        The timestamp for the new value in ISO-8601 format.  # noqa: E501

        :param timestamp: The timestamp of this InsertValue.  # noqa: E501
        :type: datetime
        """
        if self.local_vars_configuration.client_side_validation and timestamp is None:  # noqa: E501
            raise ValueError("Invalid value for `timestamp`, must not be `None`")  # noqa: E501

        self._timestamp = timestamp

    @property
    def value(self):
        """Gets the value of this InsertValue.  # noqa: E501

        The value to insert.  # noqa: E501

        :return: The value of this InsertValue.  # noqa: E501
        :rtype: str
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this InsertValue.

        The value to insert.  # noqa: E501

        :param value: The value of this InsertValue.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and value is None:  # noqa: E501
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def workspace(self):
        """Gets the workspace of this InsertValue.  # noqa: E501

        The workspace ID for the tag. If this is not specified, the default workspace will be used.  # noqa: E501

        :return: The workspace of this InsertValue.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this InsertValue.

        The workspace ID for the tag. If this is not specified, the default workspace will be used.  # noqa: E501

        :param workspace: The workspace of this InsertValue.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, InsertValue):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, InsertValue):
            return True

        return self.to_dict() != other.to_dict()
