# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class StorageResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'used': 'int',
        'limit': 'int',
        'resource': 'str',
        'last_updated': 'datetime'
    }

    attribute_map = {
        'used': 'used',
        'limit': 'limit',
        'resource': 'resource',
        'last_updated': 'lastUpdated'
    }

    def __init__(self, used=None, limit=None, resource=None, last_updated=None, local_vars_configuration=None):  # noqa: E501
        """StorageResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._used = None
        self._limit = None
        self._resource = None
        self._last_updated = None
        self.discriminator = None

        if used is not None:
            self.used = used
        if limit is not None:
            self.limit = limit
        if resource is not None:
            self.resource = resource
        if last_updated is not None:
            self.last_updated = last_updated

    @property
    def used(self):
        """Gets the used of this StorageResponse.  # noqa: E501

        The amount of storage used in bytes.  # noqa: E501

        :return: The used of this StorageResponse.  # noqa: E501
        :rtype: int
        """
        return self._used

    @used.setter
    def used(self, used):
        """Sets the used of this StorageResponse.

        The amount of storage used in bytes.  # noqa: E501

        :param used: The used of this StorageResponse.  # noqa: E501
        :type: int
        """

        self._used = used

    @property
    def limit(self):
        """Gets the limit of this StorageResponse.  # noqa: E501

        The total amount of storage in bytes.  # noqa: E501

        :return: The limit of this StorageResponse.  # noqa: E501
        :rtype: int
        """
        return self._limit

    @limit.setter
    def limit(self, limit):
        """Sets the limit of this StorageResponse.

        The total amount of storage in bytes.  # noqa: E501

        :param limit: The limit of this StorageResponse.  # noqa: E501
        :type: int
        """

        self._limit = limit

    @property
    def resource(self):
        """Gets the resource of this StorageResponse.  # noqa: E501

        The type of resource stored, e.g., \"tags\" or \"files\".  # noqa: E501

        :return: The resource of this StorageResponse.  # noqa: E501
        :rtype: str
        """
        return self._resource

    @resource.setter
    def resource(self, resource):
        """Sets the resource of this StorageResponse.

        The type of resource stored, e.g., \"tags\" or \"files\".  # noqa: E501

        :param resource: The resource of this StorageResponse.  # noqa: E501
        :type: str
        """

        self._resource = resource

    @property
    def last_updated(self):
        """Gets the last_updated of this StorageResponse.  # noqa: E501

        The timestamp when the storage was last updated in ISO-8601 format.  # noqa: E501

        :return: The last_updated of this StorageResponse.  # noqa: E501
        :rtype: datetime
        """
        return self._last_updated

    @last_updated.setter
    def last_updated(self, last_updated):
        """Sets the last_updated of this StorageResponse.

        The timestamp when the storage was last updated in ISO-8601 format.  # noqa: E501

        :param last_updated: The last_updated of this StorageResponse.  # noqa: E501
        :type: datetime
        """

        self._last_updated = last_updated

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StorageResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StorageResponse):
            return True

        return self.to_dict() != other.to_dict()
