# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class TagHistorianExportHistoryRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'paths': 'list[str]',
        'workspace': 'str',
        'response_format': 'str'
    }

    attribute_map = {
        'paths': 'paths',
        'workspace': 'workspace',
        'response_format': 'responseFormat'
    }

    def __init__(self, paths=None, workspace=None, response_format='CSV', local_vars_configuration=None):  # noqa: E501
        """TagHistorianExportHistoryRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._paths = None
        self._workspace = None
        self._response_format = None
        self.discriminator = None

        if paths is not None:
            self.paths = paths
        if workspace is not None:
            self.workspace = workspace
        if response_format is not None:
            self.response_format = response_format

    @property
    def paths(self):
        """Gets the paths of this TagHistorianExportHistoryRequest.  # noqa: E501

        The paths whose data should be exported  # noqa: E501

        :return: The paths of this TagHistorianExportHistoryRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._paths

    @paths.setter
    def paths(self, paths):
        """Sets the paths of this TagHistorianExportHistoryRequest.

        The paths whose data should be exported  # noqa: E501

        :param paths: The paths of this TagHistorianExportHistoryRequest.  # noqa: E501
        :type: list[str]
        """

        self._paths = paths

    @property
    def workspace(self):
        """Gets the workspace of this TagHistorianExportHistoryRequest.  # noqa: E501

        The workspace ID for exporting tag values. If this is not specified, the tag values from the default workspace will be returned.  # noqa: E501

        :return: The workspace of this TagHistorianExportHistoryRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this TagHistorianExportHistoryRequest.

        The workspace ID for exporting tag values. If this is not specified, the tag values from the default workspace will be returned.  # noqa: E501

        :param workspace: The workspace of this TagHistorianExportHistoryRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def response_format(self):
        """Gets the response_format of this TagHistorianExportHistoryRequest.  # noqa: E501

        The format of the response. Currently only supports \"CSV\"  # noqa: E501

        :return: The response_format of this TagHistorianExportHistoryRequest.  # noqa: E501
        :rtype: str
        """
        return self._response_format

    @response_format.setter
    def response_format(self, response_format):
        """Sets the response_format of this TagHistorianExportHistoryRequest.

        The format of the response. Currently only supports \"CSV\"  # noqa: E501

        :param response_format: The response_format of this TagHistorianExportHistoryRequest.  # noqa: E501
        :type: str
        """
        allowed_values = ["CSV"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and response_format not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `response_format` ({0}), must be one of {1}"  # noqa: E501
                .format(response_format, allowed_values)
            )

        self._response_format = response_format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, TagHistorianExportHistoryRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, TagHistorianExportHistoryRequest):
            return True

        return self.to_dict() != other.to_dict()
