# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class WebSocketAsyncQueryData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'action': 'str',
        'request_id': 'str',
        'results': 'dict(str, TypeAndValues)',
        'workspace': 'str',
        'error': 'object',
        'failed': 'object'
    }

    attribute_map = {
        'action': 'action',
        'request_id': 'requestId',
        'results': 'results',
        'workspace': 'workspace',
        'error': 'error',
        'failed': 'failed'
    }

    def __init__(self, action=None, request_id=None, results=None, workspace=None, error=None, failed=None, local_vars_configuration=None):  # noqa: E501
        """WebSocketAsyncQueryData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._action = None
        self._request_id = None
        self._results = None
        self._workspace = None
        self._error = None
        self._failed = None
        self.discriminator = None

        if action is not None:
            self.action = action
        if request_id is not None:
            self.request_id = request_id
        if results is not None:
            self.results = results
        if workspace is not None:
            self.workspace = workspace
        if error is not None:
            self.error = error
        if failed is not None:
            self.failed = failed

    @property
    def action(self):
        """Gets the action of this WebSocketAsyncQueryData.  # noqa: E501

        The action performed. Must be set to \"TagHistorianAsyncQueryDataRoutedMessage\".  # noqa: E501

        :return: The action of this WebSocketAsyncQueryData.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this WebSocketAsyncQueryData.

        The action performed. Must be set to \"TagHistorianAsyncQueryDataRoutedMessage\".  # noqa: E501

        :param action: The action of this WebSocketAsyncQueryData.  # noqa: E501
        :type: str
        """
        allowed_values = ["TagHistorianAsyncQueryDataRoutedMessage"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and action not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def request_id(self):
        """Gets the request_id of this WebSocketAsyncQueryData.  # noqa: E501

        The identifier of the completed asynchronous query as given in the corresponding *WebSocketAsyncQueryResponse* message.  # noqa: E501

        :return: The request_id of this WebSocketAsyncQueryData.  # noqa: E501
        :rtype: str
        """
        return self._request_id

    @request_id.setter
    def request_id(self, request_id):
        """Sets the request_id of this WebSocketAsyncQueryData.

        The identifier of the completed asynchronous query as given in the corresponding *WebSocketAsyncQueryResponse* message.  # noqa: E501

        :param request_id: The request_id of this WebSocketAsyncQueryData.  # noqa: E501
        :type: str
        """

        self._request_id = request_id

    @property
    def results(self):
        """Gets the results of this WebSocketAsyncQueryData.  # noqa: E501

        An object containing the historical values for each requested tag that was successfully queried. The object's property names correspond to a tag path.  # noqa: E501

        :return: The results of this WebSocketAsyncQueryData.  # noqa: E501
        :rtype: dict(str, TypeAndValues)
        """
        return self._results

    @results.setter
    def results(self, results):
        """Sets the results of this WebSocketAsyncQueryData.

        An object containing the historical values for each requested tag that was successfully queried. The object's property names correspond to a tag path.  # noqa: E501

        :param results: The results of this WebSocketAsyncQueryData.  # noqa: E501
        :type: dict(str, TypeAndValues)
        """

        self._results = results

    @property
    def workspace(self):
        """Gets the workspace of this WebSocketAsyncQueryData.  # noqa: E501

        The workspace ID of the tag values  # noqa: E501

        :return: The workspace of this WebSocketAsyncQueryData.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this WebSocketAsyncQueryData.

        The workspace ID of the tag values  # noqa: E501

        :param workspace: The workspace of this WebSocketAsyncQueryData.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def error(self):
        """Gets the error of this WebSocketAsyncQueryData.  # noqa: E501

        This value is always null.  # noqa: E501

        :return: The error of this WebSocketAsyncQueryData.  # noqa: E501
        :rtype: object
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this WebSocketAsyncQueryData.

        This value is always null.  # noqa: E501

        :param error: The error of this WebSocketAsyncQueryData.  # noqa: E501
        :type: object
        """

        self._error = error

    @property
    def failed(self):
        """Gets the failed of this WebSocketAsyncQueryData.  # noqa: E501

        This value is always null.  # noqa: E501

        :return: The failed of this WebSocketAsyncQueryData.  # noqa: E501
        :rtype: object
        """
        return self._failed

    @failed.setter
    def failed(self, failed):
        """Sets the failed of this WebSocketAsyncQueryData.

        This value is always null.  # noqa: E501

        :param failed: The failed of this WebSocketAsyncQueryData.  # noqa: E501
        :type: object
        """

        self._failed = failed

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WebSocketAsyncQueryData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WebSocketAsyncQueryData):
            return True

        return self.to_dict() != other.to_dict()
