# coding: utf-8

"""
    Tag Historian Web Service

    SystemLink Tag Historian Service HTTP API.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitaghistorian.configuration import Configuration


class WebSocketSubscribeRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'action': 'str',
        'search_paths': 'list[str]',
        'workspace': 'str'
    }

    attribute_map = {
        'action': 'action',
        'search_paths': 'searchPaths',
        'workspace': 'workspace'
    }

    def __init__(self, action=None, search_paths=None, workspace=None, local_vars_configuration=None):  # noqa: E501
        """WebSocketSubscribeRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._action = None
        self._search_paths = None
        self._workspace = None
        self.discriminator = None

        self.action = action
        self.search_paths = search_paths
        if workspace is not None:
            self.workspace = workspace

    @property
    def action(self):
        """Gets the action of this WebSocketSubscribeRequest.  # noqa: E501

        The action to perform. Must be set to \"TagHistorianAsyncSubscribeRequest\".  # noqa: E501

        :return: The action of this WebSocketSubscribeRequest.  # noqa: E501
        :rtype: str
        """
        return self._action

    @action.setter
    def action(self, action):
        """Sets the action of this WebSocketSubscribeRequest.

        The action to perform. Must be set to \"TagHistorianAsyncSubscribeRequest\".  # noqa: E501

        :param action: The action of this WebSocketSubscribeRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and action is None:  # noqa: E501
            raise ValueError("Invalid value for `action`, must not be `None`")  # noqa: E501
        allowed_values = ["TagHistorianAsyncSubscribeRequest"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and action not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `action` ({0}), must be one of {1}"  # noqa: E501
                .format(action, allowed_values)
            )

        self._action = action

    @property
    def search_paths(self):
        """Gets the search_paths of this WebSocketSubscribeRequest.  # noqa: E501

        Contains one or more tag paths to subscribe to. The paths may contain wildcards to subscribe to similar tags.  # noqa: E501

        :return: The search_paths of this WebSocketSubscribeRequest.  # noqa: E501
        :rtype: list[str]
        """
        return self._search_paths

    @search_paths.setter
    def search_paths(self, search_paths):
        """Sets the search_paths of this WebSocketSubscribeRequest.

        Contains one or more tag paths to subscribe to. The paths may contain wildcards to subscribe to similar tags.  # noqa: E501

        :param search_paths: The search_paths of this WebSocketSubscribeRequest.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and search_paths is None:  # noqa: E501
            raise ValueError("Invalid value for `search_paths`, must not be `None`")  # noqa: E501

        self._search_paths = search_paths

    @property
    def workspace(self):
        """Gets the workspace of this WebSocketSubscribeRequest.  # noqa: E501

        The workspace ID to subscribe to for tag updates. If this is not specified, the tag values from the default workspace will be returned.  # noqa: E501

        :return: The workspace of this WebSocketSubscribeRequest.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this WebSocketSubscribeRequest.

        The workspace ID to subscribe to for tag updates. If this is not specified, the tag values from the default workspace will be returned.  # noqa: E501

        :param workspace: The workspace of this WebSocketSubscribeRequest.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, WebSocketSubscribeRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, WebSocketSubscribeRequest):
            return True

        return self.to_dict() != other.to_dict()
