# coding: utf-8

"""
    Tag Rule Engine Web Service

    SystemLink Tag Rule Engine Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitagrule.configuration import Configuration


class Condition(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'set_points': 'list[str]',
        'comparator': 'str',
        'deadband': 'str',
        'severity_level': 'int',
        'notification_strategy_ids': 'list[str]'
    }

    attribute_map = {
        'set_points': 'setPoints',
        'comparator': 'comparator',
        'deadband': 'deadband',
        'severity_level': 'severityLevel',
        'notification_strategy_ids': 'notificationStrategyIds'
    }

    def __init__(self, set_points=None, comparator=None, deadband=None, severity_level=None, notification_strategy_ids=None, local_vars_configuration=None):  # noqa: E501
        """Condition - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._set_points = None
        self._comparator = None
        self._deadband = None
        self._severity_level = None
        self._notification_strategy_ids = None
        self.discriminator = None

        self.set_points = set_points
        self.comparator = comparator
        if deadband is not None:
            self.deadband = deadband
        if severity_level is not None:
            self.severity_level = severity_level
        if notification_strategy_ids is not None:
            self.notification_strategy_ids = notification_strategy_ids

    @property
    def set_points(self):
        """Gets the set_points of this Condition.  # noqa: E501

        Values compared against the tag's current value to determine whether or not the condition is true. Conditions associated with the IN_RANGE and OUT_OF_RANGE comparators will have two set points. All other conditions should have only one set point. For tags of the DATE_TIME type, a timespan (for example, \"01:00:00\") is a valid value and represents a time interval relative to the server's current time when the rule is evaluated. Positive timespans represent times in the future, and negative timespans represent times in the past. The expected timespan format is `[-]d.hh:mm:ss.ff`.  # noqa: E501

        :return: The set_points of this Condition.  # noqa: E501
        :rtype: list[str]
        """
        return self._set_points

    @set_points.setter
    def set_points(self, set_points):
        """Sets the set_points of this Condition.

        Values compared against the tag's current value to determine whether or not the condition is true. Conditions associated with the IN_RANGE and OUT_OF_RANGE comparators will have two set points. All other conditions should have only one set point. For tags of the DATE_TIME type, a timespan (for example, \"01:00:00\") is a valid value and represents a time interval relative to the server's current time when the rule is evaluated. Positive timespans represent times in the future, and negative timespans represent times in the past. The expected timespan format is `[-]d.hh:mm:ss.ff`.  # noqa: E501

        :param set_points: The set_points of this Condition.  # noqa: E501
        :type: list[str]
        """
        if self.local_vars_configuration.client_side_validation and set_points is None:  # noqa: E501
            raise ValueError("Invalid value for `set_points`, must not be `None`")  # noqa: E501

        self._set_points = set_points

    @property
    def comparator(self):
        """Gets the comparator of this Condition.  # noqa: E501

        Operator which will be used when comparing the tag's current value to the set point(s). Note that the CONTAINS and NOT_CONTAINS comparators are only valid for rules associated with string tags. Similarly, LESS_THAN, GREATER_THAN, IN_RANGE, and the other numeric comparators are not valid for rules associated with string tags.  # noqa: E501

        :return: The comparator of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._comparator

    @comparator.setter
    def comparator(self, comparator):
        """Sets the comparator of this Condition.

        Operator which will be used when comparing the tag's current value to the set point(s). Note that the CONTAINS and NOT_CONTAINS comparators are only valid for rules associated with string tags. Similarly, LESS_THAN, GREATER_THAN, IN_RANGE, and the other numeric comparators are not valid for rules associated with string tags.  # noqa: E501

        :param comparator: The comparator of this Condition.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and comparator is None:  # noqa: E501
            raise ValueError("Invalid value for `comparator`, must not be `None`")  # noqa: E501
        allowed_values = ["LESS_THAN", "LESS_THAN_OR_EQUAL", "GREATER_THAN", "GREATER_THAN_OR_EQUAL", "IN_RANGE", "OUT_OF_RANGE", "EQUAL", "NOT_EQUAL", "CONTAINS", "NOT_CONTAINS"]  # noqa: E501
        if self.local_vars_configuration.client_side_validation and comparator not in allowed_values:  # noqa: E501
            raise ValueError(
                "Invalid value for `comparator` ({0}), must be one of {1}"  # noqa: E501
                .format(comparator, allowed_values)
            )

        self._comparator = comparator

    @property
    def deadband(self):
        """Gets the deadband of this Condition.  # noqa: E501

        The change in signal from the set point necessary to clear an alarm. For example, a condition with a set point of 10, a comparator of GREATER_THAN, and a deadband of 2 will request that alarms be cleared if the tag's values is less than or equal to (10 - 2) = 8. Similarly, if the condition had a comparator of LESS_THAN, the condition would request that alarms be cleared if the tag's value is greater than or equal to (10 + 2) = 12.  # noqa: E501

        :return: The deadband of this Condition.  # noqa: E501
        :rtype: str
        """
        return self._deadband

    @deadband.setter
    def deadband(self, deadband):
        """Sets the deadband of this Condition.

        The change in signal from the set point necessary to clear an alarm. For example, a condition with a set point of 10, a comparator of GREATER_THAN, and a deadband of 2 will request that alarms be cleared if the tag's values is less than or equal to (10 - 2) = 8. Similarly, if the condition had a comparator of LESS_THAN, the condition would request that alarms be cleared if the tag's value is greater than or equal to (10 + 2) = 12.  # noqa: E501

        :param deadband: The deadband of this Condition.  # noqa: E501
        :type: str
        """

        self._deadband = deadband

    @property
    def severity_level(self):
        """Gets the severity_level of this Condition.  # noqa: E501

        An integer in the range [1,4] which specifies the severity level of a condition. Higher numeric values correspond to higher severity levels.  # noqa: E501

        :return: The severity_level of this Condition.  # noqa: E501
        :rtype: int
        """
        return self._severity_level

    @severity_level.setter
    def severity_level(self, severity_level):
        """Sets the severity_level of this Condition.

        An integer in the range [1,4] which specifies the severity level of a condition. Higher numeric values correspond to higher severity levels.  # noqa: E501

        :param severity_level: The severity_level of this Condition.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                severity_level is not None and severity_level > 4):  # noqa: E501
            raise ValueError("Invalid value for `severity_level`, must be a value less than or equal to `4`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                severity_level is not None and severity_level < 1):  # noqa: E501
            raise ValueError("Invalid value for `severity_level`, must be a value greater than or equal to `1`")  # noqa: E501

        self._severity_level = severity_level

    @property
    def notification_strategy_ids(self):
        """Gets the notification_strategy_ids of this Condition.  # noqa: E501

        The IDs of the notification strategies which should be triggered if a condition results in alarms being created or increasing in severity.  # noqa: E501

        :return: The notification_strategy_ids of this Condition.  # noqa: E501
        :rtype: list[str]
        """
        return self._notification_strategy_ids

    @notification_strategy_ids.setter
    def notification_strategy_ids(self, notification_strategy_ids):
        """Sets the notification_strategy_ids of this Condition.

        The IDs of the notification strategies which should be triggered if a condition results in alarms being created or increasing in severity.  # noqa: E501

        :param notification_strategy_ids: The notification_strategy_ids of this Condition.  # noqa: E501
        :type: list[str]
        """

        self._notification_strategy_ids = notification_strategy_ids

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Condition):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Condition):
            return True

        return self.to_dict() != other.to_dict()
