# coding: utf-8

"""
    Tag Rule Engine Web Service

    SystemLink Tag Rule Engine Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitagrule.configuration import Configuration


class DuplicateResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'duplicated_ids': 'dict(str, str)',
        'failed': 'list[str]',
        'error': 'Error'
    }

    attribute_map = {
        'duplicated_ids': 'duplicatedIds',
        'failed': 'failed',
        'error': 'error'
    }

    def __init__(self, duplicated_ids=None, failed=None, error=None, local_vars_configuration=None):  # noqa: E501
        """DuplicateResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._duplicated_ids = None
        self._failed = None
        self._error = None
        self.discriminator = None

        if duplicated_ids is not None:
            self.duplicated_ids = duplicated_ids
        if failed is not None:
            self.failed = failed
        if error is not None:
            self.error = error

    @property
    def duplicated_ids(self):
        """Gets the duplicated_ids of this DuplicateResponse.  # noqa: E501

        A dictionary where the keys are the IDs of the rules which were successfully duplicated, and the values are the IDs of the new duplicate rules.  # noqa: E501

        :return: The duplicated_ids of this DuplicateResponse.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._duplicated_ids

    @duplicated_ids.setter
    def duplicated_ids(self, duplicated_ids):
        """Sets the duplicated_ids of this DuplicateResponse.

        A dictionary where the keys are the IDs of the rules which were successfully duplicated, and the values are the IDs of the new duplicate rules.  # noqa: E501

        :param duplicated_ids: The duplicated_ids of this DuplicateResponse.  # noqa: E501
        :type: dict(str, str)
        """

        self._duplicated_ids = duplicated_ids

    @property
    def failed(self):
        """Gets the failed of this DuplicateResponse.  # noqa: E501

        The IDs of the rules which were failed to be duplicated. See *error* for why each rule failed to duplicate. Reasons include the rule could not be found or the caller is not authorized to create the rule.  # noqa: E501

        :return: The failed of this DuplicateResponse.  # noqa: E501
        :rtype: list[str]
        """
        return self._failed

    @failed.setter
    def failed(self, failed):
        """Sets the failed of this DuplicateResponse.

        The IDs of the rules which were failed to be duplicated. See *error* for why each rule failed to duplicate. Reasons include the rule could not be found or the caller is not authorized to create the rule.  # noqa: E501

        :param failed: The failed of this DuplicateResponse.  # noqa: E501
        :type: list[str]
        """

        self._failed = failed

    @property
    def error(self):
        """Gets the error of this DuplicateResponse.  # noqa: E501


        :return: The error of this DuplicateResponse.  # noqa: E501
        :rtype: Error
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this DuplicateResponse.


        :param error: The error of this DuplicateResponse.  # noqa: E501
        :type: Error
        """

        self._error = error

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DuplicateResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, DuplicateResponse):
            return True

        return self.to_dict() != other.to_dict()
