# coding: utf-8

"""
    Tag Rule Engine Web Service

    SystemLink Tag Rule Engine Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitagrule.configuration import Configuration


class QueryRequestBody(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'display_name': 'str',
        'description': 'str',
        'tag_path': 'str',
        'properties': 'dict(str, str)',
        'keywords': 'list[str]',
        'workspaces': 'list[str]',
        'skip': 'int',
        'take': 'int'
    }

    attribute_map = {
        'display_name': 'displayName',
        'description': 'description',
        'tag_path': 'tagPath',
        'properties': 'properties',
        'keywords': 'keywords',
        'workspaces': 'workspaces',
        'skip': 'skip',
        'take': 'take'
    }

    def __init__(self, display_name=None, description=None, tag_path=None, properties=None, keywords=None, workspaces=None, skip=None, take=None, local_vars_configuration=None):  # noqa: E501
        """QueryRequestBody - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._display_name = None
        self._description = None
        self._tag_path = None
        self._properties = None
        self._keywords = None
        self._workspaces = None
        self._skip = None
        self._take = None
        self.discriminator = None

        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if tag_path is not None:
            self.tag_path = tag_path
        if properties is not None:
            self.properties = properties
        if keywords is not None:
            self.keywords = keywords
        if workspaces is not None:
            self.workspaces = workspaces
        if skip is not None:
            self.skip = skip
        if take is not None:
            self.take = take

    @property
    def display_name(self):
        """Gets the display_name of this QueryRequestBody.  # noqa: E501

        Display name query. Returns rules whose *displayName* fields contain the query string, without taking case into account.  # noqa: E501

        :return: The display_name of this QueryRequestBody.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this QueryRequestBody.

        Display name query. Returns rules whose *displayName* fields contain the query string, without taking case into account.  # noqa: E501

        :param display_name: The display_name of this QueryRequestBody.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this QueryRequestBody.  # noqa: E501

        Description query. Returns rules whose *description* fields contain the query string, without taking case into account.  # noqa: E501

        :return: The description of this QueryRequestBody.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this QueryRequestBody.

        Description query. Returns rules whose *description* fields contain the query string, without taking case into account.  # noqa: E501

        :param description: The description of this QueryRequestBody.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def tag_path(self):
        """Gets the tag_path of this QueryRequestBody.  # noqa: E501

        Tag path query. If the query string contains wildcard characters, the service will return rules whose *searchPaths* either intersect with, or are matched by, the query string. For example, if the query string is CRIO1.System.Health.*, then the service would return rules with search paths of CRIO1.System.Health.Foo and *.System.Health.DiskUsePercentage. The former is matched by the query string, and the latter intersects with the query string, as there exists a string which could be matched by both expressions (such as CRIO1.System.Health.DiskUsePercentage). If the query string does not contain wildcard characters, the service will return rules whose *searchPaths* match the query string.  # noqa: E501

        :return: The tag_path of this QueryRequestBody.  # noqa: E501
        :rtype: str
        """
        return self._tag_path

    @tag_path.setter
    def tag_path(self, tag_path):
        """Sets the tag_path of this QueryRequestBody.

        Tag path query. If the query string contains wildcard characters, the service will return rules whose *searchPaths* either intersect with, or are matched by, the query string. For example, if the query string is CRIO1.System.Health.*, then the service would return rules with search paths of CRIO1.System.Health.Foo and *.System.Health.DiskUsePercentage. The former is matched by the query string, and the latter intersects with the query string, as there exists a string which could be matched by both expressions (such as CRIO1.System.Health.DiskUsePercentage). If the query string does not contain wildcard characters, the service will return rules whose *searchPaths* match the query string.  # noqa: E501

        :param tag_path: The tag_path of this QueryRequestBody.  # noqa: E501
        :type: str
        """

        self._tag_path = tag_path

    @property
    def properties(self):
        """Gets the properties of this QueryRequestBody.  # noqa: E501

        Property query. The service will return rules whose *properties* fields contain all of the specified key/value pairs.  # noqa: E501

        :return: The properties of this QueryRequestBody.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this QueryRequestBody.

        Property query. The service will return rules whose *properties* fields contain all of the specified key/value pairs.  # noqa: E501

        :param properties: The properties of this QueryRequestBody.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    @property
    def keywords(self):
        """Gets the keywords of this QueryRequestBody.  # noqa: E501

        Keyword query. The service will return rules whose *keywords* fields contain all of the specified keywords.  # noqa: E501

        :return: The keywords of this QueryRequestBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this QueryRequestBody.

        Keyword query. The service will return rules whose *keywords* fields contain all of the specified keywords.  # noqa: E501

        :param keywords: The keywords of this QueryRequestBody.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def workspaces(self):
        """Gets the workspaces of this QueryRequestBody.  # noqa: E501

        Workspace query. The service will return rules whose *workspace* field is one of the specified workspaces. Added in version 2 of the readRules operation.  # noqa: E501

        :return: The workspaces of this QueryRequestBody.  # noqa: E501
        :rtype: list[str]
        """
        return self._workspaces

    @workspaces.setter
    def workspaces(self, workspaces):
        """Sets the workspaces of this QueryRequestBody.

        Workspace query. The service will return rules whose *workspace* field is one of the specified workspaces. Added in version 2 of the readRules operation.  # noqa: E501

        :param workspaces: The workspaces of this QueryRequestBody.  # noqa: E501
        :type: list[str]
        """

        self._workspaces = workspaces

    @property
    def skip(self):
        """Gets the skip of this QueryRequestBody.  # noqa: E501

        Number of entries to skip in the response list. Typically used in combination with the take parameter to implement pagination.  # noqa: E501

        :return: The skip of this QueryRequestBody.  # noqa: E501
        :rtype: int
        """
        return self._skip

    @skip.setter
    def skip(self, skip):
        """Sets the skip of this QueryRequestBody.

        Number of entries to skip in the response list. Typically used in combination with the take parameter to implement pagination.  # noqa: E501

        :param skip: The skip of this QueryRequestBody.  # noqa: E501
        :type: int
        """

        self._skip = skip

    @property
    def take(self):
        """Gets the take of this QueryRequestBody.  # noqa: E501

        Number of entries to include in the response list. Typically used in combination with the skip parameter to implement pagination.  # noqa: E501

        :return: The take of this QueryRequestBody.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this QueryRequestBody.

        Number of entries to include in the response list. Typically used in combination with the skip parameter to implement pagination.  # noqa: E501

        :param take: The take of this QueryRequestBody.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take > 10000):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value less than or equal to `10000`")  # noqa: E501

        self._take = take

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, QueryRequestBody):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, QueryRequestBody):
            return True

        return self.to_dict() != other.to_dict()
