# coding: utf-8

"""
    Tag Rule Engine Web Service

    SystemLink Tag Rule Engine Service HTTP API. Only available on SystemLink Server.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitagrule.configuration import Configuration


class RuleCommonFields(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'search_path': 'str',
        'workspace': 'str',
        'tag_data_type': 'TagDataType',
        'conditions': 'list[Condition]',
        'disabled': 'bool',
        'display_name': 'str',
        'description': 'str',
        'alarm_instance_display_name_template': 'str',
        'alarm_instance_description_template': 'str',
        'keywords': 'list[str]',
        'properties': 'dict(str, str)'
    }

    attribute_map = {
        'search_path': 'searchPath',
        'workspace': 'workspace',
        'tag_data_type': 'tagDataType',
        'conditions': 'conditions',
        'disabled': 'disabled',
        'display_name': 'displayName',
        'description': 'description',
        'alarm_instance_display_name_template': 'alarmInstanceDisplayNameTemplate',
        'alarm_instance_description_template': 'alarmInstanceDescriptionTemplate',
        'keywords': 'keywords',
        'properties': 'properties'
    }

    def __init__(self, search_path=None, workspace=None, tag_data_type=None, conditions=None, disabled=False, display_name=None, description=None, alarm_instance_display_name_template=None, alarm_instance_description_template=None, keywords=None, properties=None, local_vars_configuration=None):  # noqa: E501
        """RuleCommonFields - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._search_path = None
        self._workspace = None
        self._tag_data_type = None
        self._conditions = None
        self._disabled = None
        self._display_name = None
        self._description = None
        self._alarm_instance_display_name_template = None
        self._alarm_instance_description_template = None
        self._keywords = None
        self._properties = None
        self.discriminator = None

        if search_path is not None:
            self.search_path = search_path
        if workspace is not None:
            self.workspace = workspace
        if tag_data_type is not None:
            self.tag_data_type = tag_data_type
        if conditions is not None:
            self.conditions = conditions
        if disabled is not None:
            self.disabled = disabled
        if display_name is not None:
            self.display_name = display_name
        if description is not None:
            self.description = description
        if alarm_instance_display_name_template is not None:
            self.alarm_instance_display_name_template = alarm_instance_display_name_template
        if alarm_instance_description_template is not None:
            self.alarm_instance_description_template = alarm_instance_description_template
        if keywords is not None:
            self.keywords = keywords
        if properties is not None:
            self.properties = properties

    @property
    def search_path(self):
        """Gets the search_path of this RuleCommonFields.  # noqa: E501

        A string describing which tag(s) a rule applies to. This can take the form of either a single tag's path, or a string containing wildcard characters which can match multiple tags.  # noqa: E501

        :return: The search_path of this RuleCommonFields.  # noqa: E501
        :rtype: str
        """
        return self._search_path

    @search_path.setter
    def search_path(self, search_path):
        """Sets the search_path of this RuleCommonFields.

        A string describing which tag(s) a rule applies to. This can take the form of either a single tag's path, or a string containing wildcard characters which can match multiple tags.  # noqa: E501

        :param search_path: The search_path of this RuleCommonFields.  # noqa: E501
        :type: str
        """

        self._search_path = search_path

    @property
    def workspace(self):
        """Gets the workspace of this RuleCommonFields.  # noqa: E501

        The ID of the workspace to which this rule belongs. Added in version 2 of the readRules operation.  # noqa: E501

        :return: The workspace of this RuleCommonFields.  # noqa: E501
        :rtype: str
        """
        return self._workspace

    @workspace.setter
    def workspace(self, workspace):
        """Sets the workspace of this RuleCommonFields.

        The ID of the workspace to which this rule belongs. Added in version 2 of the readRules operation.  # noqa: E501

        :param workspace: The workspace of this RuleCommonFields.  # noqa: E501
        :type: str
        """

        self._workspace = workspace

    @property
    def tag_data_type(self):
        """Gets the tag_data_type of this RuleCommonFields.  # noqa: E501


        :return: The tag_data_type of this RuleCommonFields.  # noqa: E501
        :rtype: TagDataType
        """
        return self._tag_data_type

    @tag_data_type.setter
    def tag_data_type(self, tag_data_type):
        """Sets the tag_data_type of this RuleCommonFields.


        :param tag_data_type: The tag_data_type of this RuleCommonFields.  # noqa: E501
        :type: TagDataType
        """

        self._tag_data_type = tag_data_type

    @property
    def conditions(self):
        """Gets the conditions of this RuleCommonFields.  # noqa: E501

        Array containing one or more conditions which control when a rule creates or clears alarms.  # noqa: E501

        :return: The conditions of this RuleCommonFields.  # noqa: E501
        :rtype: list[Condition]
        """
        return self._conditions

    @conditions.setter
    def conditions(self, conditions):
        """Sets the conditions of this RuleCommonFields.

        Array containing one or more conditions which control when a rule creates or clears alarms.  # noqa: E501

        :param conditions: The conditions of this RuleCommonFields.  # noqa: E501
        :type: list[Condition]
        """

        self._conditions = conditions

    @property
    def disabled(self):
        """Gets the disabled of this RuleCommonFields.  # noqa: E501

        A value indicating whether or not a rule is disabled.  # noqa: E501

        :return: The disabled of this RuleCommonFields.  # noqa: E501
        :rtype: bool
        """
        return self._disabled

    @disabled.setter
    def disabled(self, disabled):
        """Sets the disabled of this RuleCommonFields.

        A value indicating whether or not a rule is disabled.  # noqa: E501

        :param disabled: The disabled of this RuleCommonFields.  # noqa: E501
        :type: bool
        """

        self._disabled = disabled

    @property
    def display_name(self):
        """Gets the display_name of this RuleCommonFields.  # noqa: E501

        Display string for a rule's name.  # noqa: E501

        :return: The display_name of this RuleCommonFields.  # noqa: E501
        :rtype: str
        """
        return self._display_name

    @display_name.setter
    def display_name(self, display_name):
        """Sets the display_name of this RuleCommonFields.

        Display string for a rule's name.  # noqa: E501

        :param display_name: The display_name of this RuleCommonFields.  # noqa: E501
        :type: str
        """

        self._display_name = display_name

    @property
    def description(self):
        """Gets the description of this RuleCommonFields.  # noqa: E501

        Display string for a rule's description.  # noqa: E501

        :return: The description of this RuleCommonFields.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this RuleCommonFields.

        Display string for a rule's description.  # noqa: E501

        :param description: The description of this RuleCommonFields.  # noqa: E501
        :type: str
        """

        self._description = description

    @property
    def alarm_instance_display_name_template(self):
        """Gets the alarm_instance_display_name_template of this RuleCommonFields.  # noqa: E501

        Template string which will be used to set the *displayName* field on alarms created by a rule. Values surrounded by angle brackets will be substituted with values from the tag's property dictionary. For example, if an *alarmInstanceDisplayNameTemplate* contained the string \"Excessive vibration on turbine <turbine_number>\", and the rule was evaluated against a tag whose property dictionary contained the key \"turbine_number\" with value \"5\", then the rule would request that an alarm with display name \"Excessive vibration on turbine 5\" be created.  # noqa: E501

        :return: The alarm_instance_display_name_template of this RuleCommonFields.  # noqa: E501
        :rtype: str
        """
        return self._alarm_instance_display_name_template

    @alarm_instance_display_name_template.setter
    def alarm_instance_display_name_template(self, alarm_instance_display_name_template):
        """Sets the alarm_instance_display_name_template of this RuleCommonFields.

        Template string which will be used to set the *displayName* field on alarms created by a rule. Values surrounded by angle brackets will be substituted with values from the tag's property dictionary. For example, if an *alarmInstanceDisplayNameTemplate* contained the string \"Excessive vibration on turbine <turbine_number>\", and the rule was evaluated against a tag whose property dictionary contained the key \"turbine_number\" with value \"5\", then the rule would request that an alarm with display name \"Excessive vibration on turbine 5\" be created.  # noqa: E501

        :param alarm_instance_display_name_template: The alarm_instance_display_name_template of this RuleCommonFields.  # noqa: E501
        :type: str
        """

        self._alarm_instance_display_name_template = alarm_instance_display_name_template

    @property
    def alarm_instance_description_template(self):
        """Gets the alarm_instance_description_template of this RuleCommonFields.  # noqa: E501

        Template string which will be used to set the *description* field on alarms created by a rule. Values surrounded by angle brackets will be substituted with values from the tag's property dictionary. See the description of AlarmInstanceDisplayNameTemplate for more information.  # noqa: E501

        :return: The alarm_instance_description_template of this RuleCommonFields.  # noqa: E501
        :rtype: str
        """
        return self._alarm_instance_description_template

    @alarm_instance_description_template.setter
    def alarm_instance_description_template(self, alarm_instance_description_template):
        """Sets the alarm_instance_description_template of this RuleCommonFields.

        Template string which will be used to set the *description* field on alarms created by a rule. Values surrounded by angle brackets will be substituted with values from the tag's property dictionary. See the description of AlarmInstanceDisplayNameTemplate for more information.  # noqa: E501

        :param alarm_instance_description_template: The alarm_instance_description_template of this RuleCommonFields.  # noqa: E501
        :type: str
        """

        self._alarm_instance_description_template = alarm_instance_description_template

    @property
    def keywords(self):
        """Gets the keywords of this RuleCommonFields.  # noqa: E501

        Words or phrases associated with a rule. Rules can be tagged with keywords to make it easier to find them with queries.  # noqa: E501

        :return: The keywords of this RuleCommonFields.  # noqa: E501
        :rtype: list[str]
        """
        return self._keywords

    @keywords.setter
    def keywords(self, keywords):
        """Sets the keywords of this RuleCommonFields.

        Words or phrases associated with a rule. Rules can be tagged with keywords to make it easier to find them with queries.  # noqa: E501

        :param keywords: The keywords of this RuleCommonFields.  # noqa: E501
        :type: list[str]
        """

        self._keywords = keywords

    @property
    def properties(self):
        """Gets the properties of this RuleCommonFields.  # noqa: E501

        Key-value-pair metadata associated with a rule. Rules can be tagged with properties to make it easier to find them with queries.  # noqa: E501

        :return: The properties of this RuleCommonFields.  # noqa: E501
        :rtype: dict(str, str)
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this RuleCommonFields.

        Key-value-pair metadata associated with a rule. Rules can be tagged with properties to make it easier to find them with queries.  # noqa: E501

        :param properties: The properties of this RuleCommonFields.  # noqa: E501
        :type: dict(str, str)
        """

        self._properties = properties

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, RuleCommonFields):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, RuleCommonFields):
            return True

        return self.to_dict() != other.to_dict()
