# coding: utf-8

"""
    TDMReader Web Service

    TDMReader HTTP API  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitdmreader.configuration import Configuration


class OneChannelData(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'data_type': 'str',
        'numeric_data': 'list[float]',
        'string_data': 'list[str]',
        'decimated': 'bool',
        'lossy_decimation': 'bool',
        'undecimated_length': 'int'
    }

    attribute_map = {
        'data_type': 'dataType',
        'numeric_data': 'numericData',
        'string_data': 'stringData',
        'decimated': 'decimated',
        'lossy_decimation': 'lossyDecimation',
        'undecimated_length': 'undecimatedLength'
    }

    def __init__(self, data_type=None, numeric_data=None, string_data=None, decimated=None, lossy_decimation=None, undecimated_length=None, local_vars_configuration=None):  # noqa: E501
        """OneChannelData - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._data_type = None
        self._numeric_data = None
        self._string_data = None
        self._decimated = None
        self._lossy_decimation = None
        self._undecimated_length = None
        self.discriminator = None

        if data_type is not None:
            self.data_type = data_type
        if numeric_data is not None:
            self.numeric_data = numeric_data
        if string_data is not None:
            self.string_data = string_data
        if decimated is not None:
            self.decimated = decimated
        if lossy_decimation is not None:
            self.lossy_decimation = lossy_decimation
        if undecimated_length is not None:
            self.undecimated_length = undecimated_length

    @property
    def data_type(self):
        """Gets the data_type of this OneChannelData.  # noqa: E501

        Native data type for the channel  # noqa: E501

        :return: The data_type of this OneChannelData.  # noqa: E501
        :rtype: str
        """
        return self._data_type

    @data_type.setter
    def data_type(self, data_type):
        """Sets the data_type of this OneChannelData.

        Native data type for the channel  # noqa: E501

        :param data_type: The data_type of this OneChannelData.  # noqa: E501
        :type: str
        """

        self._data_type = data_type

    @property
    def numeric_data(self):
        """Gets the numeric_data of this OneChannelData.  # noqa: E501

        Channel data  # noqa: E501

        :return: The numeric_data of this OneChannelData.  # noqa: E501
        :rtype: list[float]
        """
        return self._numeric_data

    @numeric_data.setter
    def numeric_data(self, numeric_data):
        """Sets the numeric_data of this OneChannelData.

        Channel data  # noqa: E501

        :param numeric_data: The numeric_data of this OneChannelData.  # noqa: E501
        :type: list[float]
        """

        self._numeric_data = numeric_data

    @property
    def string_data(self):
        """Gets the string_data of this OneChannelData.  # noqa: E501

        Channel data  # noqa: E501

        :return: The string_data of this OneChannelData.  # noqa: E501
        :rtype: list[str]
        """
        return self._string_data

    @string_data.setter
    def string_data(self, string_data):
        """Sets the string_data of this OneChannelData.

        Channel data  # noqa: E501

        :param string_data: The string_data of this OneChannelData.  # noqa: E501
        :type: list[str]
        """

        self._string_data = string_data

    @property
    def decimated(self):
        """Gets the decimated of this OneChannelData.  # noqa: E501

        Specifies whether returned data is decimated  # noqa: E501

        :return: The decimated of this OneChannelData.  # noqa: E501
        :rtype: bool
        """
        return self._decimated

    @decimated.setter
    def decimated(self, decimated):
        """Sets the decimated of this OneChannelData.

        Specifies whether returned data is decimated  # noqa: E501

        :param decimated: The decimated of this OneChannelData.  # noqa: E501
        :type: bool
        """

        self._decimated = decimated

    @property
    def lossy_decimation(self):
        """Gets the lossy_decimation of this OneChannelData.  # noqa: E501

        Specifies whether data was decimated in a lossy manner such that the returned data is not necessarily a true visual representation  # noqa: E501

        :return: The lossy_decimation of this OneChannelData.  # noqa: E501
        :rtype: bool
        """
        return self._lossy_decimation

    @lossy_decimation.setter
    def lossy_decimation(self, lossy_decimation):
        """Sets the lossy_decimation of this OneChannelData.

        Specifies whether data was decimated in a lossy manner such that the returned data is not necessarily a true visual representation  # noqa: E501

        :param lossy_decimation: The lossy_decimation of this OneChannelData.  # noqa: E501
        :type: bool
        """

        self._lossy_decimation = lossy_decimation

    @property
    def undecimated_length(self):
        """Gets the undecimated_length of this OneChannelData.  # noqa: E501

        Number of points of undecimated data  # noqa: E501

        :return: The undecimated_length of this OneChannelData.  # noqa: E501
        :rtype: int
        """
        return self._undecimated_length

    @undecimated_length.setter
    def undecimated_length(self, undecimated_length):
        """Sets the undecimated_length of this OneChannelData.

        Number of points of undecimated data  # noqa: E501

        :param undecimated_length: The undecimated_length of this OneChannelData.  # noqa: E501
        :type: int
        """

        self._undecimated_length = undecimated_length

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OneChannelData):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OneChannelData):
            return True

        return self.to_dict() != other.to_dict()
