# coding: utf-8

"""
    Test Monitor Web Service

    Test Monitor HTTP API  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitestmonitor.configuration import Configuration


class PathResponseObject(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'path': 'str',
        'program_name': 'str',
        'part_number': 'str',
        'path_names': 'list[str]',
        'inputs': 'dict(str, ValueSummaryObject)',
        'outputs': 'dict(str, ValueSummaryObject)',
        'measurements': 'dict(str, object)'
    }

    attribute_map = {
        'id': 'id',
        'path': 'path',
        'program_name': 'programName',
        'part_number': 'partNumber',
        'path_names': 'pathNames',
        'inputs': 'inputs',
        'outputs': 'outputs',
        'measurements': 'measurements'
    }

    def __init__(self, id=None, path=None, program_name=None, part_number=None, path_names=None, inputs=None, outputs=None, measurements=None, local_vars_configuration=None):  # noqa: E501
        """PathResponseObject - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._path = None
        self._program_name = None
        self._part_number = None
        self._path_names = None
        self._inputs = None
        self._outputs = None
        self._measurements = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if path is not None:
            self.path = path
        if program_name is not None:
            self.program_name = program_name
        if part_number is not None:
            self.part_number = part_number
        if path_names is not None:
            self.path_names = path_names
        if inputs is not None:
            self.inputs = inputs
        if outputs is not None:
            self.outputs = outputs
        if measurements is not None:
            self.measurements = measurements

    @property
    def id(self):
        """Gets the id of this PathResponseObject.  # noqa: E501

        The unique ID of this path. Note that this value may change if the collection is repaired.  # noqa: E501

        :return: The id of this PathResponseObject.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this PathResponseObject.

        The unique ID of this path. Note that this value may change if the collection is repaired.  # noqa: E501

        :param id: The id of this PathResponseObject.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def path(self):
        """Gets the path of this PathResponseObject.  # noqa: E501

        Identifies the steps that this path is representative of.  # noqa: E501

        :return: The path of this PathResponseObject.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this PathResponseObject.

        Identifies the steps that this path is representative of.  # noqa: E501

        :param path: The path of this PathResponseObject.  # noqa: E501
        :type: str
        """

        self._path = path

    @property
    def program_name(self):
        """Gets the program_name of this PathResponseObject.  # noqa: E501

        The program name for which this path is defined.  # noqa: E501

        :return: The program_name of this PathResponseObject.  # noqa: E501
        :rtype: str
        """
        return self._program_name

    @program_name.setter
    def program_name(self, program_name):
        """Sets the program_name of this PathResponseObject.

        The program name for which this path is defined.  # noqa: E501

        :param program_name: The program_name of this PathResponseObject.  # noqa: E501
        :type: str
        """

        self._program_name = program_name

    @property
    def part_number(self):
        """Gets the part_number of this PathResponseObject.  # noqa: E501

        The part number for which this path is defined.  # noqa: E501

        :return: The part_number of this PathResponseObject.  # noqa: E501
        :rtype: str
        """
        return self._part_number

    @part_number.setter
    def part_number(self, part_number):
        """Sets the part_number of this PathResponseObject.

        The part number for which this path is defined.  # noqa: E501

        :param part_number: The part_number of this PathResponseObject.  # noqa: E501
        :type: str
        """

        self._part_number = part_number

    @property
    def path_names(self):
        """Gets the path_names of this PathResponseObject.  # noqa: E501

        The list of all ancestor step names for any step which corresponds to this path.  # noqa: E501

        :return: The path_names of this PathResponseObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._path_names

    @path_names.setter
    def path_names(self, path_names):
        """Sets the path_names of this PathResponseObject.

        The list of all ancestor step names for any step which corresponds to this path.  # noqa: E501

        :param path_names: The path_names of this PathResponseObject.  # noqa: E501
        :type: list[str]
        """

        self._path_names = path_names

    @property
    def inputs(self):
        """Gets the inputs of this PathResponseObject.  # noqa: E501

        The set of inputs that steps which correspond to this path may take.  # noqa: E501

        :return: The inputs of this PathResponseObject.  # noqa: E501
        :rtype: dict(str, ValueSummaryObject)
        """
        return self._inputs

    @inputs.setter
    def inputs(self, inputs):
        """Sets the inputs of this PathResponseObject.

        The set of inputs that steps which correspond to this path may take.  # noqa: E501

        :param inputs: The inputs of this PathResponseObject.  # noqa: E501
        :type: dict(str, ValueSummaryObject)
        """

        self._inputs = inputs

    @property
    def outputs(self):
        """Gets the outputs of this PathResponseObject.  # noqa: E501

        The set of outputs that steps which correspond to this path may log.  # noqa: E501

        :return: The outputs of this PathResponseObject.  # noqa: E501
        :rtype: dict(str, ValueSummaryObject)
        """
        return self._outputs

    @outputs.setter
    def outputs(self, outputs):
        """Sets the outputs of this PathResponseObject.

        The set of outputs that steps which correspond to this path may log.  # noqa: E501

        :param outputs: The outputs of this PathResponseObject.  # noqa: E501
        :type: dict(str, ValueSummaryObject)
        """

        self._outputs = outputs

    @property
    def measurements(self):
        """Gets the measurements of this PathResponseObject.  # noqa: E501

        The set of measurements that steps which correspond to this path may take.  # noqa: E501

        :return: The measurements of this PathResponseObject.  # noqa: E501
        :rtype: dict(str, object)
        """
        return self._measurements

    @measurements.setter
    def measurements(self, measurements):
        """Sets the measurements of this PathResponseObject.

        The set of measurements that steps which correspond to this path may take.  # noqa: E501

        :param measurements: The measurements of this PathResponseObject.  # noqa: E501
        :type: dict(str, object)
        """

        self._measurements = measurements

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PathResponseObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PathResponseObject):
            return True

        return self.to_dict() != other.to_dict()
