# coding: utf-8

"""
    Test Monitor Web Service

    Test Monitor HTTP API  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitestmonitor.configuration import Configuration


class ProductValuesQuery(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'field': 'ProductField',
        'filter': 'str',
        'substitutions': 'list[object]',
        'starts_with': 'str'
    }

    attribute_map = {
        'field': 'field',
        'filter': 'filter',
        'substitutions': 'substitutions',
        'starts_with': 'startsWith'
    }

    def __init__(self, field=None, filter=None, substitutions=None, starts_with=None, local_vars_configuration=None):  # noqa: E501
        """ProductValuesQuery - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._field = None
        self._filter = None
        self._substitutions = None
        self._starts_with = None
        self.discriminator = None

        self.field = field
        if filter is not None:
            self.filter = filter
        if substitutions is not None:
            self.substitutions = substitutions
        if starts_with is not None:
            self.starts_with = starts_with

    @property
    def field(self):
        """Gets the field of this ProductValuesQuery.  # noqa: E501


        :return: The field of this ProductValuesQuery.  # noqa: E501
        :rtype: ProductField
        """
        return self._field

    @field.setter
    def field(self, field):
        """Sets the field of this ProductValuesQuery.


        :param field: The field of this ProductValuesQuery.  # noqa: E501
        :type: ProductField
        """
        if self.local_vars_configuration.client_side_validation and field is None:  # noqa: E501
            raise ValueError("Invalid value for `field`, must not be `None`")  # noqa: E501

        self._field = field

    @property
    def filter(self):
        """Gets the filter of this ProductValuesQuery.  # noqa: E501

        A Dynamic Linq query which specifies the products to consider when getting values.  # noqa: E501

        :return: The filter of this ProductValuesQuery.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this ProductValuesQuery.

        A Dynamic Linq query which specifies the products to consider when getting values.  # noqa: E501

        :param filter: The filter of this ProductValuesQuery.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def substitutions(self):
        """Gets the substitutions of this ProductValuesQuery.  # noqa: E501

        Makes substitutions in the query filter expression. Substitutions for the query expression are indicated by non-negative integers that are prefixed with the \"at\" symbol. Each substitution in the given expression will be replaced by the element at the corresponding index (zero-based) in this list. For example, \"@0\" in the filter expression will be replaced with the element at the zeroth index of the substitutions list.  # noqa: E501

        :return: The substitutions of this ProductValuesQuery.  # noqa: E501
        :rtype: list[object]
        """
        return self._substitutions

    @substitutions.setter
    def substitutions(self, substitutions):
        """Sets the substitutions of this ProductValuesQuery.

        Makes substitutions in the query filter expression. Substitutions for the query expression are indicated by non-negative integers that are prefixed with the \"at\" symbol. Each substitution in the given expression will be replaced by the element at the corresponding index (zero-based) in this list. For example, \"@0\" in the filter expression will be replaced with the element at the zeroth index of the substitutions list.  # noqa: E501

        :param substitutions: The substitutions of this ProductValuesQuery.  # noqa: E501
        :type: list[object]
        """

        self._substitutions = substitutions

    @property
    def starts_with(self):
        """Gets the starts_with of this ProductValuesQuery.  # noqa: E501

        Only return string values prefixed by this value (case sensitive).  # noqa: E501

        :return: The starts_with of this ProductValuesQuery.  # noqa: E501
        :rtype: str
        """
        return self._starts_with

    @starts_with.setter
    def starts_with(self, starts_with):
        """Sets the starts_with of this ProductValuesQuery.

        Only return string values prefixed by this value (case sensitive).  # noqa: E501

        :param starts_with: The starts_with of this ProductValuesQuery.  # noqa: E501
        :type: str
        """

        self._starts_with = starts_with

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProductValuesQuery):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProductValuesQuery):
            return True

        return self.to_dict() != other.to_dict()
