# coding: utf-8

"""
    Test Monitor Web Service

    Test Monitor HTTP API  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitestmonitor.configuration import Configuration


class ProductsQueryResponse(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'products': 'list[ProductResponseObject]',
        'continuation_token': 'str',
        'total_count': 'int'
    }

    attribute_map = {
        'products': 'products',
        'continuation_token': 'continuationToken',
        'total_count': 'totalCount'
    }

    def __init__(self, products=None, continuation_token=None, total_count=None, local_vars_configuration=None):  # noqa: E501
        """ProductsQueryResponse - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._products = None
        self._continuation_token = None
        self._total_count = None
        self.discriminator = None

        self.products = products
        if continuation_token is not None:
            self.continuation_token = continuation_token
        if total_count is not None:
            self.total_count = total_count

    @property
    def products(self):
        """Gets the products of this ProductsQueryResponse.  # noqa: E501

        Array of products  # noqa: E501

        :return: The products of this ProductsQueryResponse.  # noqa: E501
        :rtype: list[ProductResponseObject]
        """
        return self._products

    @products.setter
    def products(self, products):
        """Sets the products of this ProductsQueryResponse.

        Array of products  # noqa: E501

        :param products: The products of this ProductsQueryResponse.  # noqa: E501
        :type: list[ProductResponseObject]
        """
        if self.local_vars_configuration.client_side_validation and products is None:  # noqa: E501
            raise ValueError("Invalid value for `products`, must not be `None`")  # noqa: E501

        self._products = products

    @property
    def continuation_token(self):
        """Gets the continuation_token of this ProductsQueryResponse.  # noqa: E501

        A token which allows the user to resume this query at the next item in the matching product set. In order to continue paginating a query, pass this token to the service on a subsequent request. The service will respond with a new continuation token. To paginate a set of products, continue sending requests with the newest continuation token provided by the service, until this value is null.  # noqa: E501

        :return: The continuation_token of this ProductsQueryResponse.  # noqa: E501
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this ProductsQueryResponse.

        A token which allows the user to resume this query at the next item in the matching product set. In order to continue paginating a query, pass this token to the service on a subsequent request. The service will respond with a new continuation token. To paginate a set of products, continue sending requests with the newest continuation token provided by the service, until this value is null.  # noqa: E501

        :param continuation_token: The continuation_token of this ProductsQueryResponse.  # noqa: E501
        :type: str
        """

        self._continuation_token = continuation_token

    @property
    def total_count(self):
        """Gets the total_count of this ProductsQueryResponse.  # noqa: E501

        The number of matching products, if returnCount is true. This value is not present if returnCount is false.  # noqa: E501

        :return: The total_count of this ProductsQueryResponse.  # noqa: E501
        :rtype: int
        """
        return self._total_count

    @total_count.setter
    def total_count(self, total_count):
        """Sets the total_count of this ProductsQueryResponse.

        The number of matching products, if returnCount is true. This value is not present if returnCount is false.  # noqa: E501

        :param total_count: The total_count of this ProductsQueryResponse.  # noqa: E501
        :type: int
        """

        self._total_count = total_count

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ProductsQueryResponse):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ProductsQueryResponse):
            return True

        return self.to_dict() != other.to_dict()
