# coding: utf-8

"""
    Test Monitor Web Service

    Test Monitor HTTP API  # noqa: E501

    The version of the OpenAPI document: 2
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.nitestmonitor.configuration import Configuration


class StepsAdvancedQuery(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'filter': 'str',
        'substitutions': 'list[object]',
        'result_filter': 'str',
        'result_substitutions': 'list[object]',
        'order_by': 'StepField',
        'descending': 'bool',
        'projection': 'list[StepField]',
        'take': 'int',
        'continuation_token': 'str',
        'return_count': 'bool',
        'response_format': 'ResponseFormat'
    }

    attribute_map = {
        'filter': 'filter',
        'substitutions': 'substitutions',
        'result_filter': 'resultFilter',
        'result_substitutions': 'resultSubstitutions',
        'order_by': 'orderBy',
        'descending': 'descending',
        'projection': 'projection',
        'take': 'take',
        'continuation_token': 'continuationToken',
        'return_count': 'returnCount',
        'response_format': 'responseFormat'
    }

    def __init__(self, filter=None, substitutions=None, result_filter=None, result_substitutions=None, order_by=None, descending=False, projection=None, take=1000, continuation_token=None, return_count=False, response_format=None, local_vars_configuration=None):  # noqa: E501
        """StepsAdvancedQuery - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._filter = None
        self._substitutions = None
        self._result_filter = None
        self._result_substitutions = None
        self._order_by = None
        self._descending = None
        self._projection = None
        self._take = None
        self._continuation_token = None
        self._return_count = None
        self._response_format = None
        self.discriminator = None

        if filter is not None:
            self.filter = filter
        if substitutions is not None:
            self.substitutions = substitutions
        if result_filter is not None:
            self.result_filter = result_filter
        if result_substitutions is not None:
            self.result_substitutions = result_substitutions
        if order_by is not None:
            self.order_by = order_by
        if descending is not None:
            self.descending = descending
        if projection is not None:
            self.projection = projection
        if take is not None:
            self.take = take
        if continuation_token is not None:
            self.continuation_token = continuation_token
        if return_count is not None:
            self.return_count = return_count
        if response_format is not None:
            self.response_format = response_format

    @property
    def filter(self):
        """Gets the filter of this StepsAdvancedQuery.  # noqa: E501

        The step query filter in Dynamic Linq  # noqa: E501

        :return: The filter of this StepsAdvancedQuery.  # noqa: E501
        :rtype: str
        """
        return self._filter

    @filter.setter
    def filter(self, filter):
        """Sets the filter of this StepsAdvancedQuery.

        The step query filter in Dynamic Linq  # noqa: E501

        :param filter: The filter of this StepsAdvancedQuery.  # noqa: E501
        :type: str
        """

        self._filter = filter

    @property
    def substitutions(self):
        """Gets the substitutions of this StepsAdvancedQuery.  # noqa: E501

        Makes substitutions in the query filter expression. Substitutions for the query expression are indicated by non-negative integers that are prefixed with the \"at\" symbol. Each substitution in the given expression will be replaced by the element at the corresponding index (zero-based) in this list. For example, \"@0\" in the filter expression will be replaced with the element at the zeroth index of the substitutions list.  # noqa: E501

        :return: The substitutions of this StepsAdvancedQuery.  # noqa: E501
        :rtype: list[object]
        """
        return self._substitutions

    @substitutions.setter
    def substitutions(self, substitutions):
        """Sets the substitutions of this StepsAdvancedQuery.

        Makes substitutions in the query filter expression. Substitutions for the query expression are indicated by non-negative integers that are prefixed with the \"at\" symbol. Each substitution in the given expression will be replaced by the element at the corresponding index (zero-based) in this list. For example, \"@0\" in the filter expression will be replaced with the element at the zeroth index of the substitutions list.  # noqa: E501

        :param substitutions: The substitutions of this StepsAdvancedQuery.  # noqa: E501
        :type: list[object]
        """

        self._substitutions = substitutions

    @property
    def result_filter(self):
        """Gets the result_filter of this StepsAdvancedQuery.  # noqa: E501

        The result query filter in Dynamic Linq.  # noqa: E501

        :return: The result_filter of this StepsAdvancedQuery.  # noqa: E501
        :rtype: str
        """
        return self._result_filter

    @result_filter.setter
    def result_filter(self, result_filter):
        """Sets the result_filter of this StepsAdvancedQuery.

        The result query filter in Dynamic Linq.  # noqa: E501

        :param result_filter: The result_filter of this StepsAdvancedQuery.  # noqa: E501
        :type: str
        """

        self._result_filter = result_filter

    @property
    def result_substitutions(self):
        """Gets the result_substitutions of this StepsAdvancedQuery.  # noqa: E501

        Makes substitutions in the query filter expression for results. Substitutions for the query expression are indicated by non-negative integers that are prefixed with the \"at\" symbol. Each substitution in the given expression will be replaced by the element at the corresponding index (zero-based) in this list. For example, \"@0\" in the filter expression will be replaced with the element at the zeroth index of the substitutions list.  # noqa: E501

        :return: The result_substitutions of this StepsAdvancedQuery.  # noqa: E501
        :rtype: list[object]
        """
        return self._result_substitutions

    @result_substitutions.setter
    def result_substitutions(self, result_substitutions):
        """Sets the result_substitutions of this StepsAdvancedQuery.

        Makes substitutions in the query filter expression for results. Substitutions for the query expression are indicated by non-negative integers that are prefixed with the \"at\" symbol. Each substitution in the given expression will be replaced by the element at the corresponding index (zero-based) in this list. For example, \"@0\" in the filter expression will be replaced with the element at the zeroth index of the substitutions list.  # noqa: E501

        :param result_substitutions: The result_substitutions of this StepsAdvancedQuery.  # noqa: E501
        :type: list[object]
        """

        self._result_substitutions = result_substitutions

    @property
    def order_by(self):
        """Gets the order_by of this StepsAdvancedQuery.  # noqa: E501


        :return: The order_by of this StepsAdvancedQuery.  # noqa: E501
        :rtype: StepField
        """
        return self._order_by

    @order_by.setter
    def order_by(self, order_by):
        """Sets the order_by of this StepsAdvancedQuery.


        :param order_by: The order_by of this StepsAdvancedQuery.  # noqa: E501
        :type: StepField
        """

        self._order_by = order_by

    @property
    def descending(self):
        """Gets the descending of this StepsAdvancedQuery.  # noqa: E501

        -> Whether to return the steps in descending order.  # noqa: E501

        :return: The descending of this StepsAdvancedQuery.  # noqa: E501
        :rtype: bool
        """
        return self._descending

    @descending.setter
    def descending(self, descending):
        """Sets the descending of this StepsAdvancedQuery.

        -> Whether to return the steps in descending order.  # noqa: E501

        :param descending: The descending of this StepsAdvancedQuery.  # noqa: E501
        :type: bool
        """

        self._descending = descending

    @property
    def projection(self):
        """Gets the projection of this StepsAdvancedQuery.  # noqa: E501

        Specifies the step fields to project. When a field value is given here, the corresponding field will be present in all returned steps, and all unspecified fields will be excluded. If no projection is specified, all step fields will be returned.  # noqa: E501

        :return: The projection of this StepsAdvancedQuery.  # noqa: E501
        :rtype: list[StepField]
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this StepsAdvancedQuery.

        Specifies the step fields to project. When a field value is given here, the corresponding field will be present in all returned steps, and all unspecified fields will be excluded. If no projection is specified, all step fields will be returned.  # noqa: E501

        :param projection: The projection of this StepsAdvancedQuery.  # noqa: E501
        :type: list[StepField]
        """

        self._projection = projection

    @property
    def take(self):
        """Gets the take of this StepsAdvancedQuery.  # noqa: E501

        The maximum number of steps to return.  # noqa: E501

        :return: The take of this StepsAdvancedQuery.  # noqa: E501
        :rtype: int
        """
        return self._take

    @take.setter
    def take(self, take):
        """Sets the take of this StepsAdvancedQuery.

        The maximum number of steps to return.  # noqa: E501

        :param take: The take of this StepsAdvancedQuery.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                take is not None and take < -1):  # noqa: E501
            raise ValueError("Invalid value for `take`, must be a value greater than or equal to `-1`")  # noqa: E501

        self._take = take

    @property
    def continuation_token(self):
        """Gets the continuation_token of this StepsAdvancedQuery.  # noqa: E501

        A token which allows the user to resume a query at the next item in the matching step set. When querying for steps, a token will be returned if a query may be continued. To obtain the next page of steps, pass the token to the service on a subsequent request.  # noqa: E501

        :return: The continuation_token of this StepsAdvancedQuery.  # noqa: E501
        :rtype: str
        """
        return self._continuation_token

    @continuation_token.setter
    def continuation_token(self, continuation_token):
        """Sets the continuation_token of this StepsAdvancedQuery.

        A token which allows the user to resume a query at the next item in the matching step set. When querying for steps, a token will be returned if a query may be continued. To obtain the next page of steps, pass the token to the service on a subsequent request.  # noqa: E501

        :param continuation_token: The continuation_token of this StepsAdvancedQuery.  # noqa: E501
        :type: str
        """

        self._continuation_token = continuation_token

    @property
    def return_count(self):
        """Gets the return_count of this StepsAdvancedQuery.  # noqa: E501

        Whether to return the total number of steps which match the provided filter, disregarding the take value.  # noqa: E501

        :return: The return_count of this StepsAdvancedQuery.  # noqa: E501
        :rtype: bool
        """
        return self._return_count

    @return_count.setter
    def return_count(self, return_count):
        """Sets the return_count of this StepsAdvancedQuery.

        Whether to return the total number of steps which match the provided filter, disregarding the take value.  # noqa: E501

        :param return_count: The return_count of this StepsAdvancedQuery.  # noqa: E501
        :type: bool
        """

        self._return_count = return_count

    @property
    def response_format(self):
        """Gets the response_format of this StepsAdvancedQuery.  # noqa: E501


        :return: The response_format of this StepsAdvancedQuery.  # noqa: E501
        :rtype: ResponseFormat
        """
        return self._response_format

    @response_format.setter
    def response_format(self, response_format):
        """Sets the response_format of this StepsAdvancedQuery.


        :param response_format: The response_format of this StepsAdvancedQuery.  # noqa: E501
        :type: ResponseFormat
        """

        self._response_format = response_format

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, StepsAdvancedQuery):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, StepsAdvancedQuery):
            return True

        return self.to_dict() != other.to_dict()
