# coding: utf-8

"""
    User Data Service

    Manage user specific data.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niuserdata.configuration import Configuration


class CreateOrUpdateUserDataItem(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'application': 'str',
        'category': 'str',
        'name': 'str',
        'value': 'object',
        'visible_to_others': 'bool',
        'expected_revision': 'int'
    }

    attribute_map = {
        'application': 'application',
        'category': 'category',
        'name': 'name',
        'value': 'value',
        'visible_to_others': 'visibleToOthers',
        'expected_revision': 'expectedRevision'
    }

    def __init__(self, application=None, category='', name=None, value=None, visible_to_others=None, expected_revision=None, local_vars_configuration=None):  # noqa: E501
        """CreateOrUpdateUserDataItem - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._application = None
        self._category = None
        self._name = None
        self._value = None
        self._visible_to_others = None
        self._expected_revision = None
        self.discriminator = None

        self.application = application
        if category is not None:
            self.category = category
        self.name = name
        self.value = value
        if visible_to_others is not None:
            self.visible_to_others = visible_to_others
        if expected_revision is not None:
            self.expected_revision = expected_revision

    @property
    def application(self):
        """Gets the application of this CreateOrUpdateUserDataItem.  # noqa: E501

        The application name that this user data item belongs to.  # noqa: E501

        :return: The application of this CreateOrUpdateUserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._application

    @application.setter
    def application(self, application):
        """Sets the application of this CreateOrUpdateUserDataItem.

        The application name that this user data item belongs to.  # noqa: E501

        :param application: The application of this CreateOrUpdateUserDataItem.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and application is None:  # noqa: E501
            raise ValueError("Invalid value for `application`, must not be `None`")  # noqa: E501

        self._application = application

    @property
    def category(self):
        """Gets the category of this CreateOrUpdateUserDataItem.  # noqa: E501

        The category name in the application that this user data item belongs to. An empty category name is accepted.  # noqa: E501

        :return: The category of this CreateOrUpdateUserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this CreateOrUpdateUserDataItem.

        The category name in the application that this user data item belongs to. An empty category name is accepted.  # noqa: E501

        :param category: The category of this CreateOrUpdateUserDataItem.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def name(self):
        """Gets the name of this CreateOrUpdateUserDataItem.  # noqa: E501

        The name of the user data item.  # noqa: E501

        :return: The name of this CreateOrUpdateUserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CreateOrUpdateUserDataItem.

        The name of the user data item.  # noqa: E501

        :param name: The name of this CreateOrUpdateUserDataItem.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and name is None:  # noqa: E501
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def value(self):
        """Gets the value of this CreateOrUpdateUserDataItem.  # noqa: E501

        The value of the user data item.  # noqa: E501

        :return: The value of this CreateOrUpdateUserDataItem.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this CreateOrUpdateUserDataItem.

        The value of the user data item.  # noqa: E501

        :param value: The value of this CreateOrUpdateUserDataItem.  # noqa: E501
        :type: object
        """
        if self.local_vars_configuration.client_side_validation and value is None:  # noqa: E501
            raise ValueError("Invalid value for `value`, must not be `None`")  # noqa: E501

        self._value = value

    @property
    def visible_to_others(self):
        """Gets the visible_to_others of this CreateOrUpdateUserDataItem.  # noqa: E501

        Whether this user data item is visible to other users. This will allow other users to query this data.  # noqa: E501

        :return: The visible_to_others of this CreateOrUpdateUserDataItem.  # noqa: E501
        :rtype: bool
        """
        return self._visible_to_others

    @visible_to_others.setter
    def visible_to_others(self, visible_to_others):
        """Sets the visible_to_others of this CreateOrUpdateUserDataItem.

        Whether this user data item is visible to other users. This will allow other users to query this data.  # noqa: E501

        :param visible_to_others: The visible_to_others of this CreateOrUpdateUserDataItem.  # noqa: E501
        :type: bool
        """

        self._visible_to_others = visible_to_others

    @property
    def expected_revision(self):
        """Gets the expected_revision of this CreateOrUpdateUserDataItem.  # noqa: E501

        This is an optional value. When specified, this is an integer that should be set to match the last known revision number of the user data item. If it doesn't match at the time of execution, the update request will be rejected. This is used to ensure that changes to this user data item are correctly using the previous state. This may be important, for instance, in the case where multiple clients are updating an array value at the same time. A value of 0 means that the item must not already exist.  # noqa: E501

        :return: The expected_revision of this CreateOrUpdateUserDataItem.  # noqa: E501
        :rtype: int
        """
        return self._expected_revision

    @expected_revision.setter
    def expected_revision(self, expected_revision):
        """Sets the expected_revision of this CreateOrUpdateUserDataItem.

        This is an optional value. When specified, this is an integer that should be set to match the last known revision number of the user data item. If it doesn't match at the time of execution, the update request will be rejected. This is used to ensure that changes to this user data item are correctly using the previous state. This may be important, for instance, in the case where multiple clients are updating an array value at the same time. A value of 0 means that the item must not already exist.  # noqa: E501

        :param expected_revision: The expected_revision of this CreateOrUpdateUserDataItem.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                expected_revision is not None and expected_revision < 0):  # noqa: E501
            raise ValueError("Invalid value for `expected_revision`, must be a value greater than or equal to `0`")  # noqa: E501

        self._expected_revision = expected_revision

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CreateOrUpdateUserDataItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, CreateOrUpdateUserDataItem):
            return True

        return self.to_dict() != other.to_dict()
