# coding: utf-8

"""
    User Data Service

    Manage user specific data.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niuserdata.configuration import Configuration


class UserDataItem(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'id': 'str',
        'user': 'str',
        'application': 'str',
        'category': 'str',
        'name': 'str',
        'value': 'object',
        'visible_to_others': 'bool',
        'revision': 'int',
        'created_at': 'datetime',
        'updated_at': 'datetime'
    }

    attribute_map = {
        'id': 'id',
        'user': 'user',
        'application': 'application',
        'category': 'category',
        'name': 'name',
        'value': 'value',
        'visible_to_others': 'visibleToOthers',
        'revision': 'revision',
        'created_at': 'createdAt',
        'updated_at': 'updatedAt'
    }

    def __init__(self, id=None, user=None, application=None, category='', name=None, value=None, visible_to_others=None, revision=None, created_at=None, updated_at=None, local_vars_configuration=None):  # noqa: E501
        """UserDataItem - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._user = None
        self._application = None
        self._category = None
        self._name = None
        self._value = None
        self._visible_to_others = None
        self._revision = None
        self._created_at = None
        self._updated_at = None
        self.discriminator = None

        if id is not None:
            self.id = id
        if user is not None:
            self.user = user
        if application is not None:
            self.application = application
        if category is not None:
            self.category = category
        if name is not None:
            self.name = name
        if value is not None:
            self.value = value
        if visible_to_others is not None:
            self.visible_to_others = visible_to_others
        if revision is not None:
            self.revision = revision
        if created_at is not None:
            self.created_at = created_at
        if updated_at is not None:
            self.updated_at = updated_at

    @property
    def id(self):
        """Gets the id of this UserDataItem.  # noqa: E501

        The ID for this user data item.  # noqa: E501

        :return: The id of this UserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this UserDataItem.

        The ID for this user data item.  # noqa: E501

        :param id: The id of this UserDataItem.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def user(self):
        """Gets the user of this UserDataItem.  # noqa: E501

        The user that this data item belongs to.  # noqa: E501

        :return: The user of this UserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._user

    @user.setter
    def user(self, user):
        """Sets the user of this UserDataItem.

        The user that this data item belongs to.  # noqa: E501

        :param user: The user of this UserDataItem.  # noqa: E501
        :type: str
        """

        self._user = user

    @property
    def application(self):
        """Gets the application of this UserDataItem.  # noqa: E501

        The application name that this user data item belongs to.  # noqa: E501

        :return: The application of this UserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._application

    @application.setter
    def application(self, application):
        """Sets the application of this UserDataItem.

        The application name that this user data item belongs to.  # noqa: E501

        :param application: The application of this UserDataItem.  # noqa: E501
        :type: str
        """

        self._application = application

    @property
    def category(self):
        """Gets the category of this UserDataItem.  # noqa: E501

        The category name in the application that this user data item belongs to. An empty category name is accepted.  # noqa: E501

        :return: The category of this UserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._category

    @category.setter
    def category(self, category):
        """Sets the category of this UserDataItem.

        The category name in the application that this user data item belongs to. An empty category name is accepted.  # noqa: E501

        :param category: The category of this UserDataItem.  # noqa: E501
        :type: str
        """

        self._category = category

    @property
    def name(self):
        """Gets the name of this UserDataItem.  # noqa: E501

        The name of the user data item.  # noqa: E501

        :return: The name of this UserDataItem.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this UserDataItem.

        The name of the user data item.  # noqa: E501

        :param name: The name of this UserDataItem.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def value(self):
        """Gets the value of this UserDataItem.  # noqa: E501

        The value of the user data item.  # noqa: E501

        :return: The value of this UserDataItem.  # noqa: E501
        :rtype: object
        """
        return self._value

    @value.setter
    def value(self, value):
        """Sets the value of this UserDataItem.

        The value of the user data item.  # noqa: E501

        :param value: The value of this UserDataItem.  # noqa: E501
        :type: object
        """

        self._value = value

    @property
    def visible_to_others(self):
        """Gets the visible_to_others of this UserDataItem.  # noqa: E501

        Whether this user data item is visible to other users. This will allow other users to query this data.  # noqa: E501

        :return: The visible_to_others of this UserDataItem.  # noqa: E501
        :rtype: bool
        """
        return self._visible_to_others

    @visible_to_others.setter
    def visible_to_others(self, visible_to_others):
        """Sets the visible_to_others of this UserDataItem.

        Whether this user data item is visible to other users. This will allow other users to query this data.  # noqa: E501

        :param visible_to_others: The visible_to_others of this UserDataItem.  # noqa: E501
        :type: bool
        """

        self._visible_to_others = visible_to_others

    @property
    def revision(self):
        """Gets the revision of this UserDataItem.  # noqa: E501

        The revision number for this user data item. When a user data item is created, the revision number starts at 1. Every time it is updated, the revision number is incremented by 1.  # noqa: E501

        :return: The revision of this UserDataItem.  # noqa: E501
        :rtype: int
        """
        return self._revision

    @revision.setter
    def revision(self, revision):
        """Sets the revision of this UserDataItem.

        The revision number for this user data item. When a user data item is created, the revision number starts at 1. Every time it is updated, the revision number is incremented by 1.  # noqa: E501

        :param revision: The revision of this UserDataItem.  # noqa: E501
        :type: int
        """

        self._revision = revision

    @property
    def created_at(self):
        """Gets the created_at of this UserDataItem.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the user data item was created.  # noqa: E501

        :return: The created_at of this UserDataItem.  # noqa: E501
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """Sets the created_at of this UserDataItem.

        ISO-8601 formatted timestamp specifying when the user data item was created.  # noqa: E501

        :param created_at: The created_at of this UserDataItem.  # noqa: E501
        :type: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """Gets the updated_at of this UserDataItem.  # noqa: E501

        ISO-8601 formatted timestamp specifying when the user data item was last updated.  # noqa: E501

        :return: The updated_at of this UserDataItem.  # noqa: E501
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """Sets the updated_at of this UserDataItem.

        ISO-8601 formatted timestamp specifying when the user data item was last updated.  # noqa: E501

        :param updated_at: The updated_at of this UserDataItem.  # noqa: E501
        :type: datetime
        """

        self._updated_at = updated_at

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserDataItem):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserDataItem):
            return True

        return self.to_dict() != other.to_dict()
