# coding: utf-8

"""
    User Data Service

    Manage user specific data.  # noqa: E501

    The version of the OpenAPI document: 1
    Contact: support@ni.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from systemlink.clients.niuserdata.configuration import Configuration


class UserDataItemQueryObject(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'ids': 'list[str]',
        'applications': 'list[str]',
        'categories': 'list[str]',
        'names': 'list[str]',
        'value_query': 'list[JsonQueryObject]',
        'visible_to_others': 'bool',
        'revision_query': 'list[IntegerQueryObject]',
        'created_at_query': 'list[TimeQueryObject]',
        'updated_at_query': 'list[TimeQueryObject]',
        'sort_by': 'list[UserDataItemSortDefinitionObject]',
        'projection': 'list[UserDataItemField]'
    }

    attribute_map = {
        'ids': 'ids',
        'applications': 'applications',
        'categories': 'categories',
        'names': 'names',
        'value_query': 'valueQuery',
        'visible_to_others': 'visibleToOthers',
        'revision_query': 'revisionQuery',
        'created_at_query': 'createdAtQuery',
        'updated_at_query': 'updatedAtQuery',
        'sort_by': 'sortBy',
        'projection': 'projection'
    }

    def __init__(self, ids=None, applications=None, categories=None, names=None, value_query=None, visible_to_others=None, revision_query=None, created_at_query=None, updated_at_query=None, sort_by=None, projection=None, local_vars_configuration=None):  # noqa: E501
        """UserDataItemQueryObject - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._ids = None
        self._applications = None
        self._categories = None
        self._names = None
        self._value_query = None
        self._visible_to_others = None
        self._revision_query = None
        self._created_at_query = None
        self._updated_at_query = None
        self._sort_by = None
        self._projection = None
        self.discriminator = None

        if ids is not None:
            self.ids = ids
        if applications is not None:
            self.applications = applications
        if categories is not None:
            self.categories = categories
        if names is not None:
            self.names = names
        if value_query is not None:
            self.value_query = value_query
        if visible_to_others is not None:
            self.visible_to_others = visible_to_others
        if revision_query is not None:
            self.revision_query = revision_query
        if created_at_query is not None:
            self.created_at_query = created_at_query
        if updated_at_query is not None:
            self.updated_at_query = updated_at_query
        if sort_by is not None:
            self.sort_by = sort_by
        if projection is not None:
            self.projection = projection

    @property
    def ids(self):
        """Gets the ids of this UserDataItemQueryObject.  # noqa: E501

        Array of user data item IDs  # noqa: E501

        :return: The ids of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._ids

    @ids.setter
    def ids(self, ids):
        """Sets the ids of this UserDataItemQueryObject.

        Array of user data item IDs  # noqa: E501

        :param ids: The ids of this UserDataItemQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._ids = ids

    @property
    def applications(self):
        """Gets the applications of this UserDataItemQueryObject.  # noqa: E501

        Array of application names  # noqa: E501

        :return: The applications of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._applications

    @applications.setter
    def applications(self, applications):
        """Sets the applications of this UserDataItemQueryObject.

        Array of application names  # noqa: E501

        :param applications: The applications of this UserDataItemQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._applications = applications

    @property
    def categories(self):
        """Gets the categories of this UserDataItemQueryObject.  # noqa: E501

        Array of category names  # noqa: E501

        :return: The categories of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._categories

    @categories.setter
    def categories(self, categories):
        """Sets the categories of this UserDataItemQueryObject.

        Array of category names  # noqa: E501

        :param categories: The categories of this UserDataItemQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._categories = categories

    @property
    def names(self):
        """Gets the names of this UserDataItemQueryObject.  # noqa: E501

        Array of user data item names  # noqa: E501

        :return: The names of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[str]
        """
        return self._names

    @names.setter
    def names(self, names):
        """Sets the names of this UserDataItemQueryObject.

        Array of user data item names  # noqa: E501

        :param names: The names of this UserDataItemQueryObject.  # noqa: E501
        :type: list[str]
        """

        self._names = names

    @property
    def value_query(self):
        """Gets the value_query of this UserDataItemQueryObject.  # noqa: E501

        Array of JSON query objects to query against the values of the user data items.  # noqa: E501

        :return: The value_query of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[JsonQueryObject]
        """
        return self._value_query

    @value_query.setter
    def value_query(self, value_query):
        """Sets the value_query of this UserDataItemQueryObject.

        Array of JSON query objects to query against the values of the user data items.  # noqa: E501

        :param value_query: The value_query of this UserDataItemQueryObject.  # noqa: E501
        :type: list[JsonQueryObject]
        """

        self._value_query = value_query

    @property
    def visible_to_others(self):
        """Gets the visible_to_others of this UserDataItemQueryObject.  # noqa: E501

        Match against the 'visibleToOthers' field in the user item data. If not set, will match both true and false values.  # noqa: E501

        :return: The visible_to_others of this UserDataItemQueryObject.  # noqa: E501
        :rtype: bool
        """
        return self._visible_to_others

    @visible_to_others.setter
    def visible_to_others(self, visible_to_others):
        """Sets the visible_to_others of this UserDataItemQueryObject.

        Match against the 'visibleToOthers' field in the user item data. If not set, will match both true and false values.  # noqa: E501

        :param visible_to_others: The visible_to_others of this UserDataItemQueryObject.  # noqa: E501
        :type: bool
        """

        self._visible_to_others = visible_to_others

    @property
    def revision_query(self):
        """Gets the revision_query of this UserDataItemQueryObject.  # noqa: E501

        Array of integer query objects used to query the revision of the user data items.  # noqa: E501

        :return: The revision_query of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[IntegerQueryObject]
        """
        return self._revision_query

    @revision_query.setter
    def revision_query(self, revision_query):
        """Sets the revision_query of this UserDataItemQueryObject.

        Array of integer query objects used to query the revision of the user data items.  # noqa: E501

        :param revision_query: The revision_query of this UserDataItemQueryObject.  # noqa: E501
        :type: list[IntegerQueryObject]
        """

        self._revision_query = revision_query

    @property
    def created_at_query(self):
        """Gets the created_at_query of this UserDataItemQueryObject.  # noqa: E501

        Array of time query objects used to query when the user data items were created.  # noqa: E501

        :return: The created_at_query of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._created_at_query

    @created_at_query.setter
    def created_at_query(self, created_at_query):
        """Sets the created_at_query of this UserDataItemQueryObject.

        Array of time query objects used to query when the user data items were created.  # noqa: E501

        :param created_at_query: The created_at_query of this UserDataItemQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._created_at_query = created_at_query

    @property
    def updated_at_query(self):
        """Gets the updated_at_query of this UserDataItemQueryObject.  # noqa: E501

        Array of time query objects used to query when the user data items were last updated.  # noqa: E501

        :return: The updated_at_query of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[TimeQueryObject]
        """
        return self._updated_at_query

    @updated_at_query.setter
    def updated_at_query(self, updated_at_query):
        """Sets the updated_at_query of this UserDataItemQueryObject.

        Array of time query objects used to query when the user data items were last updated.  # noqa: E501

        :param updated_at_query: The updated_at_query of this UserDataItemQueryObject.  # noqa: E501
        :type: list[TimeQueryObject]
        """

        self._updated_at_query = updated_at_query

    @property
    def sort_by(self):
        """Gets the sort_by of this UserDataItemQueryObject.  # noqa: E501

        Array of user data item sort definition objects to define how to sort the results.  # noqa: E501

        :return: The sort_by of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[UserDataItemSortDefinitionObject]
        """
        return self._sort_by

    @sort_by.setter
    def sort_by(self, sort_by):
        """Sets the sort_by of this UserDataItemQueryObject.

        Array of user data item sort definition objects to define how to sort the results.  # noqa: E501

        :param sort_by: The sort_by of this UserDataItemQueryObject.  # noqa: E501
        :type: list[UserDataItemSortDefinitionObject]
        """

        self._sort_by = sort_by

    @property
    def projection(self):
        """Gets the projection of this UserDataItemQueryObject.  # noqa: E501

        Array of user data item fields. If you specify an array, the query returns a result with the user data items containing the fields that are both specified and available. If you do not specify an array, the query will return a result with the user data items containing all available fields.  # noqa: E501

        :return: The projection of this UserDataItemQueryObject.  # noqa: E501
        :rtype: list[UserDataItemField]
        """
        return self._projection

    @projection.setter
    def projection(self, projection):
        """Sets the projection of this UserDataItemQueryObject.

        Array of user data item fields. If you specify an array, the query returns a result with the user data items containing the fields that are both specified and available. If you do not specify an array, the query will return a result with the user data items containing all available fields.  # noqa: E501

        :param projection: The projection of this UserDataItemQueryObject.  # noqa: E501
        :type: list[UserDataItemField]
        """

        self._projection = projection

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UserDataItemQueryObject):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UserDataItemQueryObject):
            return True

        return self.to_dict() != other.to_dict()
