# -*- coding: utf-8 -*-
"""
Implementation of 'BroadcastMessage' class
"""
# Import python libs
from typing import Optional

# Import local libs
from systemlink.messagebus.message_base import MessageBase
from systemlink.messagebus.message_header import MessageHeader

class BroadcastMessage(MessageBase):  # pylint: disable=too-few-public-methods
    """
    Broadcast Message.

    Bundles a message that is to be broadcasted out
    to anyone who subscribes to the message.
    """
    def __init__(self, header: MessageHeader, body: Optional[bytes]) -> None:  # pylint: disable=useless-super-delegation
        """
        :param header: The message header.
        :type header: MessageHeader
        :param body: The message body.
        :type body: Optional[bytes]
        """
        super().__init__(header, body)
