# -*- coding: utf-8 -*-
"""
Implementation of 'ResponseMessage' class
"""
# Import python libs
from typing import Optional

# Import local libs
from systemlink.messagebus.message_base import MessageBase
from systemlink.messagebus.message_header import MessageHeader


class ResponseMessage(MessageBase):  # pylint: disable=too-few-public-methods
    """
    Response Message

    A message meant to be sent as a response to
    a RequestMessage.
    """
    def __init__(self, header: MessageHeader, body: Optional[bytes]) -> None:  # pylint: disable=useless-super-delegation
        """
        :param header: The message header.
        :type header: MessageHeader
        :param body: The raw message body.
        :type body: Optional[bytes]
        """
        super().__init__(
            header,
            body
        )
