# -*- coding: utf-8 -*-
# DO NOT EDIT! This file is auto-generated.
"""
Classes for SystemLink Message Bus usage.
"""
# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import
from typing import cast, Any, Dict, List, Optional, Union  # pylint: disable=unused-import

# Import local libs
from systemlink.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from systemlink.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from systemlink.messagebus.generic_message import GenericMessage  # pylint: disable=unused-import
from systemlink.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from systemlink.messagebus.message_base import MessageBase
from systemlink.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from systemlink.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from systemlink.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import

_PASS_THROUGH_TYPES = {
    'bool',
    'bytes',
    'float',
    'int',
    'object',
    'str'
}

_PRIMITIVE_TYPES = {
    'bool': bool,
    'bytes': bytes,
    'datetime': datetime,
    'dict': dict,
    'float': float,
    'int': int,
    'list': list,
    'object': object,
    'str': str
}


def _str_to_type(type_name: str) -> type:
    """
    Convert a type name to a type.

    :param type_name: The name of the type.
    :type type_name: str
    :return: The corresponding type.
    :rtype: type
    """
    type_ = _PRIMITIVE_TYPES.get(type_name)
    if type_ is not None:
        return type_
    return getattr(sys.modules[__name__], type_name)


def _deserialize(value: Any, type_name: str) -> Any:  # pylint: disable=too-many-return-statements,too-many-branches
    """
    Deserialize a value from a Python native type.

    :param value: The value to deserialize.
    :type value: Any
    :param type_name: The name of the type of `value``.
    :type type_name: str
    :return: The deserialized object.
    :rtype: Any
    """
    if value is None:
        return None
    if not type_name:
        return value
    if type_name.endswith(']'):
        sep_index = type_name.find('[')
        sub_type_name = type_name[sep_index+1:-1]
        type_name = type_name[:sep_index]
        if type_name in ('list', 'List'):
            if sub_type_name in _PASS_THROUGH_TYPES:
                return value
            return [_deserialize(item, sub_type_name) for item in value]
        assert type_name in ('dict', 'Dict')
        sep_index = sub_type_name.find(',')
        key_type_name = sub_type_name[:sep_index]
        value_type_name = sub_type_name[sep_index+1:].strip()
        if key_type_name in _PASS_THROUGH_TYPES and value_type_name in _PASS_THROUGH_TYPES:
            return value
        new_dict = {}
        for dict_key, dict_value in value.items():
            new_dict[_deserialize(dict_key, key_type_name)] = _deserialize(
                dict_value, value_type_name
            )
        return new_dict
    if type_name in _PASS_THROUGH_TYPES:
        return value
    type_ = _str_to_type(type_name)
    if type_ == datetime:
        if not isinstance(value, datetime):
            return to_datetime(value)
        return value
    if hasattr(type_, 'from_dict'):
        return type_.from_dict(value)  # type: ignore
    if hasattr(type_, 'from_string'):
        if isinstance(value, int):
            return type_(value)
        return type_.from_string(value)  # type: ignore
    if hasattr(type_, 'from_list'):
        if isinstance(value, int):
            return type_(value)
        return type_.from_list(value)  # type: ignore
    return value


def _serialize(value: Any) -> Any:  # pylint: disable=too-many-return-statements
    """
    Serialize a value to a Python native type.

    :param value: The value to serialize.
    :type value: Any
    :return: The serialized object.
    :rtype: Any
    """
    if value is None:
        return None
    if isinstance(value, list):
        return [_serialize(item) for item in value]
    if isinstance(value, dict):
        new_dict = {}
        for dict_key, dict_value in value.items():
            new_dict[_serialize(dict_key)] = _serialize(dict_value)
        return new_dict
    if isinstance(value, datetime):
        return from_datetime(value)
    if hasattr(value, 'to_dict'):
        return value.to_dict()
    if hasattr(value, 'to_string'):
        return value.to_string()
    if hasattr(value, 'to_list'):
        return value.to_list()
    return value


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes,too-many-arguments,too-many-locals,useless-object-inheritance


#
# TraceLogger service
#


class LogType:  # pylint: disable=too-few-public-methods
    """
    LogType normal enum.
    """
    LOG = 0
    ERROR = 1
    INFO = 2
    _INT_TO_STRING = {
        0: 'LOG',
        1: 'ERROR',
        2: 'INFO'
    }
    _STRING_TO_INT = {
        'LOG': 0,
        'ERROR': 1,
        'INFO': 2
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string: str) -> 'LogType':
        """
        Create a new instance of :class:`LogType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`LogType`.
        :rtype: LogType
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class LogEntry:
    """
    LogEntry custom data type.
    """
    def __init__(
            self,
            module_name_=None,
            timestamp_=None,
            trace_point_name_=None,
            text_=None,
            type_=None
        ) -> None:
        """
        :param module_name_: module_name
        :type module_name_: str
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param trace_point_name_: trace_point_name
        :type trace_point_name_: str
        :param text_: text
        :type text_: str
        :param type_: type
        :type type_: LogType
        """
        self.module_name = module_name_
        self.timestamp = timestamp_
        self.trace_point_name = trace_point_name_
        self.text = text_
        self.type = type_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'LogEntry':
        """
        Create a new instance of :class:`LogEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`LogEntry`.
        :rtype: LogEntry
        """
        module_name_ = _deserialize(body_dict.get('moduleName'), 'str')
        timestamp_ = _deserialize(body_dict.get('timestamp'), 'datetime')
        trace_point_name_ = _deserialize(body_dict.get('tracePointName'), 'str')
        text_ = _deserialize(body_dict.get('text'), 'str')
        type_ = _deserialize(body_dict.get('type'), 'LogType')
        return cls(
            module_name_=module_name_,
            timestamp_=timestamp_,
            trace_point_name_=trace_point_name_,
            text_=text_,
            type_=type_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'LogEntry':
        """
        Create a new instance of :class:`LogEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`LogEntry`.
        :rtype: LogEntry
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'LogEntry':
        """
        Create a new instance of :class:`LogEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`LogEntry`.
        :rtype: LogEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        module_name_ = _serialize(self.module_name)
        timestamp_ = _serialize(self.timestamp)
        trace_point_name_ = _serialize(self.trace_point_name)
        text_ = _serialize(self.text)
        type_ = _serialize(self.type)
        return {
            'moduleName': module_name_,
            'timestamp': timestamp_,
            'tracePointName': trace_point_name_,
            'text': text_,
            'type': type_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TracePointSetting:
    """
    TracePointSetting custom data type.
    """
    def __init__(
            self,
            name_=None,
            enabled_=None,
            exceptions_=None,
            times_=None
        ) -> None:
        """
        :param name_: name
        :type name_: str
        :param enabled_: enabled
        :type enabled_: bool
        :param exceptions_: exceptions
        :type exceptions_: List[str]
        :param times_: times
        :type times_: str
        """
        self.name = name_
        self.enabled = enabled_
        self.exceptions = exceptions_
        self.times = times_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TracePointSetting':
        """
        Create a new instance of :class:`TracePointSetting` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TracePointSetting`.
        :rtype: TracePointSetting
        """
        name_ = _deserialize(body_dict.get('name'), 'str')
        enabled_ = _deserialize(body_dict.get('enabled'), 'bool')
        exceptions_ = _deserialize(body_dict.get('exceptions'), 'List[str]')
        times_ = _deserialize(body_dict.get('times'), 'str')
        return cls(
            name_=name_,
            enabled_=enabled_,
            exceptions_=exceptions_,
            times_=times_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TracePointSetting':
        """
        Create a new instance of :class:`TracePointSetting` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TracePointSetting`.
        :rtype: TracePointSetting
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TracePointSetting':
        """
        Create a new instance of :class:`TracePointSetting` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TracePointSetting`.
        :rtype: TracePointSetting
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        name_ = _serialize(self.name)
        enabled_ = _serialize(self.enabled)
        exceptions_ = _serialize(self.exceptions)
        times_ = _serialize(self.times)
        return {
            'name': name_,
            'enabled': enabled_,
            'exceptions': exceptions_,
            'times': times_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TraceLoggerStoreEntriesRoutedMessage(RoutedMessage):
    """
    TraceLoggerStoreEntriesRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TraceLoggerStoreEntriesRoutedMessage'

    def __init__(
            self,
            entries_=None
        ) -> None:
        """
        :param entries_: entries
        :type entries_: List[LogEntry]
        """
        self.entries = entries_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TraceLogger', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerStoreEntriesRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerStoreEntriesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerStoreEntriesRoutedMessage`.
        :rtype: TraceLoggerStoreEntriesRoutedMessage
        """
        entries_ = _deserialize(body_dict.get('entries'), 'List[LogEntry]')
        return cls(
            entries_=entries_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerStoreEntriesRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerStoreEntriesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerStoreEntriesRoutedMessage`.
        :rtype: TraceLoggerStoreEntriesRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerStoreEntriesRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerStoreEntriesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerStoreEntriesRoutedMessage`.
        :rtype: TraceLoggerStoreEntriesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerStoreEntriesRoutedMessage':
        """
        Create a new instance of :class`TraceLoggerStoreEntriesRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerStoreEntriesRoutedMessage`.
        :rtype: TraceLoggerStoreEntriesRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        entries_ = _serialize(self.entries)
        return {
            'entries': entries_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerStoreEntriesRoutedMessage does not support setting 'body_bytes'")


class TraceLoggerRegisterTracePointRoutedMessage(RoutedMessage):
    """
    TraceLoggerRegisterTracePointRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TraceLoggerRegisterTracePointRoutedMessage'

    def __init__(
            self,
            trace_point_name_=None
        ) -> None:
        """
        :param trace_point_name_: trace_point_name
        :type trace_point_name_: str
        """
        self.trace_point_name = trace_point_name_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TraceLogger', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerRegisterTracePointRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerRegisterTracePointRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerRegisterTracePointRoutedMessage`.
        :rtype: TraceLoggerRegisterTracePointRoutedMessage
        """
        trace_point_name_ = _deserialize(body_dict.get('tracePointName'), 'str')
        return cls(
            trace_point_name_=trace_point_name_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerRegisterTracePointRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerRegisterTracePointRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerRegisterTracePointRoutedMessage`.
        :rtype: TraceLoggerRegisterTracePointRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerRegisterTracePointRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerRegisterTracePointRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerRegisterTracePointRoutedMessage`.
        :rtype: TraceLoggerRegisterTracePointRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerRegisterTracePointRoutedMessage':
        """
        Create a new instance of :class`TraceLoggerRegisterTracePointRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerRegisterTracePointRoutedMessage`.
        :rtype: TraceLoggerRegisterTracePointRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        trace_point_name_ = _serialize(self.trace_point_name)
        return {
            'tracePointName': trace_point_name_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerRegisterTracePointRoutedMessage does not support setting 'body_bytes'")


class TraceLoggerTracePointListRequest(RequestMessage):
    """
    TraceLoggerTracePointListRequest JSON request message.
    """
    MESSAGE_NAME = 'TraceLoggerTracePointListRequest'

    def __init__(
            self
        ) -> None:
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TraceLogger', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerTracePointListRequest':  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TraceLoggerTracePointListRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerTracePointListRequest`.
        :rtype: TraceLoggerTracePointListRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerTracePointListRequest':
        """
        Create a new instance of :class:`TraceLoggerTracePointListRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerTracePointListRequest`.
        :rtype: TraceLoggerTracePointListRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerTracePointListRequest':
        """
        Create a new instance of :class:`TraceLoggerTracePointListRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerTracePointListRequest`.
        :rtype: TraceLoggerTracePointListRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerTracePointListRequest':
        """
        Create a new instance of :class`TraceLoggerTracePointListRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerTracePointListRequest`.
        :rtype: TraceLoggerTracePointListRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        return {
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerTracePointListRequest does not support setting 'body_bytes'")


class TraceLoggerTracePointListResponse(ResponseMessage):
    """
    TraceLoggerTracePointListResponse JSON response message.
    """
    MESSAGE_NAME = 'TraceLoggerTracePointListResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            settings_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param settings_: settings
        :type settings_: List[TracePointSetting]
        """
        self.settings = settings_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TraceLoggerTracePointListResponse':
        """
        Create a new instance of :class:`TraceLoggerTracePointListResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerTracePointListResponse`.
        :rtype: TraceLoggerTracePointListResponse
        """
        settings_ = _deserialize(body_dict.get('settings'), 'List[TracePointSetting]')
        return cls(
            request_message,
            settings_=settings_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TraceLoggerTracePointListResponse':
        """
        Create a new instance of :class:`TraceLoggerTracePointListResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerTracePointListResponse`.
        :rtype: TraceLoggerTracePointListResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TraceLoggerTracePointListResponse':
        """
        Create a new instance of :class:`TraceLoggerTracePointListResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerTracePointListResponse`.
        :rtype: TraceLoggerTracePointListResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerTracePointListResponse':
        """
        Create a new instance of :class`TraceLoggerTracePointListResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerTracePointListResponse`.
        :rtype: TraceLoggerTracePointListResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        settings_ = _serialize(self.settings)
        return {
            'settings': settings_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerTracePointListResponse does not support setting 'body_bytes'")


class TraceLoggerCommandRequest(RequestMessage):
    """
    TraceLoggerCommandRequest JSON request message.
    """
    MESSAGE_NAME = 'TraceLoggerCommandRequest'

    def __init__(
            self,
            arguments_=None
        ) -> None:
        """
        :param arguments_: arguments
        :type arguments_: List[str]
        """
        self.arguments = arguments_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TraceLogger', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerCommandRequest':
        """
        Create a new instance of :class:`TraceLoggerCommandRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerCommandRequest`.
        :rtype: TraceLoggerCommandRequest
        """
        arguments_ = _deserialize(body_dict.get('arguments'), 'List[str]')
        return cls(
            arguments_=arguments_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerCommandRequest':
        """
        Create a new instance of :class:`TraceLoggerCommandRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerCommandRequest`.
        :rtype: TraceLoggerCommandRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerCommandRequest':
        """
        Create a new instance of :class:`TraceLoggerCommandRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerCommandRequest`.
        :rtype: TraceLoggerCommandRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerCommandRequest':
        """
        Create a new instance of :class`TraceLoggerCommandRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerCommandRequest`.
        :rtype: TraceLoggerCommandRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        arguments_ = _serialize(self.arguments)
        return {
            'arguments': arguments_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerCommandRequest does not support setting 'body_bytes'")


class TraceLoggerCommandResponse(ResponseMessage):
    """
    TraceLoggerCommandResponse JSON response message.
    """
    MESSAGE_NAME = 'TraceLoggerCommandResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            response_text_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param response_text_: response_text
        :type response_text_: List[str]
        """
        self.response_text = response_text_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TraceLoggerCommandResponse':
        """
        Create a new instance of :class:`TraceLoggerCommandResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerCommandResponse`.
        :rtype: TraceLoggerCommandResponse
        """
        response_text_ = _deserialize(body_dict.get('responseText'), 'List[str]')
        return cls(
            request_message,
            response_text_=response_text_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TraceLoggerCommandResponse':
        """
        Create a new instance of :class:`TraceLoggerCommandResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerCommandResponse`.
        :rtype: TraceLoggerCommandResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TraceLoggerCommandResponse':
        """
        Create a new instance of :class:`TraceLoggerCommandResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerCommandResponse`.
        :rtype: TraceLoggerCommandResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerCommandResponse':
        """
        Create a new instance of :class`TraceLoggerCommandResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerCommandResponse`.
        :rtype: TraceLoggerCommandResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        response_text_ = _serialize(self.response_text)
        return {
            'responseText': response_text_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerCommandResponse does not support setting 'body_bytes'")


class TraceLoggerBroadcastTracePointsRoutedMessage(RoutedMessage):
    """
    TraceLoggerBroadcastTracePointsRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TraceLoggerBroadcastTracePointsRoutedMessage'

    def __init__(
            self
        ) -> None:
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TraceLogger', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerBroadcastTracePointsRoutedMessage':  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TraceLoggerBroadcastTracePointsRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerBroadcastTracePointsRoutedMessage`.
        :rtype: TraceLoggerBroadcastTracePointsRoutedMessage
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerBroadcastTracePointsRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerBroadcastTracePointsRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerBroadcastTracePointsRoutedMessage`.
        :rtype: TraceLoggerBroadcastTracePointsRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerBroadcastTracePointsRoutedMessage':
        """
        Create a new instance of :class:`TraceLoggerBroadcastTracePointsRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerBroadcastTracePointsRoutedMessage`.
        :rtype: TraceLoggerBroadcastTracePointsRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerBroadcastTracePointsRoutedMessage':
        """
        Create a new instance of :class`TraceLoggerBroadcastTracePointsRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerBroadcastTracePointsRoutedMessage`.
        :rtype: TraceLoggerBroadcastTracePointsRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        return {
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerBroadcastTracePointsRoutedMessage does not support setting 'body_bytes'")


class TraceLoggerSnapshotBroadcast(BroadcastMessage):
    """
    TraceLoggerSnapshotBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TraceLoggerSnapshotBroadcast'

    def __init__(
            self,
            settings_=None
        ) -> None:
        """
        :param settings_: settings
        :type settings_: List[TracePointSetting]
        """
        self.settings = settings_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerSnapshotBroadcast':
        """
        Create a new instance of :class:`TraceLoggerSnapshotBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerSnapshotBroadcast`.
        :rtype: TraceLoggerSnapshotBroadcast
        """
        settings_ = _deserialize(body_dict.get('settings'), 'List[TracePointSetting]')
        return cls(
            settings_=settings_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerSnapshotBroadcast':
        """
        Create a new instance of :class:`TraceLoggerSnapshotBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerSnapshotBroadcast`.
        :rtype: TraceLoggerSnapshotBroadcast
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerSnapshotBroadcast':
        """
        Create a new instance of :class:`TraceLoggerSnapshotBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerSnapshotBroadcast`.
        :rtype: TraceLoggerSnapshotBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerSnapshotBroadcast':
        """
        Create a new instance of :class`TraceLoggerSnapshotBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerSnapshotBroadcast`.
        :rtype: TraceLoggerSnapshotBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        settings_ = _serialize(self.settings)
        return {
            'settings': settings_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerSnapshotBroadcast does not support setting 'body_bytes'")


class TraceLoggerGetIsCeipEnabledRequest(RequestMessage):
    """
    TraceLoggerGetIsCeipEnabledRequest JSON request message.
    """
    MESSAGE_NAME = 'TraceLoggerGetIsCeipEnabledRequest'

    def __init__(
            self
        ) -> None:
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TraceLogger', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TraceLoggerGetIsCeipEnabledRequest':  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TraceLoggerGetIsCeipEnabledRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerGetIsCeipEnabledRequest`.
        :rtype: TraceLoggerGetIsCeipEnabledRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TraceLoggerGetIsCeipEnabledRequest':
        """
        Create a new instance of :class:`TraceLoggerGetIsCeipEnabledRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerGetIsCeipEnabledRequest`.
        :rtype: TraceLoggerGetIsCeipEnabledRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TraceLoggerGetIsCeipEnabledRequest':
        """
        Create a new instance of :class:`TraceLoggerGetIsCeipEnabledRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerGetIsCeipEnabledRequest`.
        :rtype: TraceLoggerGetIsCeipEnabledRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerGetIsCeipEnabledRequest':
        """
        Create a new instance of :class`TraceLoggerGetIsCeipEnabledRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerGetIsCeipEnabledRequest`.
        :rtype: TraceLoggerGetIsCeipEnabledRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        return {
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerGetIsCeipEnabledRequest does not support setting 'body_bytes'")


class TraceLoggerGetIsCeipEnabledResponse(ResponseMessage):
    """
    TraceLoggerGetIsCeipEnabledResponse JSON response message.
    """
    MESSAGE_NAME = 'TraceLoggerGetIsCeipEnabledResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            enabled_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param enabled_: enabled
        :type enabled_: bool
        """
        self.enabled = enabled_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TraceLoggerGetIsCeipEnabledResponse':
        """
        Create a new instance of :class:`TraceLoggerGetIsCeipEnabledResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TraceLoggerGetIsCeipEnabledResponse`.
        :rtype: TraceLoggerGetIsCeipEnabledResponse
        """
        enabled_ = _deserialize(body_dict.get('enabled'), 'bool')
        return cls(
            request_message,
            enabled_=enabled_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TraceLoggerGetIsCeipEnabledResponse':
        """
        Create a new instance of :class:`TraceLoggerGetIsCeipEnabledResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TraceLoggerGetIsCeipEnabledResponse`.
        :rtype: TraceLoggerGetIsCeipEnabledResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TraceLoggerGetIsCeipEnabledResponse':
        """
        Create a new instance of :class:`TraceLoggerGetIsCeipEnabledResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TraceLoggerGetIsCeipEnabledResponse`.
        :rtype: TraceLoggerGetIsCeipEnabledResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TraceLoggerGetIsCeipEnabledResponse':
        """
        Create a new instance of :class`TraceLoggerGetIsCeipEnabledResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TraceLoggerGetIsCeipEnabledResponse`.
        :rtype: TraceLoggerGetIsCeipEnabledResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        enabled_ = _serialize(self.enabled)
        return {
            'enabled': enabled_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TraceLoggerGetIsCeipEnabledResponse does not support setting 'body_bytes'")
