# -*- coding: utf-8 -*-
# DO NOT EDIT! This file is auto-generated.
"""
Classes for SystemLink Message Bus usage.
"""
# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import
from typing import cast, Any, Dict, List, Optional, Union  # pylint: disable=unused-import

# Import local libs
from systemlink.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from systemlink.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from systemlink.messagebus.generic_message import GenericMessage  # pylint: disable=unused-import
from systemlink.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from systemlink.messagebus.message_base import MessageBase
from systemlink.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from systemlink.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from systemlink.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import

_PASS_THROUGH_TYPES = {
    'bool',
    'bytes',
    'float',
    'int',
    'object',
    'str'
}

_PRIMITIVE_TYPES = {
    'bool': bool,
    'bytes': bytes,
    'datetime': datetime,
    'dict': dict,
    'float': float,
    'int': int,
    'list': list,
    'object': object,
    'str': str
}


def _str_to_type(type_name: str) -> type:
    """
    Convert a type name to a type.

    :param type_name: The name of the type.
    :type type_name: str
    :return: The corresponding type.
    :rtype: type
    """
    type_ = _PRIMITIVE_TYPES.get(type_name)
    if type_ is not None:
        return type_
    return getattr(sys.modules[__name__], type_name)


def _deserialize(value: Any, type_name: str) -> Any:  # pylint: disable=too-many-return-statements,too-many-branches
    """
    Deserialize a value from a Python native type.

    :param value: The value to deserialize.
    :type value: Any
    :param type_name: The name of the type of `value``.
    :type type_name: str
    :return: The deserialized object.
    :rtype: Any
    """
    if value is None:
        return None
    if not type_name:
        return value
    if type_name.endswith(']'):
        sep_index = type_name.find('[')
        sub_type_name = type_name[sep_index+1:-1]
        type_name = type_name[:sep_index]
        if type_name in ('list', 'List'):
            if sub_type_name in _PASS_THROUGH_TYPES:
                return value
            return [_deserialize(item, sub_type_name) for item in value]
        assert type_name in ('dict', 'Dict')
        sep_index = sub_type_name.find(',')
        key_type_name = sub_type_name[:sep_index]
        value_type_name = sub_type_name[sep_index+1:].strip()
        if key_type_name in _PASS_THROUGH_TYPES and value_type_name in _PASS_THROUGH_TYPES:
            return value
        new_dict = {}
        for dict_key, dict_value in value.items():
            new_dict[_deserialize(dict_key, key_type_name)] = _deserialize(
                dict_value, value_type_name
            )
        return new_dict
    if type_name in _PASS_THROUGH_TYPES:
        return value
    type_ = _str_to_type(type_name)
    if type_ == datetime:
        if not isinstance(value, datetime):
            return to_datetime(value)
        return value
    if hasattr(type_, 'from_dict'):
        return type_.from_dict(value)  # type: ignore
    if hasattr(type_, 'from_string'):
        if isinstance(value, int):
            return type_(value)
        return type_.from_string(value)  # type: ignore
    if hasattr(type_, 'from_list'):
        if isinstance(value, int):
            return type_(value)
        return type_.from_list(value)  # type: ignore
    return value


def _serialize(value: Any) -> Any:  # pylint: disable=too-many-return-statements
    """
    Serialize a value to a Python native type.

    :param value: The value to serialize.
    :type value: Any
    :return: The serialized object.
    :rtype: Any
    """
    if value is None:
        return None
    if isinstance(value, list):
        return [_serialize(item) for item in value]
    if isinstance(value, dict):
        new_dict = {}
        for dict_key, dict_value in value.items():
            new_dict[_serialize(dict_key)] = _serialize(dict_value)
        return new_dict
    if isinstance(value, datetime):
        return from_datetime(value)
    if hasattr(value, 'to_dict'):
        return value.to_dict()
    if hasattr(value, 'to_string'):
        return value.to_string()
    if hasattr(value, 'to_list'):
        return value.to_list()
    return value


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes,too-many-arguments,too-many-locals,useless-object-inheritance


#
# TagMessageObjects namespace
#


class DataType:  # pylint: disable=too-few-public-methods
    """
    DataType normal enum.
    """
    NONE = 0
    DOUBLE = 1
    INT = 2
    STRING = 3
    BOOLEAN = 4
    U_INT64 = 5
    DATE_TIME = 6
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'DOUBLE',
        2: 'INT',
        3: 'STRING',
        4: 'BOOLEAN',
        5: 'U_INT64',
        6: 'DATE_TIME'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'DOUBLE': 1,
        'INT': 2,
        'STRING': 3,
        'BOOLEAN': 4,
        'U_INT64': 5,
        'DATE_TIME': 6
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string: str) -> 'DataType':
        """
        Create a new instance of :class:`DataType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`DataType`.
        :rtype: DataType
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class Aggregation:  # pylint: disable=too-few-public-methods
    """
    Aggregation normal enum.
    """
    NONE = 0
    ENABLE = 1
    DISABLE = 2
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'ENABLE',
        2: 'DISABLE'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'ENABLE': 1,
        'DISABLE': 2
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string: str) -> 'Aggregation':
        """
        Create a new instance of :class:`Aggregation` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`Aggregation`.
        :rtype: Aggregation
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class RetentionType:  # pylint: disable=too-few-public-methods
    """
    RetentionType normal enum.
    """
    NONE = 0
    DURATION = 1
    COUNT = 2
    PERMANENT = 3
    _INT_TO_STRING = {
        0: 'NONE',
        1: 'DURATION',
        2: 'COUNT',
        3: 'PERMANENT'
    }
    _STRING_TO_INT = {
        'NONE': 0,
        'DURATION': 1,
        'COUNT': 2,
        'PERMANENT': 3
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string: str) -> 'RetentionType':
        """
        Create a new instance of :class:`RetentionType` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`RetentionType`.
        :rtype: RetentionType
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class TagFields:  # pylint: disable=too-few-public-methods
    """
    TagFields flags enum.
    """
    KEYWORDS = 1
    PROPERTIES = 2
    COLLECT_AGGREGATES = 4
    _INT_TO_STRING = {
        1: 'KEYWORDS',
        2: 'PROPERTIES',
        4: 'COLLECT_AGGREGATES'
    }
    _STRING_TO_INT = {
        'KEYWORDS': 1,
        'PROPERTIES': 2,
        'COLLECT_AGGREGATES': 4
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_list(cls, value_list: List[str]) -> 'TagFields':
        """
        Create a new instance of :class:`TagFields` using a list.

        :param value_list: A list of string values for the enum.
        :type value_list: List[str]
        :return: A new instance of :class:`TagFields`.
        :rtype: TagFields
        """
        value = 0
        for value_string in value_list:
            value = value | cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_list(self) -> List[str]:
        """
        Returns a list of strings representing the enum.

        :return: A list of strings representing the enum.
        :rtype: List[str]
        """
        value_list = []  # type: List[str]
        for value_int, value_string in self._INT_TO_STRING.items():
            if self._value & value_int:
                value_list.append(value_string)
        if not value_list and 0 in self._INT_TO_STRING:
            value_list.append(self._INT_TO_STRING[0])
        return value_list


class SortOrder:  # pylint: disable=too-few-public-methods
    """
    SortOrder normal enum.
    """
    ASCENDING = 0
    DESCENDING = 1
    _INT_TO_STRING = {
        0: 'ASCENDING',
        1: 'DESCENDING'
    }
    _STRING_TO_INT = {
        'ASCENDING': 0,
        'DESCENDING': 1
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string: str) -> 'SortOrder':
        """
        Create a new instance of :class:`SortOrder` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`SortOrder`.
        :rtype: SortOrder
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class Tag:
    """
    Tag custom data type.
    """
    def __init__(
            self,
            path_=None,
            type_=None,
            properties_=None,
            keywords_=None,
            collect_aggregates_=None,
            workspace_=None
        ) -> None:
        """
        :param path_: path
        :type path_: str
        :param type_: type
        :type type_: DataType
        :param properties_: properties
        :type properties_: Dict[str, str]
        :param keywords_: keywords
        :type keywords_: List[str]
        :param collect_aggregates_: collect_aggregates
        :type collect_aggregates_: bool
        :param workspace_: workspace
        :type workspace_: str
        """
        self.path = path_
        self.type = type_
        self.properties = properties_
        self.keywords = keywords_
        self.collect_aggregates = collect_aggregates_
        self.workspace = workspace_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'Tag':
        """
        Create a new instance of :class:`Tag` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        type_ = _deserialize(body_dict.get('type'), 'DataType')
        properties_ = _deserialize(body_dict.get('properties'), 'Dict[str, str]')
        keywords_ = _deserialize(body_dict.get('keywords'), 'List[str]')
        collect_aggregates_ = _deserialize(body_dict.get('collectAggregates'), 'bool')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            path_=path_,
            type_=type_,
            properties_=properties_,
            keywords_=keywords_,
            collect_aggregates_=collect_aggregates_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'Tag':
        """
        Create a new instance of :class:`Tag` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'Tag':
        """
        Create a new instance of :class:`Tag` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`Tag`.
        :rtype: Tag
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        path_ = _serialize(self.path)
        type_ = _serialize(self.type)
        properties_ = _serialize(self.properties)
        keywords_ = _serialize(self.keywords)
        collect_aggregates_ = _serialize(self.collect_aggregates)
        workspace_ = _serialize(self.workspace)
        return {
            'path': path_,
            'type': type_,
            'properties': properties_,
            'keywords': keywords_,
            'collectAggregates': collect_aggregates_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class PartialTagInfo:
    """
    PartialTagInfo custom data type.
    """
    def __init__(
            self,
            tag_=None,
            changes_=None
        ) -> None:
        """
        :param tag_: tag
        :type tag_: Tag
        :param changes_: changes
        :type changes_: TagFields
        """
        self.tag = tag_
        self.changes = changes_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'PartialTagInfo':
        """
        Create a new instance of :class:`PartialTagInfo` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        tag_ = _deserialize(body_dict.get('tag'), 'Tag')
        changes_ = _deserialize(body_dict.get('changes'), 'TagFields')
        return cls(
            tag_=tag_,
            changes_=changes_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'PartialTagInfo':
        """
        Create a new instance of :class:`PartialTagInfo` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'PartialTagInfo':
        """
        Create a new instance of :class:`PartialTagInfo` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`PartialTagInfo`.
        :rtype: PartialTagInfo
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        tag_ = _serialize(self.tag)
        changes_ = _serialize(self.changes)
        return {
            'tag': tag_,
            'changes': changes_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TypedValue:
    """
    TypedValue custom data type.
    """
    def __init__(
            self,
            type_=None,
            value_=None
        ) -> None:
        """
        :param type_: type
        :type type_: DataType
        :param value_: value
        :type value_: str
        """
        self.type = type_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TypedValue':
        """
        Create a new instance of :class:`TypedValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        type_ = _deserialize(body_dict.get('type'), 'DataType')
        value_ = _deserialize(body_dict.get('value'), 'str')
        return cls(
            type_=type_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TypedValue':
        """
        Create a new instance of :class:`TypedValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TypedValue':
        """
        Create a new instance of :class:`TypedValue` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TypedValue`.
        :rtype: TypedValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        type_ = _serialize(self.type)
        value_ = _serialize(self.value)
        return {
            'type': type_,
            'value': value_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TimestampedValue:
    """
    TimestampedValue custom data type.
    """
    def __init__(
            self,
            timestamp_=None,
            value_=None
        ) -> None:
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param value_: value
        :type value_: TypedValue
        """
        self.timestamp = timestamp_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TimestampedValue':
        """
        Create a new instance of :class:`TimestampedValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        timestamp_ = _deserialize(body_dict.get('timestamp'), 'datetime')
        value_ = _deserialize(body_dict.get('value'), 'TypedValue')
        return cls(
            timestamp_=timestamp_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TimestampedValue':
        """
        Create a new instance of :class:`TimestampedValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TimestampedValue':
        """
        Create a new instance of :class:`TimestampedValue` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TimestampedValue`.
        :rtype: TimestampedValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        timestamp_ = _serialize(self.timestamp)
        value_ = _serialize(self.value)
        return {
            'timestamp': timestamp_,
            'value': value_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class Update:
    """
    Update custom data type.
    """
    def __init__(
            self,
            path_=None,
            updates_=None,
            workspace_=None
        ) -> None:
        """
        :param path_: path
        :type path_: str
        :param updates_: updates
        :type updates_: List[TimestampedValue]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.path = path_
        self.updates = updates_
        self.workspace = workspace_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'Update':
        """
        Create a new instance of :class:`Update` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        updates_ = _deserialize(body_dict.get('updates'), 'List[TimestampedValue]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            path_=path_,
            updates_=updates_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'Update':
        """
        Create a new instance of :class:`Update` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'Update':
        """
        Create a new instance of :class:`Update` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`Update`.
        :rtype: Update
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        path_ = _serialize(self.path)
        updates_ = _serialize(self.updates)
        workspace_ = _serialize(self.workspace)
        return {
            'path': path_,
            'updates': updates_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class AggregateValue:
    """
    AggregateValue custom data type.
    """
    def __init__(
            self,
            count_=None,
            avg_=None,
            min_=None,
            max_=None
        ) -> None:
        """
        :param count_: count
        :type count_: int
        :param avg_: avg
        :type avg_: float
        :param min_: min
        :type min_: str
        :param max_: max
        :type max_: str
        """
        self.count = count_
        self.avg = avg_
        self.min = min_
        self.max = max_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'AggregateValue':
        """
        Create a new instance of :class:`AggregateValue` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        count_ = _deserialize(body_dict.get('count'), 'int')
        avg_ = _deserialize(body_dict.get('avg'), 'float')
        min_ = _deserialize(body_dict.get('min'), 'str')
        max_ = _deserialize(body_dict.get('max'), 'str')
        return cls(
            count_=count_,
            avg_=avg_,
            min_=min_,
            max_=max_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'AggregateValue':
        """
        Create a new instance of :class:`AggregateValue` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'AggregateValue':
        """
        Create a new instance of :class:`AggregateValue` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`AggregateValue`.
        :rtype: AggregateValue
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        count_ = _serialize(self.count)
        avg_ = _serialize(self.avg)
        min_ = _serialize(self.min)
        max_ = _serialize(self.max)
        return {
            'count': count_,
            'avg': avg_,
            'min': min_,
            'max': max_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class CurrentValues:
    """
    CurrentValues custom data type.
    """
    def __init__(
            self,
            path_=None,
            current_=None,
            aggregates_=None,
            workspace_=None
        ) -> None:
        """
        :param path_: path
        :type path_: str
        :param current_: current
        :type current_: TimestampedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        :param workspace_: workspace
        :type workspace_: str
        """
        self.path = path_
        self.current = current_
        self.aggregates = aggregates_
        self.workspace = workspace_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'CurrentValues':
        """
        Create a new instance of :class:`CurrentValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        current_ = _deserialize(body_dict.get('current'), 'TimestampedValue')
        aggregates_ = _deserialize(body_dict.get('aggregates'), 'AggregateValue')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            path_=path_,
            current_=current_,
            aggregates_=aggregates_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'CurrentValues':
        """
        Create a new instance of :class:`CurrentValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'CurrentValues':
        """
        Create a new instance of :class:`CurrentValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`CurrentValues`.
        :rtype: CurrentValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        path_ = _serialize(self.path)
        current_ = _serialize(self.current)
        aggregates_ = _serialize(self.aggregates)
        workspace_ = _serialize(self.workspace)
        return {
            'path': path_,
            'current': current_,
            'aggregates': aggregates_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TimestampedValueWithAggregate:
    """
    TimestampedValueWithAggregate custom data type.
    """
    def __init__(
            self,
            timestamp_=None,
            value_=None,
            aggregates_=None
        ) -> None:
        """
        :param timestamp_: timestamp
        :type timestamp_: datetime
        :param value_: value
        :type value_: TypedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.timestamp = timestamp_
        self.value = value_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TimestampedValueWithAggregate':
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        timestamp_ = _deserialize(body_dict.get('timestamp'), 'datetime')
        value_ = _deserialize(body_dict.get('value'), 'TypedValue')
        aggregates_ = _deserialize(body_dict.get('aggregates'), 'AggregateValue')
        return cls(
            timestamp_=timestamp_,
            value_=value_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TimestampedValueWithAggregate':
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TimestampedValueWithAggregate':
        """
        Create a new instance of :class:`TimestampedValueWithAggregate` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TimestampedValueWithAggregate`.
        :rtype: TimestampedValueWithAggregate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        timestamp_ = _serialize(self.timestamp)
        value_ = _serialize(self.value)
        aggregates_ = _serialize(self.aggregates)
        return {
            'timestamp': timestamp_,
            'value': value_,
            'aggregates': aggregates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class UpdateWithAggregates:
    """
    UpdateWithAggregates custom data type.
    """
    def __init__(
            self,
            path_=None,
            updates_=None,
            workspace_=None
        ) -> None:
        """
        :param path_: path
        :type path_: str
        :param updates_: updates
        :type updates_: List[TimestampedValueWithAggregate]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.path = path_
        self.updates = updates_
        self.workspace = workspace_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'UpdateWithAggregates':
        """
        Create a new instance of :class:`UpdateWithAggregates` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        updates_ = _deserialize(body_dict.get('updates'), 'List[TimestampedValueWithAggregate]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            path_=path_,
            updates_=updates_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'UpdateWithAggregates':
        """
        Create a new instance of :class:`UpdateWithAggregates` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'UpdateWithAggregates':
        """
        Create a new instance of :class:`UpdateWithAggregates` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`UpdateWithAggregates`.
        :rtype: UpdateWithAggregates
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        path_ = _serialize(self.path)
        updates_ = _serialize(self.updates)
        workspace_ = _serialize(self.workspace)
        return {
            'path': path_,
            'updates': updates_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class UpdateWithAggregatesAndMetadata:
    """
    UpdateWithAggregatesAndMetadata custom data type.
    """
    def __init__(
            self,
            tag_=None,
            updates_=None
        ) -> None:
        """
        :param tag_: tag
        :type tag_: Tag
        :param updates_: updates
        :type updates_: List[TimestampedValueWithAggregate]
        """
        self.tag = tag_
        self.updates = updates_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'UpdateWithAggregatesAndMetadata':
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        tag_ = _deserialize(body_dict.get('tag'), 'Tag')
        updates_ = _deserialize(body_dict.get('updates'), 'List[TimestampedValueWithAggregate]')
        return cls(
            tag_=tag_,
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'UpdateWithAggregatesAndMetadata':
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'UpdateWithAggregatesAndMetadata':
        """
        Create a new instance of :class:`UpdateWithAggregatesAndMetadata` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`UpdateWithAggregatesAndMetadata`.
        :rtype: UpdateWithAggregatesAndMetadata
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        tag_ = _serialize(self.tag)
        updates_ = _serialize(self.updates)
        return {
            'tag': tag_,
            'updates': updates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TagWithValues:
    """
    TagWithValues custom data type.
    """
    def __init__(
            self,
            tag_=None,
            current_=None,
            aggregates_=None
        ) -> None:
        """
        :param tag_: tag
        :type tag_: Tag
        :param current_: current
        :type current_: TimestampedValue
        :param aggregates_: aggregates
        :type aggregates_: AggregateValue
        """
        self.tag = tag_
        self.current = current_
        self.aggregates = aggregates_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagWithValues':
        """
        Create a new instance of :class:`TagWithValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        tag_ = _deserialize(body_dict.get('tag'), 'Tag')
        current_ = _deserialize(body_dict.get('current'), 'TimestampedValue')
        aggregates_ = _deserialize(body_dict.get('aggregates'), 'AggregateValue')
        return cls(
            tag_=tag_,
            current_=current_,
            aggregates_=aggregates_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagWithValues':
        """
        Create a new instance of :class:`TagWithValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagWithValues':
        """
        Create a new instance of :class:`TagWithValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagWithValues`.
        :rtype: TagWithValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        tag_ = _serialize(self.tag)
        current_ = _serialize(self.current)
        aggregates_ = _serialize(self.aggregates)
        return {
            'tag': tag_,
            'current': current_,
            'aggregates': aggregates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class Selection:
    """
    Selection custom data type.
    """
    def __init__(
            self,
            id_=None,
            search_paths_=None,
            inactivity_timeout_=None,
            workspace_=None,
            owner_=None
        ) -> None:
        """
        :param id_: id
        :type id_: str
        :param search_paths_: search_paths
        :type search_paths_: List[str]
        :param inactivity_timeout_: inactivity_timeout
        :type inactivity_timeout_: int
        :param workspace_: workspace
        :type workspace_: str
        :param owner_: owner
        :type owner_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        self.search_paths = search_paths_
        self.inactivity_timeout = inactivity_timeout_
        self.workspace = workspace_
        self.owner = owner_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'Selection':
        """
        Create a new instance of :class:`Selection` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        search_paths_ = _deserialize(body_dict.get('searchPaths'), 'List[str]')
        inactivity_timeout_ = _deserialize(body_dict.get('inactivityTimeout'), 'int')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        owner_ = _deserialize(body_dict.get('owner'), 'str')
        return cls(
            id_=id_,
            search_paths_=search_paths_,
            inactivity_timeout_=inactivity_timeout_,
            workspace_=workspace_,
            owner_=owner_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'Selection':
        """
        Create a new instance of :class:`Selection` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'Selection':
        """
        Create a new instance of :class:`Selection` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`Selection`.
        :rtype: Selection
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        search_paths_ = _serialize(self.search_paths)
        inactivity_timeout_ = _serialize(self.inactivity_timeout)
        workspace_ = _serialize(self.workspace)
        owner_ = _serialize(self.owner)
        return {
            'id': id_,
            'searchPaths': search_paths_,
            'inactivityTimeout': inactivity_timeout_,
            'workspace': workspace_,
            'owner': owner_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class NodeTagPath:
    """
    NodeTagPath custom data type.
    """
    def __init__(
            self,
            node_name_=None,
            tag_path_=None
        ) -> None:
        """
        :param node_name_: node_name
        :type node_name_: str
        :param tag_path_: tag_path
        :type tag_path_: str
        """
        self.node_name = node_name_
        self.tag_path = tag_path_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'NodeTagPath':
        """
        Create a new instance of :class:`NodeTagPath` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        node_name_ = _deserialize(body_dict.get('nodeName'), 'str')
        tag_path_ = _deserialize(body_dict.get('tagPath'), 'str')
        return cls(
            node_name_=node_name_,
            tag_path_=tag_path_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'NodeTagPath':
        """
        Create a new instance of :class:`NodeTagPath` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'NodeTagPath':
        """
        Create a new instance of :class:`NodeTagPath` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`NodeTagPath`.
        :rtype: NodeTagPath
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        node_name_ = _serialize(self.node_name)
        tag_path_ = _serialize(self.tag_path)
        return {
            'nodeName': node_name_,
            'tagPath': tag_path_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class SubscriptionValues:
    """
    SubscriptionValues custom data type.
    """
    def __init__(
            self,
            subscription_id_=None
        ) -> None:
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        """
        self.subscription_id = subscription_id_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'SubscriptionValues':
        """
        Create a new instance of :class:`SubscriptionValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        return cls(
            subscription_id_=subscription_id_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'SubscriptionValues':
        """
        Create a new instance of :class:`SubscriptionValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'SubscriptionValues':
        """
        Create a new instance of :class:`SubscriptionValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`SubscriptionValues`.
        :rtype: SubscriptionValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_id_ = _serialize(self.subscription_id)
        return {
            'subscriptionId': subscription_id_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class NodeCurrentValues:
    """
    NodeCurrentValues custom data type.
    """
    def __init__(
            self,
            node_name_=None,
            current_values_=None
        ) -> None:
        """
        :param node_name_: node_name
        :type node_name_: str
        :param current_values_: current_values
        :type current_values_: List[CurrentValues]
        """
        self.node_name = node_name_
        self.current_values = current_values_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'NodeCurrentValues':
        """
        Create a new instance of :class:`NodeCurrentValues` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        node_name_ = _deserialize(body_dict.get('nodeName'), 'str')
        current_values_ = _deserialize(body_dict.get('currentValues'), 'List[CurrentValues]')
        return cls(
            node_name_=node_name_,
            current_values_=current_values_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'NodeCurrentValues':
        """
        Create a new instance of :class:`NodeCurrentValues` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'NodeCurrentValues':
        """
        Create a new instance of :class:`NodeCurrentValues` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`NodeCurrentValues`.
        :rtype: NodeCurrentValues
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        node_name_ = _serialize(self.node_name)
        current_values_ = _serialize(self.current_values)
        return {
            'nodeName': node_name_,
            'currentValues': current_values_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class ErrorEntry:
    """
    ErrorEntry custom data type.
    """
    def __init__(
            self,
            name_=None,
            message_=None,
            args_=None,
            inner_errors_=None,
            resource_id_=None,
            resource_type_=None
        ) -> None:
        """
        :param name_: name
        :type name_: str
        :param message_: message
        :type message_: str
        :param args_: args
        :type args_: List[str]
        :param inner_errors_: inner_errors
        :type inner_errors_: List[ErrorEntry]
        :param resource_id_: resource_id
        :type resource_id_: str
        :param resource_type_: resource_type
        :type resource_type_: str
        """
        self.name = name_
        self.message = message_
        self.args = args_
        self.inner_errors = inner_errors_
        self.resource_id = resource_id_
        self.resource_type = resource_type_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'ErrorEntry':
        """
        Create a new instance of :class:`ErrorEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        name_ = _deserialize(body_dict.get('name'), 'str')
        message_ = _deserialize(body_dict.get('message'), 'str')
        args_ = _deserialize(body_dict.get('args'), 'List[str]')
        inner_errors_ = _deserialize(body_dict.get('innerErrors'), 'List[ErrorEntry]')
        resource_id_ = _deserialize(body_dict.get('resourceId'), 'str')
        resource_type_ = _deserialize(body_dict.get('resourceType'), 'str')
        return cls(
            name_=name_,
            message_=message_,
            args_=args_,
            inner_errors_=inner_errors_,
            resource_id_=resource_id_,
            resource_type_=resource_type_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'ErrorEntry':
        """
        Create a new instance of :class:`ErrorEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'ErrorEntry':
        """
        Create a new instance of :class:`ErrorEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`ErrorEntry`.
        :rtype: ErrorEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        name_ = _serialize(self.name)
        message_ = _serialize(self.message)
        args_ = _serialize(self.args)
        inner_errors_ = _serialize(self.inner_errors)
        resource_id_ = _serialize(self.resource_id)
        resource_type_ = _serialize(self.resource_type)
        return {
            'name': name_,
            'message': message_,
            'args': args_,
            'innerErrors': inner_errors_,
            'resourceId': resource_id_,
            'resourceType': resource_type_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


#
# TagIngestion service
#


class TagUpdateValuesRoutedMessage(RoutedMessage):
    """
    TagUpdateValuesRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagUpdateValuesRoutedMessage'

    def __init__(
            self,
            updates_=None
        ) -> None:
        """
        :param updates_: updates
        :type updates_: List[Update]
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagIngestion', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagUpdateValuesRoutedMessage':
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        updates_ = _deserialize(body_dict.get('updates'), 'List[Update]')
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagUpdateValuesRoutedMessage':
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagUpdateValuesRoutedMessage':
        """
        Create a new instance of :class:`TagUpdateValuesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagUpdateValuesRoutedMessage':
        """
        Create a new instance of :class`TagUpdateValuesRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagUpdateValuesRoutedMessage`.
        :rtype: TagUpdateValuesRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagUpdateValuesRoutedMessage does not support setting 'body_bytes'")


class TagNewTagsIngestedBroadcast(BroadcastMessage):
    """
    TagNewTagsIngestedBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagNewTagsIngestedBroadcast'

    def __init__(
            self,
            updates_=None
        ) -> None:
        """
        :param updates_: updates
        :type updates_: List[UpdateWithAggregatesAndMetadata]
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagNewTagsIngestedBroadcast':
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        updates_ = _deserialize(body_dict.get('updates'), 'List[UpdateWithAggregatesAndMetadata]')
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagNewTagsIngestedBroadcast':
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagNewTagsIngestedBroadcast':
        """
        Create a new instance of :class:`TagNewTagsIngestedBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagNewTagsIngestedBroadcast':
        """
        Create a new instance of :class`TagNewTagsIngestedBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagNewTagsIngestedBroadcast`.
        :rtype: TagNewTagsIngestedBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagNewTagsIngestedBroadcast does not support setting 'body_bytes'")


#
# TagCurrentValue service
#


class TagCvResetAggregatesRoutedMessage(RoutedMessage):
    """
    TagCvResetAggregatesRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagCvResetAggregatesRoutedMessage'

    def __init__(
            self,
            paths_=None,
            workspace_=None
        ) -> None:
        """
        :param paths_: paths
        :type paths_: List[str]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.paths = paths_
        self.workspace = workspace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagCurrentValue', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagCvResetAggregatesRoutedMessage':
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        paths_ = _deserialize(body_dict.get('paths'), 'List[str]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            paths_=paths_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagCvResetAggregatesRoutedMessage':
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagCvResetAggregatesRoutedMessage':
        """
        Create a new instance of :class:`TagCvResetAggregatesRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagCvResetAggregatesRoutedMessage':
        """
        Create a new instance of :class`TagCvResetAggregatesRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagCvResetAggregatesRoutedMessage`.
        :rtype: TagCvResetAggregatesRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        paths_ = _serialize(self.paths)
        workspace_ = _serialize(self.workspace)
        return {
            'paths': paths_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagCvResetAggregatesRoutedMessage does not support setting 'body_bytes'")


class TagCvAggregatesResetBroadcast(BroadcastMessage):
    """
    TagCvAggregatesResetBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagCvAggregatesResetBroadcast'

    def __init__(
            self,
            updates_=None
        ) -> None:
        """
        :param updates_: updates
        :type updates_: List[UpdateWithAggregates]
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagCvAggregatesResetBroadcast':
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        updates_ = _deserialize(body_dict.get('updates'), 'List[UpdateWithAggregates]')
        return cls(
            updates_=updates_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagCvAggregatesResetBroadcast':
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagCvAggregatesResetBroadcast':
        """
        Create a new instance of :class:`TagCvAggregatesResetBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagCvAggregatesResetBroadcast':
        """
        Create a new instance of :class`TagCvAggregatesResetBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagCvAggregatesResetBroadcast`.
        :rtype: TagCvAggregatesResetBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagCvAggregatesResetBroadcast does not support setting 'body_bytes'")


class TagCvQueryCurrentValuesByPathRequest(RequestMessage):
    """
    TagCvQueryCurrentValuesByPathRequest JSON request message.
    """
    MESSAGE_NAME = 'TagCvQueryCurrentValuesByPathRequest'

    def __init__(
            self,
            paths_=None,
            allow_stale_=None,
            workspace_=None
        ) -> None:
        """
        :param paths_: paths
        :type paths_: List[str]
        :param allow_stale_: allow_stale
        :type allow_stale_: bool
        :param workspace_: workspace
        :type workspace_: str
        """
        self.paths = paths_
        self.allow_stale = allow_stale_
        self.workspace = workspace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagCurrentValue', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagCvQueryCurrentValuesByPathRequest':
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        paths_ = _deserialize(body_dict.get('paths'), 'List[str]')
        allow_stale_ = _deserialize(body_dict.get('allowStale'), 'bool')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            paths_=paths_,
            allow_stale_=allow_stale_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagCvQueryCurrentValuesByPathRequest':
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagCvQueryCurrentValuesByPathRequest':
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagCvQueryCurrentValuesByPathRequest':
        """
        Create a new instance of :class`TagCvQueryCurrentValuesByPathRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagCvQueryCurrentValuesByPathRequest`.
        :rtype: TagCvQueryCurrentValuesByPathRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        paths_ = _serialize(self.paths)
        allow_stale_ = _serialize(self.allow_stale)
        workspace_ = _serialize(self.workspace)
        return {
            'paths': paths_,
            'allowStale': allow_stale_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagCvQueryCurrentValuesByPathRequest does not support setting 'body_bytes'")


class TagCvQueryCurrentValuesByPathResponse(ResponseMessage):
    """
    TagCvQueryCurrentValuesByPathResponse JSON response message.
    """
    MESSAGE_NAME = 'TagCvQueryCurrentValuesByPathResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            values_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param values_: values
        :type values_: List[CurrentValues]
        """
        self.values = values_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagCvQueryCurrentValuesByPathResponse':
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        values_ = _deserialize(body_dict.get('values'), 'List[CurrentValues]')
        return cls(
            request_message,
            values_=values_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagCvQueryCurrentValuesByPathResponse':
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagCvQueryCurrentValuesByPathResponse':
        """
        Create a new instance of :class:`TagCvQueryCurrentValuesByPathResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagCvQueryCurrentValuesByPathResponse':
        """
        Create a new instance of :class`TagCvQueryCurrentValuesByPathResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagCvQueryCurrentValuesByPathResponse`.
        :rtype: TagCvQueryCurrentValuesByPathResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        values_ = _serialize(self.values)
        return {
            'values': values_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagCvQueryCurrentValuesByPathResponse does not support setting 'body_bytes'")


#
# TagInfo service
#


class TagInfoCreateTagRoutedMessage(RoutedMessage):
    """
    TagInfoCreateTagRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagInfoCreateTagRoutedMessage'

    def __init__(
            self,
            new_tag_=None
        ) -> None:
        """
        :param new_tag_: new_tag
        :type new_tag_: Tag
        """
        self.new_tag = new_tag_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoCreateTagRoutedMessage':
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        new_tag_ = _deserialize(body_dict.get('newTag'), 'Tag')
        return cls(
            new_tag_=new_tag_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoCreateTagRoutedMessage':
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoCreateTagRoutedMessage':
        """
        Create a new instance of :class:`TagInfoCreateTagRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoCreateTagRoutedMessage':
        """
        Create a new instance of :class`TagInfoCreateTagRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoCreateTagRoutedMessage`.
        :rtype: TagInfoCreateTagRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        new_tag_ = _serialize(self.new_tag)
        return {
            'newTag': new_tag_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoCreateTagRoutedMessage does not support setting 'body_bytes'")


class TagInfoCreateOrUpdateTagsRequest(RequestMessage):
    """
    TagInfoCreateOrUpdateTagsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagInfoCreateOrUpdateTagsRequest'

    def __init__(
            self,
            tags_=None,
            merge_=None
        ) -> None:
        """
        :param tags_: tags
        :type tags_: List[PartialTagInfo]
        :param merge_: merge
        :type merge_: bool
        """
        self.tags = tags_
        self.merge = merge_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoCreateOrUpdateTagsRequest':
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        tags_ = _deserialize(body_dict.get('tags'), 'List[PartialTagInfo]')
        merge_ = _deserialize(body_dict.get('merge'), 'bool')
        return cls(
            tags_=tags_,
            merge_=merge_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoCreateOrUpdateTagsRequest':
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoCreateOrUpdateTagsRequest':
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoCreateOrUpdateTagsRequest':
        """
        Create a new instance of :class`TagInfoCreateOrUpdateTagsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoCreateOrUpdateTagsRequest`.
        :rtype: TagInfoCreateOrUpdateTagsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        tags_ = _serialize(self.tags)
        merge_ = _serialize(self.merge)
        return {
            'tags': tags_,
            'merge': merge_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoCreateOrUpdateTagsRequest does not support setting 'body_bytes'")


class TagInfoCreateOrUpdateTagsResponse(ResponseMessage):
    """
    TagInfoCreateOrUpdateTagsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagInfoCreateOrUpdateTagsResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            errors_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param errors_: errors
        :type errors_: ErrorEntry
        """
        self.errors = errors_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagInfoCreateOrUpdateTagsResponse':
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        errors_ = _deserialize(body_dict.get('errors'), 'ErrorEntry')
        return cls(
            request_message,
            errors_=errors_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagInfoCreateOrUpdateTagsResponse':
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagInfoCreateOrUpdateTagsResponse':
        """
        Create a new instance of :class:`TagInfoCreateOrUpdateTagsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoCreateOrUpdateTagsResponse':
        """
        Create a new instance of :class`TagInfoCreateOrUpdateTagsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoCreateOrUpdateTagsResponse`.
        :rtype: TagInfoCreateOrUpdateTagsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        errors_ = _serialize(self.errors)
        return {
            'errors': errors_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoCreateOrUpdateTagsResponse does not support setting 'body_bytes'")


class TagInfoUpdateTagRoutedMessage(RoutedMessage):
    """
    TagInfoUpdateTagRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagInfoUpdateTagRoutedMessage'

    def __init__(
            self,
            path_=None,
            keywords_=None,
            properties_=None,
            collect_aggregates_=None,
            replace_=None,
            workspace_=None
        ) -> None:
        """
        :param path_: path
        :type path_: str
        :param keywords_: keywords
        :type keywords_: List[str]
        :param properties_: properties
        :type properties_: Dict[str, str]
        :param collect_aggregates_: collect_aggregates
        :type collect_aggregates_: Aggregation
        :param replace_: replace
        :type replace_: bool
        :param workspace_: workspace
        :type workspace_: str
        """
        self.path = path_
        self.keywords = keywords_
        self.properties = properties_
        self.collect_aggregates = collect_aggregates_
        self.replace = replace_
        self.workspace = workspace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoUpdateTagRoutedMessage':
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        path_ = _deserialize(body_dict.get('path'), 'str')
        keywords_ = _deserialize(body_dict.get('keywords'), 'List[str]')
        properties_ = _deserialize(body_dict.get('properties'), 'Dict[str, str]')
        collect_aggregates_ = _deserialize(body_dict.get('collectAggregates'), 'Aggregation')
        replace_ = _deserialize(body_dict.get('replace'), 'bool')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            path_=path_,
            keywords_=keywords_,
            properties_=properties_,
            collect_aggregates_=collect_aggregates_,
            replace_=replace_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoUpdateTagRoutedMessage':
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoUpdateTagRoutedMessage':
        """
        Create a new instance of :class:`TagInfoUpdateTagRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoUpdateTagRoutedMessage':
        """
        Create a new instance of :class`TagInfoUpdateTagRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoUpdateTagRoutedMessage`.
        :rtype: TagInfoUpdateTagRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        path_ = _serialize(self.path)
        keywords_ = _serialize(self.keywords)
        properties_ = _serialize(self.properties)
        collect_aggregates_ = _serialize(self.collect_aggregates)
        replace_ = _serialize(self.replace)
        workspace_ = _serialize(self.workspace)
        return {
            'path': path_,
            'keywords': keywords_,
            'properties': properties_,
            'collectAggregates': collect_aggregates_,
            'replace': replace_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoUpdateTagRoutedMessage does not support setting 'body_bytes'")


class TagInfoDeleteTagsRoutedMessage(RoutedMessage):
    """
    TagInfoDeleteTagsRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagInfoDeleteTagsRoutedMessage'

    def __init__(
            self,
            paths_=None,
            workspace_=None
        ) -> None:
        """
        :param paths_: paths
        :type paths_: List[str]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.paths = paths_
        self.workspace = workspace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoDeleteTagsRoutedMessage':
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        paths_ = _deserialize(body_dict.get('paths'), 'List[str]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            paths_=paths_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoDeleteTagsRoutedMessage':
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoDeleteTagsRoutedMessage':
        """
        Create a new instance of :class:`TagInfoDeleteTagsRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoDeleteTagsRoutedMessage':
        """
        Create a new instance of :class`TagInfoDeleteTagsRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoDeleteTagsRoutedMessage`.
        :rtype: TagInfoDeleteTagsRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        paths_ = _serialize(self.paths)
        workspace_ = _serialize(self.workspace)
        return {
            'paths': paths_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoDeleteTagsRoutedMessage does not support setting 'body_bytes'")


class TagInfoQueryTagsRequest(RequestMessage):
    """
    TagInfoQueryTagsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagInfoQueryTagsRequest'

    def __init__(
            self,
            search_paths_=None,
            properties_=None,
            keywords_=None,
            skip_=None,
            take_=None,
            allow_stale_=None,
            workspaces_=None
        ) -> None:
        """
        :param search_paths_: search_paths
        :type search_paths_: List[str]
        :param properties_: properties
        :type properties_: Dict[str, str]
        :param keywords_: keywords
        :type keywords_: List[str]
        :param skip_: skip
        :type skip_: int
        :param take_: take
        :type take_: int
        :param allow_stale_: allow_stale
        :type allow_stale_: bool
        :param workspaces_: workspaces
        :type workspaces_: List[str]
        """
        self.search_paths = search_paths_
        self.properties = properties_
        self.keywords = keywords_
        self.skip = skip_
        self.take = take_
        self.allow_stale = allow_stale_
        self.workspaces = workspaces_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagInfo', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoQueryTagsRequest':
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        search_paths_ = _deserialize(body_dict.get('searchPaths'), 'List[str]')
        properties_ = _deserialize(body_dict.get('properties'), 'Dict[str, str]')
        keywords_ = _deserialize(body_dict.get('keywords'), 'List[str]')
        skip_ = _deserialize(body_dict.get('skip'), 'int')
        take_ = _deserialize(body_dict.get('take'), 'int')
        allow_stale_ = _deserialize(body_dict.get('allowStale'), 'bool')
        workspaces_ = _deserialize(body_dict.get('workspaces'), 'List[str]')
        return cls(
            search_paths_=search_paths_,
            properties_=properties_,
            keywords_=keywords_,
            skip_=skip_,
            take_=take_,
            allow_stale_=allow_stale_,
            workspaces_=workspaces_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoQueryTagsRequest':
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoQueryTagsRequest':
        """
        Create a new instance of :class:`TagInfoQueryTagsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoQueryTagsRequest':
        """
        Create a new instance of :class`TagInfoQueryTagsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoQueryTagsRequest`.
        :rtype: TagInfoQueryTagsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        search_paths_ = _serialize(self.search_paths)
        properties_ = _serialize(self.properties)
        keywords_ = _serialize(self.keywords)
        skip_ = _serialize(self.skip)
        take_ = _serialize(self.take)
        allow_stale_ = _serialize(self.allow_stale)
        workspaces_ = _serialize(self.workspaces)
        return {
            'searchPaths': search_paths_,
            'properties': properties_,
            'keywords': keywords_,
            'skip': skip_,
            'take': take_,
            'allowStale': allow_stale_,
            'workspaces': workspaces_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoQueryTagsRequest does not support setting 'body_bytes'")


class TagInfoQueryTagsResponse(ResponseMessage):
    """
    TagInfoQueryTagsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagInfoQueryTagsResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            tags_=None,
            total_count_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param tags_: tags
        :type tags_: List[Tag]
        :param total_count_: total_count
        :type total_count_: int
        """
        self.tags = tags_
        self.total_count = total_count_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagInfoQueryTagsResponse':
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        tags_ = _deserialize(body_dict.get('tags'), 'List[Tag]')
        total_count_ = _deserialize(body_dict.get('totalCount'), 'int')
        return cls(
            request_message,
            tags_=tags_,
            total_count_=total_count_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagInfoQueryTagsResponse':
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagInfoQueryTagsResponse':
        """
        Create a new instance of :class:`TagInfoQueryTagsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoQueryTagsResponse':
        """
        Create a new instance of :class`TagInfoQueryTagsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoQueryTagsResponse`.
        :rtype: TagInfoQueryTagsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        tags_ = _serialize(self.tags)
        total_count_ = _serialize(self.total_count)
        return {
            'tags': tags_,
            'totalCount': total_count_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoQueryTagsResponse does not support setting 'body_bytes'")


class TagInfoDeletedTagsBroadcast(BroadcastMessage):
    """
    TagInfoDeletedTagsBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagInfoDeletedTagsBroadcast'

    def __init__(
            self,
            tags_=None,
            workspace_=None
        ) -> None:
        """
        :param tags_: tags
        :type tags_: List[str]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.tags = tags_
        self.workspace = workspace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoDeletedTagsBroadcast':
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        tags_ = _deserialize(body_dict.get('tags'), 'List[str]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            tags_=tags_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoDeletedTagsBroadcast':
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoDeletedTagsBroadcast':
        """
        Create a new instance of :class:`TagInfoDeletedTagsBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoDeletedTagsBroadcast':
        """
        Create a new instance of :class`TagInfoDeletedTagsBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoDeletedTagsBroadcast`.
        :rtype: TagInfoDeletedTagsBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        tags_ = _serialize(self.tags)
        workspace_ = _serialize(self.workspace)
        return {
            'tags': tags_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoDeletedTagsBroadcast does not support setting 'body_bytes'")


class TagInfoTagMetadataUpdatedBroadcast(BroadcastMessage):
    """
    TagInfoTagMetadataUpdatedBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'TagInfoTagMetadataUpdatedBroadcast'

    def __init__(
            self,
            updated_tag_=None
        ) -> None:
        """
        :param updated_tag_: updated_tag
        :type updated_tag_: Tag
        """
        self.updated_tag = updated_tag_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagInfoTagMetadataUpdatedBroadcast':
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        updated_tag_ = _deserialize(body_dict.get('updatedTag'), 'Tag')
        return cls(
            updated_tag_=updated_tag_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagInfoTagMetadataUpdatedBroadcast':
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagInfoTagMetadataUpdatedBroadcast':
        """
        Create a new instance of :class:`TagInfoTagMetadataUpdatedBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagInfoTagMetadataUpdatedBroadcast':
        """
        Create a new instance of :class`TagInfoTagMetadataUpdatedBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagInfoTagMetadataUpdatedBroadcast`.
        :rtype: TagInfoTagMetadataUpdatedBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        updated_tag_ = _serialize(self.updated_tag)
        return {
            'updatedTag': updated_tag_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagInfoTagMetadataUpdatedBroadcast does not support setting 'body_bytes'")


#
# TagHttp service
#


class TagHttpGetSelectionsRequest(RequestMessage):
    """
    TagHttpGetSelectionsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionsRequest'

    def __init__(
            self
        ) -> None:
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagHttpGetSelectionsRequest':  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagHttpGetSelectionsRequest':
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagHttpGetSelectionsRequest':
        """
        Create a new instance of :class:`TagHttpGetSelectionsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpGetSelectionsRequest':
        """
        Create a new instance of :class`TagHttpGetSelectionsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpGetSelectionsRequest`.
        :rtype: TagHttpGetSelectionsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        return {
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpGetSelectionsRequest does not support setting 'body_bytes'")


class TagHttpGetSelectionsResponse(ResponseMessage):
    """
    TagHttpGetSelectionsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionsResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            selections_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param selections_: selections
        :type selections_: List[Selection]
        """
        self.selections = selections_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagHttpGetSelectionsResponse':
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        selections_ = _deserialize(body_dict.get('selections'), 'List[Selection]')
        return cls(
            request_message,
            selections_=selections_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagHttpGetSelectionsResponse':
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagHttpGetSelectionsResponse':
        """
        Create a new instance of :class:`TagHttpGetSelectionsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpGetSelectionsResponse':
        """
        Create a new instance of :class`TagHttpGetSelectionsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpGetSelectionsResponse`.
        :rtype: TagHttpGetSelectionsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        selections_ = _serialize(self.selections)
        return {
            'selections': selections_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpGetSelectionsResponse does not support setting 'body_bytes'")


class TagHttpGetSelectionRequest(RequestMessage):
    """
    TagHttpGetSelectionRequest JSON request message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionRequest'

    def __init__(
            self,
            id_=None
        ) -> None:
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagHttpGetSelectionRequest':
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagHttpGetSelectionRequest':
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagHttpGetSelectionRequest':
        """
        Create a new instance of :class:`TagHttpGetSelectionRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpGetSelectionRequest':
        """
        Create a new instance of :class`TagHttpGetSelectionRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpGetSelectionRequest`.
        :rtype: TagHttpGetSelectionRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        return {
            'id': id_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpGetSelectionRequest does not support setting 'body_bytes'")


class TagHttpGetSelectionResponse(ResponseMessage):
    """
    TagHttpGetSelectionResponse JSON response message.
    """
    MESSAGE_NAME = 'TagHttpGetSelectionResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            selection_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagHttpGetSelectionResponse':
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        selection_ = _deserialize(body_dict.get('selection'), 'Selection')
        return cls(
            request_message,
            selection_=selection_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagHttpGetSelectionResponse':
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagHttpGetSelectionResponse':
        """
        Create a new instance of :class:`TagHttpGetSelectionResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpGetSelectionResponse':
        """
        Create a new instance of :class`TagHttpGetSelectionResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpGetSelectionResponse`.
        :rtype: TagHttpGetSelectionResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        selection_ = _serialize(self.selection)
        return {
            'selection': selection_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpGetSelectionResponse does not support setting 'body_bytes'")


class TagHttpCreateSelectionRequest(RequestMessage):
    """
    TagHttpCreateSelectionRequest JSON request message.
    """
    MESSAGE_NAME = 'TagHttpCreateSelectionRequest'

    def __init__(
            self,
            selection_=None
        ) -> None:
        """
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagHttpCreateSelectionRequest':
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        selection_ = _deserialize(body_dict.get('selection'), 'Selection')
        return cls(
            selection_=selection_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagHttpCreateSelectionRequest':
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagHttpCreateSelectionRequest':
        """
        Create a new instance of :class:`TagHttpCreateSelectionRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpCreateSelectionRequest':
        """
        Create a new instance of :class`TagHttpCreateSelectionRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpCreateSelectionRequest`.
        :rtype: TagHttpCreateSelectionRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        selection_ = _serialize(self.selection)
        return {
            'selection': selection_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpCreateSelectionRequest does not support setting 'body_bytes'")


class TagHttpCreateSelectionResponse(ResponseMessage):
    """
    TagHttpCreateSelectionResponse JSON response message.
    """
    MESSAGE_NAME = 'TagHttpCreateSelectionResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            id_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagHttpCreateSelectionResponse':
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        return cls(
            request_message,
            id_=id_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagHttpCreateSelectionResponse':
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagHttpCreateSelectionResponse':
        """
        Create a new instance of :class:`TagHttpCreateSelectionResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpCreateSelectionResponse':
        """
        Create a new instance of :class`TagHttpCreateSelectionResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpCreateSelectionResponse`.
        :rtype: TagHttpCreateSelectionResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        return {
            'id': id_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpCreateSelectionResponse does not support setting 'body_bytes'")


class TagHttpUpdateSelectionRoutedMessage(RoutedMessage):
    """
    TagHttpUpdateSelectionRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagHttpUpdateSelectionRoutedMessage'

    def __init__(
            self,
            selection_=None
        ) -> None:
        """
        :param selection_: selection
        :type selection_: Selection
        """
        self.selection = selection_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagHttpUpdateSelectionRoutedMessage':
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        selection_ = _deserialize(body_dict.get('selection'), 'Selection')
        return cls(
            selection_=selection_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagHttpUpdateSelectionRoutedMessage':
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagHttpUpdateSelectionRoutedMessage':
        """
        Create a new instance of :class:`TagHttpUpdateSelectionRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpUpdateSelectionRoutedMessage':
        """
        Create a new instance of :class`TagHttpUpdateSelectionRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpUpdateSelectionRoutedMessage`.
        :rtype: TagHttpUpdateSelectionRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        selection_ = _serialize(self.selection)
        return {
            'selection': selection_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpUpdateSelectionRoutedMessage does not support setting 'body_bytes'")


class TagHttpDeleteSelectionRoutedMessage(RoutedMessage):
    """
    TagHttpDeleteSelectionRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagHttpDeleteSelectionRoutedMessage'

    def __init__(
            self,
            id_=None
        ) -> None:
        """
        :param id_: id
        :type id_: str
        """
        self.id = id_  # pylint: disable=invalid-name
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagHttp', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagHttpDeleteSelectionRoutedMessage':
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        id_ = _deserialize(body_dict.get('id'), 'str')  # pylint: disable=invalid-name
        return cls(
            id_=id_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagHttpDeleteSelectionRoutedMessage':
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagHttpDeleteSelectionRoutedMessage':
        """
        Create a new instance of :class:`TagHttpDeleteSelectionRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagHttpDeleteSelectionRoutedMessage':
        """
        Create a new instance of :class`TagHttpDeleteSelectionRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagHttpDeleteSelectionRoutedMessage`.
        :rtype: TagHttpDeleteSelectionRoutedMessage
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        id_ = _serialize(self.id)  # pylint: disable=invalid-name
        return {
            'id': id_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagHttpDeleteSelectionRoutedMessage does not support setting 'body_bytes'")


#
# TagSubscriptionCommunicator service
#


class UpdateMode:  # pylint: disable=too-few-public-methods
    """
    UpdateMode normal enum.
    """
    POLL = 0
    IMMEDIATE_NOTIFICATION = 1
    BATCH = 2
    _INT_TO_STRING = {
        0: 'POLL',
        1: 'IMMEDIATE_NOTIFICATION',
        2: 'BATCH'
    }
    _STRING_TO_INT = {
        'POLL': 0,
        'IMMEDIATE_NOTIFICATION': 1,
        'BATCH': 2
    }

    def __init__(self, value: int) -> None:
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self) -> int:
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value: int) -> None:
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string: str) -> 'UpdateMode':
        """
        Create a new instance of :class:`UpdateMode` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`UpdateMode`.
        :rtype: UpdateMode
        """
        if value_string is None:
            return None
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self) -> str:
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class SubscriptionOptions:
    """
    SubscriptionOptions custom data type.
    """
    def __init__(
            self,
            update_mode_=None,
            updates_only_=None,
            batch_interval_seconds_=None
        ) -> None:
        """
        :param update_mode_: update_mode
        :type update_mode_: UpdateMode
        :param updates_only_: updates_only
        :type updates_only_: bool
        :param batch_interval_seconds_: batch_interval_seconds
        :type batch_interval_seconds_: int
        """
        self.update_mode = update_mode_
        self.updates_only = updates_only_
        self.batch_interval_seconds = batch_interval_seconds_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'SubscriptionOptions':
        """
        Create a new instance of :class:`SubscriptionOptions` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        update_mode_ = _deserialize(body_dict.get('updateMode'), 'UpdateMode')
        updates_only_ = _deserialize(body_dict.get('updatesOnly'), 'bool')
        batch_interval_seconds_ = _deserialize(body_dict.get('batchIntervalSeconds'), 'int')
        return cls(
            update_mode_=update_mode_,
            updates_only_=updates_only_,
            batch_interval_seconds_=batch_interval_seconds_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'SubscriptionOptions':
        """
        Create a new instance of :class:`SubscriptionOptions` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'SubscriptionOptions':
        """
        Create a new instance of :class:`SubscriptionOptions` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`SubscriptionOptions`.
        :rtype: SubscriptionOptions
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        update_mode_ = _serialize(self.update_mode)
        updates_only_ = _serialize(self.updates_only)
        batch_interval_seconds_ = _serialize(self.batch_interval_seconds)
        return {
            'updateMode': update_mode_,
            'updatesOnly': updates_only_,
            'batchIntervalSeconds': batch_interval_seconds_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class SubscriptionUpdate:
    """
    SubscriptionUpdate custom data type.
    """
    def __init__(
            self,
            subscription_id_=None,
            alias_=None,
            updates_=None,
            created_tags_=None,
            deleted_tags_=None,
            nonexistent_tags_=None,
            workspace_=None
        ) -> None:
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        :param alias_: alias
        :type alias_: str
        :param updates_: updates
        :type updates_: List[UpdateWithAggregatesAndMetadata]
        :param created_tags_: created_tags
        :type created_tags_: List[str]
        :param deleted_tags_: deleted_tags
        :type deleted_tags_: List[str]
        :param nonexistent_tags_: nonexistent_tags
        :type nonexistent_tags_: List[str]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.subscription_id = subscription_id_
        self.alias = alias_
        self.updates = updates_
        self.created_tags = created_tags_
        self.deleted_tags = deleted_tags_
        self.nonexistent_tags = nonexistent_tags_
        self.workspace = workspace_

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'SubscriptionUpdate':
        """
        Create a new instance of :class:`SubscriptionUpdate` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        updates_ = _deserialize(body_dict.get('updates'), 'List[UpdateWithAggregatesAndMetadata]')
        created_tags_ = _deserialize(body_dict.get('createdTags'), 'List[str]')
        deleted_tags_ = _deserialize(body_dict.get('deletedTags'), 'List[str]')
        nonexistent_tags_ = _deserialize(body_dict.get('nonexistentTags'), 'List[str]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            subscription_id_=subscription_id_,
            alias_=alias_,
            updates_=updates_,
            created_tags_=created_tags_,
            deleted_tags_=deleted_tags_,
            nonexistent_tags_=nonexistent_tags_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'SubscriptionUpdate':
        """
        Create a new instance of :class:`SubscriptionUpdate` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'SubscriptionUpdate':
        """
        Create a new instance of :class:`SubscriptionUpdate` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`SubscriptionUpdate`.
        :rtype: SubscriptionUpdate
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_id_ = _serialize(self.subscription_id)
        alias_ = _serialize(self.alias)
        updates_ = _serialize(self.updates)
        created_tags_ = _serialize(self.created_tags)
        deleted_tags_ = _serialize(self.deleted_tags)
        nonexistent_tags_ = _serialize(self.nonexistent_tags)
        workspace_ = _serialize(self.workspace)
        return {
            'subscriptionId': subscription_id_,
            'alias': alias_,
            'updates': updates_,
            'createdTags': created_tags_,
            'deletedTags': deleted_tags_,
            'nonexistentTags': nonexistent_tags_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')


class TagSubscriptionCommunicatorSubscribeRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorSubscribeRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscribeRequest'

    def __init__(
            self,
            alias_=None,
            options_=None,
            tags_=None,
            workspace_=None
        ) -> None:
        """
        :param alias_: alias
        :type alias_: str
        :param options_: options
        :type options_: SubscriptionOptions
        :param tags_: tags
        :type tags_: List[str]
        :param workspace_: workspace
        :type workspace_: str
        """
        self.alias = alias_
        self.options = options_
        self.tags = tags_
        self.workspace = workspace_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorSubscribeRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        options_ = _deserialize(body_dict.get('options'), 'SubscriptionOptions')
        tags_ = _deserialize(body_dict.get('tags'), 'List[str]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        return cls(
            alias_=alias_,
            options_=options_,
            tags_=tags_,
            workspace_=workspace_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorSubscribeRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorSubscribeRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorSubscribeRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscribeRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorSubscribeRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        alias_ = _serialize(self.alias)
        options_ = _serialize(self.options)
        tags_ = _serialize(self.tags)
        workspace_ = _serialize(self.workspace)
        return {
            'alias': alias_,
            'options': options_,
            'tags': tags_,
            'workspace': workspace_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorSubscribeRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorSubscribeResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorSubscribeResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscribeResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            subscription_id_=None,
            alias_=None,
            nonexistent_tags_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        :param alias_: alias
        :type alias_: str
        :param nonexistent_tags_: nonexistent_tags
        :type nonexistent_tags_: List[str]
        """
        self.subscription_id = subscription_id_
        self.alias = alias_
        self.nonexistent_tags = nonexistent_tags_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorSubscribeResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        nonexistent_tags_ = _deserialize(body_dict.get('nonexistentTags'), 'List[str]')
        return cls(
            request_message,
            subscription_id_=subscription_id_,
            alias_=alias_,
            nonexistent_tags_=nonexistent_tags_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorSubscribeResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorSubscribeResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorSubscribeResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscribeResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorSubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_id_ = _serialize(self.subscription_id)
        alias_ = _serialize(self.alias)
        nonexistent_tags_ = _serialize(self.nonexistent_tags)
        return {
            'subscriptionId': subscription_id_,
            'alias': alias_,
            'nonexistentTags': nonexistent_tags_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorSubscribeResponse does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorGetSubscriptionRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionRequest'

    def __init__(
            self,
            subscription_id_=None
        ) -> None:
        """
        :param subscription_id_: subscription_id
        :type subscription_id_: str
        """
        self.subscription_id = subscription_id_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorGetSubscriptionRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        subscription_id_ = _deserialize(body_dict.get('subscriptionId'), 'str')
        return cls(
            subscription_id_=subscription_id_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorGetSubscriptionRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorGetSubscriptionRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorGetSubscriptionRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_id_ = _serialize(self.subscription_id)
        return {
            'subscriptionId': subscription_id_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorGetSubscriptionRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorGetSubscriptionResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            valid_subscription_=None,
            alias_=None,
            options_=None,
            tags_=None,
            workspace_=None,
            owner_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param valid_subscription_: valid_subscription
        :type valid_subscription_: bool
        :param alias_: alias
        :type alias_: str
        :param options_: options
        :type options_: SubscriptionOptions
        :param tags_: tags
        :type tags_: List[str]
        :param workspace_: workspace
        :type workspace_: str
        :param owner_: owner
        :type owner_: str
        """
        self.valid_subscription = valid_subscription_
        self.alias = alias_
        self.options = options_
        self.tags = tags_
        self.workspace = workspace_
        self.owner = owner_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorGetSubscriptionResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        valid_subscription_ = _deserialize(body_dict.get('validSubscription'), 'bool')
        alias_ = _deserialize(body_dict.get('alias'), 'str')
        options_ = _deserialize(body_dict.get('options'), 'SubscriptionOptions')
        tags_ = _deserialize(body_dict.get('tags'), 'List[str]')
        workspace_ = _deserialize(body_dict.get('workspace'), 'str')
        owner_ = _deserialize(body_dict.get('owner'), 'str')
        return cls(
            request_message,
            valid_subscription_=valid_subscription_,
            alias_=alias_,
            options_=options_,
            tags_=tags_,
            workspace_=workspace_,
            owner_=owner_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorGetSubscriptionResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorGetSubscriptionResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorGetSubscriptionResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        valid_subscription_ = _serialize(self.valid_subscription)
        alias_ = _serialize(self.alias)
        options_ = _serialize(self.options)
        tags_ = _serialize(self.tags)
        workspace_ = _serialize(self.workspace)
        owner_ = _serialize(self.owner)
        return {
            'validSubscription': valid_subscription_,
            'alias': alias_,
            'options': options_,
            'tags': tags_,
            'workspace': workspace_,
            'owner': owner_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorGetSubscriptionResponse does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorGetSubscriptionsRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionsRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionsRequest'

    def __init__(
            self
        ) -> None:
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorGetSubscriptionsRequest':  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorGetSubscriptionsRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorGetSubscriptionsRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorGetSubscriptionsRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsRequest`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        return {
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorGetSubscriptionsRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorGetSubscriptionsResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetSubscriptionsResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetSubscriptionsResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            subscription_ids_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: List[str]
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorGetSubscriptionsResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'List[str]')
        return cls(
            request_message,
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorGetSubscriptionsResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorGetSubscriptionsResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorGetSubscriptionsResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorGetSubscriptionsResponse`.
        :rtype: TagSubscriptionCommunicatorGetSubscriptionsResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorGetSubscriptionsResponse does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorUnsubscribeRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorUnsubscribeRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorUnsubscribeRequest'

    def __init__(
            self,
            subscription_ids_=None
        ) -> None:
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: List[str]
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorUnsubscribeRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'List[str]')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorUnsubscribeRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorUnsubscribeRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorUnsubscribeRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorUnsubscribeRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorUnsubscribeRequest`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorUnsubscribeRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorUnsubscribeResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorUnsubscribeResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorUnsubscribeResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            invalid_subscription_ids_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: List[str]
        """
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorUnsubscribeResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        invalid_subscription_ids_ = _deserialize(body_dict.get('invalidSubscriptionIds'), 'List[str]')
        return cls(
            request_message,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorUnsubscribeResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorUnsubscribeResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorUnsubscribeResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorUnsubscribeResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorUnsubscribeResponse`.
        :rtype: TagSubscriptionCommunicatorUnsubscribeResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        invalid_subscription_ids_ = _serialize(self.invalid_subscription_ids)
        return {
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorUnsubscribeResponse does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorSubscriptionHeartbeatRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorSubscriptionHeartbeatRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest'

    def __init__(
            self,
            subscription_ids_=None
        ) -> None:
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: List[str]
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'List[str]')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatRequest`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorSubscriptionHeartbeatRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorSubscriptionHeartbeatResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorSubscriptionHeartbeatResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            invalid_subscription_ids_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: List[str]
        """
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        invalid_subscription_ids_ = _deserialize(body_dict.get('invalidSubscriptionIds'), 'List[str]')
        return cls(
            request_message,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorSubscriptionHeartbeatResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorSubscriptionHeartbeatResponse`.
        :rtype: TagSubscriptionCommunicatorSubscriptionHeartbeatResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        invalid_subscription_ids_ = _serialize(self.invalid_subscription_ids)
        return {
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorSubscriptionHeartbeatResponse does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorGetUpdatesRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorGetUpdatesRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetUpdatesRequest'

    def __init__(
            self,
            subscription_ids_=None
        ) -> None:
        """
        :param subscription_ids_: subscription_ids
        :type subscription_ids_: List[str]
        """
        self.subscription_ids = subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorGetUpdatesRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        subscription_ids_ = _deserialize(body_dict.get('subscriptionIds'), 'List[str]')
        return cls(
            subscription_ids_=subscription_ids_
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorGetUpdatesRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorGetUpdatesRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorGetUpdatesRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetUpdatesRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorGetUpdatesRequest`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        subscription_ids_ = _serialize(self.subscription_ids)
        return {
            'subscriptionIds': subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorGetUpdatesRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorGetUpdatesResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorGetUpdatesResponse JSON response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorGetUpdatesResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            updates_=None,
            invalid_subscription_ids_=None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param updates_: updates
        :type updates_: List[SubscriptionUpdate]
        :param invalid_subscription_ids_: invalid_subscription_ids
        :type invalid_subscription_ids_: List[str]
        """
        self.updates = updates_
        self.invalid_subscription_ids = invalid_subscription_ids_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorGetUpdatesResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a dictionary.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        updates_ = _deserialize(body_dict.get('updates'), 'List[SubscriptionUpdate]')
        invalid_subscription_ids_ = _deserialize(body_dict.get('invalidSubscriptionIds'), 'List[str]')
        return cls(
            request_message,
            updates_=updates_,
            invalid_subscription_ids_=invalid_subscription_ids_
        )

    @classmethod
    def from_json(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorGetUpdatesResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a JSON string.

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(request_message, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorGetUpdatesResponse':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(request_message, body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorGetUpdatesResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorGetUpdatesResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorGetUpdatesResponse`.
        :rtype: TagSubscriptionCommunicatorGetUpdatesResponse
        """
        instance = cls.from_body_bytes(message, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        updates_ = _serialize(self.updates)
        invalid_subscription_ids_ = _serialize(self.invalid_subscription_ids)
        return {
            'updates': updates_,
            'invalidSubscriptionIds': invalid_subscription_ids_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorGetUpdatesResponse does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorMessageWrapperRequest(RequestMessage):
    """
    TagSubscriptionCommunicatorMessageWrapperRequest JSON request message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorMessageWrapperRequest'

    def __init__(
            self
        ) -> None:
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key('TagSubscriptionCommunicator', self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict: Dict[str, Any]) -> 'TagSubscriptionCommunicatorMessageWrapperRequest':  # pylint: disable=unused-argument
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        return cls(
        )

    @classmethod
    def from_json(cls, body_json: str) -> 'TagSubscriptionCommunicatorMessageWrapperRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes: Union[bytes, bytearray]) -> 'TagSubscriptionCommunicatorMessageWrapperRequest':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorMessageWrapperRequest':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorMessageWrapperRequest` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorMessageWrapperRequest`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperRequest
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:  # pylint: disable=no-self-use
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        return {
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorMessageWrapperRequest does not support setting 'body_bytes'")


class TagSubscriptionCommunicatorMessageWrapperResponse(ResponseMessage):
    """
    TagSubscriptionCommunicatorMessageWrapperResponse binary response message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorMessageWrapperResponse'

    def __init__(
            self,
            request_message: Optional[Union[GenericMessage, MessageBase]],
            body: Optional[Union[bytes, bytearray]] = None
        ) -> None:
        """
        :param request_message: The request_message to use for reply information. May be None.
        :type request_message: Optional[Union[GenericMessage, MessageBase]]
        :param body: The binary message body
        :type body: Optional[Union[bytes, bytearray]]
        """
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = BINARY_MESSAGE_CONTENT_TYPE
        # If request_message is None, routing key needs to be set outside this constructor.
        if request_message:
            header.correlation_id = request_message.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_message.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        super().__init__(header, body)

    @classmethod
    def from_message(cls, message: GenericMessage) -> 'TagSubscriptionCommunicatorMessageWrapperResponse':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorMessageWrapperResponse` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorMessageWrapperResponse`.
        :rtype: TagSubscriptionCommunicatorMessageWrapperResponse
        """
        source_body = message.body_bytes
        instance = cls(
            message,
            source_body
        )
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        routing_key = MessageHeader.generate_routing_key(message.reply_to, cls.MESSAGE_NAME)
        instance.routing_key = routing_key
        return instance

    def to_message(self, request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(request_header.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.body_bytes
        return GenericMessage(header, body_bytes)


class TagSubscriptionCommunicatorPushedUpdateRoutedMessage(RoutedMessage):
    """
    TagSubscriptionCommunicatorPushedUpdateRoutedMessage JSON routed message.
    """
    MESSAGE_NAME = 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage'

    def __init__(
            self,
            routing_source: Union[GenericMessage, MessageBase],
            updates_=None
        ) -> None:
        """
        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: Optional[Union[GenericMessage, MessageBase]]
        :param updates_: updates
        :type updates_: List[SubscriptionUpdate]
        """
        self.updates = updates_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(routing_source.reply_to, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super().__init__(header, None)

    @classmethod
    def from_dict(
            cls,
            routing_source: Union[GenericMessage, MessageBase],
            body_dict: Dict[str, Any]
        ) -> 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a dictionary.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: Union[GenericMessage, MessageBase]
        :param body_dict: The body as a dictionary.
        :type body_dict: Dict[str, Any]
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        updates_ = _deserialize(body_dict.get('updates'), 'List[SubscriptionUpdate]')
        return cls(
            routing_source,
            updates_=updates_
        )

    @classmethod
    def from_json(
            cls,
            routing_source: Union[GenericMessage, MessageBase],
            body_json: str
        ) -> 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a JSON string.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: Union[GenericMessage, MessageBase]
        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        body_dict = cast(Dict[str, Any], json.loads(body_json))
        return cls.from_dict(routing_source, body_dict)

    @classmethod
    def from_body_bytes(
            cls,
            routing_source: Union[GenericMessage, MessageBase],
            body_bytes: Union[bytes, bytearray]
        ) -> 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage':
        """
        Create a new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: Union[GenericMessage, MessageBase]
        :param body_bytes: The body to use.
        :type body_bytes: Union[bytes, bytearray]
        :return: A new instance of :class:`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(routing_source, body_json)

    @classmethod
    def from_message(cls, routing_source: Union[GenericMessage, MessageBase], message: GenericMessage) -> 'TagSubscriptionCommunicatorPushedUpdateRoutedMessage':
        """
        Create a new instance of :class`TagSubscriptionCommunicatorPushedUpdateRoutedMessage` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: Union[GenericMessage, MessageBase]
        :param message: The message to use as the basis for this class instance.
        :type message: GenericMessage
        :return: A new instance of :class`TagSubscriptionCommunicatorPushedUpdateRoutedMessage`.
        :rtype: TagSubscriptionCommunicatorPushedUpdateRoutedMessage
        """
        instance = cls.from_body_bytes(routing_source, message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self) -> Dict[str, Any]:
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: Dict[str, Any]
        """
        updates_ = _serialize(self.updates)
        return {
            'updates': updates_
        }

    def to_json(self) -> str:
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        body_json = self.to_json()
        return bytes(body_json, 'utf-8')

    def to_message(self, routing_source: Union[GenericMessage, MessageBase], request_message: Optional[GenericMessage] = None) -> GenericMessage:
        """
        Returns a :class:`systemlink.messagebus.generic_message.GenericMessage`
        object representing the data in this object.

        :param routing_source: The message to use its reply-to field as a routing parameter.
        :type routing_source: Union[GenericMessage, MessageBase]
        :param request_message: Request message if this is a response.
        :type request_message: Optional[GenericMessage]
        :return: A :class:`systemlink.messagebus.generic_message.GenericMessage`
            object representing the data in this object.
        :rtype: GenericMessage
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
            routing_key = MessageHeader.generate_routing_key(routing_source.reply_to, self.MESSAGE_NAME)
            header.routing_key = routing_key
        body_bytes = self.to_body_bytes()
        return GenericMessage(header, body_bytes)

    @property
    def body_bytes(self) -> bytes:
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body

    @body_bytes.setter
    def body_bytes(self, body_bytes: Optional[bytes]) -> None:  # pylint: disable=no-self-use,unused-argument
        """
        Set the raw message body.

        Not implemented. Do not use!

        :param body_bytes: The raw message body.
        :type body_bytes: Optional[bytes]
        """
        # This class method is defined simply because it is defined in
        # the base class.
        raise NotImplementedError("TagSubscriptionCommunicatorPushedUpdateRoutedMessage does not support setting 'body_bytes'")
